!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-05-07 19:53             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 169

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(531)
  integer, parameter :: nGC_4331 = 1
  integer, parameter :: nGC_4332 = 2
  integer, parameter :: nGC_4333 = 3
  integer, parameter :: nGC_4334 = 4
  integer, parameter :: nGC_4335 = 5
  integer, parameter :: nGC_4336 = 6
  integer, parameter :: nGC_4337 = 7
  integer, parameter :: nGC_4338 = 8
  integer, parameter :: nGC_4339 = 9
  integer, parameter :: nGC_28 = 10
  integer, parameter :: nGC_29 = 11
  integer, parameter :: nGC_22 = 12
  integer, parameter :: nGC_23 = 13
  integer, parameter :: nGC_20 = 14
  integer, parameter :: nGC_21 = 15
  integer, parameter :: nGC_26 = 16
  integer, parameter :: nGC_27 = 17
  integer, parameter :: nGC_24 = 18
  integer, parameter :: nGC_25 = 19
  integer, parameter :: nGC_153 = 20
  integer, parameter :: nGC_151 = 21
  integer, parameter :: nGC_150 = 22
  integer, parameter :: nGC_156 = 23
  integer, parameter :: nGC_155 = 24
  integer, parameter :: nGC_159 = 25
  integer, parameter :: nGC_158 = 26
  integer, parameter :: nGC_126 = 27
  integer, parameter :: nGC_127 = 28
  integer, parameter :: nGC_124 = 29
  integer, parameter :: nGC_125 = 30
  integer, parameter :: nGC_122 = 31
  integer, parameter :: nGC_123 = 32
  integer, parameter :: nGC_120 = 33
  integer, parameter :: nGC_121 = 34
  integer, parameter :: nGC_129 = 35
  integer, parameter :: nGC_971 = 36
  integer, parameter :: nGC_4340 = 37
  integer, parameter :: nGC_4289 = 38
  integer, parameter :: nGC_3 = 39
  integer, parameter :: nGC_2 = 40
  integer, parameter :: nGC_1 = 41
  integer, parameter :: nGC_6 = 42
  integer, parameter :: nGC_5 = 43
  integer, parameter :: nGC_4 = 44
  integer, parameter :: nGC_9 = 45
  integer, parameter :: nGC_8 = 46
  integer, parameter :: nGC_1741 = 47
  integer, parameter :: nGC_53 = 48
  integer, parameter :: nGC_52 = 49
  integer, parameter :: nGC_51 = 50
  integer, parameter :: nGC_50 = 51
  integer, parameter :: nGC_57 = 52
  integer, parameter :: nGC_56 = 53
  integer, parameter :: nGC_55 = 54
  integer, parameter :: nGC_54 = 55
  integer, parameter :: nGC_59 = 56
  integer, parameter :: nGC_58 = 57
  integer, parameter :: nGC_169 = 58
  integer, parameter :: nGC_160 = 59
  integer, parameter :: nGC_4309 = 60
  integer, parameter :: nGC_4305 = 61
  integer, parameter :: nGC_4307 = 62
  integer, parameter :: nGC_4306 = 63
  integer, parameter :: nGC_4301 = 64
  integer, parameter :: nGC_4303 = 65
  integer, parameter :: nGC_4302 = 66
  integer, parameter :: nGC_6128 = 67
  integer, parameter :: nGC_6220 = 68
  integer, parameter :: nGC_6221 = 69
  integer, parameter :: nGC_6222 = 70
  integer, parameter :: nGC_6223 = 71
  integer, parameter :: nGC_17 = 72
  integer, parameter :: nGC_16 = 73
  integer, parameter :: nGC_15 = 74
  integer, parameter :: nGC_14 = 75
  integer, parameter :: nGC_13 = 76
  integer, parameter :: nGC_12 = 77
  integer, parameter :: nGC_11 = 78
  integer, parameter :: nGC_10 = 79
  integer, parameter :: nGC_19 = 80
  integer, parameter :: nGC_18 = 81
  integer, parameter :: nGC_4089 = 82
  integer, parameter :: nGC_2023 = 83
  integer, parameter :: nGC_637 = 84
  integer, parameter :: nGC_7 = 85
  integer, parameter :: nGC_135 = 86
  integer, parameter :: nGC_134 = 87
  integer, parameter :: nGC_137 = 88
  integer, parameter :: nGC_136 = 89
  integer, parameter :: nGC_131 = 90
  integer, parameter :: nGC_130 = 91
  integer, parameter :: nGC_133 = 92
  integer, parameter :: nGC_132 = 93
  integer, parameter :: nGC_139 = 94
  integer, parameter :: nGC_138 = 95
  integer, parameter :: nGC_1513 = 96
  integer, parameter :: nGC_1515 = 97
  integer, parameter :: nGC_4170 = 98
  integer, parameter :: nGC_4171 = 99
  integer, parameter :: nGC_1423 = 100
  integer, parameter :: nGC_2973 = 101
  integer, parameter :: nGC_2975 = 102
  integer, parameter :: nGC_2977 = 103
  integer, parameter :: nGC_4120 = 104
  integer, parameter :: nGC_4123 = 105
  integer, parameter :: nGC_3497 = 106
  integer, parameter :: nGC_3499 = 107
  integer, parameter :: nGC_4371 = 108
  integer, parameter :: nGC_353 = 109
  integer, parameter :: nGC_48 = 110
  integer, parameter :: nGC_49 = 111
  integer, parameter :: nGC_44 = 112
  integer, parameter :: nGC_45 = 113
  integer, parameter :: nGC_46 = 114
  integer, parameter :: nGC_47 = 115
  integer, parameter :: nGC_40 = 116
  integer, parameter :: nGC_41 = 117
  integer, parameter :: nGC_42 = 118
  integer, parameter :: nGC_43 = 119
  integer, parameter :: nGC_4869 = 120
  integer, parameter :: nGC_4310 = 121
  integer, parameter :: nGC_6104 = 122
  integer, parameter :: nGC_6101 = 123
  integer, parameter :: nGC_4169 = 124
  integer, parameter :: nGC_4168 = 125
  integer, parameter :: nGC_4165 = 126
  integer, parameter :: nGC_4167 = 127
  integer, parameter :: nGC_4166 = 128
  integer, parameter :: nGC_4161 = 129
  integer, parameter :: nGC_4162 = 130
  integer, parameter :: nGC_4361 = 131
  integer, parameter :: nGC_6469 = 132
  integer, parameter :: nGC_2909 = 133
  integer, parameter :: nGC_6210 = 134
  integer, parameter :: nGC_6353 = 135
  integer, parameter :: nGC_6355 = 136
  integer, parameter :: nGC_6356 = 137
  integer, parameter :: nGC_6357 = 138
  integer, parameter :: nGC_4091 = 139
  integer, parameter :: nGC_152 = 140
  integer, parameter :: nGC_4093 = 141
  integer, parameter :: nGC_4092 = 142
  integer, parameter :: nGC_157 = 143
  integer, parameter :: nGC_4097 = 144
  integer, parameter :: nGC_154 = 145
  integer, parameter :: nGC_99 = 146
  integer, parameter :: nGC_98 = 147
  integer, parameter :: nGC_97 = 148
  integer, parameter :: nGC_96 = 149
  integer, parameter :: nGC_95 = 150
  integer, parameter :: nGC_94 = 151
  integer, parameter :: nGC_93 = 152
  integer, parameter :: nGC_92 = 153
  integer, parameter :: nGC_91 = 154
  integer, parameter :: nGC_90 = 155
  integer, parameter :: nGC_75 = 156
  integer, parameter :: nGC_74 = 157
  integer, parameter :: nGC_77 = 158
  integer, parameter :: nGC_76 = 159
  integer, parameter :: nGC_71 = 160
  integer, parameter :: nGC_70 = 161
  integer, parameter :: nGC_73 = 162
  integer, parameter :: nGC_72 = 163
  integer, parameter :: nGC_6077 = 164
  integer, parameter :: nGC_6076 = 165
  integer, parameter :: nGC_79 = 166
  integer, parameter :: nGC_78 = 167
  integer, parameter :: nGC_4185 = 168
  integer, parameter :: nGC_4184 = 169
  integer, parameter :: nGC_4182 = 170
  integer, parameter :: nGC_4180 = 171
  integer, parameter :: nGC_4189 = 172
  integer, parameter :: nGC_4188 = 173
  integer, parameter :: nGC_100 = 174
  integer, parameter :: nGC_101 = 175
  integer, parameter :: nGC_102 = 176
  integer, parameter :: nGC_103 = 177
  integer, parameter :: nGC_104 = 178
  integer, parameter :: nGC_105 = 179
  integer, parameter :: nGC_106 = 180
  integer, parameter :: nGC_107 = 181
  integer, parameter :: nGC_108 = 182
  integer, parameter :: nGC_109 = 183
  integer, parameter :: nGC_2281 = 184
  integer, parameter :: nGC_4323 = 185
  integer, parameter :: nGC_959 = 186
  integer, parameter :: nGC_4327 = 187
  integer, parameter :: nGC_4325 = 188
  integer, parameter :: nGC_4324 = 189
  integer, parameter :: nGC_4329 = 190
  integer, parameter :: nGC_4328 = 191
  integer, parameter :: nGC_219 = 192
  integer, parameter :: nGC_6394 = 193
  integer, parameter :: nGC_6395 = 194
  integer, parameter :: nGC_6396 = 195
  integer, parameter :: nGC_6397 = 196
  integer, parameter :: nGC_6157 = 197
  integer, parameter :: nGC_6152 = 198
  integer, parameter :: nGC_881 = 199
  integer, parameter :: nGC_281 = 200
  integer, parameter :: nGC_6327 = 201
  integer, parameter :: nGC_6326 = 202
  integer, parameter :: nGC_437 = 203
  integer, parameter :: nGC_39 = 204
  integer, parameter :: nGC_38 = 205
  integer, parameter :: nGC_31 = 206
  integer, parameter :: nGC_30 = 207
  integer, parameter :: nGC_33 = 208
  integer, parameter :: nGC_32 = 209
  integer, parameter :: nGC_35 = 210
  integer, parameter :: nGC_34 = 211
  integer, parameter :: nGC_37 = 212
  integer, parameter :: nGC_36 = 213
  integer, parameter :: nGC_144 = 214
  integer, parameter :: nGC_145 = 215
  integer, parameter :: nGC_146 = 216
  integer, parameter :: nGC_2627 = 217
  integer, parameter :: nGC_140 = 218
  integer, parameter :: nGC_141 = 219
  integer, parameter :: nGC_142 = 220
  integer, parameter :: nGC_143 = 221
  integer, parameter :: nGC_148 = 222
  integer, parameter :: nGC_149 = 223
  integer, parameter :: nGC_2001 = 224
  integer, parameter :: nGC_2003 = 225
  integer, parameter :: nGC_2005 = 226
  integer, parameter :: nGC_1153 = 227
  integer, parameter :: nGC_1151 = 228
  integer, parameter :: nGC_6186 = 229
  integer, parameter :: nGC_65 = 230
  integer, parameter :: nGC_MI = 231
  integer, parameter :: nGC_1383 = 232
  integer, parameter :: nGC_1381 = 233
  integer, parameter :: nGC_MC = 234
  integer, parameter :: nGC_MB = 235
  integer, parameter :: nGC_MD = 236
  integer, parameter :: nGC_MS = 237
  integer, parameter :: nGC_MU = 238
  integer, parameter :: nGC_MT = 239
  integer, parameter :: nGC_6358 = 240
  integer, parameter :: nGC_6116 = 241
  integer, parameter :: nGC_6115 = 242
  integer, parameter :: nGC_1379 = 243
  integer, parameter :: nGC_4178 = 244
  integer, parameter :: nGC_4076 = 245
  integer, parameter :: nGC_4172 = 246
  integer, parameter :: nGC_4173 = 247
  integer, parameter :: nGC_4176 = 248
  integer, parameter :: nGC_4174 = 249
  integer, parameter :: nGC_4374 = 250
  integer, parameter :: nGC_4375 = 251
  integer, parameter :: nGC_4370 = 252
  integer, parameter :: nGC_6809 = 253
  integer, parameter :: nGC_4372 = 254
  integer, parameter :: nGC_4373 = 255
  integer, parameter :: nGC_6366 = 256
  integer, parameter :: nGC_329 = 257
  integer, parameter :: nGC_1073 = 258
  integer, parameter :: nGC_6369 = 259
  integer, parameter :: nGC_6368 = 260
  integer, parameter :: nGC_1375 = 261
  integer, parameter :: nGC_128 = 262
  integer, parameter :: nGC_6206 = 263
  integer, parameter :: nGC_6207 = 264
  integer, parameter :: nGC_6204 = 265
  integer, parameter :: nGC_6205 = 266
  integer, parameter :: nGC_4299 = 267
  integer, parameter :: nGC_4298 = 268
  integer, parameter :: nGC_4297 = 269
  integer, parameter :: nGC_4296 = 270
  integer, parameter :: nGC_4295 = 271
  integer, parameter :: nGC_4294 = 272
  integer, parameter :: nGC_4293 = 273
  integer, parameter :: nGC_4291 = 274
  integer, parameter :: nGC_4290 = 275
  integer, parameter :: nGC_4109 = 276
  integer, parameter :: nGC_4108 = 277
  integer, parameter :: nGC_4107 = 278
  integer, parameter :: nGC_4106 = 279
  integer, parameter :: nGC_4105 = 280
  integer, parameter :: nGC_4104 = 281
  integer, parameter :: nGC_4103 = 282
  integer, parameter :: nGC_4102 = 283
  integer, parameter :: nGC_4101 = 284
  integer, parameter :: nGC_4100 = 285
  integer, parameter :: nGC_2279 = 286
  integer, parameter :: nGC_1743 = 287
  integer, parameter :: nGC_88 = 288
  integer, parameter :: nGC_89 = 289
  integer, parameter :: nGC_80 = 290
  integer, parameter :: nGC_81 = 291
  integer, parameter :: nGC_82 = 292
  integer, parameter :: nGC_83 = 293
  integer, parameter :: nGC_84 = 294
  integer, parameter :: nGC_85 = 295
  integer, parameter :: nGC_86 = 296
  integer, parameter :: nGC_87 = 297
  integer, parameter :: nGC_66 = 298
  integer, parameter :: nGC_67 = 299
  integer, parameter :: nGC_64 = 300
  integer, parameter :: nGC_147 = 301
  integer, parameter :: nGC_62 = 302
  integer, parameter :: nGC_63 = 303
  integer, parameter :: nGC_60 = 304
  integer, parameter :: nGC_61 = 305
  integer, parameter :: nGC_1751 = 306
  integer, parameter :: nGC_6883 = 307
  integer, parameter :: nGC_68 = 308
  integer, parameter :: nGC_69 = 309
  integer, parameter :: nGC_4190 = 310
  integer, parameter :: nGC_4191 = 311
  integer, parameter :: nGC_119 = 312
  integer, parameter :: nGC_118 = 313
  integer, parameter :: nGC_117 = 314
  integer, parameter :: nGC_116 = 315
  integer, parameter :: nGC_115 = 316
  integer, parameter :: nGC_114 = 317
  integer, parameter :: nGC_113 = 318
  integer, parameter :: nGC_112 = 319
  integer, parameter :: nGC_111 = 320
  integer, parameter :: nGC_110 = 321
  integer, parameter :: nGC_1747 = 322
  integer, parameter :: nGC_565 = 323
  integer, parameter :: nGC_1629 = 324
  integer, parameter :: nGC_563 = 325
  integer, parameter :: nGC_1749 = 326
  integer, parameter :: nGC_1745 = 327
  integer, parameter :: nGC_4121 = 328
  integer, parameter :: nGC_4122 = 329
  integer, parameter :: nGC_4125 = 330
  integer, parameter :: nGC_4124 = 331
  integer, parameter :: nGC_4127 = 332
  integer, parameter :: nGC_4126 = 333
  integer, parameter :: nGC_6138 = 334
  integer, parameter :: nGC_217 = 335
  integer, parameter :: nGC_597 = 336
  integer, parameter :: nGC_595 = 337
  integer, parameter :: nGC_6798 = 338
  integer, parameter :: nGC_6094 = 339
  integer, parameter :: nGC_517 = 340
  integer, parameter :: nGC_6159 = 341
  integer, parameter :: nGC_519 = 342
  integer, parameter :: nGC_6795 = 343
  integer, parameter :: nGC_6796 = 344
  integer, parameter :: nGC_4330 = 345
  integer, parameter :: nGC_4137 = 346
  integer, parameter :: nGC_4134 = 347
  integer, parameter :: nGC_4135 = 348
  integer, parameter :: nGC_4132 = 349
  integer, parameter :: nGC_4133 = 350
  integer, parameter :: nGC_4326 = 351
  integer, parameter :: nGC_6367 = 352
  integer, parameter :: nGC_4138 = 353
  integer, parameter :: nGC_4139 = 354
  integer, parameter :: nGC_6240 = 355
  integer, parameter :: nGC_6241 = 356
  integer, parameter :: nGC_1239 = 357
  integer, parameter :: nGC_883 = 358
  integer, parameter :: nGC_6249 = 359
  integer, parameter :: nGC_6085 = 360
  integer, parameter :: nGC_6086 = 361
  integer, parameter :: nGC_6087 = 362
  integer, parameter :: nGC_6080 = 363
  integer, parameter :: nGC_6137 = 364
  integer, parameter :: nGC_6088 = 365
  integer, parameter :: nGC_6089 = 366
  integer, parameter :: nGC_4147 = 367
  integer, parameter :: nGC_4146 = 368
  integer, parameter :: nGC_4145 = 369
  integer, parameter :: nGC_4144 = 370
  integer, parameter :: nGC_4304 = 371
  integer, parameter :: nGC_4149 = 372
  integer, parameter :: nGC_4148 = 373
  integer, parameter :: nGC_4300 = 374
  integer, parameter :: nGC_377 = 375
  integer, parameter :: nGC_375 = 376
  integer, parameter :: nGC_373 = 377
  integer, parameter :: nGC_479 = 378
  integer, parameter :: nGC_6236 = 379
  integer, parameter :: nGC_6233 = 380
  integer, parameter :: nGC_6232 = 381
  integer, parameter :: nGC_6325 = 382
  integer, parameter :: nGC_6133 = 383
  integer, parameter :: nGC_6134 = 384
  integer, parameter :: nGC_6239 = 385
  integer, parameter :: nGC_6238 = 386
  integer, parameter :: nGC_4150 = 387
  integer, parameter :: nGC_4151 = 388
  integer, parameter :: nGC_4152 = 389
  integer, parameter :: nGC_4153 = 390
  integer, parameter :: nGC_4154 = 391
  integer, parameter :: nGC_4155 = 392
  integer, parameter :: nGC_4156 = 393
  integer, parameter :: nGC_4157 = 394
  integer, parameter :: nGC_4158 = 395
  integer, parameter :: nGC_6127 = 396
  integer, parameter :: nGC_6185 = 397
  integer, parameter :: nGC_6105 = 398
  integer, parameter :: nGC_4090 = 399
  integer, parameter :: nGC_6106 = 400
  integer, parameter :: nGC_4095 = 401
  integer, parameter :: nGC_307 = 402
  integer, parameter :: nGC_4096 = 403
  integer, parameter :: nGC_4099 = 404
  integer, parameter :: nGC_4098 = 405
  integer, parameter :: nGC_6252 = 406
  integer, parameter :: nGC_6431 = 407
  integer, parameter :: nGC_6430 = 408
  integer, parameter :: nGC_721 = 409
  integer, parameter :: nGC_2211 = 410
  integer, parameter :: nGC_4164 = 411
  integer, parameter :: nGC_4163 = 412
  integer, parameter :: nGC_2355 = 413
  integer, parameter :: nGC_6810 = 414
  integer, parameter :: nGC_6192 = 415
  integer, parameter :: nGC_6191 = 416
  integer, parameter :: nGC_6194 = 417
  integer, parameter :: nGC_6195 = 418
  integer, parameter :: nGC_4094 = 419
  integer, parameter :: nGC_315 = 420
  integer, parameter :: nGC_4088 = 421
  integer, parameter :: nGC_295 = 422
  integer, parameter :: nGC_4086 = 423
  integer, parameter :: nGC_4087 = 424
  integer, parameter :: nGC_4084 = 425
  integer, parameter :: nGC_4085 = 426
  integer, parameter :: nGC_6211 = 427
  integer, parameter :: nGC_6099 = 428
  integer, parameter :: nGC_793 = 429
  integer, parameter :: nGC_4070 = 430
  integer, parameter :: nGC_4077 = 431
  integer, parameter :: nGC_4075 = 432
  integer, parameter :: nGC_6470 = 433
  integer, parameter :: nGC_6885 = 434
  integer, parameter :: nGC_6886 = 435
  integer, parameter :: nGC_6882 = 436
  integer, parameter :: nGC_3509 = 437
  integer, parameter :: nGC_6285 = 438
  integer, parameter :: nGC_6282 = 439
  integer, parameter :: nGC_6154 = 440
  integer, parameter :: nGC_6100 = 441
  integer, parameter :: nGC_6419 = 442
  integer, parameter :: nGC_305 = 443
  integer, parameter :: nGC_1377 = 444
  integer, parameter :: nGC_4308 = 445
  integer, parameter :: nGC_7100 = 446
  integer, parameter :: nGC_4136 = 447
  integer, parameter :: nGC_4063 = 448
  integer, parameter :: nGC_4064 = 449
  integer, parameter :: nGC_4065 = 450
  integer, parameter :: nGC_4066 = 451
  integer, parameter :: nGC_4067 = 452
  integer, parameter :: nGC_4068 = 453
  integer, parameter :: nGC_4069 = 454
  integer, parameter :: nGC_4292 = 455
  integer, parameter :: nGC_4179 = 456
  integer, parameter :: nGC_6372 = 457
  integer, parameter :: nGC_233 = 458
  integer, parameter :: nGC_4183 = 459
  integer, parameter :: nGC_4181 = 460
  integer, parameter :: nGC_6400 = 461
  integer, parameter :: nGC_6401 = 462
  integer, parameter :: nGC_4074 = 463
  integer, parameter :: nGC_4079 = 464
  integer, parameter :: nGC_6174 = 465
  integer, parameter :: nGC_6175 = 466
  integer, parameter :: nGC_6176 = 467
  integer, parameter :: nGC_6170 = 468
  integer, parameter :: nGC_6171 = 469
  integer, parameter :: nGC_6179 = 470
  integer, parameter :: nGC_4187 = 471
  integer, parameter :: nGC_4175 = 472
  integer, parameter :: nGC_6373 = 473
  integer, parameter :: nGC_4118 = 474
  integer, parameter :: nGC_4119 = 475
  integer, parameter :: nGC_6433 = 476
  integer, parameter :: nGC_6432 = 477
  integer, parameter :: nGC_4114 = 478
  integer, parameter :: nGC_4115 = 479
  integer, parameter :: nGC_4116 = 480
  integer, parameter :: nGC_4117 = 481
  integer, parameter :: nGC_4110 = 482
  integer, parameter :: nGC_4111 = 483
  integer, parameter :: nGC_4112 = 484
  integer, parameter :: nGC_4113 = 485
  integer, parameter :: nGC_7098 = 486
  integer, parameter :: nGC_589 = 487
  integer, parameter :: nGC_229 = 488
  integer, parameter :: nGC_3209 = 489
  integer, parameter :: nGC_6140 = 490
  integer, parameter :: nGC_6147 = 491
  integer, parameter :: nGC_6146 = 492
  integer, parameter :: nGC_6149 = 493
  integer, parameter :: nGC_6263 = 494
  integer, parameter :: nGC_6264 = 495
  integer, parameter :: nGC_6266 = 496
  integer, parameter :: nGC_6267 = 497
  integer, parameter :: nGC_4143 = 498
  integer, parameter :: nGC_4142 = 499
  integer, parameter :: nGC_4141 = 500
  integer, parameter :: nGC_4140 = 501
  integer, parameter :: nGC_4072 = 502
  integer, parameter :: nGC_6929 = 503
  integer, parameter :: nGC_4160 = 504
  integer, parameter :: nGC_4129 = 505
  integer, parameter :: nGC_4128 = 506
  integer, parameter :: nGC_6420 = 507
  integer, parameter :: nGC_6940 = 508
  integer, parameter :: nGC_4186 = 509
  integer, parameter :: nGC_6251 = 510
  integer, parameter :: nGC_6139 = 511
  integer, parameter :: nGC_4082 = 512
  integer, parameter :: nGC_4083 = 513
  integer, parameter :: nGC_4080 = 514
  integer, parameter :: nGC_4081 = 515
  integer, parameter :: nGC_6237 = 516
  integer, parameter :: nGC_6799 = 517
  integer, parameter :: nGC_6155 = 518
  integer, parameter :: nGC_6150 = 519
  integer, parameter :: nGC_4073 = 520
  integer, parameter :: nGC_6931 = 521
  integer, parameter :: nGC_4071 = 522
  integer, parameter :: nGC_4130 = 523
  integer, parameter :: nGC_4131 = 524
  integer, parameter :: nGC_4159 = 525
  integer, parameter :: nGC_4078 = 526
  integer, parameter :: nGC_4177 = 527
  integer, parameter :: nGC_6286 = 528
  integer, parameter :: nGC_6287 = 529
  integer, parameter :: nGC_6180 = 530
  integer, parameter :: nGC_6930 = 531
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
