!******************************************************************************!
!                                                                              !
!    fill_couplings2.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings2.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-05-07 19:53             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  contains
    subroutine fill_couplings_mdl2()
      coupl(nGC_87) = cima*ee**2d0*vev/(2d0*sw)
      coupl(nGC_66) = -cima*ee**2d0*vev/(2d0*cw)
      coupl(nGC_67) = CBL2*cima*ee**2d0*vev/(4d0*cw)
      coupl(nGC_64) = -cMH**2d0*cima/vev
      coupl(nGC_147) = -sqrt(2d0)*ys/2d0
      coupl(nGC_62) = -2d0*cMH**2d0*cima/vev**2d0
      coupl(nGC_63) = -3d0*cMH**2d0*cima/vev**2d0
      coupl(nGC_60) = cima*cw**2d0*ee**2d0/(2d0*sw**2d0) + cima*ee**2d0 + cima*&
                      ee**2d0*sw**2d0/(2d0*cw**2d0)
      coupl(nGC_61) = -cMH**2d0*cima/vev**2d0
      coupl(nGC_1751) = -coupl(nGC_102) - coupl(nGC_98)
      coupl(nGC_68) = -CPWL2*cima*ee**2d0*vev/(4d0*cw)
      coupl(nGC_69) = CWL2*cima*ee**2d0*vev/(4d0*cw)
      coupl(nGC_119) = -4d0*CBBL4*cima*cw*qeddim**2d0*sw*vev - CBWL4*cima*cw** &
                       2d0*qeddim**2d0*vev + CBWL4*cima*qeddim**2d0*sw**2d0*vev&
                        + CWWL4*cima*cw*qeddim**2d0*sw*vev
      coupl(nGC_118) = -4d0*CBBL4*cima*qeddim**2d0*sw**2d0*vev - 2d0*CBWL4*cima&
                       *cw*qeddim**2d0*sw*vev - CWWL4*cima*cw**2d0*qeddim**2d0*&
                       vev
      coupl(nGC_117) = -CBL2*cima*ee**2d0*vev/4d0 - CBL2*cima*ee**2d0*sw**2d0* &
                       vev/(4d0*cw**2d0) - CWL2*cima*cw**2d0*ee**2d0*vev/(4d0* &
                       sw**2d0) - CWL2*cima*ee**2d0*vev/4d0
      coupl(nGC_116) = cima*cw**2d0*ee**2d0*vev/(2d0*sw**2d0) + cima*ee**2d0*  &
                       vev + cima*ee**2d0*sw**2d0*vev/(2d0*cw**2d0)
      coupl(nGC_115) = -cima*cw**2d0*ee**2d0*vev/(4d0*sw**2d0) - cima*ee**2d0* &
                       vev/2d0 - cima*ee**2d0*sw**2d0*vev/(4d0*cw**2d0)
      coupl(nGC_114) = -CBL2*cima*cw*ee**2d0*vev/(4d0*sw) - CBL2*cima*ee**2d0* &
                       sw*vev/(4d0*cw) + CWL2*cima*cw*ee**2d0*vev/(4d0*sw) +   &
                       CWL2*cima*ee**2d0*sw*vev/(4d0*cw)
      coupl(nGC_113) = -CPWL2*cima*cw*ee**2d0*vev/(4d0*sw) - CPWL2*cima*ee**2d0&
                       *sw*vev/(4d0*cw)
      coupl(nGC_112) = CBL2*cima*ee**2d0*vev/(4d0*sw) + CWL2*cima*ee**2d0*vev/(&
                       4d0*sw)
      coupl(nGC_111) = CPWL2*cima*cw**2d0*ee**2d0*vev/(4d0*sw**2d0) + CPWL2*   &
                       cima*ee**2d0*vev/4d0
      coupl(nGC_110) = cima*cw*ee**2d0*vev/(4d0*sw**2d0) + cima*ee**2d0*vev/(  &
                       4d0*cw)
      coupl(nGC_1747) = -coupl(nGC_101) - coupl(nGC_99)
      coupl(nGC_565) = -coupl(nGC_82)
      coupl(nGC_1629) = -coupl(nGC_81)
      coupl(nGC_563) = -coupl(nGC_68) - coupl(nGC_82)
      coupl(nGC_1749) = -coupl(nGC_98)
      coupl(nGC_1745) = -coupl(nGC_103) - coupl(nGC_99)
      coupl(nGC_217) = 2d0*coupl(nGC_37)
      coupl(nGC_597) = -coupl(nGC_113)
      coupl(nGC_595) = -coupl(nGC_114)
      coupl(nGC_517) = -coupl(nGC_112)
      coupl(nGC_519) = -coupl(nGC_88)
      coupl(nGC_1239) = -coupl(nGC_32)
      coupl(nGC_883) = -coupl(nGC_33)
      coupl(nGC_377) = coupl(nGC_68) + coupl(nGC_82)
      coupl(nGC_375) = coupl(nGC_69) + coupl(nGC_85)
      coupl(nGC_373) = coupl(nGC_67) - coupl(nGC_85)
      coupl(nGC_479) = -coupl(nGC_136)
      coupl(nGC_307) = -coupl(nGC_34)
      coupl(nGC_721) = -2d0*coupl(nGC_7)
      coupl(nGC_2211) = -coupl(nGC_80)
      coupl(nGC_2355) = -coupl(nGC_111)
      coupl(nGC_315) = -coupl(nGC_30)
      coupl(nGC_295) = -coupl(nGC_147)
      coupl(nGC_793) = -coupl(nGC_84)
      coupl(nGC_3509) = -2d0*coupl(nGC_18)
      coupl(nGC_305) = -coupl(nGC_40)
      coupl(nGC_1377) = coupl(nGC_101) + coupl(nGC_99)
      coupl(nGC_233) = -coupl(nGC_3)
      coupl(nGC_589) = -coupl(nGC_39)
      coupl(nGC_229) = -coupl(nGC_35)
      coupl(nGC_3209) = -coupl(nGC_96)
    end subroutine fill_couplings_mdl2
end module fill_couplings2
