!******************************************************************************!
!                                                                              !
!    fill_ctcouplings2.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings2.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-05-07 19:53             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  contains
    subroutine fill_CTcouplings_mdl2()
      coupl(nGC_6394) = coupl(nGC_48)*dZsR_QCD2
      coupl(nGC_6395) = coupl(nGC_52)*dZsL_QCD2
      coupl(nGC_6396) = coupl(nGC_17)*dZtL_QCD2
      coupl(nGC_6397) = coupl(nGC_17)*dZtR_QCD2
      coupl(nGC_6157) = coupl(nGC_151)*(dZtL_QCD2 + dZtR_QCD2)/2d0
      coupl(nGC_6152) = coupl(nGC_129)*(dZbL_QCD2 + dZbR_QCD2)/2d0
      coupl(nGC_6327) = coupl(nGC_49)*dZtR_QCD2
      coupl(nGC_6326) = coupl(nGC_53)*dZtL_QCD2
      coupl(nGC_6186) = coupl(nGC_132)*dZcL_QCD2/2d0 + coupl(nGC_132)*dZcR_QCD2&
                        /2d0 + coupl(nGC_4324)
      coupl(nGC_6358) = coupl(nGC_2)*dZcR_QCD2
      coupl(nGC_6116) = coupl(nGC_160)*dZuL_QCD2/2d0 + coupl(nGC_160)*dZuR_QCD2&
                        /2d0 + coupl(nGC_4332)
      coupl(nGC_6115) = coupl(nGC_158)*dZuL_QCD2/2d0 + coupl(nGC_158)*dZuR_QCD2&
                        /2d0 + coupl(nGC_4334)
      coupl(nGC_4178) = (5d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 - 3d0*Nc*cima*&
                        coupl(nGC_18)*coupl(nGC_3499) + 3d0*Nc*cima*coupl(     &
                        nGC_3497)*coupl(nGC_3499) - 6d0*Nc*coupl(nGC_16)**2d0* &
                        coupl(nGC_18)*sq2**2d0 + 3d0*Nc*coupl(nGC_16)**2d0*    &
                        coupl(nGC_3497)*sq2**2d0 - 3d0*Nc*coupl(nGC_16)**2d0*  &
                        coupl(nGC_3499)*sq2**2d0 - 3d0*cima*coupl(nGC_17)**4d0*&
                        sq2**4d0)/(192d0*pi**2d0*Nc)
      coupl(nGC_4076) = cima*(4d0*Nc*coupl(nGC_130)**2d0 + 4d0*Nc*coupl(nGC_133&
                        )**2d0 + 4d0*Nc*coupl(nGC_137)**2d0 + 4d0*Nc*coupl(    &
                        nGC_148)**2d0 + 4d0*Nc*coupl(nGC_151)**2d0 + 4d0*Nc*   &
                        coupl(nGC_159)**2d0 + 4d0*coupl(nGC_140)**2d0 + 4d0*   &
                        coupl(nGC_144)**2d0 + 4d0*coupl(nGC_155)**2d0 + coupl( &
                        nGC_219)*coupl(nGC_51) + coupl(nGC_28)*coupl(nGC_971   &
                        ) + coupl(nGC_281)*coupl(nGC_29))/(96d0*pi**2d0)
      coupl(nGC_4172) = cima*coupl(nGC_17)**3d0*sq2**3d0*(coupl(nGC_48) + coupl&
                        (nGC_49) + coupl(nGC_52) + coupl(nGC_53))/(128d0*pi**  &
                        2d0)
      coupl(nGC_4173) = cima*coupl(nGC_17)**3d0*sq2**3d0*(-coupl(nGC_48) -     &
                        coupl(nGC_49) - coupl(nGC_52) - coupl(nGC_53))/(64d0*pi&
                        **2d0*Nc)
      coupl(nGC_4176) = (-8d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 + 12d0*Nc*   &
                        cima*coupl(nGC_18)**2d0 + 12d0*Nc*cima*coupl(nGC_3497  &
                        )**2d0 + 21d0*Nc*coupl(nGC_16)**2d0*coupl(nGC_18)*sq2**&
                        2d0 - 21d0*Nc*coupl(nGC_16)**2d0*coupl(nGC_3497)*sq2** &
                        2d0 + 36d0*cima*coupl(nGC_17)**4d0*sq2**4d0)/(768d0*pi &
                        **2d0)
      coupl(nGC_4174) = cima*coupl(nGC_17)**3d0*sq2**3d0*(coupl(nGC_48) + coupl&
                        (nGC_49) + coupl(nGC_52) + coupl(nGC_53))/(32d0*pi**2d0&
                        *Nc**2d0)
      coupl(nGC_4374) = -cima*dMS_QCD2
      coupl(nGC_4375) = -cima*dMB_QCD2
      coupl(nGC_4370) = -cima*dMT_QCD2
      coupl(nGC_6809) = coupl(nGC_MI)*dZg_QCD2
      coupl(nGC_4372) = -cima*dMD_QCD2
      coupl(nGC_4373) = -cima*dMC_QCD2
      coupl(nGC_6366) = coupl(nGC_152)*dZtL_QCD2/2d0 + coupl(nGC_152)*dZtR_QCD2&
                        /2d0 + coupl(nGC_4328)
      coupl(nGC_6369) = coupl(nGC_17)*dZbR_QCD2
      coupl(nGC_6368) = coupl(nGC_17)*dZbL_QCD2
      coupl(nGC_6206) = coupl(nGC_1)*dZbR_QCD2
      coupl(nGC_6207) = coupl(nGC_1)*dZbL_QCD2
      coupl(nGC_6204) = coupl(nGC_53)*dZuL_QCD2
      coupl(nGC_6205) = coupl(nGC_49)*dZuR_QCD2
      coupl(nGC_4298) = cima*dyc_QED1_QCD2
      coupl(nGC_4297) = -cima*dys_QED1_QCD2
      coupl(nGC_4296) = -cima*dydo_QED1_QCD2
      coupl(nGC_4295) = cima*dyup_QED1_QCD2
      coupl(nGC_4294) = cima*dyt_QED1_QCD2
      coupl(nGC_4293) = -cima*dyb_QED1_QCD2
      coupl(nGC_4290) = coupl(nGC_4289)*dZgs_QCD2
      coupl(nGC_4109) = cMB*cima*(-coupl(nGC_1)**2d0 - coupl(nGC_48)*coupl(    &
                        nGC_52))/(8d0*pi**2d0)
      coupl(nGC_4108) = cMB*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_4107) = cMS*cima*(-coupl(nGC_1)**2d0 - coupl(nGC_48)*coupl(    &
                        nGC_52))/(8d0*pi**2d0)
      coupl(nGC_4106) = cMS*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_4105) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_48)**2d0)/(16d0*pi&
                        **2d0)
      coupl(nGC_4104) = cMD*cima*(-coupl(nGC_1)**2d0 - coupl(nGC_48)*coupl(    &
                        nGC_52))/(8d0*pi**2d0)
      coupl(nGC_4103) = cMD*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_4102) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_31)**2d0 - coupl( &
                        nGC_52)**2d0)/(16d0*pi**2d0)
      coupl(nGC_4101) = cMT*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_4100) = cMT*cima*(-coupl(nGC_2)**2d0 - coupl(nGC_49)*coupl(    &
                        nGC_53))/(8d0*pi**2d0)
      coupl(nGC_6883) = coupl(nGC_MT)*(dZtL_QCD2 + dZtR_QCD2)/2d0
      coupl(nGC_4190) = cima*coupl(nGC_17)**4d0*sq2**4d0/(32d0*pi**2d0*Nc**2d0)
    end subroutine fill_CTcouplings_mdl2
end module fill_ctcouplings2
