!******************************************************************************!
!                                                                              !
!    fill_ctcouplings5.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings5.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-05-07 19:53             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings5
  use constants_mdl
  use class_couplings
  use class_ctparameters
  contains
    subroutine fill_CTcouplings_mdl5()
      coupl(nGC_4063) = cima*sq2**2d0*(Nc*coupl(nGC_16)**2d0 - 4d0*coupl(nGC_17&
                        )**2d0)/(64d0*pi**2d0)
      coupl(nGC_4064) = -Nc*cima*coupl(nGC_16)**2d0*sq2**2d0/(96d0*pi**2d0)
      coupl(nGC_4065) = cima*coupl(nGC_17)**2d0*sq2**2d0*(cMB**2d0 + cMC**2d0  &
                         + cMD**2d0 + cMS**2d0 + cMT**2d0 + cMU**2d0)/(16d0*pi &
                        **2d0)
      coupl(nGC_4066) = cima*sq2**2d0*(-Nc*coupl(nGC_16)**2d0 + 4d0*coupl(     &
                        nGC_17)**2d0)/(64d0*pi**2d0*Nc)
      coupl(nGC_4067) = cima*coupl(nGC_16)**2d0*sq2**2d0/(96d0*pi**2d0)
      coupl(nGC_4068) = cima*coupl(nGC_17)**2d0*sq2**2d0*(-cMB**2d0 - cMC**2d0 &
                         - cMD**2d0 - cMS**2d0 - cMT**2d0 - cMU**2d0)/(16d0*pi &
                        **2d0*Nc)
      coupl(nGC_4069) = cima*(4d0*Nc*coupl(nGC_128)**2d0 + 4d0*Nc*coupl(nGC_131&
                        )**2d0 + 4d0*Nc*coupl(nGC_135)**2d0 + 4d0*Nc*coupl(    &
                        nGC_146)**2d0 + 4d0*Nc*coupl(nGC_149)**2d0 + 4d0*Nc*   &
                        coupl(nGC_157)**2d0 + 4d0*coupl(nGC_138)**2d0 + 4d0*   &
                        coupl(nGC_142)**2d0 + coupl(nGC_1423)**2d0 + 4d0*coupl(&
                        nGC_153)**2d0 + coupl(nGC_28)*coupl(nGC_971) + coupl(  &
                        nGC_281)*coupl(nGC_29) + 2d0*coupl(nGC_30)*coupl(      &
                        nGC_315) + coupl(nGC_353)**2d0 + coupl(nGC_4)**2d0 +   &
                        coupl(nGC_54)**2d0)/(192d0*pi**2d0)
      coupl(nGC_4292) = coupl(nGC_4291)*dZgs_QCD2
      coupl(nGC_4179) = (10d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 - 6d0*Nc*cima&
                        *coupl(nGC_18)*coupl(nGC_3499) + 6d0*Nc*cima*coupl(    &
                        nGC_3497)*coupl(nGC_3499) - 9d0*Nc*coupl(nGC_16)**2d0* &
                        coupl(nGC_18)*sq2**2d0 + 9d0*Nc*coupl(nGC_16)**2d0*    &
                        coupl(nGC_3497)*sq2**2d0 - 9d0*Nc*coupl(nGC_16)**2d0*  &
                        coupl(nGC_3499)*sq2**2d0 - 3d0*Nc*coupl(nGC_16)**2d0*  &
                        coupl(nGC_3509)*sq2**2d0 - 6d0*cima*coupl(nGC_17)**4d0*&
                        sq2**4d0)/(384d0*pi**2d0*Nc)
      coupl(nGC_6372) = coupl(nGC_6087) + coupl(nGC_6369)
      coupl(nGC_4183) = (-10d0*cima*coupl(nGC_16)**4d0*sq2**4d0 + 6d0*cima*    &
                        coupl(nGC_3499)**2d0 + 18d0*coupl(nGC_16)**2d0*coupl(  &
                        nGC_3499)*sq2**2d0 + 3d0*coupl(nGC_16)**2d0*coupl(     &
                        nGC_3509)*sq2**2d0)/(192d0*pi**2d0)
      coupl(nGC_4181) = (-20d0*cima*coupl(nGC_16)**4d0*sq2**4d0 + 12d0*cima*   &
                        coupl(nGC_3499)**2d0 + 3d0*coupl(nGC_16)**2d0*coupl(   &
                        nGC_18)*sq2**2d0 + 3d0*coupl(nGC_16)**2d0*coupl(       &
                        nGC_3497)*sq2**2d0 + 33d0*coupl(nGC_16)**2d0*coupl(    &
                        nGC_3499)*sq2**2d0 + 3d0*coupl(nGC_16)**2d0*coupl(     &
                        nGC_3509)*sq2**2d0)/(384d0*pi**2d0)
      coupl(nGC_6400) = coupl(nGC_6087) + coupl(nGC_6397)
      coupl(nGC_6401) = coupl(nGC_6087) + coupl(nGC_6396)
      coupl(nGC_4074) = cima*(4d0*Nc*coupl(nGC_129)*coupl(nGC_437) + 4d0*Nc*   &
                        coupl(nGC_132)*coupl(nGC_134) + 4d0*Nc*coupl(nGC_136)* &
                        coupl(nGC_479) + 4d0*Nc*coupl(nGC_147)*coupl(nGC_295   &
                        ) + 4d0*Nc*coupl(nGC_150)*coupl(nGC_152) + 4d0*Nc*coupl&
                        (nGC_158)*coupl(nGC_160) + 4d0*coupl(nGC_139)*coupl(   &
                        nGC_141) + 4d0*coupl(nGC_143)*coupl(nGC_145) + 4d0*    &
                        coupl(nGC_154)*coupl(nGC_156) + coupl(nGC_219)*coupl(  &
                        nGC_51) + 2d0*coupl(nGC_30)*coupl(nGC_315))/(96d0*pi** &
                        2d0)
      coupl(nGC_4079) = cima*(coupl(nGC_233)**2d0 + coupl(nGC_3)**2d0)/(48d0*pi&
                        **2d0)
      coupl(nGC_6174) = coupl(nGC_130)*(dZbL_QCD2 + dZbR_QCD2)/2d0
      coupl(nGC_6175) = coupl(nGC_4306) + coupl(nGC_6174)
      coupl(nGC_6176) = coupl(nGC_31)*(dZbL_QCD2 + dZtL_QCD2)/2d0
      coupl(nGC_6170) = coupl(nGC_148)*(dZsL_QCD2 + dZsR_QCD2)/2d0
      coupl(nGC_6171) = coupl(nGC_4310) + coupl(nGC_6170)
      coupl(nGC_6179) = coupl(nGC_133)*(dZcL_QCD2 + dZcR_QCD2)/2d0
      coupl(nGC_4187) = sq2**2d0*(-4d0*Nc*cima*coupl(nGC_16)**4d0*sq2**2d0 -   &
                        9d0*Nc*coupl(nGC_16)**2d0*coupl(nGC_3499) + 3d0*Nc*    &
                        coupl(nGC_16)**2d0*coupl(nGC_3509) - 60d0*cima*coupl(  &
                        nGC_17)**4d0*sq2**2d0)/(768d0*pi**2d0)
      coupl(nGC_4175) = sq2**2d0*(-2d0*Nc*cima*coupl(nGC_16)**4d0*sq2**2d0 -   &
                        3d0*Nc*coupl(nGC_16)**2d0*coupl(nGC_3499) + 3d0*Nc*    &
                        coupl(nGC_16)**2d0*coupl(nGC_3509) - 30d0*cima*coupl(  &
                        nGC_17)**4d0*sq2**2d0)/(384d0*pi**2d0)
      coupl(nGC_6373) = coupl(nGC_6087) + coupl(nGC_6368)
      coupl(nGC_4118) = coupl(nGC_17)*sq2*(-coupl(nGC_132)*coupl(nGC_134) -    &
                        coupl(nGC_133)**2d0 - coupl(nGC_146)**2d0 - 4d0*coupl( &
                        nGC_2)**2d0 - 4d0*coupl(nGC_31)**2d0 - 4d0*coupl(nGC_53&
                        )**2d0)/(64d0*pi**2d0*Nc)
      coupl(nGC_4119) = coupl(nGC_17)*sq2*(-coupl(nGC_131)**2d0 - coupl(nGC_132&
                        )*coupl(nGC_134) - coupl(nGC_133)**2d0 - 4d0*coupl(    &
                        nGC_2)**2d0 - 4d0*coupl(nGC_49)**2d0)/(64d0*pi**2d0*Nc)
      coupl(nGC_6433) = coupl(nGC_4372) + coupl(nGC_6431)
      coupl(nGC_6432) = coupl(nGC_MI)*dZdR_QCD2
      coupl(nGC_4114) = coupl(nGC_17)**2d0*coupl(nGC_52)*sq2**2d0*(Nc**2d0 -   &
                        1d0)/(32d0*pi**2d0*Nc)
      coupl(nGC_4115) = coupl(nGC_17)**2d0*coupl(nGC_48)*sq2**2d0*(Nc**2d0 -   &
                        1d0)/(32d0*pi**2d0*Nc)
      coupl(nGC_4116) = coupl(nGC_17)**2d0*sq2**2d0*(-cMB*coupl(nGC_130) - cMC*&
                        coupl(nGC_133) - cMD*coupl(nGC_137) - cMS*coupl(nGC_148&
                        ) - cMT*coupl(nGC_151) - cMU*coupl(nGC_159))/(16d0*pi**&
                        2d0)
      coupl(nGC_4117) = coupl(nGC_17)**2d0*sq2**2d0*(cMB*coupl(nGC_130) + cMC* &
                        coupl(nGC_133) + cMD*coupl(nGC_137) + cMS*coupl(nGC_148&
                        ) + cMT*coupl(nGC_151) + cMU*coupl(nGC_159))/(16d0*pi**&
                        2d0*Nc)
      coupl(nGC_4110) = coupl(nGC_17)**2d0*coupl(nGC_2)*sq2**2d0*(Nc**2d0 - 1d0&
                        )/(32d0*pi**2d0*Nc)
      coupl(nGC_4111) = coupl(nGC_1)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                        )/(32d0*pi**2d0*Nc)
      coupl(nGC_4112) = coupl(nGC_17)**2d0*coupl(nGC_53)*sq2**2d0*(Nc**2d0 -   &
                        1d0)/(32d0*pi**2d0*Nc)
      coupl(nGC_4113) = coupl(nGC_17)**2d0*coupl(nGC_49)*sq2**2d0*(Nc**2d0 -   &
                        1d0)/(32d0*pi**2d0*Nc)
      coupl(nGC_7098) = -coupl(nGC_4144)
      coupl(nGC_6140) = coupl(nGC_6087) + coupl(nGC_6138)
      coupl(nGC_6147) = coupl(nGC_MB)*(dZbL_QCD2 + dZbR_QCD2)/2d0
      coupl(nGC_6146) = coupl(nGC_MI)*dZbL_QCD2
      coupl(nGC_6149) = coupl(nGC_MI)*dZbR_QCD2
      coupl(nGC_6263) = coupl(nGC_MI)*dZcL_QCD2
      coupl(nGC_6264) = coupl(nGC_MC)*(dZcL_QCD2 + dZcR_QCD2)/2d0
      coupl(nGC_6266) = coupl(nGC_MI)*dZcR_QCD2
      coupl(nGC_6267) = coupl(nGC_4373) + coupl(nGC_6264)
      coupl(nGC_4143) = coupl(nGC_17)*sq2*(4d0*coupl(nGC_1)**2d0 + coupl(      &
                        nGC_146)**2d0 + coupl(nGC_147)*coupl(nGC_295) + coupl( &
                        nGC_148)**2d0 + 4d0*coupl(nGC_48)**2d0)/(64d0*pi**2d0)
      coupl(nGC_4142) = coupl(nGC_17)*sq2*(4d0*coupl(nGC_1)**2d0 + coupl(      &
                        nGC_131)**2d0 + coupl(nGC_147)*coupl(nGC_295) + coupl( &
                        nGC_148)**2d0 + 4d0*coupl(nGC_31)**2d0 + 4d0*coupl(    &
                        nGC_52)**2d0)/(64d0*pi**2d0)
      coupl(nGC_4141) = coupl(nGC_17)*sq2*(-4d0*coupl(nGC_1)**2d0 - coupl(     &
                        nGC_146)**2d0 - coupl(nGC_147)*coupl(nGC_295) - coupl( &
                        nGC_148)**2d0 - 4d0*coupl(nGC_48)**2d0)/(64d0*pi**2d0* &
                        Nc)
      coupl(nGC_4140) = coupl(nGC_17)*sq2*(-4d0*coupl(nGC_1)**2d0 - coupl(     &
                        nGC_131)**2d0 - coupl(nGC_147)*coupl(nGC_295) - coupl( &
                        nGC_148)**2d0 - 4d0*coupl(nGC_31)**2d0 - 4d0*coupl(    &
                        nGC_52)**2d0)/(64d0*pi**2d0*Nc)
    end subroutine fill_CTcouplings_mdl5
end module fill_ctcouplings5
