!******************************************************************************!
!                                                                              !
!    tcVSV.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSV.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-05-07 19:53             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311, x312, x313, x314, x315, x316, x317,  &
                  x318, x319, x320, x321, x322, x323, x324, x325, x326, x327,  &
                  x328, x329, x330, x331, x332
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec
  contains
    subroutine treeVSV(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,   &
    VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSV0)
!       c0*(-P(-1,1)*P(-1,2)*P(1,3)*P(3,2) + P(-1,1)*P(-1,3)*P(1,2)*P(3,2) - P(-1
!       ,2)*P(-1,3)*P(1,2)*P(3,1))
!       Metric(1,3)*P(-1,1)*P(-1,2)**2*P(-1,3)*c1
!       c2*(-Epsilon(-1,-2,-3,1)*P(-1,1)*P(-2,2)*P(-3,3)*P(3,2) - Epsilon(-1,-2,1
!       ,3)*P(-1,1)*P(-2,2)*P(-3,2)*P(-3,3))
!       c3*(Epsilon(-1,-2,-3,3)*P(-1,1)*P(-2,2)*P(-3,3)*P(1,2) - Epsilon(-2,-3,1,
!       3)*P(-1,1)*P(-1,2)*P(-2,2)*P(-3,3))
        if (last) VB_last = .true.
        x0 = P1(0)*P2(0)
        x1 = P1(2)*w1(3) - P1(3)*w1(2)
        x2 = P1(1)*w1(2) - P1(2)*w1(1)
        x3 = P1(1)*w1(3) - P1(3)*w1(1)
        x4 = P2(1)*x1 - P2(2)*x3 + P2(3)*x2
        x5 = co(2)*x4
        x6 = P2(2)*w1(3) - P2(3)*w1(2)
        x7 = P2(1)*w1(2) - P2(2)*w1(1)
        x8 = P2(1)*w1(3) - P2(3)*w1(1)
        x9 = P2(1)*x6 - P2(2)*x8 + P2(3)*x7
        x10 = co(2)*x9
        x11 = P2(0)**2
        x12 = -P1(0)*w1(0) + P1(1)*w1(1) + P1(2)*w1(2) + P1(3)*w1(3)
        x13 = co(0)*x12
        x14 = -P2(0)*w1(0) + P2(1)*w1(1) + P2(2)*w1(2) + P2(3)*w1(3)
        x15 = co(0)*x11*x14
        x16 = P1(1)*P2(1)
        x17 = co(3)*x4
        x18 = P1(1)*P2(1)*co(3)
        x19 = P2(1)**2
        x20 = P2(2)**2
        x21 = P2(3)**2
        x22 = -x11 + x19 + x20 + x21
        x23 = P1(1)*co(2)*x6
        x24 = P1(2)*P2(2)
        x25 = P1(3)*P2(3)
        x26 = -x0 + x16 + x24 + x25
        x27 = co(3)*x14*(P1(2)*P2(3) - P1(3)*P2(2))
        x28 = P1(0)*w1(1)
        x29 = -P1(1)*w1(0) + x28
        x30 = P1(0)*w1(3)
        x31 = -P1(3)*w1(0) + x30
        x32 = P2(0)*x3 - P2(1)*x31 + P2(3)*x29
        x33 = P1(2)*P2(0)*co(2)
        x34 = P2(0)*w1(1) - P2(1)*w1(0)
        x35 = P2(0)*w1(3) - P2(3)*w1(0)
        x36 = P2(0)*x8 - P2(1)*x35 + P2(3)*x34
        x37 = P1(2)*P2(2)*co(3)
        x38 = P1(3)*P2(3)*co(3)
        x39 = P1(3)*co(2)*x22
        x40 = P1(3)*co(2)*x26
        x41 = P1(1)*P2(2)
        x42 = -P1(2)*P2(1) + x41
        x43 = P1(3)*co(3)*x14
        x44 = P1(1)**2
        x45 = P2(0)*co(0)*x14
        x46 = P1(2)**2
        x47 = P1(3)**2
        x48 = P1(0)*P2(0)*co(3)
        x49 = co(0)*x14*x19
        x50 = co(0)*x14*x20
        x51 = co(0)*x14*x21
        x52 = P1(1)*P2(0)
        x53 = P1(0)*w1(2)
        x54 = -P1(2)*w1(0) + x53
        x55 = P2(0)*x1 - P2(2)*x31 + P2(3)*x54
        x56 = co(2)*x55
        x57 = P2(0)*w1(2) - P2(2)*w1(0)
        x58 = P2(0)*x6 - P2(2)*x35 + P2(3)*x57
        x59 = co(2)*x58
        x60 = co(2)*x22
        x61 = P1(2)*x8
        x62 = co(2)*x26
        x63 = P1(1)*P2(3)
        x64 = -P1(3)*P2(1) + x63
        x65 = P1(2)*co(3)*x14
        x66 = P2(0)*x2 - P2(1)*x54 + P2(2)*x29
        x67 = P1(3)*P2(0)*co(2)
        x68 = P2(0)*x7 - P2(1)*x57 + P2(2)*x34
        x69 = P1(1)*P2(1)*co(1)*x22
        x70 = P1(1)*P2(1)*co(1)*x26
        x71 = co(1)*w1(0)*x22
        x72 = co(1)*w1(0)*x26
        x73 = P1(0)*co(0)*x14
        x74 = P1(2)*P2(2)*co(0)*x14
        x75 = P2(0)*co(0)*x12
        x76 = P1(0)*P2(1)
        x77 = P1(0)*co(2)*x22
        x78 = P1(0)*co(2)*x26
        x79 = co(3)*x58
        x80 = P1(2)*P2(1)*co(2)
        x81 = P1(0)*P2(2)
        x82 = -P1(2)*P2(0) + x81
        x83 = P2(1)*co(0)*x14
        x84 = P1(1)*x19
        x85 = co(0)*x14
        x86 = co(2)*x22*x35
        x87 = co(2)*x26*x35
        x88 = P1(0)*P2(3)
        x89 = P1(3)*P2(0)
        x90 = x88 - x89
        x91 = P1(3)*P2(1)*co(2)
        x92 = P1(0)**2
        x93 = P1(1)*co(0)*x14
        x94 = co(1)*x22
        x95 = P1(2)*P2(2)*w1(1)
        x96 = co(1)*x26
        x97 = P1(3)*P2(3)*w1(1)
        x98 = P2(0)*co(1)*x22
        x99 = P2(0)*co(1)*x26
        x100 = P1(2)*co(0)*x14
        x101 = P1(2)*P2(2)*co(0)*x12
        x102 = P1(3)*P2(3)*co(0)*x12
        x103 = P1(1)*co(3)*x14
        x104 = P1(2)*P2(2)*co(2)
        x105 = co(0)*x14*x44
        x106 = P1(0)*co(3)*x14
        x107 = P1(2)*x20
        x108 = P1(3)*P2(2)*co(2)
        x109 = -x52 + x76
        x110 = co(0)*x14*x92
        x111 = P1(2)*P2(2)*w1(2)
        x112 = P1(3)*P2(3)*w1(2)
        x113 = co(3)*x68
        x114 = P1(2)*P2(3)*co(2)
        x115 = P1(2)*x34
        x116 = P1(3)*P2(3)*x66
        x117 = P1(1)*x57
        x118 = P1(3)*x21
        x119 = P2(3)*co(0)*x12
        x120 = P1(2)*P2(2)*w1(3)
        x121 = P1(3)*P2(3)*w1(3)
        wout(0) = w2(0)*(P1(0)*x11*x13 + P1(0)*x15 - P1(0)*x49 - P1(0)*x50 - P1&
                  (0)*x51 - P1(0)*x74 + P1(1)*x27 + w1(0)*x69 + w1(0)*x70 + x0*&
                  x10 - x0*x17 + x0*x5 - x0*x71 - x0*x72 + x16*x17 - x16*x73 - &
                  x16*x75 + x17*x24 + x17*x25 + x18*x9 + x22*x23 + x23*x26 +   &
                  x24*x71 + x24*x72 - x24*x75 + x25*x71 + x25*x72 - x25*x73 -  &
                  x25*x75 + x32*x33 + x33*x36 + x37*x9 + x38*x9 + x39*x7 + x40*&
                  x7 + x42*x43 + x44*x45 + x45*x46 + x45*x47 - x48*x9 - x52*x56&
                   - x52*x59 - x60*x61 - x61*x62 - x64*x65 - x66*x67 - x67*x68)
        wout(1) = w2(0)*(P1(0)*x27 + P1(1)*x15 - P1(1)*x50 - P1(1)*x51 - P1(2)*&
                  x86 - P1(2)*x87 - P2(1)*x101 - P2(1)*x102 + w1(1)*x69 + w1(1 &
                  )*x70 - x0*x79 + x0*x93 + x10*x76 - x100*x41 - x13*x84 - x16*&
                  x56 - x16*x59 + x16*x79 + x18*x55 + x24*x79 + x25*x79 - x25* &
                  x93 - x28*x98 - x28*x99 + x32*x80 + x36*x80 + x37*x55 + x38* &
                  x55 + x39*x57 + x40*x57 + x43*x82 + x46*x83 + x47*x83 - x48* &
                  x55 + x5*x76 + x6*x77 + x6*x78 - x65*x90 - x66*x91 - x68*x91 &
                   + x75*x76 - x83*x92 - x84*x85 + x94*x95 + x94*x97 + x95*x96 &
                   + x96*x97)
        wout(2) = w2(0)*(-P1(1)*P2(1)*P2(2)*x13 + P1(1)*x86 + P1(1)*x87 + P1(2 &
                  )*x15 - P1(2)*x49 - P1(2)*x51 - P2(2)*x102 + P2(2)*x105 - P2(&
                  2)*x110 + P2(2)*x47*x85 + w1(2)*x69 + w1(2)*x70 + x0*x100 +  &
                  x10*x81 - x100*x16 - x100*x25 + x103*x90 + x104*x32 + x104*  &
                  x36 - x106*x64 - x107*x13 - x107*x85 - x108*x66 - x108*x68 - &
                  x109*x43 + x111*x94 + x111*x96 + x112*x94 + x112*x96 - x18*  &
                  x32 - x18*x36 - x32*x37 - x32*x38 + x32*x48 - x34*x39 - x34* &
                  x40 - x36*x37 - x36*x38 + x36*x48 - x41*x56 - x41*x59 + x5*  &
                  x81 - x53*x98 - x53*x99 + x75*x81 - x77*x8 - x78*x8)
        wout(3) = w2(0)*(-P1(1)*P1(3)*P2(1)*x85 + P1(3)*x15 - P1(3)*x49 - P1(3 &
                  )*x50 - P1(3)*x74 - P2(3)*x101 + P2(3)*x105 - P2(3)*x110 + P2&
                  (3)*x46*x85 - co(2)*x116 - co(2)*x25*x68 + co(3)*x116 + w1(3 &
                  )*x69 + w1(3)*x70 - x0*x113 + x0*x119 + x10*x88 - x103*x82 + &
                  x106*x42 + x109*x65 + x113*x16 + x113*x24 + x113*x25 + x114* &
                  x32 + x114*x36 + x115*x60 + x115*x62 - x117*x60 - x117*x62 - &
                  x118*x13 - x118*x85 - x119*x16 + x120*x94 + x120*x96 + x121* &
                  x94 + x121*x96 + x18*x66 - x30*x98 - x30*x99 + x37*x66 - x48*&
                  x66 + x5*x88 - x56*x63 - x59*x63 + x7*x77 + x7*x78 + x73*x89)
      case(VSV1)
!       P(1,3)*P(3,2)*c0
!       Metric(1,3)*P(-1,2)*P(-1,3)*c1
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*c2
        if (last) VB_last = .true.
        x0 = P1(1)*w1(3) - P1(3)*w1(1)
        x1 = P2(2)*co(2)
        x2 = P2(1)*w1(3)
        x3 = P2(3)*w1(1)
        x4 = x2 - x3
        x5 = P2(1)**2
        x6 = co(1)*x5
        x7 = P2(2)**2
        x8 = co(1)*w1(0)
        x9 = P2(3)**2
        x10 = co(1)*x9
        x11 = P1(2)*w1(3) - P1(3)*w1(2)
        x12 = P2(1)*co(2)
        x13 = P2(2)*w1(3)
        x14 = P2(3)*w1(2)
        x15 = x13 - x14
        x16 = P1(1)*w1(2) - P1(2)*w1(1)
        x17 = P2(3)*co(2)
        x18 = P2(1)*w1(2)
        x19 = P2(2)*w1(1)
        x20 = x18 - x19
        x21 = P2(0)**2
        x22 = w1(0)*x21
        x23 = P2(0)*w1(1)
        x24 = P1(1)*co(0)
        x25 = P1(1)*w1(0)
        x26 = P2(0)*w1(2)
        x27 = P1(2)*co(0)
        x28 = P2(2)*w1(0)
        x29 = P1(2)*co(1)
        x30 = P2(0)*w1(3)
        x31 = P1(3)*co(0)
        x32 = P1(3)*w1(0)
        x33 = P2(1)*co(0)
        x34 = P2(2)*co(0)
        x35 = P2(3)*co(0)
        x36 = P1(0)*co(0)
        x37 = P1(0)*w1(3)
        x38 = -x32 + x37
        x39 = P2(3)*w1(0)
        x40 = x30 - x39
        x41 = co(0)*w1(1)
        x42 = co(1)*w1(1)
        x43 = P2(0)*co(2)
        x44 = P1(0)*w1(2)
        x45 = -P1(2)*w1(0) + x44
        x46 = x26 - x28
        x47 = P1(1)*P2(1)
        x48 = P1(3)*co(1)
        x49 = P2(1)*w1(0)
        x50 = P2(0)*co(0)
        x51 = P1(0)*w1(1) - x25
        x52 = x23 - x49
        x53 = w1(2)*x7
        x54 = co(1)*w1(2)
        x55 = P1(1)*co(1)
        x56 = P2(2)*co(0)*w1(1)
        x57 = P2(2)*co(0)*w1(3)
        x58 = P2(0)*co(1)
        x59 = co(0)*w1(3)
        x60 = co(1)*w1(3)
        x61 = P1(3)*P2(3)
        wout(0) = -w2(0)*(-P1(0)*P2(0)*x8 - P2(0)*w1(0)*x36 + P2(1)*co(1)*x25  &
                   + P2(3)*co(1)*x32 - co(0)*x22 - co(1)*x22 + w1(0)*x10 + w1(0&
                  )*x6 + x0*x1 + x1*x4 - x11*x12 - x12*x15 - x16*x17 - x17*x20 &
                   + x23*x24 + x23*x33 + x26*x27 + x26*x34 + x28*x29 + x30*x31 &
                   + x30*x35 + x7*x8)
        wout(1) = -w2(0)*(-P1(0)*co(1)*x23 + w1(1)*x10 + w1(1)*x6 + x1*x38 + x1&
                  *x40 - x11*x43 - x15*x43 - x17*x45 - x17*x46 + x18*x27 + x18*&
                  x34 + x19*x29 + x2*x31 + x2*x35 - x21*x42 + x3*x48 - x36*x49 &
                   + x41*x47 + x41*x5 + x42*x47 + x42*x7 - x49*x50)
        wout(2) = -w2(0)*(P1(1)*x56 + P1(2)*P2(2)*x54 + P1(2)*w1(2)*x34 + P1(3 &
                  )*x57 + P2(1)*x56 + P2(3)*x57 + co(0)*x53 + co(1)*x53 + w1(2 &
                  )*x10 + w1(2)*x6 + x0*x43 - x12*x38 - x12*x40 + x14*x48 + x17&
                  *x51 + x17*x52 + x18*x55 - x21*x54 - x28*x36 - x28*x50 + x4* &
                  x43 - x44*x58)
        wout(3) = -w2(0)*(w1(3)*x6 - x1*x51 - x1*x52 + x12*x45 + x12*x46 + x13*&
                  x29 + x14*x27 + x14*x34 - x16*x43 + x2*x55 - x20*x43 - x21*  &
                  x60 + x24*x3 + x3*x33 - x36*x39 - x37*x58 - x39*x50 + x59*x61&
                   + x59*x9 + x60*x61 + x60*x7 + x60*x9)
      case(VSV2)
!       Metric(1,3)*c0
        if (last) VB_last = .true.
        wout = -co(0)*w1(:)*w2(0)
      case(VSV3)
!       c0*(-P(-1,1)*P(-1,2)*P(1,3)*P(3,2) + P(-1,1)*P(-1,3)*P(1,2)*P(3,2) - P(-1
!       ,2)*P(-1,3)*P(1,2)*P(3,1))
!       Metric(1,3)*P(-1,1)*P(-1,2)**2*P(-1,3)*c1
!       c2*(Epsilon(-1,-2,-3,3)*P(-1,1)*P(-2,2)*P(-3,3)*P(1,2) - Epsilon(-2,-3,1,
!       3)*P(-1,1)*P(-1,2)*P(-2,2)*P(-3,3))
        if (last) VB_last = .true.
        x0 = P2(1)**2
        x1 = -P2(0)*w1(0) + P2(1)*w1(1) + P2(2)*w1(2) + P2(3)*w1(3)
        x2 = P2(2)**2
        x3 = P1(0)*co(0)*x1
        x4 = P2(3)**2
        x5 = P1(1)*w1(3) - P1(3)*w1(1)
        x6 = P1(2)*w1(3) - P1(3)*w1(2)
        x7 = P1(1)*w1(2) - P1(2)*w1(1)
        x8 = -P2(1)*x6 + P2(2)*x5 - P2(3)*x7
        x9 = P1(1)*P2(1)*co(2)
        x10 = P1(1)*P2(1)
        x11 = P2(1)*w1(3) - P2(3)*w1(1)
        x12 = P2(2)*w1(3) - P2(3)*w1(2)
        x13 = P2(1)*w1(2) - P2(2)*w1(1)
        x14 = -P2(1)*x12 + P2(2)*x11 - P2(3)*x13
        x15 = co(2)*x14
        x16 = P1(2)*P2(2)*co(2)
        x17 = P1(3)*P2(3)
        x18 = co(2)*x8
        x19 = P1(0)*P2(0)
        x20 = P2(0)**2
        x21 = -P1(0)*w1(0) + P1(1)*w1(1) + P1(2)*w1(2) + P1(3)*w1(3)
        x22 = co(0)*x21
        x23 = P1(2)*P2(3)
        x24 = P1(3)*P2(2)
        x25 = P1(1)*co(2)*x1
        x26 = P1(3)*P2(1)
        x27 = P1(1)*P2(3)
        x28 = P1(2)*co(2)*x1
        x29 = P1(1)*P2(2)
        x30 = P1(2)*P2(1)
        x31 = P1(3)*co(2)*x1
        x32 = P1(1)**2*co(0)*x1
        x33 = P1(2)**2
        x34 = co(0)*x1*x33
        x35 = P1(3)**2
        x36 = co(0)*x1*x35
        x37 = P1(2)*P2(2)
        x38 = x0 + x2 - x20 + x4
        x39 = co(1)*w1(0)*x38
        x40 = x10 + x17 - x19 + x37
        x41 = co(1)*w1(0)*x40
        x42 = P1(1)*P2(1)*co(0)*x21
        x43 = P2(0)*co(0)*x21
        x44 = P1(3)*P2(3)*co(0)*x21
        x45 = P1(1)*P2(1)*co(1)*x38
        x46 = P1(2)*P2(2)*co(1)*w1(0)
        x47 = P1(0)*co(2)*x1
        x48 = P1(0)*w1(3)
        x49 = -P1(3)*w1(0) + x48
        x50 = P1(0)*w1(2)
        x51 = -P1(2)*w1(0) + x50
        x52 = -P2(0)*x6 + P2(2)*x49 - P2(3)*x51
        x53 = co(2)*x52
        x54 = P2(0)*w1(3) - P2(3)*w1(0)
        x55 = P2(0)*w1(2) - P2(2)*w1(0)
        x56 = -P2(0)*x12 + P2(2)*x54 - P2(3)*x55
        x57 = P1(1)*co(0)*x0
        x58 = co(0)*x1*x2
        x59 = co(0)*x1*x4
        x60 = P1(3)*P2(0)
        x61 = P1(0)*P2(3) - x60
        x62 = P1(3)*P2(3)*co(2)
        x63 = P1(0)**2
        x64 = P2(1)*co(0)*x1
        x65 = P1(0)*P2(0)*co(2)
        x66 = co(0)*x1*x20
        x67 = P1(0)*P2(2) - P1(2)*P2(0)
        x68 = co(1)*x38
        x69 = P1(0)*P2(0)*w1(1)
        x70 = co(1)*x40
        x71 = P1(2)*co(0)*x1
        x72 = P1(1)*co(0)*x1
        x73 = P1(2)*P2(2)*co(0)*x21
        x74 = P1(0)*P2(1)
        x75 = P1(1)*P2(1)*co(1)*x40
        x76 = co(1)*w1(1)*x38
        x77 = P1(2)*P2(2)*co(1)*x40
        x78 = P1(3)*P2(3)*co(1)*x40
        x79 = P1(0)*w1(1) - P1(1)*w1(0)
        x80 = P2(0)*x5 - P2(1)*x49 + P2(3)*x79
        x81 = P2(0)*w1(1) - P2(1)*w1(0)
        x82 = P2(0)*x11 - P2(1)*x54 + P2(3)*x81
        x83 = co(0)*x0*x1
        x84 = P1(2)*x2
        x85 = -P1(1)*P2(0) + x74
        x86 = co(0)*x1*x63
        x87 = P2(0)*co(1)*x38
        x88 = P2(0)*co(1)*x40
        x89 = P1(0)*P2(0)*co(0)*x21
        x90 = P1(3)*P2(3)*w1(2)
        x91 = -P2(0)*x7 + P2(1)*x51 - P2(2)*x79
        x92 = -P2(0)*x13 + P2(1)*x55 - P2(2)*x81
        x93 = P1(3)*co(0)*x1
        x94 = P1(2)*P2(2)*w1(3)
        wout(0) = -w2(0)*(P1(0)*co(0)*x0*x1 - P1(0)*x20*x22 - P2(0)*x32 - P2(0 &
                  )*x34 - P2(0)*x36 + P2(0)*x42 + P2(0)*x44 - w1(0)*x45 + x10* &
                  x15 + x10*x3 - x10*x41 + x14*x16 + x15*x17 - x15*x19 + x16*x8&
                   + x17*x18 + x17*x3 - x17*x39 - x17*x41 - x18*x19 + x19*x39  &
                   + x19*x41 + x2*x3 - x20*x3 - x25*(x23 - x24) - x28*(x26 -   &
                  x27) + x3*x37 + x3*x4 - x31*(x29 - x30) + x37*x43 - x38*x46  &
                   - x40*x46 + x8*x9)
        wout(1) = -w2(0)*(P1(1)*x58 + P1(1)*x59 - P1(1)*x66 + P2(1)*x44 + P2(1 &
                  )*x73 - w1(1)*x45 - w1(1)*x75 - w1(1)*x77 - w1(1)*x78 + x1*  &
                  x57 + x10*x53 + x16*x52 + x16*x56 + x17*x53 + x17*x72 - x17* &
                  x76 - x19*x53 - x19*x72 + x21*x57 + x28*x61 + x29*x71 - x31* &
                  x67 - x33*x64 - x35*x64 - x37*x76 - x43*x74 + x47*(-x23 + x24&
                  ) + x56*x62 - x56*x65 + x56*x9 + x63*x64 + x68*x69 + x69*x70)
        wout(2) = -w2(0)*(-P1(2)*P2(2)*w1(2)*x68 + P1(2)*x59 - P1(2)*x66 + P1(2&
                  )*x83 - P2(2)*x32 - P2(2)*x36 + P2(2)*x42 + P2(2)*x44 + P2(2 &
                  )*x86 - P2(2)*x89 + co(0)*x1*x84 - w1(2)*x45 - w1(2)*x75 - w1&
                  (2)*x77 + x10*x71 + x16*x80 + x16*x82 + x17*x71 - x19*x71 +  &
                  x22*x84 - x25*x61 + x31*x85 + x47*(-x26 + x27) + x50*x87 +   &
                  x50*x88 + x62*x80 + x62*x82 - x65*x80 - x65*x82 - x68*x90 -  &
                  x70*x90 + x80*x9 + x82*x9)
        wout(3) = -w2(0)*(-P1(3)*P2(3)*w1(3)*x68 + P1(3)*x22*x4 + P1(3)*x58 +  &
                  P1(3)*x59 - P1(3)*x66 + P1(3)*x83 - P2(3)*x32 - P2(3)*x34 +  &
                  P2(3)*x42 + P2(3)*x73 + P2(3)*x86 - P2(3)*x89 - w1(3)*x45 -  &
                  w1(3)*x75 - w1(3)*x78 + x10*x93 + x16*x91 + x16*x92 + x25*x67&
                   - x28*x85 - x3*x60 + x37*x93 + x47*(-x29 + x30) + x48*x87 + &
                  x48*x88 + x62*x91 + x62*x92 - x65*x91 - x65*x92 - x68*x94 -  &
                  x70*x94 + x9*x91 + x9*x92)
      case(VSV4)
!       c0*(P(1,2)*P(3,1) + P(1,3)*P(3,2))
!       c1*(-Metric(1,3)*P(-1,1)*P(-1,2) - Metric(1,3)*P(-1,2)*P(-1,3))
!       c2*(-Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2) - Epsilon(-1,-2,1,3)*P(-1,2)*P(-2
!       ,3))
        if (last) VB_last = .true.
        x0 = P2(1)*w1(3)
        x1 = P2(3)*w1(1)
        x2 = x0 - x1
        x3 = P1(2)*co(2)
        x4 = P1(2)*w1(3)
        x5 = P1(3)*w1(2)
        x6 = x4 - x5
        x7 = P2(1)*co(2)
        x8 = P2(2)*w1(3)
        x9 = P2(3)*w1(2)
        x10 = x8 - x9
        x11 = P1(1)*w1(2)
        x12 = P1(2)*w1(1)
        x13 = x11 - x12
        x14 = P2(3)*co(2)
        x15 = P2(1)*w1(2)
        x16 = P2(2)*w1(1)
        x17 = x15 - x16
        x18 = P2(0)**2
        x19 = w1(0)*x18
        x20 = P1(1)*co(2)
        x21 = P1(3)*co(2)
        x22 = P1(1)*w1(3)
        x23 = P1(3)*w1(1)
        x24 = x22 - x23
        x25 = P2(2)*co(2)
        x26 = P2(1)**2
        x27 = co(1)*x26
        x28 = P2(2)**2
        x29 = P2(3)**2
        x30 = co(1)*x29
        x31 = P2(0)*w1(1)
        x32 = P1(1)*co(0)
        x33 = P2(0)*w1(2)
        x34 = P1(2)*co(0)
        x35 = P2(0)*w1(3)
        x36 = P1(3)*co(0)
        x37 = P2(1)*co(0)
        x38 = P2(2)*co(0)
        x39 = P2(3)*co(0)
        x40 = P1(0)*w1(1)
        x41 = P1(0)*w1(2)
        x42 = P1(0)*w1(3)
        x43 = P2(3)*w1(0)
        x44 = x35 - x43
        x45 = P2(0)*co(2)
        x46 = P1(2)*w1(0)
        x47 = x41 - x46
        x48 = P2(2)*w1(0)
        x49 = x33 - x48
        x50 = co(1)*w1(1)
        x51 = P1(0)*co(2)
        x52 = P1(3)*w1(0)
        x53 = x42 - x52
        x54 = P1(1)*w1(0)
        x55 = P2(0)*co(0)
        x56 = P2(1)*w1(0)
        x57 = P1(0)*co(0)
        x58 = x40 - x54
        x59 = x31 - x56
        x60 = w1(2)*x28
        x61 = co(1)*w1(3)
        wout(0) = -w2(0)*(-co(0)*x19 - co(1)*w1(0)*x28 + co(1)*x19 - w1(0)*x27 &
                   - w1(0)*x30 - x10*x20 + x10*x7 + x13*x14 + x14*x17 - x17*x21&
                   - x2*x25 + x2*x3 - x24*x25 + x31*x32 + x31*x37 + x33*x34 +  &
                  x33*x38 + x35*x36 + x35*x39 - x37*x40 - x38*x41 - x39*x42 +  &
                  x6*x7)
        wout(1) = -w2(0)*(co(0)*w1(1)*x26 - w1(1)*x27 - w1(1)*x30 + x0*x36 + x0&
                  *x39 + x10*x45 - x10*x51 - x11*x38 + x14*x47 + x14*x49 + x15*&
                  x34 + x15*x38 + x18*x50 - x21*x49 - x22*x39 - x25*x44 - x25* &
                  x53 - x28*x50 + x3*x44 + x45*x6 + x54*x55 - x55*x56 - x56*x57&
                  )
        wout(2) = w2(0)*(-co(0)*x60 - co(1)*w1(2)*x18 + co(1)*x60 + w1(2)*x27  &
                   + w1(2)*x30 + x12*x37 + x14*x58 + x14*x59 - x16*x32 - x16*  &
                  x37 + x2*x45 - x2*x51 + x20*x44 - x21*x59 + x24*x45 - x36*x8 &
                   + x39*x4 - x39*x8 - x44*x7 - x46*x55 + x48*x55 + x48*x57 -  &
                  x53*x7)
        wout(3) = -w2(0)*(co(0)*w1(3)*x29 - w1(3)*x27 + x1*x32 + x1*x37 + x13* &
                  x45 + x17*x45 - x17*x51 + x18*x61 + x20*x49 - x23*x37 + x25* &
                  x58 + x25*x59 - x28*x61 - x29*x61 - x3*x59 + x34*x9 - x38*x5 &
                   + x38*x9 - x43*x55 - x43*x57 - x47*x7 - x49*x7 + x52*x55)
      case(VSV5)
!       P(1,2)*P(3,1)*c0
!       P(1,3)*P(3,2)*c1
!       -Metric(1,3)*P(-1,1)*P(-1,2)*c2
!       -Metric(1,3)*P(-1,2)*P(-1,3)*c3
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*c4
!       -Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*c5
        if (last) VB_last = .true.
        x0 = P2(2)*w1(3)
        x1 = P2(3)*w1(2)
        x2 = x0 - x1
        x3 = co(5)*x2
        x4 = P2(1)*w1(2)
        x5 = P2(2)*w1(1)
        x6 = x4 - x5
        x7 = P1(3)*co(5)
        x8 = P1(2)*w1(3)
        x9 = P1(3)*w1(2)
        x10 = x8 - x9
        x11 = P2(1)*co(4)
        x12 = P1(1)*w1(2)
        x13 = P1(2)*w1(1)
        x14 = x12 - x13
        x15 = P2(3)*co(4)
        x16 = P2(0)**2
        x17 = co(1)*w1(0)
        x18 = P2(1)**2
        x19 = co(3)*w1(0)
        x20 = P2(2)**2
        x21 = P2(3)**2
        x22 = P2(1)*w1(3)
        x23 = P2(3)*w1(1)
        x24 = x22 - x23
        x25 = P1(2)*co(5)
        x26 = P1(1)*w1(3)
        x27 = P1(3)*w1(1)
        x28 = x26 - x27
        x29 = P2(2)*co(4)
        x30 = P1(0)*P2(0)
        x31 = P1(0)*w1(1)
        x32 = P2(1)*co(0)
        x33 = P1(0)*w1(2)
        x34 = P2(2)*co(0)
        x35 = P1(0)*w1(3)
        x36 = P2(3)*co(0)
        x37 = P1(1)*P2(1)*w1(0)
        x38 = P2(2)*w1(0)
        x39 = P1(2)*co(3)
        x40 = P1(3)*P2(3)*w1(0)
        x41 = P2(0)*co(0)
        x42 = P2(0)*w1(1)
        x43 = P1(1)*co(1)
        x44 = P2(0)*co(1)*w1(2)
        x45 = P1(2)*co(2)
        x46 = P2(0)*w1(3)
        x47 = P1(3)*co(1)
        x48 = P2(1)*co(1)
        x49 = P2(3)*co(1)
        x50 = P2(0)*w1(2) - x38
        x51 = P2(0)*co(4)
        x52 = P1(2)*w1(0)
        x53 = x33 - x52
        x54 = w1(1)*x18
        x55 = co(3)*w1(1)
        x56 = P2(3)*w1(0)
        x57 = x46 - x56
        x58 = P1(3)*w1(0)
        x59 = x35 - x58
        x60 = co(3)*x16
        x61 = P1(0)*P2(0)*w1(1)
        x62 = P2(1)*w1(0)
        x63 = P1(0)*co(1)
        x64 = P1(1)*P2(1)
        x65 = P1(3)*co(3)
        x66 = P2(0)*co(1)
        x67 = P1(1)*w1(0)
        x68 = P1(1)*co(2)
        x69 = P2(1)*co(1)*w1(2)
        x70 = P1(3)*co(2)
        x71 = P1(0)*co(5)
        x72 = x42 - x62
        x73 = x31 - x67
        x74 = w1(2)*x20
        x75 = P1(1)*co(5)
        x76 = co(3)*w1(2)
        x77 = P1(0)*P2(0)*w1(2)
        x78 = P1(2)*w1(2)
        x79 = P1(1)*co(3)
        x80 = co(3)*w1(3)
        x81 = co(1)*w1(3)
        x82 = P1(0)*P2(0)*w1(3)
        x83 = P1(3)*P2(3)
        x84 = P2(3)*co(1)*w1(2)
        wout(0) = w2(0)*(-P1(0)*w1(0)*x41 + P1(1)*x3 - P1(2)*x44 - P2(2)*x44 + &
                  co(2)*w1(0)*x30 - co(2)*x37 - co(2)*x40 + co(3)*x37 + co(3)* &
                  x40 + x10*x11 + x11*x2 + x14*x15 + x15*x6 + x16*x17 - x16*x19&
                   + x17*x30 + x18*x19 + x19*x20 + x19*x21 - x19*x30 - x24*x25 &
                   - x24*x29 - x28*x29 + x31*x32 + x33*x34 + x35*x36 + x38*x39 &
                   - x38*x45 - x42*x43 - x42*x48 - x46*x47 - x46*x49 + x6*x7)
        wout(1) = w2(0)*(P1(0)*x3 - P1(1)*w1(1)*x48 - P1(2)*x69 - P2(1)*w1(1)* &
                  x68 - P2(2)*x69 + co(0)*w1(1)*x64 - co(1)*x54 + co(2)*x61 +  &
                  co(3)*x54 - co(3)*x61 - w1(1)*x60 + x10*x51 + x12*x34 + x15* &
                  x50 + x15*x53 + x2*x51 + x20*x55 + x21*x55 - x22*x47 - x22*  &
                  x49 + x23*x65 - x23*x70 - x25*x57 + x26*x36 - x29*x57 - x29* &
                  x59 + x39*x5 - x41*x67 - x45*x5 + x50*x7 + x55*x64 + x62*x63 &
                   + x62*x66)
        wout(2) = -w2(0)*(-P1(2)*P2(2)*x76 + P2(2)*co(1)*x78 + P2(2)*w1(2)*x45 &
                   + co(1)*x74 - co(2)*x77 - co(3)*x74 + co(3)*x77 + w1(2)*x60 &
                   + x0*x47 + x0*x49 - x1*x65 + x1*x70 - x11*x57 - x11*x59 -   &
                  x13*x32 + x15*x72 + x15*x73 - x18*x76 - x21*x76 + x24*x51 +  &
                  x24*x71 + x28*x51 - x34*x78 - x36*x8 - x38*x63 - x38*x66 + x4&
                  *x68 - x4*x79 + x41*x52 + x43*x5 + x48*x5 - x57*x75 + x7*x72)
        wout(3) = w2(0)*(-P1(2)*x84 + P1(3)*w1(3)*x36 - P2(2)*x84 - P2(3)*w1(3 &
                  )*x70 + co(2)*x82 - co(3)*x82 + x0*x39 - x0*x45 - x11*x50 -  &
                  x11*x53 + x14*x51 - x16*x80 + x18*x80 + x20*x80 + x21*x80 -  &
                  x21*x81 - x22*x68 + x22*x79 - x23*x43 - x23*x48 + x25*x72 +  &
                  x27*x32 + x29*x72 + x29*x73 + x34*x9 - x41*x58 - x50*x75 +   &
                  x51*x6 + x56*x63 + x56*x66 + x6*x71 + x80*x83 - x81*x83)
      case(VSV6)
!       P(1,2)*P(3,1)*c0
!       Metric(1,3)*P(-1,1)*P(-1,2)*c1
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*c2
        if (last) VB_last = .true.
        x0 = P2(1)*w1(3)
        x1 = P2(3)*w1(1)
        x2 = x0 - x1
        x3 = P2(2)*w1(3)
        x4 = P2(3)*w1(2)
        x5 = x3 - x4
        x6 = P1(1)*co(2)
        x7 = P2(1)*w1(2)
        x8 = P2(2)*w1(1)
        x9 = co(2)*(x7 - x8)
        x10 = P2(1)*co(0)*w1(1)
        x11 = P2(2)*co(0)*w1(2)
        x12 = P2(3)*co(0)*w1(3)
        x13 = P2(1)*w1(0)
        x14 = P1(1)*co(1)
        x15 = P2(2)*w1(0)
        x16 = P1(2)*co(1)
        x17 = P2(3)*w1(0)
        x18 = P1(3)*co(1)
        x19 = P2(0)*co(0)*w1(0)
        x20 = P1(0)*co(1)
        x21 = P2(0)*w1(3)
        x22 = co(2)*(-x17 + x21)
        x23 = P1(0)*co(2)
        x24 = P2(0)*w1(2)
        x25 = -x15 + x24
        x26 = P2(0)*w1(1)
        x27 = co(2)*(-x13 + x26)
        wout(0) = w2(0)*(P1(0)*x10 + P1(0)*x11 + P1(0)*x12 - P1(0)*x19 + P1(2)*&
                  co(2)*x2 - P1(3)*x9 - P2(0)*w1(0)*x20 + x13*x14 + x15*x16 +  &
                  x17*x18 - x5*x6)
        wout(1) = w2(0)*(P1(1)*x10 + P1(1)*x11 + P1(1)*x12 - P1(1)*x19 + P1(2)*&
                  x22 - P1(3)*co(2)*x25 + P2(1)*w1(1)*x14 + x1*x18 + x16*x8 -  &
                  x20*x26 - x23*x5)
        wout(2) = w2(0)*(-P1(1)*x22 + P1(2)*x10 + P1(2)*x11 + P1(2)*x12 - P1(2 &
                  )*x19 + P1(3)*x27 + P2(2)*w1(2)*x16 + x14*x7 + x18*x4 + x2*  &
                  x23 - x20*x24)
        wout(3) = w2(0)*(-P1(0)*x9 - P1(2)*x27 + P1(3)*x10 + P1(3)*x11 + P1(3)*&
                  x12 - P1(3)*x19 + P2(3)*w1(3)*x18 + x0*x14 + x16*x3 - x20*x21&
                   + x25*x6)
      case(VSV7)
!       c0*(-P(-1,1)*P(-1,2)*P(1,3)*P(3,2) + P(-1,1)*P(-1,3)*P(1,2)*P(3,2) - P(-1
!       ,2)*P(-1,3)*P(1,2)*P(3,1))
!       Metric(1,3)*P(-1,1)*P(-1,2)**2*P(-1,3)*c1
!       c2*(-Epsilon(-1,-2,-3,1)*P(-1,1)*P(-2,2)*P(-3,3)*P(3,2) - Epsilon(-1,-2,1
!       ,3)*P(-1,1)*P(-2,2)*P(-3,2)*P(-3,3))
        if (last) VB_last = .true.
        x0 = P1(2)*w1(3) - P1(3)*w1(2)
        x1 = P1(1)*w1(2) - P1(2)*w1(1)
        x2 = P1(1)*w1(3) - P1(3)*w1(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(0)*P2(0)*co(2)
        x5 = P2(2)*w1(3) - P2(3)*w1(2)
        x6 = P2(1)*w1(2) - P2(2)*w1(1)
        x7 = P2(1)*w1(3) - P2(3)*w1(1)
        x8 = P2(1)*x5 - P2(2)*x7 + P2(3)*x6
        x9 = P2(0)**2
        x10 = -P1(0)*w1(0) + P1(1)*w1(1) + P1(2)*w1(2) + P1(3)*w1(3)
        x11 = co(0)*x10
        x12 = -P2(0)*w1(0) + P2(1)*w1(1) + P2(2)*w1(2) + P2(3)*w1(3)
        x13 = co(0)*x12*x9
        x14 = P2(1)**2
        x15 = P2(2)**2
        x16 = P2(3)**2
        x17 = x14 + x15 + x16 - x9
        x18 = P1(1)*co(2)*x5
        x19 = P1(1)*P2(1)
        x20 = P1(2)*P2(2)
        x21 = P1(3)*P2(3)
        x22 = P1(0)*P2(0)
        x23 = x19 + x20 + x21 - x22
        x24 = P1(0)*w1(1)
        x25 = -P1(1)*w1(0) + x24
        x26 = P1(0)*w1(3)
        x27 = -P1(3)*w1(0) + x26
        x28 = P2(0)*x2 - P2(1)*x27 + P2(3)*x25
        x29 = P1(2)*x28
        x30 = P2(0)*co(2)
        x31 = P2(0)*w1(1) - P2(1)*w1(0)
        x32 = P2(0)*w1(3) - P2(3)*w1(0)
        x33 = P2(0)*x7 - P2(1)*x32 + P2(3)*x31
        x34 = P1(2)*x33
        x35 = P1(3)*co(2)*x17
        x36 = P1(3)*co(2)*x23
        x37 = P1(1)**2*co(0)*x12
        x38 = P1(2)**2
        x39 = P2(0)*co(0)*x12
        x40 = P1(3)**2
        x41 = co(0)*x12*x14
        x42 = co(0)*x12*x15
        x43 = co(0)*x12*x16
        x44 = P1(0)*w1(2)
        x45 = -P1(2)*w1(0) + x44
        x46 = P2(0)*x0 - P2(2)*x27 + P2(3)*x45
        x47 = P1(1)*co(2)*x46
        x48 = P2(0)*w1(2) - P2(2)*w1(0)
        x49 = P2(0)*x5 - P2(2)*x32 + P2(3)*x48
        x50 = P1(1)*x49
        x51 = P1(2)*co(2)*x17
        x52 = P1(2)*co(2)*x23
        x53 = P2(0)*x1 - P2(1)*x45 + P2(2)*x25
        x54 = P1(3)*P2(0)*co(2)
        x55 = P2(0)*x6 - P2(1)*x48 + P2(2)*x31
        x56 = P1(1)*P2(1)*co(1)*x17
        x57 = P1(1)*P2(1)*co(1)*x23
        x58 = P1(2)*P2(2)*co(1)*w1(0)
        x59 = co(1)*x17
        x60 = P1(3)*P2(3)*w1(0)
        x61 = co(1)*x23
        x62 = P1(1)*P2(1)*co(0)*x12
        x63 = P1(2)*P2(2)*co(0)*x12
        x64 = co(0)*x12
        x65 = P1(0)*P2(0)*w1(0)
        x66 = P1(1)*P2(1)*co(0)*x10
        x67 = P2(0)*co(0)*x10
        x68 = P2(1)*co(2)
        x69 = P1(0)*x3
        x70 = P1(0)*co(2)*x8
        x71 = P1(0)*co(2)*x17
        x72 = P1(0)*co(2)*x23
        x73 = P2(1)*co(0)*x12
        x74 = co(2)*x17*x32
        x75 = co(2)*x23*x32
        x76 = P1(3)*P2(1)*co(2)
        x77 = P1(0)**2
        x78 = P1(1)*co(0)*x12
        x79 = P2(1)*co(0)*x10
        x80 = P1(2)*P2(2)*w1(1)
        x81 = P1(3)*P2(3)*w1(1)
        x82 = P2(0)*co(1)*x17
        x83 = P2(0)*co(1)*x23
        x84 = P2(2)*co(2)
        x85 = P1(2)*P2(2)*co(2)
        x86 = P2(2)*co(0)*x12
        x87 = P1(2)*x15
        x88 = co(2)*x53
        x89 = P1(2)*co(0)*x12
        x90 = P2(2)*co(0)*x10
        x91 = P1(2)*P2(2)*w1(2)
        x92 = P1(3)*P2(3)*w1(2)
        x93 = P2(3)*co(2)
        x94 = P2(3)*co(0)*x12
        x95 = P1(1)*x48
        x96 = P1(3)*x16
        x97 = P2(3)*co(0)*x10
        x98 = P1(2)*P2(2)*w1(3)
        x99 = P1(3)*P2(3)*w1(3)
        wout(0) = w2(0)*(-P1(0)*P1(3)*P2(3)*x64 + P1(0)*x11*x9 + P1(0)*x13 - P1&
                  (0)*x41 - P1(0)*x42 - P1(0)*x43 - P1(0)*x62 - P1(0)*x63 + P2(&
                  0)*x37 - P2(0)*x47 - P2(0)*x66 + w1(0)*x56 + w1(0)*x57 + x17*&
                  x18 + x17*x58 + x18*x23 - x20*x67 - x21*x67 + x23*x58 + x29* &
                  x30 + x3*x4 + x30*x34 - x30*x50 + x35*x6 + x36*x6 + x38*x39  &
                   + x39*x40 + x4*x8 - x51*x7 - x52*x7 - x53*x54 - x54*x55 +   &
                  x59*x60 - x59*x65 + x60*x61 - x61*x65)
        wout(1) = w2(0)*(-P1(1)*co(0)*x10*x14 + P1(1)*x13 - P1(1)*x41 - P1(1)* &
                  x42 - P1(1)*x43 - P1(2)*x74 - P1(2)*x75 + P2(1)*x70 - co(2)* &
                  x19*x46 - co(2)*x19*x49 + w1(1)*x56 + w1(1)*x57 - x20*x78 -  &
                  x20*x79 - x21*x78 - x21*x79 + x22*x78 + x22*x79 - x24*x82 -  &
                  x24*x83 + x29*x68 + x34*x68 + x35*x48 + x36*x48 + x38*x73 +  &
                  x40*x73 + x5*x71 + x5*x72 - x53*x76 - x55*x76 + x59*x80 + x59&
                  *x81 + x61*x80 + x61*x81 + x68*x69 - x73*x77)
        wout(2) = w2(0)*(P1(1)*x74 + P1(1)*x75 + P1(2)*x13 - P1(2)*x41 - P1(2)*&
                  x43 - P1(3)*P2(2)*x88 - P1(3)*x55*x84 + P2(2)*x37 - P2(2)*x47&
                   - P2(2)*x66 + P2(2)*x70 + w1(2)*x56 + w1(2)*x57 - x11*x87 - &
                  x19*x89 - x21*x89 - x21*x90 + x22*x89 + x22*x90 + x28*x85 -  &
                  x31*x35 - x31*x36 + x33*x85 + x40*x86 - x44*x82 - x44*x83 -  &
                  x50*x84 + x59*x91 + x59*x92 + x61*x91 + x61*x92 - x64*x87 +  &
                  x69*x84 - x7*x71 - x7*x72 - x77*x86)
        wout(3) = w2(0)*(P1(0)*P1(3)*P2(0)*x64 + P1(3)*x13 - P1(3)*x41 - P1(3)*&
                  x42 - P1(3)*x62 - P1(3)*x63 + P2(3)*x37 - P2(3)*x47 - P2(3)* &
                  x66 + P2(3)*x70 - co(2)*x17*x95 - co(2)*x21*x55 - co(2)*x23* &
                  x95 + w1(3)*x56 + w1(3)*x57 - x11*x96 - x20*x97 - x21*x88 +  &
                  x22*x97 - x26*x82 - x26*x83 + x29*x93 + x31*x51 + x31*x52 +  &
                  x34*x93 + x38*x94 - x50*x93 + x59*x98 + x59*x99 + x6*x71 + x6&
                  *x72 + x61*x98 + x61*x99 - x64*x96 + x69*x93 - x77*x94)
      case(VSV8)
!       c0*(-P(1,2)*P(3,1) + P(1,3)*P(3,2))
!       c1*(Metric(1,3)*P(-1,1)*P(-1,2) - Metric(1,3)*P(-1,2)*P(-1,3))
!       c2*(Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2) - Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,
!       3))
        if (last) VB_last = .true.
        x0 = P2(2)*w1(3)
        x1 = P2(3)*w1(2)
        x2 = x0 - x1
        x3 = P1(1)*co(2)
        x4 = P2(1)*w1(2)
        x5 = P2(2)*w1(1)
        x6 = x4 - x5
        x7 = P1(3)*co(2)
        x8 = P1(2)*w1(3)
        x9 = P1(3)*w1(2)
        x10 = x8 - x9
        x11 = P2(1)*co(2)
        x12 = P1(1)*w1(2)
        x13 = P1(2)*w1(1)
        x14 = x12 - x13
        x15 = P2(3)*co(2)
        x16 = P2(0)**2
        x17 = w1(0)*x16
        x18 = P2(1)*w1(3)
        x19 = P2(3)*w1(1)
        x20 = x18 - x19
        x21 = P1(2)*co(2)
        x22 = P1(1)*w1(3)
        x23 = P1(3)*w1(1)
        x24 = x22 - x23
        x25 = P2(2)*co(2)
        x26 = P2(1)**2
        x27 = co(1)*x26
        x28 = P2(2)**2
        x29 = P2(3)**2
        x30 = co(1)*x29
        x31 = P1(0)*w1(1)
        x32 = P2(1)*co(0)
        x33 = P1(0)*w1(2)
        x34 = P2(2)*co(0)
        x35 = P1(0)*w1(3)
        x36 = P2(3)*co(0)
        x37 = P2(0)*w1(1)
        x38 = P1(1)*co(0)
        x39 = P2(0)*w1(2)
        x40 = P1(2)*co(0)
        x41 = P2(0)*w1(3)
        x42 = P1(3)*co(0)
        x43 = 2*P1(0)
        x44 = 2*co(1)
        x45 = P1(0)*co(2)
        x46 = P2(2)*w1(0)
        x47 = x39 - x46
        x48 = P2(0)*co(2)
        x49 = P1(2)*w1(0)
        x50 = x33 - x49
        x51 = co(0)*w1(1)
        x52 = co(1)*w1(1)
        x53 = P2(3)*w1(0)
        x54 = x41 - x53
        x55 = P1(3)*w1(0)
        x56 = x35 - x55
        x57 = P2(1)*w1(0)
        x58 = P1(0)*co(0)
        x59 = P1(1)*w1(0)
        x60 = P2(0)*co(0)
        x61 = 2*P1(1)*P2(1)
        x62 = 2*P1(2)*co(1)
        x63 = 2*P1(3)*co(1)
        x64 = 2*P1(0)*co(1)
        x65 = x37 - x57
        x66 = x31 - x59
        x67 = w1(2)*x28
        x68 = 2*P1(2)
        x69 = 2*P1(1)*co(1)
        x70 = co(0)*w1(3)
        x71 = co(1)*w1(3)
        x72 = 2*P1(3)*P2(3)
        wout(0) = -w2(0)*(-P1(1)*P2(1)*w1(0)*x44 - P1(2)*P2(2)*w1(0)*x44 - P1(3&
                  )*P2(3)*w1(0)*x44 - P2(0)*co(0)*w1(0)*x43 + P2(0)*co(1)*w1(0 &
                  )*x43 - co(0)*x17 - co(1)*w1(0)*x28 + co(1)*x17 - w1(0)*x27  &
                   - w1(0)*x30 + x10*x11 + x11*x2 + x14*x15 + x15*x6 + x2*x3 - &
                  x20*x21 - x20*x25 - x24*x25 + x31*x32 + x32*x37 + x33*x34 +  &
                  x34*x39 + x35*x36 + x36*x41 + x37*x38 + x39*x40 + x41*x42 +  &
                  x6*x7)
        wout(1) = -w2(0)*(-w1(1)*x27 - w1(1)*x30 + x10*x48 + x12*x34 + x15*x47 &
                   + x15*x50 + x16*x52 + x18*x36 + x18*x42 - x19*x63 + x2*x45  &
                   + x2*x48 - x21*x54 + x22*x36 - x25*x54 - x25*x56 + x26*x51  &
                   - x28*x52 + x34*x4 + x37*x64 + x4*x40 + x47*x7 - x5*x62 +   &
                  x51*x61 - x52*x61 - x57*x58 - x57*x60 - x59*x60)
        wout(2) = w2(0)*(-P2(2)*co(0)*w1(2)*x68 + P2(2)*co(1)*w1(2)*x68 - co(0 &
                  )*x67 - co(1)*w1(2)*x16 + co(1)*x67 + w1(2)*x27 + w1(2)*x30  &
                   - x0*x36 - x0*x42 + x1*x63 - x11*x54 - x11*x56 - x13*x32 +  &
                  x15*x65 + x15*x66 + x20*x45 + x20*x48 + x24*x48 - x3*x54 -   &
                  x32*x5 - x36*x8 - x38*x5 - x39*x64 + x4*x69 + x46*x58 + x46* &
                  x60 + x49*x60 + x65*x7)
        wout(3) = -w2(0)*(P1(0)*P2(0)*w1(3)*x44 - w1(3)*x27 - x0*x62 + x1*x34  &
                   + x1*x40 - x11*x47 - x11*x50 + x14*x48 + x16*x71 - x18*x69  &
                   + x19*x32 + x19*x38 + x21*x65 + x23*x32 + x25*x65 + x25*x66 &
                   - x28*x71 + x29*x70 - x29*x71 - x3*x47 + x34*x9 + x45*x6 +  &
                  x48*x6 - x53*x58 - x53*x60 - x55*x60 + x70*x72 - x71*x72)
      case(VSV9)
!       c0*(-P(-1,1)*P(-1,2)*P(1,3)*P(3,2) + P(-1,1)*P(-1,3)*P(1,2)*P(3,2) - P(-1
!       ,2)*P(-1,3)*P(1,2)*P(3,1))
!       Metric(1,3)*P(-1,1)*P(-1,2)**2*P(-1,3)*c1
        if (last) VB_last = .true.
        x0 = P2(1)**2
        x1 = -P2(0)*w1(0) + P2(1)*w1(1) + P2(2)*w1(2) + P2(3)*w1(3)
        x0vec = P1(:)*co(0)*x1
        x2 = P2(2)**2
        x3 = P2(3)**2
        x1vec = P2(:)*co(0)*x1
        x4 = P2(0)**2
        x5 = P1(0)*P2(0)
        x6 = x0 + x2 + x3 - x4
        x2vec = co(1)*w1(:)*x6
        x7 = P1(1)*P2(1)
        x8 = P1(2)*P2(2)
        x9 = P1(3)*P2(3)
        x10 = -x5 + x7 + x8 + x9
        x3vec = co(1)*w1(:)*x10
        x4vec = P2(:)*co(0)*(-P1(0)*w1(0) + P1(1)*w1(1) + P1(2)*w1(2) + P1(3)* &
        w1(3))
        x5vec = P1(2)*P2(2)*co(1)*w1(:)
        wout = -w2(0)*(P1(0)**2*x1vec - P1(1)**2*x1vec - P1(2)**2*x1vec - P1(3 &
               )**2*x1vec + x0*x0vec + x0vec*x2 + x0vec*x3 - x0vec*x4 - x0vec* &
               x5 + x0vec*x7 + x0vec*x8 + x0vec*x9 - x10*x5vec + x2vec*x5 -    &
               x2vec*x7 - x2vec*x9 + x3vec*x5 - x3vec*x7 - x3vec*x9 - x4vec*x5 &
                + x4vec*x7 + x4vec*x8 + x4vec*x9 - x5vec*x6)
      end select 
    end subroutine treeVSV
end module tcVSV
