!******************************************************************************!
!                                                                              !
!    tcVVV.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVV.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-05-07 19:53             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311, x312, x313, x314, x315, x316, x317,  &
                  x318, x319, x320, x321, x322, x323, x324, x325, x326, x327,  &
                  x328, x329, x330, x331, x332
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec
  contains
    subroutine treeVVV(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,   &
    VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVV0)
!       c0*(P(1,2)*P(2,3)*P(3,1) - P(1,3)*P(2,1)*P(3,2))
!       c1*(Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3,
!       1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) + Metric(1,3)*P(-1,2)*P(-1,3)*P(2
!       ,1) + Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(-2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*      
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*Epsilon(-1,-2
!       ,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + 2*Epsilon(-1,-2,1,2)*P 
!       (-1,2)*P(-2,3)*P(3,1) - 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) + 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) - 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(-Metric(1,3)*P(2,3) + Metric(2,3)*P(1,3))
!       Epsilon(-1,1,2,3)*P(-1,3)*c5
        if (last) VB_last = .true.
        x0 = w1(1)*w2(3)
        x1 = -w1(3)*w2(1) + x0
        x2 = P1(2)*x1
        x3 = P2(2)*x1
        x4 = w1(2)*w2(3)
        x5 = w1(3)*w2(2)
        x6 = x4 - x5
        x7 = P1(1)*x6
        x8 = w1(1)*w2(2)
        x9 = -w1(2)*w2(1) + x8
        x10 = P1(3)*x9
        x11 = P2(1)*x6
        x12 = P2(3)*x9
        x13 = x11 + x12 - x3
        x14 = P1(1)**2
        x15 = 2*co(3)*x14
        x16 = P1(2)**2
        x17 = 2*co(3)*x16
        x18 = P1(3)**2
        x19 = 2*co(3)*x18
        x20 = P1(0)**2
        x21 = 2*co(3)*x20
        x22 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x23 = P1(0)*x22
        x24 = P2(1)**2
        x25 = co(1)*x24
        x26 = P2(2)**2
        x27 = co(1)*x26
        x28 = P2(3)**2
        x29 = co(1)*x28
        x30 = P1(1)*w1(1)
        x31 = co(4)*w2(0)
        x32 = P1(2)*w2(0)
        x33 = co(4)*w1(2)
        x34 = P1(3)*w2(0)
        x35 = co(4)*w1(3)
        x36 = P2(1)*w2(0)
        x37 = co(4)*w1(1)
        x38 = P2(2)*w1(2)
        x39 = P2(3)*w2(0)
        x40 = P2(0)**2
        x41 = P1(1)*w2(1)
        x42 = P1(2)*w2(2)
        x43 = P1(3)*w2(3)
        x44 = P1(0)*w2(0)
        x45 = x41 + x42 + x43 - x44
        x46 = w1(0)*x40*x45
        x47 = P2(3)*w1(3)
        x48 = -P2(0)*w1(0) + P2(1)*w1(1) + x38 + x47
        x49 = co(1)*x14*x48
        x50 = co(1)*x16*x48
        x51 = co(1)*x18*x48
        x52 = w1(0)*w2(1)
        x53 = P1(1)*co(4)
        x54 = P1(2)*w1(0)
        x55 = co(4)*w2(2)
        x56 = co(4)*w1(0)
        x57 = P2(0)*co(1)*x22
        x58 = co(1)*x16*x22
        x59 = P2(1)*co(4)
        x60 = P2(2)*w1(0)
        x61 = P2(3)*w2(3)
        x62 = x24*x45
        x63 = co(1)*x26*x45
        x64 = co(1)*x28*x45
        x65 = co(1)*x20*x48
        x66 = 4*P1(1)*P2(1)*co(3)
        x67 = 4*co(3)*x48
        x68 = P2(2)*w2(3) - P2(3)*w2(2)
        x69 = P1(1)*x68
        x70 = P1(2)*P2(2)
        x71 = 4*co(3)*x13
        x72 = P1(3)*P2(3)
        x73 = P2(1)*w2(2) - P2(2)*w2(1)
        x74 = 4*P1(3)*co(3)*x48
        x75 = P1(0)*P2(1)
        x76 = P1(0)*x6
        x77 = w1(0)*w2(2) - w1(2)*w2(0)
        x78 = P1(3)*x77
        x79 = w1(3)*w2(0)
        x80 = w1(0)*w2(3) - x79
        x81 = P1(2)*x80
        x82 = x76 + x78 - x81
        x83 = 2*co(3)*x82
        x84 = P2(0)*x6
        x85 = P2(3)*x77
        x86 = P2(2)*x80
        x87 = x84 + x85 - x86
        x88 = 2*co(3)*x87
        x89 = P1(0)*P2(3)
        x90 = P1(0)*x9
        x91 = -w1(1)*w2(0) + x52
        x92 = P1(2)*x91
        x93 = P1(1)*x77
        x94 = x90 + x92 - x93
        x95 = 2*co(3)*x94
        x96 = P2(0)*x9
        x97 = P2(2)*x91
        x98 = P2(1)*x77
        x99 = x96 + x97 - x98
        x100 = 2*co(3)*x99
        x101 = P1(0)*w1(0)
        x102 = P1(2)*w2(3)
        x103 = P1(3)*w2(2)
        x104 = x102 - x103
        x105 = P1(1)*w2(2)
        x106 = P1(2)*w2(1)
        x107 = x105 - x106
        x108 = P1(1)*w2(3)
        x109 = P1(3)*w2(1)
        x110 = x108 - x109
        x111 = 2*co(2)*(P2(1)*x104 - P2(2)*x110 + P2(3)*x107)
        x112 = P2(1)*w2(3)
        x113 = P2(3)*w2(1)
        x114 = x112 - x113
        x115 = 2*co(2)*(P2(1)*x68 - P2(2)*x114 + P2(3)*x73)
        x116 = P1(2)*w1(3)
        x117 = P1(3)*w1(2)
        x118 = x116 - x117
        x119 = P2(1)*x118
        x120 = P1(1)*w1(2)
        x121 = P1(2)*w1(1)
        x122 = x120 - x121
        x123 = P2(3)*x122
        x124 = P1(1)*w1(3)
        x125 = P1(3)*w1(1)
        x126 = x124 - x125
        x127 = P2(2)*x126
        x128 = 2*co(2)*(x119 + x123 - x127)
        x129 = P2(2)*w1(3)
        x130 = P2(3)*w1(2)
        x131 = x129 - x130
        x132 = P2(1)*x131
        x133 = P2(1)*w1(2)
        x134 = P2(2)*w1(1)
        x135 = x133 - x134
        x136 = P2(3)*x135
        x137 = P2(3)*w1(1)
        x138 = P2(1)*w1(3) - x137
        x139 = P2(2)*x138
        x140 = 2*co(2)*(x132 + x136 - x139)
        x141 = P1(1)*P2(0)
        x142 = P1(1)*P2(1)
        x143 = x10 - x2 + x7
        x144 = 2*co(3)*x143
        x145 = 2*P1(1)*co(3)*x48
        x146 = 2*co(3)*x45
        x147 = P1(1)*x131
        x148 = P2(1)*w2(1)
        x149 = P2(0)*w2(0)
        x150 = P2(2)*w2(2) + x148 - x149 + x61
        x151 = 2*co(3)*x150
        x152 = P1(2)*w1(2)
        x153 = P1(3)*w1(3)
        x154 = -x101 + x152 + x153 + x30
        x155 = 2*co(3)*x154
        x156 = 2*co(3)*(x24 + x26 + x28 - x40)
        x157 = P1(0)*P2(0)
        x158 = 2*co(3)*(x142 - x157 + x70 + x72)
        x159 = P1(0)*w2(1)
        x160 = P1(1)*w2(0)
        x161 = x159 - x160
        x162 = P1(0)*w2(3)
        x163 = x162 - x34
        x164 = 2*co(2)*(P2(0)*x110 - P2(1)*x163 + P2(3)*x161)
        x165 = P2(0)*w2(1) - x36
        x166 = P2(0)*w2(3)
        x167 = x166 - x39
        x168 = 2*co(2)*(P2(0)*x114 - P2(1)*x167 + P2(3)*x165)
        x169 = P2(0)*x126
        x170 = P1(0)*w1(1)
        x171 = P1(1)*w1(0)
        x172 = x170 - x171
        x173 = P2(3)*x172
        x174 = P1(0)*w1(3)
        x175 = P1(3)*w1(0)
        x176 = x174 - x175
        x177 = P2(1)*x176
        x178 = 2*co(2)*(x169 + x173 - x177)
        x179 = P2(0)*x138
        x180 = P2(0)*w1(1)
        x181 = P2(1)*w1(0)
        x182 = x180 - x181
        x183 = P2(3)*x182
        x184 = P2(3)*w1(0)
        x185 = P2(0)*w1(3) - x184
        x186 = P2(1)*x185
        x187 = 2*co(2)*(x179 + x183 - x186)
        x188 = P1(1)*P2(3)
        x189 = P1(3)*P2(1)
        x190 = x188 - x189
        x191 = 2*P1(2)*co(2)*x22
        x192 = P1(3)*P2(0)
        x193 = 2*P1(3)*co(3)*x48
        x194 = 2*co(3)*x135*x45
        x195 = 2*P1(3)*co(3)*x150
        x196 = 2*P1(3)*co(3)*x154
        x197 = P1(0)*P2(2)
        x198 = P1(0)*x1
        x199 = P1(3)*x91
        x200 = P1(1)*x80
        x201 = x198 + x199 - x200
        x202 = 2*co(3)*x201
        x203 = P2(0)*x1
        x204 = P2(3)*x91
        x205 = P2(1)*x80
        x206 = x203 + x204 - x205
        x207 = 2*co(3)*x206
        x208 = P1(0)*w2(2)
        x209 = x208 - x32
        x210 = 2*co(2)*(P2(0)*x104 - P2(2)*x163 + P2(3)*x209)
        x211 = P2(0)*w2(2)
        x212 = -P2(2)*w2(0) + x211
        x213 = 2*co(2)*(P2(0)*x68 - P2(2)*x167 + P2(3)*x212)
        x214 = P2(0)*x118
        x215 = P1(0)*w1(2)
        x216 = x215 - x54
        x217 = P2(3)*x216
        x218 = P2(2)*x176
        x219 = 2*co(2)*(x214 + x217 - x218)
        x220 = P2(0)*x131
        x221 = P2(0)*w1(2) - x60
        x222 = P2(3)*x221
        x223 = P2(2)*x185
        x224 = 2*co(2)*(x220 + x222 - x223)
        x225 = P1(2)*P2(3)
        x226 = P1(3)*P2(2)
        x227 = x225 - x226
        x228 = 2*P1(1)*co(2)*x22
        x229 = P1(2)*P2(0)
        x230 = 2*P1(2)*co(3)*x48
        x231 = 2*P1(2)*co(3)*x45
        x232 = 2*P1(2)*co(3)*x150
        x233 = 2*P1(2)*co(3)*x154
        x234 = 2*co(2)*(P2(0)*x107 - P2(1)*x209 + P2(2)*x161)
        x235 = 2*co(2)*(P2(0)*x73 - P2(1)*x212 + P2(2)*x165)
        x236 = P2(0)*x122
        x237 = P2(2)*x172
        x238 = P2(1)*x216
        x239 = 2*co(2)*(x236 + x237 - x238)
        x240 = P2(0)*x135
        x241 = P2(2)*x182
        x242 = P2(1)*x221
        x243 = 2*co(2)*(x240 + x241 - x242)
        x244 = P1(1)*P2(2)
        x245 = P1(2)*P2(1)
        x246 = x244 - x245
        x247 = 2*P1(3)*co(2)*x22
        x248 = 4*P1(2)*co(3)*x48
        x249 = 6*co(3)
        x250 = 8*co(3)
        x251 = P1(0)*co(1)*x22
        x252 = co(0)*w1(0)*x150
        x253 = P1(0)*P2(0)*co(1)*x154
        x254 = P1(1)*co(0)*x45
        x255 = co(1)*w1(0)*x150
        x256 = w1(2)*x45
        x257 = co(0)*w1(3)*x45
        x258 = P2(1)*co(0)*x45
        x259 = P2(0)*co(0)*x45
        x260 = P1(0)*P2(1)*co(0)*w1(1)
        x261 = co(0)*x45
        x262 = P1(0)*P2(2)*w1(2)
        x263 = co(0)*x150
        x264 = P2(3)*co(0)*x45
        x265 = P2(3)*co(0)*x150
        x266 = P1(1)*co(1)*x154
        x267 = P1(2)*P2(2)*co(1)*x154
        x268 = P2(3)*co(1)*x22
        x269 = co(1)*x154
        x270 = P1(1)*x22
        x271 = co(4)*w2(1)
        x272 = P2(1)*co(1)*x22
        x273 = co(0)*w1(1)
        x274 = x40*x45
        x275 = co(1)*w1(1)
        x276 = co(1)*x22*x40
        x277 = P1(3)*co(4)
        x278 = P2(0)*co(4)
        x279 = P2(3)*co(4)
        x280 = 4*P1(0)*co(3)*x48
        x281 = 4*co(3)*x87
        x282 = 4*co(3)*x212*x48
        x283 = 2*P1(0)*co(3)*x48
        x284 = P1(0)*x131
        x285 = 2*P1(0)*co(3)*x154
        x286 = P1(2)*x22
        x287 = 2*co(2)*(-x192 + x89)
        x288 = 2*co(3)*x221*x45
        x289 = 2*co(3)*x13
        x290 = 2*P1(0)*co(2)*x22
        x291 = 2*co(3)*x150*x185
        x292 = x197 - x229
        x293 = 4*co(3)*x167*x48
        x294 = P1(1)*co(1)*x22
        x295 = co(0)*w1(0)*x45
        x296 = co(1)*w1(1)*x150
        x297 = P1(2)*co(0)*x45
        x298 = P2(2)*co(0)*x45
        x299 = P1(0)*P2(0)*co(1)*x22
        x300 = P1(1)*P2(1)*x150
        x301 = P1(1)*P2(2)*w1(2)
        x302 = co(1)*x22*x24
        x303 = P2(2)*co(1)*x22
        x304 = w1(2)*x26*x45
        x305 = co(1)*w2(2)*x48
        x306 = co(4)*w2(3)
        x307 = 4*co(3)*x206
        x308 = 2*P1(1)*co(3)*x154
        x309 = -x141 + x75
        x310 = P1(0)*x138
        x311 = P1(0)*x114
        x312 = P1(3)*x182
        x313 = P2(0)*co(1)*x154
        x314 = co(1)*x150
        x315 = P1(3)*co(1)*x22
        x316 = P1(2)*P2(2)*w1(2)
        x317 = P1(3)*co(0)*x45
        x318 = co(1)*w2(2)*x154
        x319 = P1(2)*P2(1)*w1(1)
        x320 = co(1)*w1(3)
        x321 = co(1)*w2(3)*x48
        x322 = 4*co(3)*x99
        x323 = 2*P1(3)*P2(2)*co(3)
        x324 = co(1)*w2(3)*x154
        wout(0) = P1(0)*P2(0)*x13*x250 + P1(0)*P2(0)*x143*x249 + P1(2)*P2(0)*co&
                  (0)*x256 - P1(3)*P2(3)*w2(0)*x269 - P1(3)*x194 - P2(0)*x58 - &
                  co(0)*x46 - co(1)*w1(0)*x62 + co(1)*x46 - co(5)*x10 - co(5)* &
                  x11 - co(5)*x12 + co(5)*x2 + co(5)*x3 - co(5)*x7 - w1(0)*x63 &
                   - w1(0)*x64 + w2(0)*x253 - w2(0)*x267 + w2(0)*x49 + w2(0)*  &
                  x50 + w2(0)*x51 - w2(0)*x65 - x10*x156 - x10*x158 - x100*x192&
                   - x100*x89 - x101*x111 - x101*x115 - x104*x145 - x107*x193  &
                   + x110*x230 + x114*x233 + x114*x248 + x119*x146 + x123*x146 &
                   - x127*x146 - x128*x44 - x13*x15 - x13*x17 - x13*x19 + x13* &
                  x21 - x13*x66 + x132*x146 - x135*x195 + x136*x146 + x138*x231&
                   + x138*x232 - x139*x146 - x14*x57 - x140*x44 - x141*x83 -   &
                  x141*x88 - x142*x144 + x142*x251 + x142*x255 - x142*x57 -    &
                  x144*x70 - x144*x72 - x146*x147 - x147*x151 - x150*x260 -    &
                  x155*x69 + x156*x2 - x156*x7 + x157*x252 - x157*x255 + x158* &
                  x2 - x158*x7 + x160*x219 + x160*x224 - x164*x54 - x168*x54 + &
                  x171*x210 + x171*x213 - x174*x264 - x174*x265 + x175*x234 +  &
                  x175*x235 - x178*x32 - x18*x57 + x180*x254 + x180*x258 - x187&
                  *x32 - x190*x191 + x192*x257 - x192*x268 - x192*x95 - x196*  &
                  x73 + x197*x202 + x197*x207 + x202*x229 + x207*x229 + x227*  &
                  x228 + x23*x25 + x23*x27 + x23*x29 + x239*x34 + x243*x34 +   &
                  x246*x247 + x251*x70 + x251*x72 + x255*x70 + x255*x72 + x259*&
                  x38 + x259*x47 - x260*x45 - x261*x262 - x262*x263 - x266*x36 &
                   + x30*x31 + x31*x38 + x32*x33 + x34*x35 + x35*x39 + x36*x37 &
                   - x43*x56 - x52*x53 - x52*x59 - x54*x55 - x55*x60 - x56*x61 &
                   - x57*x70 - x67*x69 - x70*x71 - x71*x72 - x73*x74 - x75*x83 &
                   - x75*x88 - x89*x95
        wout(1) = -P1(1)*P2(1)*x249*x82 - P1(1)*P2(1)*x250*x87 - P1(1)*x276 -  &
                  P1(1)*x299 + P1(2)*x291 + P1(2)*x293 - P1(3)*P2(3)*w2(1)*x269&
                   - P1(3)*x282 - P1(3)*x288 - P2(1)*x58 - P2(2)*co(4)*x8 - co(&
                  5)*x76 - co(5)*x78 + co(5)*x81 - co(5)*x84 - co(5)*x85 + co(5&
                  )*x86 - w1(1)*x63 - w1(1)*x64 + w2(1)*x253 - w2(1)*x267 + w2(&
                  1)*x49 + w2(1)*x50 + w2(1)*x51 - w2(1)*x65 - x0*x277 - x0*   &
                  x279 - x100*x188 - x100*x189 - x101*x258 - x101*x271 - x104* &
                  x283 - x106*x178 - x106*x187 + x109*x239 + x109*x243 - x111* &
                  x170 + x113*x35 - x115*x170 - x121*x164 - x121*x168 - x124*  &
                  x264 - x124*x265 + x125*x234 + x125*x235 - x128*x159 + x133* &
                  x297 + x133*x298 - x140*x159 + x141*x144 + x141*x252 + x141* &
                  x289 + x141*x295 + x142*x296 + x144*x75 + x146*x214 + x146*  &
                  x217 - x146*x218 + x146*x220 + x146*x222 - x146*x223 - x146* &
                  x284 - x148*x266 - x15*x87 - x151*x284 + x152*x271 + x153*   &
                  x258 + x153*x271 - x156*x76 - x156*x78 + x156*x81 + x157*x272&
                   + x157*x281 - x157*x296 + x157*x83 - x158*x76 - x158*x78 +  &
                  x158*x81 + x163*x230 + x167*x233 - x17*x87 - x18*x272 + x180*&
                  x31 - x181*x259 + x185*x231 - x188*x95 - x189*x95 - x19*x87  &
                   - x193*x209 - x195*x221 - x196*x212 + x20*x272 + x202*x244  &
                   + x202*x245 + x207*x244 + x207*x245 + x21*x87 + x210*x30 +  &
                  x213*x30 + x219*x41 + x224*x41 + x227*x290 + x247*x292 + x258&
                  *x47 - x261*x301 - x263*x301 + x27*x270 + x270*x29 + x271*x38&
                   - x272*x70 - x272*x72 - x273*x300 + x273*x62 + x274*x275 -  &
                  x275*x62 - x278*x52 - x280*x68 - x281*x70 - x281*x72 - x285* &
                  x68 - x286*x287 + x289*x75 + x294*x70 + x294*x72 + x296*x70  &
                   + x296*x72 - x37*x42 + x37*x44 - x70*x83 - x72*x83
        wout(2) = -P1(0)*P2(0)*w1(2)*x314 + P1(1)*P1(2)*P2(1)*co(1)*x22 + P1(1 &
                  )*P2(1)*w1(2)*x314 - P1(1)*x146*x185 - P1(1)*x291 - P1(1)*   &
                  x293 + P1(2)*P2(0)*w1(0)*x263 + P1(2)*P2(2)*x201*x249 + P1(2 &
                  )*P2(2)*x206*x250 - P1(2)*x276 - P1(2)*x299 + P1(2)*x302 + P1&
                  (3)*P2(3)*w1(2)*x314 + co(0)*x304 + co(1)*x256*x40 - co(1)*  &
                  x304 + co(5)*x198 + co(5)*x199 - co(5)*x200 + co(5)*x203 + co&
                  (5)*x204 - co(5)*x205 + w2(2)*x50 - x100*x225 - x100*x226 -  &
                  x101*x298 + x103*x239 + x103*x243 + x105*x219 + x105*x224 +  &
                  x110*x283 - x111*x215 - x115*x215 - x116*x264 - x116*x265 +  &
                  x117*x234 + x117*x235 + x120*x210 + x120*x213 - x120*x271 -  &
                  x128*x208 + x129*x264 + x129*x317 - x130*x306 - x133*x271 +  &
                  x134*x258 - x14*x303 + x14*x305 - x140*x208 + x142*x202 -    &
                  x142*x303 - x142*x318 + x144*x197 + x144*x229 - x145*x163 -  &
                  x146*x169 - x146*x173 + x146*x177 - x146*x179 - x146*x183 +  &
                  x146*x186 + x146*x310 + x146*x312 + x149*x33 + x15*x206 +    &
                  x151*x310 + x151*x312 - x152*x164 - x152*x168 + x155*x311 +  &
                  x156*x198 + x156*x199 - x156*x200 - x157*x202 + x157*x303 -  &
                  x157*x307 + x158*x198 + x158*x199 - x158*x200 + x161*x193 +  &
                  x165*x196 + x165*x74 - x167*x308 + x17*x206 - x178*x42 - x18*&
                  x303 + x18*x305 - x187*x42 + x19*x206 - x190*x290 + x197*x289&
                   + x20*x303 - x20*x305 + x202*x72 - x206*x21 + x206*x66 +    &
                  x208*x313 - x208*x56 - x211*x56 + x225*x315 - x225*x95 - x226&
                  *x95 + x229*x289 - x244*x83 - x244*x88 - x245*x83 - x245*x88 &
                   - x247*x309 - x25*x256 - x256*x29 + x259*x54 - x259*x60 -   &
                  x261*x319 - x263*x316 - x263*x319 + x270*x287 - x277*x4 +    &
                  x277*x5 + x279*x5 + x286*x29 + x298*x30 + x30*x55 - x303*x72 &
                   + x307*x72 + x311*x67 + x314*x316 - x318*x70 - x318*x72 +   &
                  x33*x44 + x59*x8
        wout(3) = -P1(0)*P2(0)*w1(3)*x314 - P1(0)*x135*x151 - P1(0)*x194 + P1(1&
                  )*x151*x221 + P1(1)*x282 + P1(1)*x288 + P1(2)*P2(2)*w1(3)*   &
                  x314 + P1(2)*co(4)*x4 - P1(3)*P2(1)*w1(1)*x263 - P1(3)*P2(2)*&
                  w1(2)*x263 + P1(3)*P2(3)*w1(3)*x314 - P1(3)*P2(3)*x249*x94 - &
                  P1(3)*P2(3)*x250*x99 + P1(3)*x22*x27 - P1(3)*x276 + P1(3)*   &
                  x302 - P2(3)*x58 - co(5)*x90 - co(5)*x92 + co(5)*x93 - co(5)*&
                  x96 - co(5)*x97 + co(5)*x98 - w1(3)*x64 + w2(3)*x50 + x0*x53 &
                   + x0*x59 - x101*x264 - x102*x178 - x102*x187 - x107*x283 +  &
                  x108*x219 + x108*x224 - x111*x174 - x112*x266 - x115*x174 -  &
                  x116*x164 - x116*x168 + x124*x210 + x124*x213 - x125*x258 -  &
                  x128*x162 - x129*x55 + x130*x297 + x130*x298 + x137*x254 +   &
                  x137*x258 - x14*x268 + x14*x321 - x140*x162 - x142*x268 +    &
                  x142*x315 - x142*x322 - x142*x95 + x144*x192 + x144*x89 +    &
                  x145*x209 + x146*x236 + x146*x237 - x146*x238 + x146*x240 +  &
                  x146*x241 - x146*x242 - x148*x35 - x15*x99 + x153*x234 + x153&
                  *x235 - x153*x265 - x156*x90 - x156*x92 + x156*x93 + x157*   &
                  x268 + x157*x322 + x157*x95 - x158*x90 - x158*x92 + x158*x93 &
                   - x161*x230 + x162*x313 - x162*x56 - x165*x233 - x165*x248  &
                   - x166*x56 - x17*x99 + x174*x31 + x18*x321 - x182*x231 -    &
                  x182*x232 - x184*x259 - x188*x83 - x188*x88 - x189*x83 - x189&
                  *x88 - x19*x99 + x191*x309 - x192*x251 + x192*x252 + x192*   &
                  x289 + x192*x295 + x20*x268 - x20*x321 + x201*x323 + x202*   &
                  x225 + x206*x323 + x207*x225 + x21*x99 + x212*x308 - x228*   &
                  x292 + x239*x43 + x243*x43 + x246*x290 + x257*x28 - x26*x320*&
                  x45 - x268*x70 + x274*x320 + x278*x79 - x280*x73 - x285*x73  &
                   + x289*x89 + x300*x320 + x306*x38 + x315*x70 - x317*x38 -   &
                  x320*x62 - x322*x70 - x324*x70 - x324*x72 - x35*x41 - x35*x42&
                   - x70*x95
      case(VVV1)
!       c0*(Metric(1,2)*P(3,1) - Metric(1,2)*P(3,2) - Metric(1,3)*P(2,1) + Metric
!       (1,3)*P(2,3) + Metric(2,3)*P(1,2) - Metric(2,3)*P(1,3))
        if (last) VB_last = .true.
        x0 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x0vec = w1(0)*w2(:)
        x1vec = w1(:)*w2(1)
        x2vec = w1(:)*w2(2)
        x3vec = w1(:)*w2(3)
        x4vec = w1(1)*w2(:)
        x5vec = w1(2)*w2(:)
        x6vec = w1(3)*w2(:)
        x7vec = w1(:)*w2(0)
        wout = co(0)*(P1(0)*x0vec - 2*P1(0)*x7vec + 2*P1(1)*x1vec - P1(1)*x4vec&
                + 2*P1(2)*x2vec - P1(2)*x5vec + 2*P1(3)*x3vec - P1(3)*x6vec -  &
               P1(:)*x0 + 2*P2(0)*x0vec - P2(0)*x7vec + P2(1)*x1vec - 2*P2(1)* &
               x4vec + P2(2)*x2vec - 2*P2(2)*x5vec + P2(3)*x3vec - 2*P2(3)*    &
               x6vec + P2(:)*x0)
      case(VVV2)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1) - Metric(2,3)*P(-1,1)*P(-1,3)*P(1
!       ,2))
!       c2*(Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + Epsilon(-1,-2,2,3)*P(-1,1
!       )*P(-2,3)*P(1,2))
        if (last) VB_last = .true.
        x0 = P1(3)*w2(2)
        x1 = P1(2)*w2(3) - x0
        x2 = P2(1)*w1(1)
        x3 = P2(2)*w1(2)
        x4 = P2(3)*w1(3)
        x5 = P2(0)*w1(0)
        x6 = x2 + x3 + x4 - x5
        x7 = P1(1)*co(2)*x6
        x8 = P2(2)*w2(3)
        x9 = -P2(3)*w2(2) + x8
        x10 = P1(2)*w2(1)
        x11 = P1(1)*w2(2) - x10
        x12 = P1(3)*co(2)*x6
        x13 = P2(1)*w2(2)
        x14 = -P2(2)*w2(1) + x13
        x15 = P1(2)*w1(3) - P1(3)*w1(2)
        x16 = P1(1)*w2(1)
        x17 = P1(2)*w2(2)
        x18 = P1(0)*w2(0)
        x19 = P1(3)*w2(3) + x16 + x17 - x18
        x20 = P2(1)*co(2)*x19
        x21 = P2(2)*w1(3)
        x22 = P2(3)*w1(2)
        x23 = x21 - x22
        x24 = P1(1)*w1(2) - P1(2)*w1(1)
        x25 = P2(3)*co(2)*x19
        x26 = P2(1)*w1(2)
        x27 = P2(2)*w1(1)
        x28 = x26 - x27
        x29 = co(0)*x19
        x30 = P2(0)**2
        x31 = w1(0)*x30
        x32 = P2(1)**2
        x33 = co(1)*w1(0)*x19
        x34 = P2(2)**2
        x35 = P2(3)**2
        x36 = P1(1)**2
        x37 = co(1)*w2(0)*x6
        x38 = P1(2)**2
        x39 = P1(3)**2
        x40 = P1(1)*w2(3) - P1(3)*w2(1)
        x41 = P1(2)*co(2)*x6
        x42 = P2(1)*w2(3)
        x43 = P2(3)*w2(1)
        x44 = x42 - x43
        x45 = P1(1)*w1(3) - P1(3)*w1(1)
        x46 = P2(2)*co(2)*x19
        x47 = P2(1)*w1(3)
        x48 = P2(3)*w1(1)
        x49 = x47 - x48
        x50 = co(1)*x19
        x51 = P1(0)**2*co(1)*x6
        x52 = P2(3)*w2(3)
        x53 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + x52
        x54 = P2(0)*co(0)*w1(0)*x53
        x55 = P1(1)*w2(0)
        x56 = P2(1)*co(1)*x6
        x57 = P2(2)*w1(0)
        x58 = P1(2)*co(1)*x19
        x59 = P2(2)*w2(0)
        x60 = P1(2)*co(1)*x6
        x61 = P1(3)*w2(0)
        x62 = P2(3)*co(1)*x6
        x63 = P1(0)*co(1)*x19
        x64 = P2(0)*co(1)*x6
        x65 = P1(0)*w1(1)
        x66 = P2(1)*co(0)*x19
        x67 = co(0)*x53
        x68 = P1(0)*w1(2)
        x69 = P2(2)*co(0)*x19
        x70 = P1(0)*P2(3)*w1(3)
        x71 = P2(0)*w1(1)
        x72 = P1(1)*co(0)*x19
        x73 = P2(0)*w1(2)
        x74 = P1(2)*co(0)*x19
        x75 = P2(0)*w1(3)
        x76 = P1(3)*co(0)*x19
        x77 = P2(0)*co(0)*x19
        x78 = P1(0)*co(0)*x19
        x79 = P1(0)*co(2)*x6
        x80 = P1(0)*w2(2)
        x81 = -P1(2)*w2(0) + x80
        x82 = P2(0)*w2(2) - x59
        x83 = P2(0)*co(2)*x19
        x84 = -P1(2)*w1(0) + x68
        x85 = -x57 + x73
        x86 = co(1)*w1(1)*x19
        x87 = co(1)*x36*x6
        x88 = co(1)*x38*x6
        x89 = co(1)*x39*x6
        x90 = P1(0)*w2(3)
        x91 = -x61 + x90
        x92 = P2(0)*w2(3) - P2(3)*w2(0)
        x93 = P1(0)*w1(3)
        x94 = P1(3)*w1(0)
        x95 = x93 - x94
        x96 = P2(3)*w1(0)
        x97 = x75 - x96
        x98 = P2(1)*w1(0)
        x99 = P1(1)*w1(0)
        x100 = P2(0)*co(0)*x53
        x101 = P1(1)*co(1)*x19
        x102 = P2(2)*co(1)*x6
        x103 = P1(3)*co(1)*x19
        x104 = P1(3)*co(1)*x6
        x105 = P1(0)*w2(1)
        x106 = P2(1)*co(0)*w1(1)*x53
        x107 = P2(2)*co(0)*w1(2)*x53
        x108 = P2(3)*co(0)*w1(3)*x53
        x109 = co(1)*w1(2)*x19
        x110 = x105 - x55
        x111 = P2(0)*w2(1) - P2(1)*w2(0)
        x112 = co(2)*x19*(x65 - x99)
        x113 = x71 - x98
        x114 = P1(1)*co(1)*x6
        x115 = P2(0)*co(1)*x19
        x116 = P2(2)*co(0)*w1(3)*x19
        x117 = co(1)*w1(3)*x19
        wout(0) = -P1(0)*P2(1)*w1(1)*x67 - P1(0)*P2(2)*w1(2)*x67 + P1(0)*x54 + &
                  P1(1)*P2(1)*w1(0)*x50 + P1(3)*P2(3)*w1(0)*x50 + 2*P2(0)*w1(0 &
                  )*x78 - w2(0)*x51 + x1*x7 + x11*x12 + x12*x14 + x15*x20 - x18&
                  *x64 + x20*x23 + x24*x25 + x25*x28 + x29*x31 - x29*x70 - x3* &
                  x77 - x31*x50 + x32*x33 + x33*x34 + x33*x35 + x36*x37 + x37* &
                  x38 + x37*x39 - x4*x77 - x40*x41 - x41*x44 - x45*x46 - x46*  &
                  x49 - x5*x63 + x55*x56 + x57*x58 + x59*x60 + x61*x62 - x65*  &
                  x66 - x66*x71 - x67*x70 - x68*x69 + x7*x9 - x71*x72 - x73*x74&
                   - x75*x76
        wout(1) = -P1(1)*x106 - P1(1)*x107 - P1(1)*x108 - 2*P2(1)*w1(1)*x72 -  &
                  w1(1)*x29*x32 - w2(1)*x51 + w2(1)*x87 + w2(1)*x88 + w2(1)*x89&
                   + x1*x79 + x10*x102 + x100*x99 + x101*x2 + x103*x48 + x104* &
                  x43 - x105*x64 + x12*x81 + x12*x82 + x15*x83 + x16*x56 + x23*&
                  x83 + x25*x84 + x25*x85 - x26*x69 - x26*x74 + x27*x58 - x3*  &
                  x72 - x30*x86 + x32*x86 + x34*x86 + x35*x86 - x4*x66 - x4*x72&
                   - x41*x91 - x41*x92 - x46*x95 - x46*x97 - x47*x76 + x5*x66  &
                   - x63*x71 + x77*x99 + x78*x98 + x79*x9
        wout(2) = -P1(2)*x106 - P1(2)*x107 - P1(2)*x108 + P1(2)*x54 - P1(3)*   &
                  x116 - 2*P2(2)*w1(2)*x74 - P2(3)*x112 - P2(3)*x116 - w1(2)*  &
                  x29*x34 - w2(2)*x51 + w2(2)*x87 + w2(2)*x88 + w2(2)*x89 + x0*&
                  x62 + x101*x26 + x102*x17 + x103*x22 - x109*x30 + x109*x32 + &
                  x109*x34 + x109*x35 - x110*x12 - x111*x12 - x113*x25 + x114* &
                  x13 - x115*x68 - x2*x74 + x20*x95 + x20*x97 - x27*x66 - x27* &
                  x72 + x3*x58 - x4*x74 - x40*x79 - x44*x79 - x45*x83 - x49*x83&
                   + x5*x74 + x57*x77 + x57*x78 - x64*x80 + x7*x91 + x7*x92
        wout(3) = -P1(3)*x106 - P1(3)*x107 - P1(3)*x108 + P2(2)*x112 - 2*P2(3)*&
                  w1(3)*x76 - w1(3)*x29*x35 - w2(3)*x51 + w2(3)*x87 + w2(3)*x88&
                   + w2(3)*x89 + x100*x94 + x101*x47 + x103*x4 + x104*x52 + x11&
                  *x79 + x110*x41 + x111*x41 + x113*x46 + x114*x42 - x115*x93  &
                   - x117*x30 + x117*x32 + x117*x34 + x117*x35 + x14*x79 - x2* &
                  x76 - x20*x84 - x20*x85 + x21*x58 - x22*x69 - x22*x74 + x24* &
                  x83 + x28*x83 - x3*x76 - x48*x66 - x48*x72 + x60*x8 - x64*x90&
                   - x7*x81 - x7*x82 + x77*x94 + x77*x96 + x78*x96
      case(VVV3)
!       c0*(P(1,2)*P(2,3)*P(3,1) - P(1,3)*P(2,1)*P(3,2))
!       c1*(Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3,
!       1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) + Metric(1,3)*P(-1,2)*P(-1,3)*P(2
!       ,1) + Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(-2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*      
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*Epsilon(-1,-2
!       ,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + 2*Epsilon(-1,-2,1,2)*P 
!       (-1,2)*P(-2,3)*P(3,1) - 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) + 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) - 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(Metric(1,2)*P(3,2) - Metric(2,3)*P(1,2))
!       c5*(-Metric(1,2)*P(3,1) + Metric(1,3)*P(2,1) - Metric(1,3)*P(2,3) +      
!       Metric(2,3)*P(1,3))
!       -Epsilon(-1,1,2,3)*P(-1,2)*c6
!       c7*(-Epsilon(-1,1,2,3)*P(-1,1) - Epsilon(-1,1,2,3)*P(-1,3))
        if (last) VB_last = .true.
        x0 = w1(3)*w2(3)
        x1 = w1(0)*w2(0)
        x2 = w1(1)*w2(1) + w1(2)*w2(2) + x0 - x1
        x3 = co(5)*x2
        x4 = w1(3)*w2(2)
        x5 = w1(2)*w2(3) - x4
        x6 = P2(1)*x5
        x7 = w1(1)*w2(3)
        x8 = -w1(3)*w2(1) + x7
        x9 = P2(2)*x8
        x10 = w1(1)*w2(2)
        x11 = -w1(2)*w2(1) + x10
        x12 = P2(3)*x11
        x13 = co(4)*x2
        x14 = x12 + x6 - x9
        x15 = P1(1)**2
        x16 = 2*co(3)*x15
        x17 = P1(2)**2
        x18 = 2*co(3)*x17
        x19 = P1(3)**2
        x20 = 2*co(3)*x19
        x21 = P1(0)**2
        x22 = 2*co(3)*x21
        x23 = P2(1)**2
        x24 = co(1)*x2*x23
        x25 = P2(2)**2
        x26 = co(1)*x2*x25
        x27 = P2(3)**2
        x28 = co(1)*x2*x27
        x29 = P1(1)*w2(0)
        x30 = co(5)*w1(1)
        x31 = P1(2)*w2(0)
        x32 = co(5)*w1(2)
        x33 = P1(3)*w1(3)
        x34 = co(5)*w2(0)
        x35 = P2(1)*w2(0)
        x36 = co(4)*w1(1)
        x37 = P2(2)*co(4)*w1(2)
        x38 = P2(2)*w1(2)
        x39 = P2(3)*w2(0)
        x40 = co(5)*w1(3)
        x41 = P2(0)**2
        x42 = P1(1)*w2(1)
        x43 = P1(2)*w2(2)
        x44 = P1(3)*w2(3)
        x45 = P1(0)*w2(0)
        x46 = x42 + x43 + x44 - x45
        x47 = w1(0)*x41*x46
        x48 = P2(3)*w1(3)
        x49 = -P2(0)*w1(0) + P2(1)*w1(1) + x38 + x48
        x50 = co(1)*x15*x49
        x51 = co(1)*x17*x49
        x52 = co(1)*x19*x49
        x53 = P2(0)*co(1)*x2
        x54 = co(1)*x17*x2
        x55 = P2(0)*co(4)
        x56 = w1(0)*w2(1)
        x57 = w1(0)*w2(2)
        x58 = P2(3)*w2(3)
        x59 = co(5)*w1(0)
        x60 = w1(0)*x46
        x61 = co(1)*x23
        x62 = co(1)*x25
        x63 = co(1)*x27
        x64 = co(1)*x21*x49
        x65 = 4*P1(1)*P2(1)*co(3)
        x66 = 4*co(3)*x49
        x67 = P2(2)*w2(3) - P2(3)*w2(2)
        x68 = P1(1)*x67
        x69 = P1(2)*P2(2)
        x70 = 4*co(3)*x14
        x71 = P1(3)*P2(3)
        x72 = P2(1)*w2(2) - P2(2)*w2(1)
        x73 = 4*P1(3)*co(3)*x49
        x74 = P1(0)*P2(1)
        x75 = P1(0)*x5
        x76 = -w1(2)*w2(0) + x57
        x77 = P1(3)*x76
        x78 = w1(3)*w2(0)
        x79 = w1(0)*w2(3) - x78
        x80 = P1(2)*x79
        x81 = x75 + x77 - x80
        x82 = 2*co(3)*x81
        x83 = P2(0)*x5
        x84 = P2(3)*x76
        x85 = P2(2)*x79
        x86 = x83 + x84 - x85
        x87 = 2*co(3)*x86
        x88 = P1(0)*P2(3)
        x89 = P1(0)*x11
        x90 = -w1(1)*w2(0) + x56
        x91 = P1(2)*x90
        x92 = P1(1)*x76
        x93 = x89 + x91 - x92
        x94 = 2*co(3)*x93
        x95 = P2(0)*x11
        x96 = P2(2)*x90
        x97 = P2(1)*x76
        x98 = x95 + x96 - x97
        x99 = 2*co(3)*x98
        x100 = P1(0)*w1(0)
        x101 = P1(2)*w2(3)
        x102 = P1(3)*w2(2)
        x103 = x101 - x102
        x104 = P1(1)*w2(2)
        x105 = P1(2)*w2(1)
        x106 = x104 - x105
        x107 = P1(1)*w2(3)
        x108 = P1(3)*w2(1)
        x109 = x107 - x108
        x110 = 2*co(2)*(P2(1)*x103 - P2(2)*x109 + P2(3)*x106)
        x111 = P2(1)*w2(3)
        x112 = -P2(3)*w2(1) + x111
        x113 = 2*co(2)*(P2(1)*x67 - P2(2)*x112 + P2(3)*x72)
        x114 = P1(2)*w1(3)
        x115 = P1(3)*w1(2)
        x116 = x114 - x115
        x117 = P2(1)*x116
        x118 = P1(1)*w1(2)
        x119 = P1(2)*w1(1)
        x120 = x118 - x119
        x121 = P2(3)*x120
        x122 = P1(1)*w1(3)
        x123 = P1(3)*w1(1)
        x124 = x122 - x123
        x125 = P2(2)*x124
        x126 = 2*co(2)*(x117 + x121 - x125)
        x127 = P2(2)*w1(3)
        x128 = P2(3)*w1(2)
        x129 = x127 - x128
        x130 = P2(1)*x129
        x131 = P2(1)*w1(2)
        x132 = P2(2)*w1(1)
        x133 = x131 - x132
        x134 = P2(3)*x133
        x135 = P2(3)*w1(1)
        x136 = P2(1)*w1(3) - x135
        x137 = P2(2)*x136
        x138 = 2*co(2)*(x130 + x134 - x137)
        x139 = P1(1)*P2(0)
        x140 = P1(1)*P2(1)
        x141 = P1(1)*x5
        x142 = P1(3)*x11
        x143 = P1(2)*x8
        x144 = x141 + x142 - x143
        x145 = 2*co(3)*x144
        x146 = 2*P1(1)*co(3)*x49
        x147 = 2*co(3)*x46
        x148 = P1(1)*x129
        x149 = P2(1)*w2(1)
        x150 = P2(0)*w2(0)
        x151 = P2(2)*w2(2) + x149 - x150 + x58
        x152 = 2*co(3)*x151
        x153 = P1(1)*w1(1)
        x154 = P1(2)*w1(2)
        x155 = -x100 + x153 + x154 + x33
        x156 = 2*co(3)*x155
        x157 = 2*co(3)*(x23 + x25 + x27 - x41)
        x158 = P1(0)*P2(0)
        x159 = 2*co(3)*(x140 - x158 + x69 + x71)
        x160 = P1(1)*co(5)
        x161 = P1(2)*w1(0)
        x162 = P1(0)*w2(1)
        x163 = x162 - x29
        x164 = P1(0)*w2(3)
        x165 = P1(3)*w2(0)
        x166 = x164 - x165
        x167 = 2*co(2)*(P2(0)*x109 - P2(1)*x166 + P2(3)*x163)
        x168 = P2(0)*w2(1) - x35
        x169 = P2(0)*w2(3) - x39
        x170 = 2*co(2)*(P2(0)*x112 - P2(1)*x169 + P2(3)*x168)
        x171 = P2(0)*x124
        x172 = P1(0)*w1(1)
        x173 = P1(1)*w1(0)
        x174 = x172 - x173
        x175 = P2(3)*x174
        x176 = P1(0)*w1(3)
        x177 = P1(3)*w1(0)
        x178 = x176 - x177
        x179 = P2(1)*x178
        x180 = 2*co(2)*(x171 + x175 - x179)
        x181 = P2(0)*x136
        x182 = P2(0)*w1(1)
        x183 = P2(1)*w1(0)
        x184 = x182 - x183
        x185 = P2(3)*x184
        x186 = P2(3)*w1(0)
        x187 = P2(0)*w1(3) - x186
        x188 = P2(1)*x187
        x189 = 2*co(2)*(x181 + x185 - x188)
        x190 = P1(1)*P2(3)
        x191 = P1(3)*P2(1)
        x192 = x190 - x191
        x193 = 2*P1(2)*co(2)*x2
        x194 = co(5)*w2(2)
        x195 = P1(3)*P2(0)
        x196 = 2*P1(3)*co(3)*x49
        x197 = 2*P1(3)*co(3)*x151
        x198 = 2*P1(3)*co(3)*x155
        x199 = co(5)*w2(3)
        x200 = P1(0)*P2(2)
        x201 = P1(0)*x8
        x202 = P1(3)*x90
        x203 = P1(1)*x79
        x204 = x201 + x202 - x203
        x205 = 2*co(3)*x204
        x206 = P2(0)*x8
        x207 = P2(3)*x90
        x208 = P2(1)*x79
        x209 = x206 + x207 - x208
        x210 = 2*co(3)*x209
        x211 = P1(0)*w2(2)
        x212 = x211 - x31
        x213 = 2*co(2)*(P2(0)*x103 - P2(2)*x166 + P2(3)*x212)
        x214 = P2(0)*w2(2) - P2(2)*w2(0)
        x215 = 2*co(2)*(P2(0)*x67 - P2(2)*x169 + P2(3)*x214)
        x216 = P2(0)*x116
        x217 = P1(0)*w1(2)
        x218 = -x161 + x217
        x219 = P2(3)*x218
        x220 = P2(2)*x178
        x221 = 2*co(2)*(x216 + x219 - x220)
        x222 = P2(0)*x129
        x223 = P2(2)*w1(0)
        x224 = P2(0)*w1(2) - x223
        x225 = P2(3)*x224
        x226 = P2(2)*x187
        x227 = 2*co(2)*(x222 + x225 - x226)
        x228 = P1(2)*P2(3)
        x229 = P1(3)*P2(2)
        x230 = x228 - x229
        x231 = 2*P1(1)*co(2)*x2
        x232 = P1(2)*P2(0)
        x233 = 2*P1(2)*co(3)*x49
        x234 = 2*P1(2)*co(3)*x46
        x235 = 2*P1(2)*co(3)*x151
        x236 = 2*P1(2)*co(3)*x155
        x237 = 2*co(2)*(P2(0)*x106 - P2(1)*x212 + P2(2)*x163)
        x238 = 2*co(2)*(P2(0)*x72 - P2(1)*x214 + P2(2)*x168)
        x239 = P2(0)*x120
        x240 = P2(2)*x174
        x241 = P2(1)*x218
        x242 = 2*co(2)*(x239 + x240 - x241)
        x243 = P2(0)*x133
        x244 = P2(2)*x184
        x245 = P2(1)*x224
        x246 = 2*co(2)*(x243 + x244 - x245)
        x247 = P1(1)*P2(2)
        x248 = P1(2)*P2(1)
        x249 = x247 - x248
        x250 = 2*P1(3)*co(2)*x2
        x251 = 4*P1(2)*co(3)*x49
        x252 = 6*co(3)
        x253 = 8*co(3)
        x254 = P1(0)*co(1)*x2
        x255 = co(0)*w1(0)*x151
        x256 = P1(0)*P2(0)*co(1)*x155
        x257 = P2(0)*co(0)*x46
        x258 = co(1)*w1(0)*x151
        x259 = w1(2)*x46
        x260 = co(0)*w1(3)*x46
        x261 = P2(1)*co(0)*x46
        x262 = co(0)*w1(1)*x46
        x263 = co(0)*x151
        x264 = co(0)*x46
        x265 = P1(0)*P2(2)*w1(2)
        x266 = P2(3)*co(0)*x46
        x267 = P2(3)*co(0)*x151
        x268 = co(1)*x155
        x269 = P1(2)*P2(2)*co(1)*x155
        x270 = P2(3)*co(1)*x2
        x271 = P1(3)*P2(3)*co(1)*x155
        x272 = co(5)*w2(1)
        x273 = P2(1)*co(1)*x2
        x274 = P2(3)*w1(3)*w2(1)
        x275 = w1(1)*x46
        x276 = co(1)*x41
        x277 = co(1)*x2*x41
        x278 = P2(0)*co(5)
        x279 = co(5)*w1(1)*w2(2)
        x280 = P2(3)*co(5)
        x281 = co(1)*x23*x46
        x282 = 4*P1(0)*co(3)*x49
        x283 = 4*co(3)*x86
        x284 = 4*co(3)*x214*x49
        x285 = 2*P1(0)*co(3)*x49
        x286 = 2*P1(0)*co(3)*x46
        x287 = 2*P1(0)*co(3)*x151
        x288 = 2*P1(0)*co(3)*x155
        x289 = 2*co(2)*x2*(-x195 + x88)
        x290 = 2*co(5)*w1(1)
        x291 = 2*co(3)*x224*x46
        x292 = P1(3)*co(5)
        x293 = 2*co(3)*x14
        x294 = 2*P1(0)*co(2)*x2
        x295 = 2*co(3)*x151*x187
        x296 = x200 - x232
        x297 = 4*co(3)*x169*x49
        x298 = P1(1)*co(1)*x2
        x299 = P1(1)*P2(0)*co(0)
        x300 = P1(1)*P2(1)*w1(1)*x151
        x301 = P1(2)*co(0)*x46
        x302 = co(1)*w1(1)*x151
        x303 = P2(2)*co(0)*x46
        x304 = P1(0)*P2(0)*co(1)*x2
        x305 = P1(1)*co(1)*x155
        x306 = P1(1)*P2(2)*w1(2)
        x307 = P2(2)*co(1)*x2
        x308 = P2(3)*co(4)
        x309 = w1(2)*x25*x46
        x310 = 4*co(3)*x209
        x311 = 2*P1(1)*co(3)*x155
        x312 = -x139 + x74
        x313 = co(5)*w1(2)*w2(3)
        x314 = P1(0)*x112
        x315 = P1(3)*x184
        x316 = P2(0)*co(1)*x155
        x317 = co(1)*x151
        x318 = P1(3)*co(1)*x2
        x319 = P1(2)*P2(2)*w1(2)
        x320 = P1(3)*co(0)*x46
        x321 = co(1)*w2(2)*x155
        x322 = P1(2)*co(0)*w1(1)
        x323 = P2(1)*x151
        x324 = w1(3)*x46
        x325 = P2(0)*w1(0)*w2(3)
        x326 = 4*co(3)*x98
        x327 = 2*co(5)*w1(3)
        x328 = 2*P1(3)*P2(2)*co(3)
        x329 = co(1)*w2(3)*x155
        wout(0) = P1(0)*P2(0)*x14*x253 + P1(0)*P2(0)*x144*x252 - P1(0)*P2(1)*w1&
                  (1)*x263 + P1(0)*co(5)*x1 + P1(0)*x24 + P1(0)*x26 + P1(0)*x28&
                   + P1(0)*x3 - P1(1)*P2(1)*w2(0)*x268 + P1(2)*P2(0)*co(0)*x259&
                   - 2*P1(2)*w1(0)*x194 - 2*P1(3)*w1(0)*x199 - P1(3)*x133*x147 &
                   - P2(0)*x13 - P2(0)*x54 - P2(1)*co(5)*x56 - P2(2)*co(5)*x57 &
                   - co(0)*x47 + co(1)*x47 + co(4)*w1(3)*x39 - co(6)*x12 - co(6&
                  )*x6 + co(6)*x9 + co(7)*x12 + co(7)*x6 - co(7)*x9 - 2*w1(0)* &
                  w2(1)*x160 + w2(0)*x256 - w2(0)*x269 - w2(0)*x271 + w2(0)*x37&
                   + w2(0)*x50 + w2(0)*x51 + w2(0)*x52 - w2(0)*x64 - x1*x55 -  &
                  x100*x110 - x100*x113 - x103*x146 - x106*x196 + x109*x233 +  &
                  x112*x236 + x112*x251 + x117*x147 + x121*x147 - x125*x147 -  &
                  x126*x45 + x130*x147 - x133*x197 + x134*x147 + x136*x234 +   &
                  x136*x235 - x137*x147 - x138*x45 - x139*x82 - x139*x87 - x14*&
                  x16 - x14*x18 - x14*x20 + x14*x22 - x14*x65 - x140*x145 +    &
                  x140*x254 + x140*x258 - x140*x53 - x141*x157 - x141*x159 -   &
                  x142*x157 - x142*x159 + x143*x157 + x143*x159 - x145*x69 -   &
                  x145*x71 - x147*x148 - x148*x152 - x15*x53 + x153*x257 - x156&
                  *x68 + x158*x255 - x158*x258 - x161*x167 - x161*x170 + x165* &
                  x242 + x165*x246 + x173*x213 + x173*x215 - x176*x266 - x176* &
                  x267 + x177*x237 + x177*x238 - x180*x31 + x182*x261 - x189*  &
                  x31 - x19*x53 - x192*x193 + x195*x260 - x195*x270 - x195*x94 &
                   - x195*x99 - x198*x72 + x200*x205 + x200*x210 + x205*x232 + &
                  x210*x232 + x221*x29 + x227*x29 + x230*x231 + x249*x250 +    &
                  x254*x69 + x254*x71 + x257*x38 + x257*x48 + x258*x69 + x258* &
                  x71 - x262*x74 - x263*x265 - x264*x265 + x29*x30 + x30*x35 + &
                  x31*x32 + x33*x34 + x34*x38 + x35*x36 + x39*x40 - x53*x69 -  &
                  x58*x59 - x60*x61 - x60*x62 - x60*x63 - x66*x68 - x69*x70 -  &
                  x70*x71 - x72*x73 - x74*x82 - x74*x87 - x88*x94 - x88*x99
        wout(1) = -P1(1)*P2(1)*x252*x81 - P1(1)*P2(1)*x253*x86 + P1(1)*x26 - P1&
                  (1)*x277 + P1(1)*x28 + P1(1)*x3 - P1(1)*x304 - P1(2)*x289 +  &
                  P1(2)*x295 + P1(2)*x297 - P1(3)*P2(3)*w2(1)*x268 - P1(3)*x284&
                   - P1(3)*x291 - P2(1)*x13 - P2(1)*x54 - P2(2)*x279 - co(0)*  &
                  x300 + co(1)*x300 + co(4)*x274 + co(5)*x274 - co(6)*x83 - co(&
                  6)*x84 + co(6)*x85 + co(7)*x83 + co(7)*x84 - co(7)*x85 + w1(0&
                  )*x151*x299 - 2*w1(1)*w2(3)*x292 - w1(1)*x281 + w2(1)*x256 - &
                  w2(1)*x269 + w2(1)*x37 + w2(1)*x50 + w2(1)*x51 + w2(1)*x52 - &
                  w2(1)*x64 - x100*x261 - x100*x272 - x103*x285 - x105*x180 -  &
                  x105*x189 + x108*x242 + x108*x246 - x110*x172 - x113*x172 -  &
                  x119*x167 - x119*x170 - x122*x266 - x122*x267 + x123*x237 +  &
                  x123*x238 - x126*x162 - x129*x286 - x129*x287 + x131*x301 +  &
                  x131*x303 - x138*x162 + x139*x145 + x139*x293 + x145*x74 +   &
                  x147*x216 + x147*x219 - x147*x220 + x147*x222 + x147*x225 -  &
                  x147*x226 - x149*x305 + x149*x36 + x153*x213 + x153*x215 -   &
                  x153*x272 + x154*x272 - x157*x75 - x157*x77 + x157*x80 + x158&
                  *x273 + x158*x283 - x158*x302 + x158*x82 - x159*x75 - x159*  &
                  x77 + x159*x80 - x16*x86 + x166*x233 + x169*x236 - x18*x86 + &
                  x182*x34 - x183*x257 + x187*x234 - x19*x273 - x190*x94 - x190&
                  *x99 - x191*x94 - x191*x99 - x196*x212 - x197*x224 - x198*   &
                  x214 - x20*x86 + x205*x247 + x205*x248 + x21*x273 + x210*x247&
                   + x210*x248 + x22*x86 + x221*x42 + x227*x42 + x23*x262 +    &
                  x230*x294 + x250*x296 + x261*x33 + x261*x48 - x263*x306 -    &
                  x264*x306 + x272*x33 + x272*x38 - x273*x69 - x273*x71 + x275*&
                  x276 - x275*x62 - x275*x63 - x278*x56 - x280*x7 - x282*x67 - &
                  x283*x69 - x283*x71 - x288*x67 - x290*x43 + x290*x45 + x293* &
                  x74 + x298*x69 + x298*x71 + x299*x60 + x302*x69 + x302*x71 - &
                  x55*x56 - x69*x82 - x71*x82
        wout(2) = -P1(0)*P2(0)*w1(2)*x317 + 2*P1(0)*w2(0)*x32 + P1(1)*P1(2)*P2(&
                  1)*co(1)*x2 + P1(1)*P2(1)*w1(2)*x317 - 2*P1(1)*w1(2)*x272 -  &
                  P1(1)*x147*x187 + P1(1)*x289 - P1(1)*x295 - P1(1)*x297 + P1(2&
                  )*P2(0)*w1(0)*x263 + P1(2)*P2(2)*x204*x252 + P1(2)*P2(2)*x209&
                  *x253 + P1(2)*x24 - P1(2)*x277 + P1(2)*x28 + P1(2)*x3 - P1(2 &
                  )*x304 + P1(3)*P2(3)*w1(2)*x317 - 2*P1(3)*x313 + P2(1)*co(4)*&
                  x10 + P2(1)*x279 - P2(1)*x322*x46 - P2(2)*x13 + co(0)*x309 - &
                  co(1)*x309 + co(6)*x206 + co(6)*x207 - co(6)*x208 - co(7)*   &
                  x206 - co(7)*x207 + co(7)*x208 - w2(2)*x271 + w2(2)*x37 + w2(&
                  2)*x50 + w2(2)*x51 + w2(2)*x52 - w2(2)*x64 - x100*x303 + x102&
                  *x242 + x102*x246 + x104*x221 + x104*x227 + x109*x285 - x110*&
                  x217 - x113*x217 - x114*x266 - x114*x267 + x115*x237 + x115* &
                  x238 + x118*x213 + x118*x215 - x126*x211 + x127*x266 + x127* &
                  x320 - x128*x199 - x131*x272 + x132*x261 + x136*x286 + x136* &
                  x287 - x138*x211 + x140*x205 - x140*x307 - x140*x321 + x145* &
                  x200 + x145*x232 - x146*x166 - x147*x171 - x147*x175 + x147* &
                  x179 - x147*x181 - x147*x185 + x147*x188 + x147*x315 - x15*  &
                  x307 + x150*x32 + x152*x315 + x153*x194 + x153*x303 - x154*  &
                  x167 - x154*x170 + x156*x314 + x157*x201 + x157*x202 - x157* &
                  x203 - x158*x205 + x158*x307 - x158*x310 + x159*x201 + x159* &
                  x202 - x159*x203 + x16*x209 + x161*x257 + x163*x196 + x168*  &
                  x198 + x168*x73 - x169*x311 + x18*x209 - x180*x43 - x189*x43 &
                   - x19*x307 - x192*x294 + x20*x209 + x200*x293 + x205*x71 -  &
                  x209*x22 + x209*x65 + x21*x307 + x211*x316 - x211*x59 - x223*&
                  x257 + x228*x318 - x228*x94 - x228*x99 - x229*x94 - x229*x99 &
                   + x232*x293 - x247*x82 - x247*x87 - x248*x82 - x248*x87 -   &
                  x250*x312 + x259*x276 - x259*x61 - x259*x63 - x263*x319 -    &
                  x278*x57 + x280*x4 + x292*x4 - x307*x71 + x308*x4 + x310*x71 &
                   + x314*x66 + x317*x319 - x32*x43 - x321*x69 - x322*x323 -   &
                  x55*x57
        wout(3) = -P1(0)*P2(0)*w1(3)*x317 + 2*P1(0)*w1(3)*x34 + P1(1)*P2(1)*w1(&
                  3)*x317 + P1(1)*x152*x224 + P1(1)*x284 + P1(1)*x291 + P1(2)* &
                  P2(2)*w1(3)*x317 + P1(2)*x313 + P1(3)*P2(0)*co(0)*x60 - P1(3 &
                  )*P2(2)*w1(2)*x263 + P1(3)*P2(3)*w1(3)*x317 - P1(3)*P2(3)*   &
                  x252*x93 - P1(3)*P2(3)*x253*x98 - P1(3)*co(0)*w1(1)*x323 + P1&
                  (3)*x24 + P1(3)*x26 - P1(3)*x277 + P1(3)*x3 - P2(3)*x13 - P2(&
                  3)*x54 - co(4)*x325 - co(5)*x325 - co(6)*x95 - co(6)*x96 + co&
                  (6)*x97 + co(7)*x95 + co(7)*x96 - co(7)*x97 - w1(3)*x281 + w2&
                  (3)*x37 + w2(3)*x50 + w2(3)*x51 + w2(3)*x52 - w2(3)*x64 - x0*&
                  x292 + x0*x308 - x100*x266 - x101*x180 - x101*x189 - x106*   &
                  x285 + x107*x221 + x107*x227 - x110*x176 + x111*x30 - x111*  &
                  x305 + x111*x36 - x113*x176 - x114*x167 - x114*x170 + x122*  &
                  x213 + x122*x215 - x123*x261 - x126*x164 - x127*x194 + x128* &
                  x301 + x128*x303 - x133*x286 - x133*x287 + x135*x261 - x138* &
                  x164 - x140*x270 + x140*x318 - x140*x326 - x140*x94 + x145*  &
                  x195 + x145*x88 + x146*x212 + x147*x239 + x147*x240 - x147*  &
                  x241 + x147*x243 + x147*x244 - x147*x245 - x149*x40 - x15*   &
                  x270 + x153*x266 - x157*x89 - x157*x91 + x157*x92 + x158*x270&
                   + x158*x326 + x158*x94 - x159*x89 - x159*x91 + x159*x92 -   &
                  x16*x98 + x160*x7 - x163*x233 + x164*x316 - x164*x59 - x168* &
                  x236 - x168*x251 - x18*x98 - x184*x234 - x184*x235 - x186*   &
                  x257 - x190*x82 - x190*x87 - x191*x82 - x191*x87 + x193*x312 &
                   - x195*x254 + x195*x255 + x195*x293 + x199*x38 - x20*x98 +  &
                  x204*x328 + x205*x228 + x209*x328 + x21*x270 + x210*x228 +   &
                  x214*x311 + x22*x98 - x231*x296 + x237*x33 + x238*x33 + x242*&
                  x44 + x246*x44 + x249*x294 + x260*x27 - x267*x33 - x270*x69  &
                   + x276*x324 + x278*x78 - x282*x72 - x288*x72 + x293*x88 +   &
                  x318*x69 - x320*x38 - x324*x62 - x324*x63 - x326*x69 - x327* &
                  x42 - x327*x43 - x329*x69 - x329*x71 - x69*x94
      case(VVV4)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2
!       ,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1) + Metric(2,3)*P(-1,1)*P(-1,2)*P(1,
!       3))
!       c3*(Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1) + Epsilon(-1,-2,2,3)*P(-1,1
!       )*P(-2,2)*P(1,3))
        if (last) VB_last = .true.
        x0 = P1(0)*co(3)
        x1 = w1(2)*w2(3) - w1(3)*w2(2)
        x2 = w1(1)*w2(2) - w1(2)*w2(1)
        x3 = w1(1)*w2(3) - w1(3)*w2(1)
        x4 = P2(0)*(P1(1)*x1 - P1(2)*x3 + P1(3)*x2)
        x5 = P2(0)*(P2(1)*x1 - P2(2)*x3 + P2(3)*x2)
        x6 = w1(0)*w2(1) - w1(1)*w2(0)
        x7 = w1(0)*w2(3) - w1(3)*w2(0)
        x8 = P2(2)*co(3)*(P1(0)*x3 - P1(1)*x7 + P1(3)*x6)
        x9 = P2(2)*co(3)*(P2(0)*x3 - P2(1)*x7 + P2(3)*x6)
        x10 = P2(0)**2
        x11 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x12 = P1(0)*co(2)*x11
        x13 = P2(2)*w2(3)
        x14 = P2(3)*w2(2)
        x15 = x13 - x14
        x16 = P1(1)*w1(1)
        x17 = P1(2)*w1(2)
        x18 = P1(3)*w1(3)
        x19 = P1(0)*w1(0)
        x20 = x16 + x17 + x18 - x19
        x21 = P1(1)*co(3)*x20
        x22 = P2(1)*w1(1)
        x23 = P2(2)*w1(2)
        x24 = P2(3)*w1(3)
        x25 = P2(0)*w1(0)
        x26 = x22 + x23 + x24 - x25
        x27 = P1(1)*co(3)*x26
        x28 = P2(1)*w2(2)
        x29 = P2(2)*w2(1)
        x30 = x28 - x29
        x31 = P1(3)*co(3)*x20
        x32 = P1(3)*co(3)*x26
        x33 = P1(1)**2
        x34 = P2(0)*co(1)*x11
        x35 = P1(2)**2
        x36 = co(1)*x11*x35
        x37 = P1(3)**2
        x38 = co(2)*x11
        x39 = P1(0)**2
        x40 = P2(0)*x39
        x41 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x42 = w1(0)*x10*x41
        x43 = P2(1)**2
        x44 = co(1)*x43
        x45 = w1(0)*x41
        x46 = P2(2)**2
        x47 = co(1)*x46
        x48 = P2(3)**2
        x49 = co(1)*x48
        x50 = co(1)*x26*x33
        x51 = co(1)*x26*x35
        x52 = co(1)*x26*x37
        x53 = w1(0)*w2(2) - w1(2)*w2(0)
        x54 = P2(1)*(P1(0)*x1 - P1(2)*x7 + P1(3)*x53)
        x55 = P2(1)*co(3)*(P2(0)*x1 - P2(2)*x7 + P2(3)*x53)
        x56 = P1(0)*x2 - P1(1)*x53 + P1(2)*x6
        x57 = P1(0)*P2(3)*co(3)
        x58 = P2(0)*x2 - P2(1)*x53 + P2(2)*x6
        x59 = co(1)*x10
        x60 = P2(1)*w2(3)
        x61 = P2(3)*w2(1)
        x62 = x60 - x61
        x63 = P1(2)*co(3)*x62
        x64 = co(1)*x11
        x65 = co(1)*x26*x39
        x66 = P2(1)*w2(1)
        x67 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x66
        x68 = co(0)*x67
        x69 = P1(0)*P2(0)*w1(0)
        x70 = co(2)*x20
        x71 = P1(0)*P2(0)*w2(0)
        x72 = co(2)*x26
        x73 = P1(1)*P2(1)*co(1)*x11
        x74 = P1(1)*P2(1)*co(1)*x67
        x75 = P2(1)*w2(0)
        x76 = P1(1)*co(1)*x26
        x77 = P1(2)*P2(2)*co(1)*x11
        x78 = P1(2)*P2(2)*co(1)*x67
        x79 = P2(2)*w2(0)
        x80 = P1(2)*co(1)*x26
        x81 = P2(3)*co(1)*x11
        x82 = P1(3)*P2(3)*co(1)*x67
        x83 = P2(3)*w2(0)
        x84 = P1(3)*co(1)*x26
        x85 = P1(1)*P2(1)
        x86 = P1(3)*P2(3)
        x87 = co(1)*x26
        x88 = P1(0)*co(0)*x41
        x89 = P2(1)*co(0)*w1(1)*x67
        x90 = P2(2)*co(0)*w1(2)*x67
        x91 = P2(3)*co(0)*w1(3)*x41
        x92 = P2(3)*co(0)*w1(3)*x67
        x93 = P2(0)*co(0)*x41
        x94 = P1(1)*co(2)*x20
        x95 = P1(1)*co(2)*x26
        x96 = P1(2)*co(2)*x20
        x97 = P1(2)*co(2)*x26
        x98 = P1(3)*co(2)*x20
        x99 = P1(3)*co(2)*x26
        x100 = 2*co(1)*x41
        x101 = 2*co(0)*x41
        x102 = 2*co(1)*w1(0)*x41
        x103 = 2*P1(2)*P2(2)*co(1)
        x104 = P1(0)*co(3)*x20
        x105 = P1(0)*co(3)*x26
        x106 = P1(1)*co(3)
        x107 = P1(1)*co(2)*x11
        x108 = P2(0)*w2(2)
        x109 = x108 - x79
        x110 = P2(1)*x33
        x111 = P2(1)*co(1)*x11
        x112 = w1(1)*x41
        x113 = P1(1)*P2(3)*co(3)
        x114 = P1(2)*co(3)
        x115 = P2(0)*w2(3)
        x116 = x115 - x83
        x117 = x116*x20
        x118 = x116*x26
        x119 = co(1)*x10*x41
        x120 = P1(0)*P2(0)*co(2)*x11
        x121 = P2(0)*w2(1)
        x122 = P1(0)*co(2)*x20
        x123 = P1(0)*co(2)*x26
        x124 = P2(1)*co(0)*x41
        x125 = P1(1)*co(0)*x41
        x126 = P2(0)*co(0)*w1(0)*x67
        x127 = co(1)*x67
        x128 = P1(1)*P2(1)*w1(1)
        x129 = P1(0)*P2(0)
        x130 = P1(0)*P2(0)*co(1)*x67
        x131 = P1(0)*co(1)*x26
        x132 = P1(2)*P2(2)*co(2)*x11
        x133 = 2*co(1)*w1(1)*x41
        x134 = P1(2)*co(2)*x11
        x135 = P2(2)*co(1)*x11
        x136 = w1(2)*x41
        x137 = w1(2)*x41*x46
        x138 = co(1)*w2(2)*x26
        x139 = P1(2)*P2(3)*co(3)
        x140 = x121 - x75
        x141 = P2(2)*co(0)*x41
        x142 = P1(2)*co(0)*x41
        x143 = P1(2)*P2(2)*w1(2)
        x144 = P1(2)*P2(2)*w2(2)
        x145 = 2*co(1)*w1(2)*x41
        x146 = P1(0)*co(3)*x30
        x147 = P1(2)*co(3)*x140
        x148 = P1(3)*co(3)
        x149 = P1(3)*co(2)*x11
        x150 = P2(3)*x37
        x151 = w1(3)*x41
        x152 = co(1)*w2(3)*x26
        x153 = P1(3)*P2(3)*co(3)
        x154 = P2(3)*co(0)*x41
        x155 = P1(3)*co(0)*x41
        x156 = P1(3)*P2(3)*w1(3)
        x157 = P1(3)*P2(3)*w2(3)
        x158 = 2*co(1)*w1(3)*x41
        wout(0) = -P1(0)*x11*x59 - P1(0)*x55 + P1(0)*x8 - P1(0)*x89 + P1(0)*x9 &
                   - P1(0)*x90 - P1(0)*x91 - P1(0)*x92 - P1(2)*P2(2)*x12 + P1(3&
                  )*P2(0)*x81 - P2(0)*co(1)*x19*x67 + P2(0)*x36 + P2(0)*x73 +  &
                  P2(0)*x77 - P2(0)*x91 + co(0)*x42 - co(1)*x42 + w1(0)*x74 +  &
                  w1(0)*x78 + w1(0)*x82 + w2(0)*x50 + w2(0)*x51 + w2(0)*x52 -  &
                  w2(0)*x65 + x0*x4 + x0*x5 - x0*x54 + x10*x12 - x100*x69 +    &
                  x101*x69 + x102*x85 + x102*x86 + x103*x45 - x12*x43 - x12*x46&
                   - x12*x48 - x12*x85 - x12*x86 + x15*x21 + x15*x27 - x16*x93 &
                   - x17*x93 - x18*x93 - x20*x63 - x22*x88 - x22*x93 - x23*x88 &
                   - x23*x93 - x26*x63 + x30*x31 + x30*x32 + x33*x34 + x34*x37 &
                   + x38*x40 - x40*x64 + x44*x45 + x45*x47 + x45*x49 - x56*x57 &
                   - x57*x58 + x68*x69 + x70*x71 + x71*x72 - x71*x87 + x75*x76 &
                   - x75*x94 - x75*x95 + x79*x80 - x79*x96 - x79*x97 + x83*x84 &
                   - x83*x98 - x83*x99
        wout(1) = P1(1)*x11*x44 + P1(1)*x120 + P1(1)*x126 - P1(1)*x132 - P1(1)*&
                  x55 + P1(1)*x8 + P1(1)*x9 - P1(1)*x90 - P1(1)*x91 - P1(1)*x92&
                   + P2(1)*x36 + P2(1)*x77 - co(0)*x112*x43 - w1(1)*x119 - w1(1&
                  )*x130 + w1(1)*x78 + w1(1)*x82 + w2(1)*x50 + w2(1)*x51 + w2(1&
                  )*x52 - w2(1)*x65 + x10*x107 + x100*x128 - x101*x128 + x103* &
                  x112 + x104*x15 + x105*x15 + x106*x4 + x106*x5 - x106*x54 -  &
                  x107*x43 - x107*x46 - x107*x48 - x107*x86 + x109*x31 + x109* &
                  x32 - x110*x38 + x110*x64 - x111*x129 + x111*x37 - x111*x39  &
                   + x111*x86 + x112*x44 + x112*x47 + x112*x49 - x113*x56 -    &
                  x113*x58 - x114*x117 - x114*x118 + x121*x122 + x121*x123 -   &
                  x121*x131 - x124*x17 - x124*x18 + x124*x19 - x124*x23 - x124*&
                  x24 + x124*x25 - x125*x23 + x125*x25 + x127*x128 - x128*x68  &
                   - x129*x133 + x133*x86 + x29*x80 - x29*x96 - x29*x97 + x61* &
                  x84 - x61*x98 - x61*x99 + x66*x76 - x66*x94 - x66*x95
        wout(2) = P1(1)*P2(1)*P2(2)*co(1)*x11 + P1(2)*x11*x47 + P1(2)*x120 + P1&
                  (2)*x126 - P1(2)*x55 + P1(2)*x8 - P1(2)*x89 + P1(2)*x9 - P1(2&
                  )*x90 - P1(2)*x92 - 2*P2(2)*w1(2)*x142 - P2(2)*x35*x38 + P2(2&
                  )*x36 - co(0)*x137 + co(1)*x137 - w1(2)*x130 + w1(2)*x74 + w1&
                  (2)*x82 + w2(2)*x51 + x10*x134 + x100*x143 - x104*x62 - x105*&
                  x62 + x106*x117 + x106*x118 + x108*x122 + x108*x123 - x108*  &
                  x131 + x114*x4 + x114*x5 - x114*x54 + x127*x143 - x129*x135  &
                   - x129*x145 - x134*x43 - x134*x46 - x134*x48 - x134*x85 -   &
                  x134*x86 + x135*x33 + x135*x37 - x135*x39 + x135*x86 + x136* &
                  x44 + x136*x49 - x136*x59 + x138*x33 + x138*x37 - x138*x39 - &
                  x139*x56 - x139*x58 + x14*x84 - x14*x98 - x14*x99 - x140*x31 &
                   - x140*x32 - x141*x16 - x141*x18 + x141*x19 - x141*x22 -    &
                  x141*x24 + x141*x25 - x142*x22 - x142*x24 + x142*x25 - x144* &
                  x70 - x144*x72 + x144*x87 + x145*x85 + x145*x86 + x28*x76 -  &
                  x28*x94 - x28*x95
        wout(3) = -P1(3)*P2(1)*x107 - 2*P1(3)*w1(3)*x154 + P1(3)*x11*x49 + P1(3&
                  )*x120 + P1(3)*x126 - P1(3)*x132 - P1(3)*x55 + P1(3)*x8 - P1(&
                  3)*x89 + P1(3)*x9 - P1(3)*x90 + P2(3)*x36 + P2(3)*x73 + P2(3 &
                  )*x77 - co(0)*x151*x48 - w1(3)*x119 - w1(3)*x130 + w1(3)*x74 &
                   + w1(3)*x78 + w2(3)*x51 + x10*x149 + x100*x156 + x103*x151  &
                   - x109*x21 - x109*x27 + x115*x122 + x115*x123 - x115*x131 + &
                  x127*x156 - x129*x158 - x129*x81 + x13*x80 - x13*x96 - x13*  &
                  x97 + x146*x20 + x146*x26 + x147*x20 + x147*x26 + x148*x4 +  &
                  x148*x5 - x148*x54 - x149*x43 - x149*x46 - x149*x48 - x150*  &
                  x38 + x150*x64 + x151*x44 + x151*x47 + x151*x49 + x152*x33 + &
                  x152*x37 - x152*x39 - x153*x56 - x153*x58 - x154*x16 - x154* &
                  x17 + x154*x19 - x154*x22 - x154*x23 + x154*x25 - x155*x22 - &
                  x155*x23 + x155*x25 - x156*x68 - x157*x70 - x157*x72 + x157* &
                  x87 + x158*x85 + x33*x81 - x39*x81 + x60*x76 - x60*x94 - x60*&
                  x95
      case(VVV5)
!       c0*(P(1,2)*P(2,3)*P(3,1) - P(1,3)*P(2,1)*P(3,2))
!       c1*(Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3,
!       1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) + Metric(1,3)*P(-1,2)*P(-1,3)*P(2
!       ,1) + Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(-2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*      
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*Epsilon(-1,-2
!       ,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + 2*Epsilon(-1,-2,1,2)*P 
!       (-1,2)*P(-2,3)*P(3,1) - 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) + 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) - 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(Metric(1,2)*P(3,2) - Metric(1,3)*P(2,3) - Metric(2,3)*P(1,2) + Metric
!       (2,3)*P(1,3))
!       c5*(-Metric(1,2)*P(3,1) + Metric(1,3)*P(2,1))
!       -Epsilon(-1,1,2,3)*P(-1,1)*c6
!       c7*(-Epsilon(-1,1,2,3)*P(-1,2) - Epsilon(-1,1,2,3)*P(-1,3))
        if (last) VB_last = .true.
        x0 = w1(3)*w2(3)
        x1 = w1(0)*w2(0)
        x2 = w1(1)*w2(1) + w1(2)*w2(2) + x0 - x1
        x3 = co(5)*x2
        x4 = w1(2)*w2(3)
        x5 = w1(3)*w2(2)
        x6 = x4 - x5
        x7 = P1(1)*x6
        x8 = w1(1)*w2(3)
        x9 = -w1(3)*w2(1) + x8
        x10 = P1(2)*x9
        x11 = w1(1)*w2(2) - w1(2)*w2(1)
        x12 = P1(3)*x11
        x13 = co(4)*x2
        x14 = P2(1)*x6 - P2(2)*x9 + P2(3)*x11
        x15 = P1(1)**2
        x16 = 2*co(3)*x15
        x17 = P1(2)**2
        x18 = 2*co(3)*x17
        x19 = P1(3)**2
        x20 = 2*co(3)*x19
        x21 = P1(0)**2
        x22 = 2*co(3)*x21
        x23 = P1(0)*x2
        x24 = P2(1)**2
        x25 = co(1)*x24
        x26 = P2(2)**2
        x27 = co(1)*x26
        x28 = P2(3)**2
        x29 = co(1)*x28
        x30 = P1(0)*w1(0)
        x31 = co(5)*w2(0)
        x32 = P1(1)*w1(1)
        x33 = co(4)*w2(0)
        x34 = P1(2)*w2(0)
        x35 = co(4)*w1(2)
        x36 = P1(3)*w1(3)
        x37 = P2(0)**2
        x38 = P1(1)*w2(1)
        x39 = P1(2)*w2(2)
        x40 = P1(3)*w2(3)
        x41 = P1(0)*w2(0)
        x42 = x38 + x39 + x40 - x41
        x43 = w1(0)*x37*x42
        x44 = P2(2)*w1(2)
        x45 = P2(3)*w1(3)
        x46 = -P2(0)*w1(0) + P2(1)*w1(1) + x44 + x45
        x47 = co(1)*x15*x46
        x48 = co(1)*x17*x46
        x49 = co(1)*x19*x46
        x50 = co(4)*w1(0)*w2(1)
        x51 = w1(0)*w2(1)
        x52 = P1(2)*w1(0)
        x53 = co(4)*w2(2)
        x54 = P1(3)*w1(0)
        x55 = co(4)*w2(3)
        x56 = P2(0)*co(1)*x2
        x57 = co(1)*x17*x2
        x58 = P2(0)*co(4)
        x59 = P2(2)*w1(0)
        x60 = P2(3)*w2(3)
        x61 = co(4)*w1(0)
        x62 = x24*x42
        x63 = co(1)*x26*x42
        x64 = co(1)*x28*x42
        x65 = co(1)*x21*x46
        x66 = 4*P1(1)*P2(1)*co(3)
        x67 = 4*co(3)*x46
        x68 = P2(2)*w2(3) - P2(3)*w2(2)
        x69 = P1(1)*x68
        x70 = P1(2)*P2(2)
        x71 = 4*co(3)*x14
        x72 = P1(3)*P2(3)
        x73 = P2(1)*w2(2) - P2(2)*w2(1)
        x74 = 4*P1(3)*co(3)*x46
        x75 = P1(0)*P2(1)
        x76 = P1(0)*x6
        x77 = w1(0)*w2(2) - w1(2)*w2(0)
        x78 = P1(3)*x77
        x79 = w1(3)*w2(0)
        x80 = w1(0)*w2(3) - x79
        x81 = P1(2)*x80
        x82 = x76 + x78 - x81
        x83 = 2*co(3)*x82
        x84 = P2(0)*x6 - P2(2)*x80 + P2(3)*x77
        x85 = 2*co(3)*x84
        x86 = P1(0)*P2(3)
        x87 = P1(0)*x11
        x88 = -w1(1)*w2(0) + x51
        x89 = P1(2)*x88
        x90 = P1(1)*x77
        x91 = x87 + x89 - x90
        x92 = 2*co(3)*x91
        x93 = P2(0)*x11 - P2(1)*x77 + P2(2)*x88
        x94 = 2*co(3)*x93
        x95 = P1(2)*w2(3)
        x96 = P1(3)*w2(2)
        x97 = x95 - x96
        x98 = P1(1)*w2(2)
        x99 = P1(2)*w2(1)
        x100 = x98 - x99
        x101 = P1(1)*w2(3)
        x102 = P1(3)*w2(1)
        x103 = x101 - x102
        x104 = 2*co(2)*(P2(1)*x97 - P2(2)*x103 + P2(3)*x100)
        x105 = P2(1)*w2(3)
        x106 = P2(3)*w2(1)
        x107 = x105 - x106
        x108 = 2*co(2)*(P2(1)*x68 - P2(2)*x107 + P2(3)*x73)
        x109 = P1(2)*w1(3)
        x110 = P1(3)*w1(2)
        x111 = x109 - x110
        x112 = P2(1)*x111
        x113 = P1(1)*w1(2)
        x114 = P1(2)*w1(1)
        x115 = x113 - x114
        x116 = P2(3)*x115
        x117 = P1(1)*w1(3)
        x118 = P1(3)*w1(1)
        x119 = x117 - x118
        x120 = P2(2)*x119
        x121 = 2*co(2)*(x112 + x116 - x120)
        x122 = P2(2)*w1(3)
        x123 = P2(3)*w1(2)
        x124 = x122 - x123
        x125 = P2(1)*x124
        x126 = P2(1)*w1(2)
        x127 = P2(2)*w1(1)
        x128 = x126 - x127
        x129 = P2(3)*x128
        x130 = P2(3)*w1(1)
        x131 = P2(1)*w1(3) - x130
        x132 = P2(2)*x131
        x133 = 2*co(2)*(x125 + x129 - x132)
        x134 = P1(1)*P2(0)
        x135 = P1(1)*P2(1)
        x136 = -x10 + x12 + x7
        x137 = 2*co(3)*x136
        x138 = 2*P1(1)*co(3)*x46
        x139 = 2*co(3)*x42
        x140 = P1(1)*x124
        x141 = P2(1)*w2(1)
        x142 = P2(0)*w2(0)
        x143 = P2(2)*w2(2) + x141 - x142 + x60
        x144 = 2*co(3)*x143
        x145 = P1(2)*w1(2)
        x146 = x145 - x30 + x32 + x36
        x147 = 2*co(3)*x146
        x148 = 2*co(3)*(x24 + x26 + x28 - x37)
        x149 = P1(0)*P2(0)
        x150 = 2*co(3)*(x135 - x149 + x70 + x72)
        x151 = P1(0)*w2(1)
        x152 = P1(1)*w2(0)
        x153 = x151 - x152
        x154 = P1(0)*w2(3)
        x155 = P1(3)*w2(0)
        x156 = x154 - x155
        x157 = 2*co(2)*(P2(0)*x103 - P2(1)*x156 + P2(3)*x153)
        x158 = P2(1)*w2(0)
        x159 = P2(0)*w2(1) - x158
        x160 = P2(0)*w2(3)
        x161 = P2(3)*w2(0)
        x162 = x160 - x161
        x163 = 2*co(2)*(P2(0)*x107 - P2(1)*x162 + P2(3)*x159)
        x164 = P2(0)*x119
        x165 = P1(0)*w1(1)
        x166 = P1(1)*w1(0)
        x167 = x165 - x166
        x168 = P2(3)*x167
        x169 = P1(0)*w1(3)
        x170 = x169 - x54
        x171 = P2(1)*x170
        x172 = 2*co(2)*(x164 + x168 - x171)
        x173 = P2(0)*x131
        x174 = P2(0)*w1(1)
        x175 = P2(1)*w1(0)
        x176 = x174 - x175
        x177 = P2(3)*x176
        x178 = P2(3)*w1(0)
        x179 = P2(0)*w1(3) - x178
        x180 = P2(1)*x179
        x181 = 2*co(2)*(x173 + x177 - x180)
        x182 = P1(1)*P2(3)
        x183 = P1(3)*P2(1)
        x184 = x182 - x183
        x185 = 2*P1(2)*co(2)*x2
        x186 = P1(3)*P2(0)
        x187 = 2*P1(3)*co(3)*x46
        x188 = 2*P1(3)*co(3)*x143
        x189 = 2*P1(3)*co(3)*x146
        x190 = P1(0)*P2(2)
        x191 = P1(0)*x9
        x192 = P1(3)*x88
        x193 = P1(1)*x80
        x194 = x191 + x192 - x193
        x195 = 2*co(3)*x194
        x196 = P2(0)*x9 - P2(1)*x80 + P2(3)*x88
        x197 = 2*co(3)*x196
        x198 = P1(0)*w2(2)
        x199 = x198 - x34
        x200 = 2*co(2)*(P2(0)*x97 - P2(2)*x156 + P2(3)*x199)
        x201 = P2(0)*w2(2)
        x202 = -P2(2)*w2(0) + x201
        x203 = 2*co(2)*(P2(0)*x68 - P2(2)*x162 + P2(3)*x202)
        x204 = P2(0)*x111
        x205 = P1(0)*w1(2)
        x206 = x205 - x52
        x207 = P2(3)*x206
        x208 = P2(2)*x170
        x209 = 2*co(2)*(x204 + x207 - x208)
        x210 = P2(0)*x124
        x211 = P2(0)*w1(2) - x59
        x212 = P2(3)*x211
        x213 = P2(2)*x179
        x214 = 2*co(2)*(x210 + x212 - x213)
        x215 = P1(2)*P2(3)
        x216 = P1(3)*P2(2)
        x217 = x215 - x216
        x218 = 2*P1(1)*co(2)*x2
        x219 = P1(2)*P2(0)
        x220 = 2*P1(2)*co(3)*x46
        x221 = 2*P1(2)*co(3)*x42
        x222 = 2*P1(2)*co(3)*x143
        x223 = 2*P1(2)*co(3)*x146
        x224 = 2*co(2)*(P2(0)*x100 - P2(1)*x199 + P2(2)*x153)
        x225 = 2*co(2)*(P2(0)*x73 - P2(1)*x202 + P2(2)*x159)
        x226 = P2(0)*x115
        x227 = P2(2)*x167
        x228 = P2(1)*x206
        x229 = 2*co(2)*(x226 + x227 - x228)
        x230 = P2(0)*x128
        x231 = P2(2)*x176
        x232 = P2(1)*x211
        x233 = 2*co(2)*(x230 + x231 - x232)
        x234 = P1(1)*P2(2)
        x235 = P1(2)*P2(1)
        x236 = x234 - x235
        x237 = 2*P1(3)*co(2)*x2
        x238 = co(4)*w1(1)
        x239 = 2*P2(2)*w1(2)
        x240 = 2*co(4)*w1(3)
        x241 = 4*P1(2)*co(3)*x46
        x242 = 6*co(3)
        x243 = 8*co(3)
        x244 = P1(0)*co(1)*x2
        x245 = co(0)*w1(0)*x143
        x246 = P1(0)*P2(0)*co(1)*x146
        x247 = P1(1)*co(0)*x42
        x248 = co(1)*w1(0)*x143
        x249 = w1(2)*x42
        x250 = co(0)*w1(3)*x42
        x251 = P2(1)*co(0)*x42
        x252 = P2(0)*co(0)*x42
        x253 = P1(0)*P2(1)*co(0)*w1(1)
        x254 = co(0)*x42
        x255 = P1(0)*P2(2)*w1(2)
        x256 = co(0)*x143
        x257 = P2(3)*co(0)*x42
        x258 = P2(3)*co(0)*x143
        x259 = P1(1)*co(1)*x146
        x260 = P1(2)*P2(2)*co(1)*x146
        x261 = P2(3)*co(1)*x2
        x262 = P1(3)*P2(3)*co(1)*x146
        x263 = P1(0)*co(5)*w2(0)
        x264 = P1(1)*x2
        x265 = co(4)*w2(1)
        x266 = P2(1)*co(1)*x2
        x267 = co(0)*w1(1)
        x268 = x37*x42
        x269 = co(1)*w1(1)
        x270 = co(1)*x2*x37
        x271 = P1(1)*co(5)*w2(1)
        x272 = P1(2)*w1(1)*w2(2)
        x273 = co(4)*w1(1)*w2(3)
        x274 = P1(3)*co(5)
        x275 = co(4)*w1(1)*w2(2)
        x276 = 4*P1(0)*co(3)*x46
        x277 = 4*co(3)*x84
        x278 = 4*co(3)*x202*x46
        x279 = 2*P1(0)*co(3)*x46
        x280 = 2*P1(0)*co(3)*x42
        x281 = 2*P1(0)*co(3)*x143
        x282 = 2*P1(0)*co(3)*x146
        x283 = P1(2)*x2
        x284 = 2*co(2)*(-x186 + x86)
        x285 = 2*co(3)*x211*x42
        x286 = 2*co(3)*x14
        x287 = 2*P1(0)*co(2)*x2
        x288 = 2*co(3)*x143*x179
        x289 = x190 - x219
        x290 = 4*co(3)*x162*x46
        x291 = P1(1)*co(1)*x2
        x292 = co(0)*w1(0)*x42
        x293 = co(1)*w1(1)*x143
        x294 = P1(2)*co(0)*x42
        x295 = P2(2)*co(0)*x42
        x296 = P1(0)*P2(0)*co(1)*x2
        x297 = P1(1)*P2(1)*x143
        x298 = P1(1)*P2(2)*w1(2)
        x299 = co(1)*x2*x24
        x300 = P2(2)*co(1)*x2
        x301 = w1(2)*x26*x42
        x302 = co(1)*w2(2)*x46
        x303 = P1(1)*w1(2)*w2(1)
        x304 = P1(3)*w1(2)*w2(3)
        x305 = 4*co(3)*x196
        x306 = 2*P1(1)*co(3)*x146
        x307 = -x134 + x75
        x308 = 2*co(4)*w1(0)
        x309 = P1(0)*x107
        x310 = P1(3)*x176
        x311 = 2*P2(1)
        x312 = P2(3)*co(4)
        x313 = P2(0)*co(1)*x146
        x314 = co(1)*x143
        x315 = P1(3)*co(1)*x2
        x316 = P1(2)*P2(2)*w1(2)
        x317 = P1(3)*co(0)*x42
        x318 = co(1)*w2(2)*x146
        x319 = P1(2)*P2(1)*w1(1)
        x320 = co(1)*w1(3)
        x321 = co(1)*w2(3)*x46
        x322 = co(4)*w1(3)
        x323 = P1(2)*w1(3)*w2(2)
        x324 = 4*co(3)*x93
        x325 = 2*P1(3)*P2(2)*co(3)
        x326 = co(1)*w2(3)*x146
        wout(0) = P1(0)*P2(0)*x136*x242 + P1(0)*P2(0)*x14*x243 + P1(0)*x3 - P1(&
                  1)*co(5)*x51 - P1(1)*x50 + P1(2)*P2(0)*co(0)*x249 - P1(3)*   &
                  x128*x139 - P2(0)*x13 - P2(0)*x57 + 2*P2(1)*w2(0)*x238 - P2(1&
                  )*x50 - co(0)*x43 - co(1)*w1(0)*x62 + co(1)*x43 - co(5)*w2(2 &
                  )*x52 - co(5)*w2(3)*x54 + co(6)*x10 - co(6)*x12 - co(6)*x7 - &
                  co(7)*x10 + co(7)*x12 + co(7)*x7 - w1(0)*x63 - w1(0)*x64 + w2&
                  (0)*x246 - w2(0)*x260 - w2(0)*x262 + w2(0)*x47 + w2(0)*x48 + &
                  w2(0)*x49 - w2(0)*x65 - x1*x58 + x10*x148 + x10*x150 - x100* &
                  x187 + x103*x220 - x104*x30 + x107*x223 + x107*x241 - x108*  &
                  x30 + x112*x139 + x116*x139 - x12*x148 - x12*x150 - x120*x139&
                   - x121*x41 + x125*x139 - x128*x188 + x129*x139 + x131*x221  &
                   + x131*x222 - x132*x139 - x133*x41 - x134*x83 - x134*x85 -  &
                  x135*x137 + x135*x244 + x135*x248 - x135*x56 - x137*x70 -    &
                  x137*x72 - x138*x97 - x139*x140 - x14*x16 - x14*x18 - x14*x20&
                   + x14*x22 - x14*x66 - x140*x144 - x143*x253 - x147*x69 -    &
                  x148*x7 + x149*x245 - x149*x248 - x15*x56 - x150*x7 + x152*  &
                  x209 + x152*x214 + x155*x229 + x155*x233 - x157*x52 - x158*  &
                  x259 + x161*x240 - x163*x52 + x166*x200 + x166*x203 - x169*  &
                  x257 - x169*x258 - x172*x34 + x174*x247 + x174*x251 - x181*  &
                  x34 - x184*x185 + x186*x250 - x186*x261 - x186*x92 - x186*x94&
                   - x189*x73 - x19*x56 + x190*x195 + x190*x197 + x195*x219 +  &
                  x197*x219 + x217*x218 + x224*x54 + x225*x54 + x23*x25 + x23* &
                  x27 + x23*x29 + x236*x237 + x239*x33 + x244*x70 + x244*x72 + &
                  x248*x70 + x248*x72 + x252*x44 + x252*x45 - x253*x42 - x254* &
                  x255 - x255*x256 + x30*x31 + x32*x33 + x33*x36 + x34*x35 -   &
                  x52*x53 - x53*x59 - x54*x55 - x56*x70 - x60*x61 - x67*x69 -  &
                  x70*x71 - x71*x72 - x73*x74 - x75*x83 - x75*x85 - x86*x92 -  &
                  x86*x94
        wout(1) = -P1(1)*P2(1)*x242*x82 - P1(1)*P2(1)*x243*x84 - P1(1)*x270 -  &
                  P1(1)*x296 + P1(1)*x3 + P1(2)*x288 + P1(2)*x290 - P1(3)*P2(3 &
                  )*co(1)*w2(1)*x146 - P1(3)*x273 - P1(3)*x278 - P1(3)*x285 - 2&
                  *P2(0)*x50 - P2(1)*x13 - P2(1)*x57 - P2(2)*x275 - P2(3)*x273 &
                   - co(4)*x272 - co(5)*x272 - co(6)*x76 - co(6)*x78 + co(6)*  &
                  x81 + co(7)*x76 + co(7)*x78 - co(7)*x81 + w1(1)*x263 - w1(1)*&
                  x271 - w1(1)*x63 - w1(1)*x64 + w2(1)*x246 - w2(1)*x260 + w2(1&
                  )*x47 + w2(1)*x48 + w2(1)*x49 - w2(1)*x65 + x102*x229 + x102*&
                  x233 - x104*x165 + x106*x240 - x108*x165 - x114*x157 - x114* &
                  x163 - x117*x257 - x117*x258 + x118*x224 + x118*x225 - x121* &
                  x151 - x124*x280 - x124*x281 + x126*x294 + x126*x295 - x133* &
                  x151 + x134*x137 + x134*x245 + x134*x286 + x134*x292 + x135* &
                  x293 + x137*x75 + x139*x204 + x139*x207 - x139*x208 + x139*  &
                  x210 + x139*x212 - x139*x213 + x141*x238 - x141*x259 + x145* &
                  x265 - x148*x76 - x148*x78 + x148*x81 + x149*x266 + x149*x277&
                   - x149*x293 + x149*x83 - x150*x76 - x150*x78 + x150*x81 +   &
                  x156*x220 - x16*x84 + x162*x223 - x172*x99 + x174*x33 - x175*&
                  x252 + x179*x221 - x18*x84 - x181*x99 - x182*x92 - x182*x94  &
                   - x183*x92 - x183*x94 - x187*x199 - x188*x211 - x189*x202 - &
                  x19*x266 + x195*x234 + x195*x235 + x197*x234 + x197*x235 -   &
                  x20*x84 + x200*x32 + x203*x32 + x209*x38 + x21*x266 + x214*  &
                  x38 + x217*x287 + x22*x84 + x237*x289 + x238*x41 + x239*x265 &
                   - x251*x30 + x251*x36 + x251*x45 - x254*x298 - x256*x298 +  &
                  x264*x27 + x264*x29 - x265*x30 + x265*x36 - x266*x70 - x266* &
                  x72 - x267*x297 + x267*x62 + x268*x269 - x269*x62 - x274*x8  &
                   - x276*x68 - x277*x70 - x277*x72 - x279*x97 - x282*x68 -    &
                  x283*x284 + x286*x75 + x291*x70 + x291*x72 + x293*x70 + x293*&
                  x72 - x70*x83 - x72*x83
        wout(2) = -P1(0)*P2(0)*w1(2)*x314 + P1(1)*P1(2)*P2(1)*co(1)*x2 + P1(1)*&
                  P2(1)*w1(2)*x314 - P1(1)*x139*x179 - P1(1)*x288 - P1(1)*x290 &
                   + P1(2)*P2(0)*w1(0)*x256 + P1(2)*P2(2)*x194*x242 + P1(2)*P2(&
                  2)*x196*x243 - P1(2)*x270 - P1(2)*x296 + P1(2)*x299 + P1(2)* &
                  x3 + P1(3)*P2(3)*w1(2)*x314 + P1(3)*co(4)*x5 - P2(2)*x13 + co&
                  (0)*x301 + co(1)*x249*x37 - co(1)*x301 - co(4)*x303 - co(4)* &
                  x304 - co(5)*w1(2)*x39 - co(5)*x303 - co(5)*x304 + co(6)*x191&
                   + co(6)*x192 - co(6)*x193 - co(7)*x191 - co(7)*x192 + co(7)*&
                  x193 + w1(2)*x263 + 2*w1(3)*w2(2)*x312 - w2(2)*x262 + w2(2)* &
                  x48 + x103*x279 - x104*x205 - x108*x205 - x109*x257 - x109*  &
                  x258 + x110*x224 + x110*x225 + x113*x200 + x113*x203 - x121* &
                  x198 + x122*x257 + x122*x317 - x123*x55 - x126*x265 + x127*  &
                  x251 + x131*x280 + x131*x281 - x133*x198 + x135*x195 - x135* &
                  x300 - x135*x318 + x137*x190 + x137*x219 - x138*x156 - x139* &
                  x164 - x139*x168 + x139*x171 - x139*x173 - x139*x177 + x139* &
                  x180 + x139*x310 + x142*x35 + x144*x310 - x145*x157 - x145*  &
                  x163 + x147*x309 + x148*x191 + x148*x192 - x148*x193 - x149* &
                  x195 + x149*x300 - x149*x305 - x15*x300 + x15*x302 + x150*   &
                  x191 + x150*x192 - x150*x193 + x153*x187 + x159*x189 + x159* &
                  x74 + x16*x196 - x162*x306 - x172*x39 + x18*x196 - x181*x39  &
                   - x184*x287 - x19*x300 + x19*x302 + x190*x286 + x195*x72 +  &
                  x196*x20 - x196*x22 + x196*x66 + x198*x313 - x198*x61 - x201*&
                  x308 + x209*x98 + x21*x300 - x21*x302 + x214*x98 + x215*x315 &
                   - x215*x92 - x215*x94 - x216*x92 - x216*x94 + x219*x286 +   &
                  x229*x96 + x233*x96 - x234*x83 - x234*x85 - x235*x83 - x235* &
                  x85 - x237*x307 - x249*x25 - x249*x29 + x252*x52 - x252*x59  &
                   - x254*x319 - x256*x316 - x256*x319 + x264*x284 + x275*x311 &
                   + x283*x29 - x295*x30 + x295*x32 - x300*x72 + x305*x72 +    &
                  x309*x67 + x314*x316 - x318*x70 + x32*x53 + x35*x41 + x44*x53
        wout(3) = -P1(0)*P2(0)*w1(3)*x314 + P1(1)*x144*x211 + P1(1)*x273 + P1(1&
                  )*x278 + P1(1)*x285 + P1(2)*P2(2)*w1(3)*x314 + P1(2)*co(4)*x4&
                   - P1(3)*P2(1)*w1(1)*x256 - P1(3)*P2(2)*w1(2)*x256 + P1(3)*P2&
                  (3)*w1(3)*x314 - P1(3)*P2(3)*x242*x91 - P1(3)*P2(3)*x243*x93 &
                   + P1(3)*x2*x27 - P1(3)*x270 + P1(3)*x299 + P1(3)*x3 - P2(3)*&
                  x13 - P2(3)*x57 - co(4)*x323 - co(5)*x323 - co(6)*x87 - co(6 &
                  )*x89 + co(6)*x90 + co(7)*x87 + co(7)*x89 - co(7)*x90 - w1(3 &
                  )*x271 - w1(3)*x64 + w2(3)*x48 - x0*x274 + x0*x312 - x100*   &
                  x279 + x101*x209 + x101*x214 - x104*x169 - x105*x259 - x108* &
                  x169 - x109*x157 - x109*x163 + x117*x200 + x117*x203 - x118* &
                  x251 - x121*x154 - x122*x53 + x123*x294 + x123*x295 - x128*  &
                  x280 - x128*x281 + x130*x247 + x130*x251 - x133*x154 - x135* &
                  x261 + x135*x315 - x135*x324 - x135*x92 + x137*x186 + x137*  &
                  x86 + x138*x199 + x139*x226 + x139*x227 - x139*x228 + x139*  &
                  x230 + x139*x231 - x139*x232 - x141*x322 - x148*x87 - x148*  &
                  x89 + x148*x90 + x149*x261 + x149*x324 + x149*x92 - x15*x261 &
                   + x15*x321 - x150*x87 - x150*x89 + x150*x90 - x153*x220 +   &
                  x154*x313 - x154*x61 - x159*x223 - x159*x241 - x16*x93 - x160&
                  *x308 + x169*x31 + x169*x33 - x172*x95 - x176*x221 - x176*   &
                  x222 - x178*x252 - x18*x93 - x181*x95 - x182*x83 - x182*x85  &
                   - x183*x83 - x183*x85 + x185*x307 - x186*x244 + x186*x245 + &
                  x186*x286 + x186*x292 + x19*x321 + x194*x325 + x195*x215 +   &
                  x196*x325 + x197*x215 - x20*x93 + x202*x306 + x21*x261 - x21*&
                  x321 - x218*x289 + x22*x93 + x224*x36 + x225*x36 + x229*x40  &
                   + x233*x40 + x236*x287 + x239*x55 + x250*x28 - x257*x30 -   &
                  x258*x36 - x26*x320*x42 - x261*x70 + x268*x320 + x273*x311 - &
                  x276*x73 - x282*x73 + x286*x86 + x297*x320 + x315*x70 - x317*&
                  x44 - x320*x62 - x322*x38 - x324*x70 - x326*x70 - x326*x72 + &
                  x58*x79 - x70*x92
      case(VVV6)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1) - Metric(1,3)*P(-1,2)*P(-1,3)*P(2
!       ,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2
!       ,3))
!       c3*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - Epsilon(-1,-2,1,3)*P(-1,
!       1)*P(-2,2)*P(2,3))
        if (last) VB_last = .true.
        x0 = P2(1)**2
        x1 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x2 = P1(0)*co(1)*x1
        x3 = P2(2)**2
        x4 = P2(3)**2
        x5 = w1(2)*w2(3) - w1(3)*w2(2)
        x6 = w1(0)*w2(2) - w1(2)*w2(0)
        x7 = w1(0)*w2(3) - w1(3)*w2(0)
        x8 = P1(0)*x5 - P1(2)*x7 + P1(3)*x6
        x9 = P1(1)*co(3)*x8
        x10 = P1(1)*co(3)*(P2(0)*x5 - P2(2)*x7 + P2(3)*x6)
        x11 = P2(1)*w1(3)
        x12 = P2(3)*w1(1)
        x13 = x11 - x12
        x14 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x15 = P1(2)*co(3)*x14
        x16 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x17 = P1(2)*co(3)*x16
        x18 = w1(1)*w2(2) - w1(2)*w2(1)
        x19 = w1(0)*w2(1) - w1(1)*w2(0)
        x20 = P1(0)*x18 - P1(1)*x6 + P1(2)*x19
        x21 = P1(3)*co(3)*x20
        x22 = P1(3)*co(3)*(P2(0)*x18 - P2(1)*x6 + P2(2)*x19)
        x23 = P1(1)**2
        x24 = P2(0)*co(2)*x1
        x25 = P1(2)**2
        x26 = P1(3)**2
        x27 = co(0)*x14
        x28 = P2(0)**2
        x29 = w1(0)*x28
        x30 = co(1)*x0*x14
        x31 = co(1)*x14*x3
        x32 = co(1)*x14*x4
        x33 = P2(1)*w1(1)
        x34 = P2(2)*w1(2)
        x35 = P2(3)*w1(3)
        x36 = P2(0)*w1(0)
        x37 = x33 + x34 + x35 - x36
        x38 = co(1)*x23*x37
        x39 = co(1)*x25*x37
        x40 = co(1)*x26*x37
        x41 = w1(1)*w2(3) - w1(3)*w2(1)
        x42 = P1(1)*x5 - P1(2)*x41 + P1(3)*x18
        x43 = P1(0)*co(3)*x42
        x44 = P2(1)*x5 - P2(2)*x41 + P2(3)*x18
        x45 = P1(0)*co(3)*x44
        x46 = co(1)*x1
        x47 = P1(0)*x28
        x48 = co(2)*x1
        x49 = P2(2)*w1(3)
        x50 = P2(3)*w1(2)
        x51 = x49 - x50
        x52 = P1(1)*co(3)*x51
        x53 = P1(0)*x41 - P1(1)*x7 + P1(3)*x19
        x54 = P1(2)*co(3)*x53
        x55 = P2(0)*x41 - P2(1)*x7 + P2(3)*x19
        x56 = P1(2)*co(3)*x55
        x57 = P2(1)*w1(2)
        x58 = P2(2)*w1(1)
        x59 = x57 - x58
        x60 = P1(3)*co(3)*x59
        x61 = P1(0)**2
        x62 = co(1)*x14
        x63 = co(1)*x37*x61
        x64 = P1(1)*P2(1)*co(1)*x1
        x65 = P1(2)*P2(2)*co(1)*x1
        x66 = P1(3)*co(1)*x1
        x67 = P1(0)*P2(0)*w1(0)
        x68 = co(0)*x16
        x69 = P1(1)*P2(1)
        x70 = P2(1)*w1(0)
        x71 = P1(1)*co(1)*x14
        x72 = P1(1)*w1(1)
        x73 = P1(2)*w1(2)
        x74 = P1(3)*w1(3)
        x75 = P1(0)*w1(0)
        x76 = x72 + x73 + x74 - x75
        x77 = co(1)*w2(0)*x76
        x78 = P1(1)*co(2)*x14
        x79 = P1(1)*co(2)*x16
        x80 = P1(2)*P2(2)
        x81 = P1(2)*P2(2)*w1(0)
        x82 = P2(2)*w1(0)
        x83 = P1(2)*co(2)*x14
        x84 = co(2)*x16
        x85 = P1(3)*P2(3)
        x86 = P2(3)*w1(0)
        x87 = P1(3)*co(1)*x14
        x88 = P1(3)*co(2)*x14
        x89 = P1(3)*co(2)*x16
        x90 = co(1)*x76
        x91 = P1(0)*P2(0)*w2(0)
        x92 = co(2)*x14
        x93 = P1(0)*co(0)*x14
        x94 = P2(1)*co(0)*w1(1)*x16
        x95 = P2(2)*co(0)*w1(2)*x16
        x96 = P2(3)*co(0)*w1(3)*x14
        x97 = P2(0)*co(0)*x14
        x98 = P2(0)*w1(1)
        x99 = P2(1)*co(0)*x14
        x100 = 2*co(1)*x37
        x101 = 2*co(0)*x14
        x102 = 2*P1(1)*P2(1)
        x103 = co(1)*w2(0)*x37
        x104 = 2*P1(2)*P2(2)
        x105 = 2*P1(3)*P2(3)*co(1)*x37
        x106 = P1(1)*co(1)*x1
        x107 = P2(0)*w1(3)
        x108 = x107 - x86
        x109 = P2(1)*co(2)*x1
        x110 = w1(1)*x0
        x111 = P1(0)*co(3)*x51
        x112 = P2(0)*w1(2) - x82
        x113 = P1(3)*co(3)*x112
        x114 = co(1)*x14*x28
        x115 = P1(1)*co(0)*x14
        x116 = P1(1)*co(0)*x16
        x117 = P1(1)*P2(1)*w1(1)
        x118 = P1(1)*P2(1)*w2(1)
        x119 = P1(2)*P2(2)*co(2)*x1
        x120 = P1(2)*co(1)*x14
        x121 = co(1)*w2(1)*x76
        x122 = P1(2)*co(2)*x16
        x123 = P1(3)*P2(3)*w1(1)
        x124 = P1(0)*P2(0)
        x125 = P1(0)*P2(0)*co(2)*x1
        x126 = P1(0)*co(1)*x14
        x127 = P1(0)*P2(0)*co(1)*x76
        x128 = P1(0)*co(2)*x14
        x129 = P1(0)*co(2)*x16
        x130 = P1(2)*co(0)*x14
        x131 = P2(2)*co(0)*x14
        x132 = 2*P1(0)*P2(0)
        x133 = co(1)*w2(1)*x37
        x134 = P1(0)*co(3)*x13
        x135 = P2(2)*co(3)
        x136 = P1(2)*co(1)*x1
        x137 = -x70 + x98
        x138 = P1(3)*co(3)*x137
        x139 = P2(2)*co(2)*x1
        x140 = co(1)*w2(2)*x37
        x141 = P1(1)*co(3)*x108
        x142 = co(1)*w2(2)*x76
        x143 = P1(2)*co(0)*x16
        x144 = P1(2)*P2(2)*w2(2)
        x145 = P1(0)*P2(0)*w1(2)
        x146 = P1(3)*co(0)*x14
        x147 = P2(3)*co(0)*x14
        x148 = P1(1)*co(3)*x112
        x149 = P2(3)*x26
        x150 = P2(3)*co(2)*x1
        x151 = co(1)*w1(3)*x14
        x152 = co(1)*w2(3)*x37
        x153 = P1(0)*co(3)*x59
        x154 = co(1)*w2(3)*x76
        x155 = P1(3)*P2(3)*w1(3)
        x156 = P1(3)*P2(3)*w2(3)
        wout(0) = -P1(0)*P2(3)*w1(3)*x68 + P1(0)*P2(3)*x66 + P1(0)*x64 + P1(0)*&
                  x65 - P1(0)*x94 - P1(0)*x95 - P1(0)*x96 + P2(0)*x10 + P2(0)* &
                  x21 + P2(0)*x22 - P2(0)*x43 - P2(0)*x45 - P2(0)*x46*x61 - P2(&
                  0)*x54 - P2(0)*x56 + P2(0)*x9 - P2(0)*x96 + w1(0)*x30 + w1(0 &
                  )*x31 + w1(0)*x32 + w2(0)*x105 + w2(0)*x38 + w2(0)*x39 + w2(0&
                  )*x40 - w2(0)*x63 + x0*x2 - x100*x91 + x101*x67 + x102*x103  &
                   + x103*x104 + x13*x15 + x13*x17 - x14*x52 - x14*x60 - x16*  &
                  x52 - x16*x60 + x2*x3 + x2*x4 + x23*x24 + x24*x25 + x24*x26  &
                   - x24*x61 + x24*x69 + x24*x80 + x24*x85 + x27*x29 - x29*x62 &
                   - x33*x93 - x34*x93 - x34*x97 - x46*x47 - x47*x48 - x62*x67 &
                   + x62*x81 + x67*x68 - x67*x84 - x67*x92 + x69*x77 + x70*x71 &
                   + x70*x78 + x70*x79 - x72*x97 - x73*x97 - x74*x97 + x77*x80 &
                   + x77*x85 + x81*x84 + x82*x83 + x86*x87 + x86*x88 + x86*x89 &
                   - x90*x91 - x98*x99
        wout(1) = P1(1)*x0*x48 - P1(1)*x96 + P2(1)*x10 + P2(1)*x119 - P2(1)*   &
                  x125 + P2(1)*x21 + P2(1)*x22 + P2(1)*x23*x46 - P2(1)*x43 - P2&
                  (1)*x45 - P2(1)*x54 - P2(1)*x56 + P2(1)*x9 - w1(1)*x114 + w1(&
                  1)*x31 + w1(1)*x32 + w2(1)*x105 - w2(1)*x127 + w2(1)*x38 + w2&
                  (1)*x39 + w2(1)*x40 - w2(1)*x63 + x0*x106 + x100*x118 - x101*&
                  x117 + x104*x133 - x106*x124 - x106*x28 + x106*x3 + x106*x4  &
                   + x106*x80 + x106*x85 + x108*x15 + x108*x17 + x109*x23 +    &
                  x109*x25 + x109*x26 - x109*x61 + x109*x85 - x110*x27 + x110* &
                  x62 - x111*x14 - x111*x16 - x113*x14 - x113*x16 - x115*x34 + &
                  x115*x36 - x116*x34 - x116*x35 + x116*x36 + x117*x62 - x117* &
                  x68 + x117*x84 + x117*x92 + x118*x90 + x120*x58 + x121*x80 + &
                  x121*x85 + x122*x58 + x123*x62 + x123*x84 + x123*x92 - x126* &
                  x98 - x128*x98 - x129*x98 - x130*x57 - x131*x57 - x132*x133  &
                   - x35*x99 + x58*x83 + x70*x97 - x74*x99 + x75*x99
        wout(2) = -P1(0)*x135*x42 - P1(0)*x135*x44 + P1(1)*x135*x8 - P1(2)*x135&
                  *x53 - P1(2)*x135*x55 + P1(2)*x3*x48 + P1(2)*x64 - P1(2)*x94 &
                   - P1(2)*x95 + P1(3)*x135*x20 - 2*P2(2)*w1(2)*x130 + P2(2)*  &
                  x10 - P2(2)*x125 + P2(2)*x22 + P2(2)*x25*x46 + 2*co(1)*w2(2)*&
                  x37*x85 - w1(2)*x114 - w1(2)*x27*x3 + w1(2)*x30 + w1(2)*x31  &
                   + w1(2)*x32 - w2(2)*x127 + w2(2)*x39 + x0*x136 + x100*x144  &
                   + x102*x140 + x120*x34 + x122*x34 - x124*x136 - x130*x33 -  &
                  x130*x35 + x130*x36 - x131*x72 + x131*x75 - x132*x140 + x134*&
                  x14 + x134*x16 - x136*x28 + x136*x3 + x136*x4 + x136*x85 +   &
                  x138*x14 + x138*x16 + x139*x23 + x139*x25 + x139*x26 - x139* &
                  x61 + x139*x69 + x139*x85 - x14*x141 + x140*x23 + x140*x26 - &
                  x140*x61 - x141*x16 + x142*x69 + x142*x85 - x143*x35 + x143* &
                  x36 + x144*x90 - x145*x62 - x145*x84 - x145*x92 - x146*x49 - &
                  x147*x49 + x34*x83 + x50*x87 + x50*x88 + x50*x89 + x57*x71 + &
                  x57*x78 + x57*x79 - x58*x99 + x82*x97
        wout(3) = P1(1)*P2(3)*x109 + P1(3)*P2(0)*w1(0)*x68 + P1(3)*x4*x48 + P1(&
                  3)*x64 + P1(3)*x65 - P1(3)*x94 - P1(3)*x95 + P2(3)*x10 + P2(3&
                  )*x119 - P2(3)*x125 + P2(3)*x21 + P2(3)*x22 - P2(3)*x43 - P2(&
                  3)*x45 - P2(3)*x54 - P2(3)*x56 + P2(3)*x9 - w1(3)*x27*x4 + w1&
                  (3)*x32 + w2(3)*x39 + x0*x151 + x0*x66 + x100*x156 - x101*   &
                  x155 + x102*x152 + x104*x152 - x107*x126 - x107*x128 - x107* &
                  x129 + x11*x71 + x11*x78 + x11*x79 - x12*x99 + x120*x49 +    &
                  x122*x49 - x124*x154 - x124*x66 - x130*x50 - x131*x50 - x132*&
                  x152 - x137*x15 - x137*x17 + x14*x148 - x14*x153 - x146*x33  &
                   - x146*x34 + x146*x36 - x147*x72 + x147*x75 + x148*x16 +    &
                  x149*x46 + x149*x48 + x150*x23 + x150*x25 - x150*x61 - x151* &
                  x28 + x151*x3 + x152*x23 + x152*x26 - x152*x61 - x153*x16 +  &
                  x154*x69 + x154*x80 + x155*x62 - x155*x68 + x155*x84 + x155* &
                  x92 + x156*x90 - x28*x66 + x3*x66 + x4*x66 + x49*x83 + x86*  &
                  x97
      case(VVV7)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) + Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(
!       2,1) + Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P
!       (1,2))
!       c2*(-Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + Epsilon(-1
!       ,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - Epsilon(-1,-2,1,3)*P(-1,
!       1)*P(-2,2)*P(2,3) - Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - Epsilon(-
!       1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) + Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2
!       ,3) - Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3))
        if (last) VB_last = .true.
        x0 = P1(1)*P2(0)
        x1 = w1(2)*w2(3) - w1(3)*w2(2)
        x2 = P1(0)*x1
        x3 = w1(0)*w2(2) - w1(2)*w2(0)
        x4 = P1(3)*x3
        x5 = w1(0)*w2(3) - w1(3)*w2(0)
        x6 = P1(2)*x5
        x7 = x2 + x4 - x6
        x8 = co(3)*x7
        x9 = co(3)*(P2(0)*x1 - P2(2)*x5 + P2(3)*x3)
        x10 = P1(1)*w2(0)
        x11 = P1(2)*w1(3) - P1(3)*w1(2)
        x12 = P2(0)*x11
        x13 = P1(2)*w1(0)
        x14 = P1(0)*w1(2) - x13
        x15 = P2(3)*x14
        x16 = P1(0)*w1(3)
        x17 = -P1(3)*w1(0) + x16
        x18 = P2(2)*x17
        x19 = x12 + x15 - x18
        x20 = co(2)*x19
        x21 = P2(2)*w1(3)
        x22 = P2(3)*w1(2)
        x23 = x21 - x22
        x24 = P2(0)*x23
        x25 = P2(2)*w1(0)
        x26 = P2(0)*w1(2) - x25
        x27 = P2(3)*x26
        x28 = P2(3)*w1(0)
        x29 = P2(0)*w1(3) - x28
        x30 = P2(2)*x29
        x31 = x24 + x27 - x30
        x32 = co(2)*x31
        x33 = P1(1)*x1
        x34 = P2(1)**2
        x35 = P2(2)**2
        x36 = P2(3)**2
        x37 = P2(0)**2
        x38 = co(3)*(x34 + x35 + x36 - x37)
        x39 = P1(1)*P2(1)
        x40 = P1(2)*P2(2)
        x41 = P1(3)*P2(3)
        x42 = P1(0)*P2(0)
        x43 = co(3)*(x39 + x40 + x41 - x42)
        x44 = P1(1)*P2(3)
        x45 = P1(3)*P2(1)
        x46 = x44 - x45
        x47 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x48 = P1(2)*co(2)*x47
        x49 = P1(1)*w2(3)
        x50 = -P1(3)*w2(1) + x49
        x51 = P2(2)*w1(2)
        x52 = P2(3)*w1(3)
        x53 = -P2(0)*w1(0) + P2(1)*w1(1) + x51 + x52
        x54 = P1(2)*co(3)*x53
        x55 = P2(3)*w1(1)
        x56 = P2(1)*w1(3) - x55
        x57 = P1(1)*w2(1)
        x58 = P1(2)*w2(2)
        x59 = P1(0)*w2(0)
        x60 = P1(3)*w2(3) + x57 + x58 - x59
        x61 = P1(2)*co(3)*x60
        x62 = P2(1)*w2(1)
        x63 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x62
        x64 = P1(2)*co(3)*x63
        x65 = P2(1)*w2(3)
        x66 = -P2(3)*w2(1) + x65
        x67 = P1(3)*P2(0)
        x68 = w1(1)*w2(2) - w1(2)*w2(1)
        x69 = P1(0)*x68
        x70 = w1(0)*w2(1) - w1(1)*w2(0)
        x71 = P1(2)*x70
        x72 = P1(1)*x3
        x73 = co(3)*(x69 + x71 - x72)
        x74 = co(3)*(P2(0)*x68 - P2(1)*x3 + P2(2)*x70)
        x75 = P1(1)*w1(2)
        x76 = P1(2)*w1(1)
        x77 = x75 - x76
        x78 = P2(0)*x77
        x79 = P1(0)*w1(1) - P1(1)*w1(0)
        x80 = P2(2)*x79
        x81 = P2(1)*x14
        x82 = x78 + x80 - x81
        x83 = P1(3)*co(2)*w2(0)
        x84 = P2(1)*w1(2)
        x85 = P2(2)*w1(1)
        x86 = x84 - x85
        x87 = P2(0)*x86
        x88 = P2(0)*w1(1)
        x89 = P2(1)*w1(0)
        x90 = x88 - x89
        x91 = P2(2)*x90
        x92 = P2(1)*x26
        x93 = x87 + x91 - x92
        x94 = P1(3)*x68
        x95 = P1(1)**2
        x96 = P2(0)*co(1)*x47
        x97 = P1(2)**2
        x98 = co(1)*x47*x97
        x99 = P1(3)**2
        x100 = P1(3)*w1(1)
        x101 = P1(1)*w1(3) - x100
        x102 = P2(2)*x101
        x103 = co(3)*x60
        x104 = P2(2)*x56
        x105 = w1(0)*x37*x60
        x106 = co(1)*w1(0)*x60
        x107 = co(1)*x36
        x108 = co(1)*w2(0)*x53
        x109 = co(1)*x34*x47
        x110 = co(1)*x35*x47
        x111 = P2(1)*x11
        x112 = P2(3)*x77
        x113 = co(2)*(-x102 + x111 + x112)
        x114 = P2(1)*x23
        x115 = P2(3)*x86
        x116 = co(2)*(-x104 + x114 + x115)
        x117 = w1(1)*w2(3) - w1(3)*w2(1)
        x118 = P1(2)*x117
        x119 = -x118 + x33 + x94
        x120 = co(3)*x119
        x121 = co(3)*(P2(1)*x1 - P2(2)*x117 + P2(3)*x68)
        x122 = P1(2)*P2(3)
        x123 = P1(3)*P2(2)
        x124 = x122 - x123
        x125 = P1(1)*co(2)*x47
        x126 = P1(2)*w2(3)
        x127 = -P1(3)*w2(2) + x126
        x128 = P1(1)*co(3)*x53
        x129 = P1(1)*co(3)*x60
        x130 = co(3)*x23*x63
        x131 = P2(2)*w2(3) - P2(3)*w2(2)
        x132 = P1(2)*P2(0)
        x133 = P1(0)*x117
        x134 = P1(3)*x70
        x135 = P1(1)*x5
        x136 = x133 + x134 - x135
        x137 = co(3)*x136
        x138 = co(3)*(P2(0)*x117 - P2(1)*x5 + P2(3)*x70)
        x139 = P1(2)*P2(2)*co(3)
        x140 = P1(2)*w2(0)
        x141 = P2(0)*x101
        x142 = P2(3)*x79
        x143 = P2(1)*x17
        x144 = co(2)*(x141 + x142 - x143)
        x145 = P2(0)*x56
        x146 = P2(3)*x90
        x147 = P2(1)*x29
        x148 = co(2)*(x145 + x146 - x147)
        x149 = P1(1)*P2(2)
        x150 = P1(2)*P2(1)
        x151 = x149 - x150
        x152 = P1(3)*co(2)*x47
        x153 = P1(2)*w2(1)
        x154 = P1(1)*w2(2) - x153
        x155 = P1(3)*co(3)*x53
        x156 = P1(3)*x86
        x157 = co(3)*x63
        x158 = P2(1)*w2(2) - P2(2)*w2(1)
        x159 = P1(0)**2
        x160 = co(0)*w1(0)*x63
        x161 = P1(1)*w1(1)
        x162 = P1(3)*w1(3)
        x163 = P1(0)*w1(0)
        x164 = P1(2)*w1(2) + x161 + x162 - x163
        x165 = P1(0)*P2(0)*co(1)*x164
        x166 = co(1)*w1(0)*x63
        x167 = P2(3)*co(1)*x47
        x168 = P1(1)*P2(1)*co(1)*x47
        x169 = P1(0)*co(1)*x47
        x170 = w1(1)*x60
        x171 = co(0)*x63
        x172 = co(0)*x60
        x173 = P1(0)*P2(2)*w1(2)
        x174 = P2(3)*co(0)*x60
        x175 = P2(3)*co(0)*x63
        x176 = P2(0)*co(0)*x60
        x177 = co(1)*x164
        x178 = co(0)*w1(2)*x60
        x179 = P1(2)*P2(2)*co(1)*x164
        x180 = co(0)*w1(3)*x60
        x181 = P1(3)*P2(3)*co(1)*x164
        x182 = P2(1)*co(0)*x60
        x183 = 2*co(1)*w1(0)*x60
        x184 = co(0)*w1(0)*x60
        x185 = 2*P1(1)*P2(1)
        x186 = 2*P1(3)*P2(3)
        x187 = P1(0)*P2(0)*co(3)
        x188 = co(1)*x37*x47
        x189 = P1(0)*P2(3)
        x190 = x189 - x67
        x191 = P1(0)*w2(3)
        x192 = -P1(3)*w2(0) + x191
        x193 = P2(0)*w2(3) - P2(3)*w2(0)
        x194 = P1(3)*co(2)*w2(1)
        x195 = P2(1)*co(1)*x47
        x196 = w1(1)*x34*x60
        x197 = co(1)*w1(1)*x60
        x198 = co(1)*w2(1)*x53
        x199 = P1(0)*P2(1)
        x200 = P1(0)*w2(1)
        x201 = P1(0)*co(2)*x47
        x202 = P1(0)*co(3)*x53
        x203 = P1(0)*co(3)*x60
        x204 = P1(0)*P2(2)
        x205 = -x132 + x204
        x206 = P1(0)*w2(2)
        x207 = -x140 + x206
        x208 = P1(3)*x26
        x209 = P2(0)*w2(2) - P2(2)*w2(0)
        x210 = co(1)*x37
        x211 = P1(0)*P2(0)*co(1)*x47
        x212 = co(1)*w1(1)*x63
        x213 = P1(1)*co(1)*x47
        x214 = P2(1)*co(0)*x63
        x215 = P1(1)*co(1)*x164
        x216 = P2(2)*co(0)*x60
        x217 = P1(1)*P2(3)*w1(3)
        x218 = P1(2)*co(0)*x60
        x219 = 2*co(1)*w1(1)*x60
        x220 = -2*P1(0)*w2(0) + 2*P1(1)*w2(1) + 2*P1(2)*w2(2) + 2*P1(3)*w2(3)
        x221 = P1(0)*co(3)*x63
        x222 = P1(1)*co(2)*w2(2)
        x223 = P1(3)*co(2)*w2(2)
        x224 = -x0 + x199
        x225 = -x10 + x200
        x226 = P1(3)*x90
        x227 = P2(0)*w2(1) - P2(1)*w2(0)
        x228 = P2(2)*co(1)*x47
        x229 = w1(2)*x35*x60
        x230 = w1(2)*x60
        x231 = co(1)*w2(2)*x53
        x232 = P2(0)*co(1)*x164
        x233 = co(1)*x63
        x234 = P1(1)*P2(1)*w1(2)
        x235 = P1(2)*P2(2)*w1(2)
        x236 = P1(3)*P2(3)*w1(2)
        x237 = P1(3)*co(1)*x47
        x238 = P1(3)*co(0)*x60
        x239 = 2*co(1)*w1(2)*x60
        x240 = co(1)*x220
        x241 = P1(1)*x26
        x242 = P1(3)*co(2)*w2(3)
        x243 = co(1)*w1(3)*x60
        x244 = co(1)*w2(3)*x53
        x245 = P1(2)*P2(2)*w1(3)
        x246 = P1(3)*P2(3)*w1(3)
        x247 = P1(0)*P2(0)*w1(3)
        wout(0) = 2*P1(0)*P2(0)*x184 - P1(0)*P2(1)*co(0)*x170 - P1(0)*P2(1)*w1(&
                  1)*x171 - P1(0)*x107*x47 - P1(0)*x109 - P1(0)*x110 - P1(0)*  &
                  x168 - P1(1)*P2(1)*w2(0)*x177 - P1(1)*x130 + P2(0)*x98 + co(0&
                  )*x105 - co(1)*x105 + w1(0)*x107*x60 + w2(0)*x165 - w2(0)*   &
                  x179 - w2(0)*x181 + x0*x8 + x0*x9 + x10*x20 + x10*x32 + x102*&
                  x103 + x103*x104 - x103*x111 - x103*x112 - x103*x114 - x103* &
                  x115 - x103*x156 + x106*x185 + x106*x186 + x106*x34 + x106*  &
                  x35 - x108*x159 + x108*x95 + x108*x97 + x108*x99 - x113*x59  &
                   - x116*x59 - x118*x38 - x118*x43 - x119*x139 - x120*x39 -   &
                  x120*x41 - x121*x39 - x121*x40 - x121*x41 - x124*x125 - x127*&
                  x128 - x128*x131 - x129*x23 - x132*x137 - x132*x138 - x132*  &
                  x178 - x140*x144 - x140*x148 - x151*x152 - x154*x155 - x155* &
                  x158 - x156*x157 - x16*x174 - x16*x175 + x160*x42 - x161*x176&
                   + x166*x39 + x166*x40 + x166*x41 - x166*x42 + x167*x67 -    &
                  x169*x40 - x169*x41 - x171*x173 - x172*x173 - x176*x51 - x176&
                  *x52 - x180*x67 - x182*x88 + x183*x40 - x183*x42 + x33*x38 + &
                  x33*x43 + x38*x94 + x39*x96 + x40*x96 + x43*x94 + x46*x48 +  &
                  x50*x54 + x54*x66 + x56*x61 + x56*x64 + x67*x73 + x67*x74 +  &
                  x82*x83 + x83*x93 + x95*x96 + x96*x99
        wout(1) = -P1(0)*x130 + P1(1)*P2(1)*co(1)*w1(1)*x220 + P1(1)*P2(1)*co(1&
                  )*w1(1)*x63 - P1(1)*P2(2)*w1(2)*x171 - 2*P1(1)*w1(1)*x182 -  &
                  P1(1)*x107*x47 - P1(1)*x110 + P1(1)*x188 + P1(1)*x211 - P1(3 &
                  )*P2(3)*w2(1)*x177 + P2(1)*x98 - co(0)*x196 + co(1)*x196 + w2&
                  (1)*x165 - w2(1)*x179 + x0*x160 + x0*x184 - x103*x12 - x103* &
                  x15 + x103*x18 - x103*x208 - x103*x24 - x103*x27 + x103*x30  &
                   + x107*x170 - x113*x200 - x116*x200 - x120*x199 - x121*x199 &
                   - x124*x201 - x127*x202 - x131*x202 - x137*x150 - x138*x150 &
                   - x139*x7 - x144*x153 - x148*x153 - x152*x205 - x155*x207 - &
                  x155*x209 - x157*x208 - x159*x195 - x159*x198 - x161*x214 -  &
                  x162*x182 + x163*x182 - x170*x210 - x171*x217 - x172*x217 +  &
                  x176*x89 - x182*x52 + x186*x197 + x187*x7 + x190*x48 + x192* &
                  x54 + x193*x54 + x194*x82 + x194*x93 + x195*x40 + x195*x41 - &
                  x195*x42 + x195*x99 + x197*x35 + x198*x95 + x198*x97 + x198* &
                  x99 + x2*x38 + x2*x43 + x20*x57 - x203*x23 + x212*x40 + x212*&
                  x41 - x212*x42 - x213*x40 - x213*x41 - x215*x62 - x216*x75 - &
                  x216*x84 - x218*x84 + x219*x40 - x219*x42 + x29*x61 + x29*x64&
                   + x32*x57 + x38*x4 - x38*x6 + x4*x43 - x40*x9 - x41*x8 - x41&
                  *x9 + x42*x9 - x43*x6 + x45*x73 + x45*x74
        wout(2) = -P1(0)*P2(0)*w1(2)*x233 - P1(1)*P2(1)*w2(2)*x177 - P1(1)*x157&
                  *x29 + P1(2)*P2(0)*w1(0)*x171 - 2*P1(2)*P2(2)*x178 - P1(2)*P2&
                  (3)*w1(3)*x171 - P1(2)*x107*x47 - P1(2)*x109 - P1(2)*x168 +  &
                  P1(2)*x188 + P1(2)*x211 - P1(3)*P2(3)*w2(2)*x177 - co(0)*x229&
                   + co(1)*w1(2)*x34*x60 + co(1)*x229 - w2(2)*x179 + x103*x141 &
                   + x103*x142 - x103*x143 + x103*x145 + x103*x146 - x103*x147 &
                   + x103*x226 + x107*x230 - x113*x206 - x116*x206 - x120*x204 &
                   - x121*x204 - x122*x180 - x122*x237 + x123*x73 + x123*x74 - &
                  x125*x190 - x128*x192 - x128*x193 - x129*x29 + x13*x176 -    &
                  x133*x38 - x133*x43 - x134*x38 - x134*x43 + x135*x38 + x135* &
                  x43 - x136*x187 + x137*x39 + x137*x41 + x138*x39 + x138*x41  &
                   - x138*x42 - x144*x58 - x148*x58 + x149*x8 + x149*x9 + x152*&
                  x224 + x155*x225 + x155*x227 + x157*x226 - x159*x228 - x159* &
                  x231 - x161*x216 + x163*x216 - x171*x235 - x174*x21 + x176*  &
                  x25 - x182*x76 - x182*x85 + x19*x222 + x201*x46 + x202*x50 + &
                  x202*x66 + x203*x56 + x206*x232 - x21*x238 - x210*x230 - x214&
                  *x76 + x221*x56 + x222*x31 + x223*x82 + x223*x93 + x228*x39  &
                   + x228*x41 - x228*x42 + x228*x95 + x228*x99 + x231*x95 +    &
                  x231*x97 + x231*x99 + x233*x234 + x233*x235 + x233*x236 +    &
                  x234*x240 + x236*x240 + x239*x40 - x239*x42
        wout(3) = P1(1)*P2(1)*w1(3)*x233 - P1(3)*P2(2)*w1(2)*x171 - 2*P1(3)*w1(&
                  3)*x174 - P1(3)*x109 - P1(3)*x110 - P1(3)*x168 + P1(3)*x188  &
                   + P2(3)*x98 + w1(3)*x107*x60 - w2(3)*x179 - w2(3)*x181 -    &
                  x100*x182 - x100*x214 + x103*x241 - x103*x78 - x103*x80 +    &
                  x103*x81 - x103*x87 - x103*x91 + x103*x92 - x113*x191 - x116*&
                  x191 - x120*x189 - x121*x189 - x122*x137 - x122*x138 + x125* &
                  x205 - x126*x144 - x126*x148 + x128*x207 + x128*x209 - x151* &
                  x201 - x154*x202 + x157*x241 - x158*x202 - x159*x167 - x159* &
                  x244 + x160*x67 - x161*x174 - x162*x175 + x163*x174 + x167*  &
                  x39 + x167*x40 - x167*x42 + x167*x95 + x169*x67 + x176*x28 - &
                  x180*x36 - x182*x55 + x184*x67 + x185*x243 + x191*x232 + x20*&
                  x49 - x203*x86 - x215*x65 - x216*x22 - x218*x22 - x221*x86 - &
                  x224*x48 - x225*x54 - x227*x54 + x233*x245 + x233*x246 - x233&
                  *x247 - x237*x40 - x238*x51 + x240*x245 + x240*x246 - x240*  &
                  x247 + x242*x82 + x242*x93 + x243*x34 + x243*x35 - x243*x37  &
                   + x244*x95 + x244*x97 + x244*x99 + x32*x49 + x38*x69 + x38* &
                  x71 - x38*x72 - x39*x73 - x39*x74 - x40*x73 - x40*x74 + x42* &
                  x73 + x42*x74 + x43*x69 + x43*x71 - x43*x72 + x44*x8 + x44*x9&
                   - x61*x90 - x64*x90
      case(VVV8)
!       c0*(P(1,2)*P(2,3)*P(3,1) - P(1,3)*P(2,1)*P(3,2))
!       c1*(Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3,
!       1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) + Metric(1,3)*P(-1,2)*P(-1,3)*P(2
!       ,1) + Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(-2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*      
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*Epsilon(-1,-2
!       ,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + 2*Epsilon(-1,-2,1,2)*P 
!       (-1,2)*P(-2,3)*P(3,1) - 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) + 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) - 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(Metric(1,3)*P(2,3) - Metric(2,3)*P(1,3))
!       c5*(Metric(1,2)*P(3,1) - Metric(1,2)*P(3,2) - Metric(1,3)*P(2,1) + Metric
!       (2,3)*P(1,2))
!       Epsilon(-1,1,2,3)*P(-1,3)*c6
!       c7*(Epsilon(-1,1,2,3)*P(-1,1) + Epsilon(-1,1,2,3)*P(-1,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3)
        x1 = w1(3)*w2(2)
        x2 = x0 - x1
        x3 = P1(1)*x2
        x4 = w1(1)*w2(3)
        x5 = -w1(3)*w2(1) + x4
        x6 = P1(2)*x5
        x7 = w1(1)*w2(2)
        x8 = -w1(2)*w2(1) + x7
        x9 = P1(3)*x8
        x10 = w1(3)*w2(3)
        x11 = w1(0)*w2(0)
        x12 = w1(1)*w2(1) + w1(2)*w2(2) + x10 - x11
        x13 = co(5)*x12
        x14 = P2(1)*x2
        x15 = P2(2)*x5
        x16 = P2(3)*x8
        x17 = x14 - x15 + x16
        x18 = P1(1)**2
        x19 = 2*co(3)*x18
        x20 = P1(2)**2
        x21 = 2*co(3)*x20
        x22 = P1(3)**2
        x23 = 2*co(3)*x22
        x24 = P1(0)**2
        x25 = 2*co(3)*x24
        x26 = P2(1)**2
        x27 = co(1)*x12*x26
        x28 = P2(2)**2
        x29 = co(1)*x12*x28
        x30 = P2(3)**2
        x31 = co(1)*x12*x30
        x32 = co(4)*w1(0)*w2(1)
        x33 = co(5)*w1(0)*w2(1)
        x34 = P1(2)*w1(0)
        x35 = co(4)*w2(2)
        x36 = P1(3)*w1(0)
        x37 = co(4)*w2(3)
        x38 = P2(0)*co(5)
        x39 = P2(2)*w1(0)
        x40 = w1(0)*w2(3)
        x41 = P2(3)*co(4)
        x42 = P2(0)**2
        x43 = P1(1)*w2(1)
        x44 = P1(2)*w2(2)
        x45 = P1(3)*w2(3)
        x46 = P1(0)*w2(0)
        x47 = x43 + x44 + x45 - x46
        x48 = w1(0)*x42*x47
        x49 = P2(2)*w1(2)
        x50 = P2(3)*w1(3)
        x51 = -P2(0)*w1(0) + P2(1)*w1(1) + x49 + x50
        x52 = co(1)*x18*x51
        x53 = co(1)*x20*x51
        x54 = co(1)*x22*x51
        x55 = P1(0)*w1(0)
        x56 = co(5)*w2(0)
        x57 = P1(1)*w1(1)
        x58 = co(4)*w2(0)
        x59 = P1(2)*w2(0)
        x60 = co(4)*w1(2)
        x61 = P1(3)*w2(0)
        x62 = co(4)*w1(3)
        x63 = P2(0)*co(1)*x12
        x64 = co(1)*x12*x20
        x65 = P2(1)*w2(0)
        x66 = co(4)*w1(1)
        x67 = co(5)*w1(1)
        x68 = P2(2)*co(5)*w1(2)
        x69 = P2(3)*w2(0)
        x70 = co(5)*w1(3)
        x71 = co(1)*x26
        x72 = w1(0)*x47
        x73 = co(1)*x28
        x74 = co(1)*x30*x47
        x75 = co(1)*x24*x51
        x76 = 4*P1(1)*P2(1)*co(3)
        x77 = 4*co(3)*x51
        x78 = P2(2)*w2(3) - P2(3)*w2(2)
        x79 = P1(1)*x78
        x80 = P1(2)*P2(2)
        x81 = 4*co(3)*x17
        x82 = P1(3)*P2(3)
        x83 = P2(1)*w2(2) - P2(2)*w2(1)
        x84 = 4*P1(3)*co(3)*x51
        x85 = P1(0)*P2(1)
        x86 = P1(0)*x2
        x87 = w1(0)*w2(2) - w1(2)*w2(0)
        x88 = P1(3)*x87
        x89 = w1(3)*w2(0)
        x90 = x40 - x89
        x91 = P1(2)*x90
        x92 = x86 + x88 - x91
        x93 = 2*co(3)*x92
        x94 = P2(0)*x2
        x95 = P2(3)*x87
        x96 = P2(2)*x90
        x97 = x94 + x95 - x96
        x98 = 2*co(3)*x97
        x99 = P1(0)*P2(3)
        x100 = P1(0)*x8
        x101 = w1(0)*w2(1)
        x102 = -w1(1)*w2(0) + x101
        x103 = P1(2)*x102
        x104 = P1(1)*x87
        x105 = x100 + x103 - x104
        x106 = 2*co(3)*x105
        x107 = P2(0)*x8
        x108 = P2(2)*x102
        x109 = P2(1)*x87
        x110 = x107 + x108 - x109
        x111 = 2*co(3)*x110
        x112 = P1(2)*w2(3)
        x113 = P1(3)*w2(2)
        x114 = x112 - x113
        x115 = P1(1)*w2(2)
        x116 = P1(2)*w2(1)
        x117 = x115 - x116
        x118 = P1(1)*w2(3)
        x119 = P1(3)*w2(1)
        x120 = x118 - x119
        x121 = 2*co(2)*(P2(1)*x114 - P2(2)*x120 + P2(3)*x117)
        x122 = P2(1)*w2(3)
        x123 = P2(3)*w2(1)
        x124 = x122 - x123
        x125 = 2*co(2)*(P2(1)*x78 - P2(2)*x124 + P2(3)*x83)
        x126 = P1(2)*w1(3)
        x127 = P1(3)*w1(2)
        x128 = x126 - x127
        x129 = P2(1)*x128
        x130 = P1(1)*w1(2)
        x131 = P1(2)*w1(1)
        x132 = x130 - x131
        x133 = P2(3)*x132
        x134 = P1(1)*w1(3)
        x135 = P1(3)*w1(1)
        x136 = x134 - x135
        x137 = P2(2)*x136
        x138 = 2*co(2)*(x129 + x133 - x137)
        x139 = P2(2)*w1(3)
        x140 = P2(3)*w1(2)
        x141 = x139 - x140
        x142 = P2(1)*x141
        x143 = P2(1)*w1(2)
        x144 = P2(2)*w1(1)
        x145 = x143 - x144
        x146 = P2(3)*x145
        x147 = P2(3)*w1(1)
        x148 = P2(1)*w1(3) - x147
        x149 = P2(2)*x148
        x150 = 2*co(2)*(x142 + x146 - x149)
        x151 = 2*P1(1)*P2(0)*co(3)
        x152 = P1(1)*P2(1)
        x153 = x3 - x6 + x9
        x154 = 2*co(3)*x153
        x155 = 2*P1(1)*co(3)*x51
        x156 = 2*co(3)*x47
        x157 = P1(1)*x141
        x158 = P2(1)*w2(1)
        x159 = P2(0)*w2(0)
        x160 = P2(2)*w2(2) + P2(3)*w2(3) + x158 - x159
        x161 = 2*co(3)*x160
        x162 = P1(2)*w1(2)
        x163 = P1(3)*w1(3)
        x164 = x162 + x163 - x55 + x57
        x165 = 2*co(3)*x164
        x166 = 2*co(3)*(x26 + x28 + x30 - x42)
        x167 = P1(0)*P2(0)
        x168 = 2*co(3)*(x152 - x167 + x80 + x82)
        x169 = P1(0)*w2(1)
        x170 = P1(1)*w2(0)
        x171 = x169 - x170
        x172 = P1(0)*w2(3)
        x173 = x172 - x61
        x174 = 2*co(2)*(P2(0)*x120 - P2(1)*x173 + P2(3)*x171)
        x175 = P2(0)*w2(1) - x65
        x176 = P2(0)*w2(3) - x69
        x177 = 2*co(2)*(P2(0)*x124 - P2(1)*x176 + P2(3)*x175)
        x178 = P2(0)*x136
        x179 = P1(0)*w1(1)
        x180 = P1(1)*w1(0)
        x181 = x179 - x180
        x182 = P2(3)*x181
        x183 = P1(0)*w1(3)
        x184 = x183 - x36
        x185 = P2(1)*x184
        x186 = 2*co(2)*(x178 + x182 - x185)
        x187 = P2(0)*x148
        x188 = P2(0)*w1(1)
        x189 = P2(1)*w1(0)
        x190 = x188 - x189
        x191 = P2(3)*x190
        x192 = P2(3)*w1(0)
        x193 = P2(0)*w1(3) - x192
        x194 = P2(1)*x193
        x195 = 2*co(2)*(x187 + x191 - x194)
        x196 = P1(1)*P2(3)
        x197 = P1(3)*P2(1)
        x198 = x196 - x197
        x199 = 2*P1(2)*co(2)*x12
        x200 = P1(3)*P2(0)
        x201 = 2*P1(3)*co(3)*x51
        x202 = 2*P1(3)*co(3)*x160
        x203 = 2*P1(3)*co(3)*x164
        x204 = P1(0)*P2(2)
        x205 = P1(0)*x5
        x206 = P1(3)*x102
        x207 = P1(1)*x90
        x208 = x205 + x206 - x207
        x209 = 2*co(3)*x208
        x210 = P2(0)*x5
        x211 = P2(3)*x102
        x212 = P2(1)*x90
        x213 = x210 + x211 - x212
        x214 = 2*co(3)*x213
        x215 = P1(0)*w2(2)
        x216 = x215 - x59
        x217 = 2*co(2)*(P2(0)*x114 - P2(2)*x173 + P2(3)*x216)
        x218 = P2(0)*w2(2)
        x219 = -P2(2)*w2(0) + x218
        x220 = 2*co(2)*(P2(0)*x78 - P2(2)*x176 + P2(3)*x219)
        x221 = P2(0)*x128
        x222 = P1(0)*w1(2)
        x223 = x222 - x34
        x224 = P2(3)*x223
        x225 = P2(2)*x184
        x226 = 2*co(2)*(x221 + x224 - x225)
        x227 = P2(0)*x141
        x228 = P2(0)*w1(2) - x39
        x229 = P2(3)*x228
        x230 = P2(2)*x193
        x231 = 2*co(2)*(x227 + x229 - x230)
        x232 = P1(2)*P2(3)
        x233 = P1(3)*P2(2)
        x234 = x232 - x233
        x235 = 2*P1(1)*co(2)*x12
        x236 = P1(2)*P2(0)
        x237 = 2*P1(2)*co(3)*x51
        x238 = 2*P1(2)*co(3)*x47
        x239 = 2*P1(2)*co(3)*x160
        x240 = 2*P1(2)*co(3)*x164
        x241 = 2*co(2)*(P2(0)*x117 - P2(1)*x216 + P2(2)*x171)
        x242 = 2*co(2)*(P2(0)*x83 - P2(1)*x219 + P2(2)*x175)
        x243 = P2(0)*x132
        x244 = P2(2)*x181
        x245 = P2(1)*x223
        x246 = 2*co(2)*(x243 + x244 - x245)
        x247 = P2(0)*x145
        x248 = P2(2)*x190
        x249 = P2(1)*x228
        x250 = 2*co(2)*(x247 + x248 - x249)
        x251 = P1(1)*P2(2)
        x252 = P1(2)*P2(1)
        x253 = x251 - x252
        x254 = 2*P1(3)*co(2)*x12
        x255 = 4*P1(2)*co(3)*x51
        x256 = 6*co(3)
        x257 = 8*co(3)
        x258 = P1(0)*co(1)*x12
        x259 = co(0)*w1(0)*x160
        x260 = P1(0)*P2(0)*co(1)*x164
        x261 = P1(1)*co(0)*x47
        x262 = co(1)*w1(0)*x160
        x263 = w1(2)*x47
        x264 = co(0)*w1(3)*x47
        x265 = P2(1)*co(0)*x47
        x266 = P2(0)*co(0)*x47
        x267 = co(0)*w1(1)*x47
        x268 = co(0)*w1(1)*x160
        x269 = co(0)*x47
        x270 = P1(0)*P2(2)*w1(2)
        x271 = co(0)*x160
        x272 = P2(3)*co(0)*x47
        x273 = P2(3)*co(0)*x160
        x274 = P1(1)*co(1)*x164
        x275 = P1(2)*P2(2)*co(1)*x164
        x276 = P2(3)*co(1)*x12
        x277 = co(1)*x164
        x278 = co(4)*w2(1)
        x279 = co(4)*w1(1)*w2(3)
        x280 = co(5)*w1(1)*w2(3)
        x281 = P2(0)*co(4)
        x282 = P2(1)*co(1)*x12
        x283 = co(1)*x42*x47
        x284 = co(1)*x12*x42
        x285 = w1(1)*x47
        x286 = 4*P1(0)*co(3)*x51
        x287 = 4*co(3)*x97
        x288 = 4*co(3)*x219*x51
        x289 = 2*P1(0)*co(3)*x51
        x290 = 2*P1(0)*co(3)*x47
        x291 = 2*P1(0)*co(3)*x160
        x292 = 2*P1(0)*co(3)*x164
        x293 = 2*co(2)*x12*(-x200 + x99)
        x294 = 2*co(3)*x228*x47
        x295 = 2*co(3)*x17
        x296 = 2*P1(0)*co(2)*x12
        x297 = P1(1)*P2(0)
        x298 = 2*co(3)*x160*x193
        x299 = x204 - x236
        x300 = 4*co(3)*x176*x51
        x301 = P1(1)*co(1)*x12
        x302 = co(0)*w1(0)*x47
        x303 = co(1)*w1(1)*x160
        x304 = P1(2)*co(0)*x47
        x305 = P2(2)*co(0)*x47
        x306 = P1(0)*P2(0)*co(1)*x12
        x307 = P1(1)*P2(2)*w1(2)
        x308 = co(4)*w1(0)
        x309 = P1(1)*w1(2)*w2(1)
        x310 = co(5)*w1(2)
        x311 = P1(3)*w1(2)*w2(3)
        x312 = P2(2)*co(1)*x12
        x313 = w1(2)*x28*x47
        x314 = P2(1)*w1(1)*w2(2)
        x315 = P2(3)*co(5)
        x316 = co(1)*x30
        x317 = 4*co(3)*x213
        x318 = 2*P1(1)*co(3)*x164
        x319 = -x297 + x85
        x320 = P1(0)*x124
        x321 = P1(3)*x190
        x322 = P2(0)*co(1)*x164
        x323 = co(1)*x160
        x324 = P1(3)*co(1)*x12
        x325 = P1(2)*P2(2)*w1(2)
        x326 = P1(3)*co(0)*x47
        x327 = co(1)*w2(2)*x164
        x328 = P1(2)*P2(1)*w1(1)
        x329 = w1(3)*x47
        x330 = 4*co(3)*x110
        x331 = 2*P1(3)*P2(2)*co(3)
        x332 = co(1)*w2(3)*x164
        wout(0) = P1(0)*P2(0)*x153*x256 + P1(0)*P2(0)*x17*x257 - P1(0)*x13 + P1&
                  (0)*x27 + P1(0)*x29 + P1(0)*x31 + P1(1)*x32 + P1(1)*x33 + P1(&
                  2)*P2(0)*co(0)*x263 - P1(3)*P2(3)*w2(0)*x277 - P1(3)*x145*   &
                  x156 + P2(0)*x13 - P2(0)*x64 + P2(1)*x32 - co(0)*x48 + co(1)*&
                  x48 + co(5)*w2(2)*x34 + co(5)*w2(3)*x36 - co(6)*x14 + co(6)* &
                  x15 - co(6)*x16 - co(6)*x3 + co(6)*x6 - co(6)*x9 + co(7)*x14 &
                   - co(7)*x15 + co(7)*x16 + co(7)*x3 - co(7)*x6 + co(7)*x9 -  &
                  w1(0)*x74 + w2(0)*x260 - w2(0)*x275 + w2(0)*x52 + w2(0)*x53  &
                   + w2(0)*x54 - w2(0)*x68 - w2(0)*x75 - x106*x200 - x106*x99  &
                   + x11*x38 - x111*x200 - x111*x99 - x114*x155 - x117*x201 +  &
                  x120*x237 - x121*x55 + x124*x240 + x124*x255 - x125*x55 +    &
                  x129*x156 + x133*x156 - x137*x156 - x138*x46 + x142*x156 -   &
                  x145*x202 + x146*x156 + x148*x238 + x148*x239 - x149*x156 -  &
                  x150*x46 - x151*x92 - x151*x97 - x152*x154 + x152*x258 + x152&
                  *x262 - x152*x63 - x154*x80 - x154*x82 - x156*x157 - x157*   &
                  x161 - x165*x79 - x166*x3 + x166*x6 - x166*x9 + x167*x259 -  &
                  x167*x262 - x168*x3 + x168*x6 - x168*x9 - x17*x19 - x17*x21  &
                   - x17*x23 + x17*x25 - x17*x76 + x170*x226 + x170*x231 - x174&
                  *x34 - x177*x34 - x18*x63 + x180*x217 + x180*x220 - x183*x272&
                   - x183*x273 - x186*x59 + x188*x261 + x188*x265 - x195*x59 - &
                  x198*x199 + x200*x264 - x200*x276 - x203*x83 + x204*x209 +   &
                  x204*x214 + x209*x236 + x214*x236 - x22*x63 + x234*x235 +    &
                  x241*x36 + x242*x36 + x246*x61 + x250*x61 + x253*x254 + x258*&
                  x80 + x258*x82 + x262*x80 + x262*x82 + x266*x49 + x266*x50 - &
                  x267*x85 - x268*x85 - x269*x270 - x270*x271 - x274*x65 + x34*&
                  x35 + x35*x39 + x36*x37 + x40*x41 - x49*x58 - x55*x56 - x57* &
                  x58 - x59*x60 - x61*x62 - x62*x69 - x63*x80 - x65*x66 - x65* &
                  x67 - x69*x70 - x71*x72 - x72*x73 - x77*x79 - x80*x81 - x81* &
                  x82 - x83*x84 - x85*x93 - x85*x98
        wout(1) = -P1(1)*P2(1)*w2(1)*x277 - P1(1)*P2(1)*x256*x92 - P1(1)*P2(1)*&
                  x257*x97 - P1(1)*x13 - P1(1)*x284 + P1(1)*x29 - P1(1)*x306 + &
                  P1(1)*x31 - P1(2)*x293 + P1(2)*x298 + P1(2)*x300 - P1(3)*P2(3&
                  )*w2(1)*x277 + P1(3)*x279 + P1(3)*x280 - P1(3)*x288 - P1(3)* &
                  x294 + P2(0)*x33 + P2(1)*x13 - P2(1)*x64 + P2(2)*co(4)*x7 -  &
                  co(6)*x86 - co(6)*x88 + co(6)*x91 - co(6)*x94 - co(6)*x95 +  &
                  co(6)*x96 + co(7)*x86 + co(7)*x88 - co(7)*x91 + co(7)*x94 +  &
                  co(7)*x95 - co(7)*x96 + w1(1)*x283 - w1(1)*x74 + w2(1)*x260  &
                   - w2(1)*x275 + w2(1)*x52 + w2(1)*x53 + w2(1)*x54 - w2(1)*x68&
                   - w2(1)*x75 + x101*x281 - x106*x196 - x106*x197 - x111*x196 &
                   - x111*x197 - x114*x289 - x116*x186 - x116*x195 + x119*x246 &
                   + x119*x250 - x121*x179 - x123*x62 - x123*x70 - x125*x179 - &
                  x131*x174 - x131*x177 - x134*x272 - x134*x273 + x135*x241 +  &
                  x135*x242 - x138*x169 - x141*x290 - x141*x291 + x143*x304 +  &
                  x143*x305 - x150*x169 + x151*x17 - x152*x268 + x152*x303 +   &
                  x154*x297 + x154*x85 + x156*x221 + x156*x224 - x156*x225 +   &
                  x156*x227 + x156*x229 - x156*x230 - x158*x67 - x162*x278 +   &
                  x163*x265 - x163*x278 - x166*x86 - x166*x88 + x166*x91 + x167&
                  *x282 + x167*x287 - x167*x303 + x167*x93 - x168*x86 - x168*  &
                  x88 + x168*x91 + x173*x237 + x176*x240 - x188*x58 - x189*x266&
                   - x19*x97 + x193*x238 - x201*x216 - x202*x228 - x203*x219 + &
                  x209*x251 + x209*x252 - x21*x97 + x214*x251 + x214*x252 +    &
                  x217*x57 - x22*x282 + x220*x57 + x226*x43 - x23*x97 + x231*  &
                  x43 + x234*x296 + x24*x282 + x25*x97 + x254*x299 + x259*x297 &
                   + x26*x267 + x265*x50 - x265*x55 - x269*x307 - x271*x307 -  &
                  x278*x49 + x278*x55 - x282*x80 - x282*x82 - x285*x71 - x285* &
                  x73 - x286*x78 - x287*x80 - x287*x82 - x292*x78 + x295*x85 + &
                  x297*x302 + x301*x80 + x301*x82 + x303*x80 + x303*x82 + x4*  &
                  x41 + x43*x67 + x44*x66 + x44*x67 - x46*x66 - x46*x67 - x80* &
                  x93 - x82*x93
        wout(2) = -P1(0)*P2(0)*w1(2)*x323 + P1(1)*P1(2)*P2(1)*co(1)*x12 + P1(1 &
                  )*P2(1)*w1(2)*x323 - P1(1)*x156*x193 + P1(1)*x293 - P1(1)*   &
                  x298 - P1(1)*x300 + P1(2)*P2(0)*w1(0)*x271 + P1(2)*P2(2)*x208&
                  *x256 + P1(2)*P2(2)*x213*x257 - P1(2)*x13 + P1(2)*x27 - P1(2 &
                  )*x284 - P1(2)*x306 + P1(2)*x31 + P1(3)*P2(3)*w1(2)*x323 - P1&
                  (3)*co(4)*x1 + P2(2)*x13 + co(0)*x313 + co(1)*x263*x42 - co(1&
                  )*x313 + co(4)*x309 + co(4)*x311 - co(4)*x314 + co(5)*w1(0)* &
                  x218 + co(5)*x309 + co(5)*x311 - co(5)*x314 + co(6)*x205 + co&
                  (6)*x206 - co(6)*x207 + co(6)*x210 + co(6)*x211 - co(6)*x212 &
                   - co(7)*x205 - co(7)*x206 + co(7)*x207 - co(7)*x210 - co(7)*&
                  x211 + co(7)*x212 + w2(2)*x52 + w2(2)*x53 + w2(2)*x54 - w2(2 &
                  )*x68 - w2(2)*x75 - x1*x315 - x1*x41 - x106*x232 - x106*x233 &
                   - x111*x232 - x111*x233 + x113*x246 + x113*x250 + x115*x226 &
                   + x115*x231 + x120*x289 - x121*x222 - x125*x222 - x126*x272 &
                   - x126*x273 + x127*x241 + x127*x242 + x130*x217 + x130*x220 &
                   - x138*x215 + x139*x272 + x139*x326 + x140*x37 + x143*x278  &
                   + x144*x265 + x148*x290 + x148*x291 - x150*x215 + x152*x209 &
                   - x152*x312 - x152*x327 + x154*x204 + x154*x236 - x155*x173 &
                   - x156*x178 - x156*x182 + x156*x185 - x156*x187 - x156*x191 &
                   + x156*x194 + x156*x321 - x159*x60 + x161*x321 - x162*x174  &
                   - x162*x177 + x165*x320 + x166*x205 + x166*x206 - x166*x207 &
                   - x167*x209 + x167*x312 - x167*x317 + x168*x205 + x168*x206 &
                   - x168*x207 + x171*x201 + x175*x203 + x175*x84 - x176*x318  &
                   - x18*x312 - x186*x44 + x19*x213 - x195*x44 - x198*x296 +   &
                  x204*x295 + x209*x82 + x21*x213 + x213*x23 - x213*x25 + x213*&
                  x76 + x215*x308 + x215*x322 + x218*x308 - x22*x312 + x232*   &
                  x324 + x236*x295 + x24*x312 - x251*x93 - x251*x98 - x252*x93 &
                   - x252*x98 - x254*x319 - x263*x316 - x263*x71 + x266*x34 -  &
                  x266*x39 - x269*x328 - x271*x325 - x271*x328 - x305*x55 +    &
                  x305*x57 + x310*x44 - x310*x46 - x312*x82 + x317*x82 + x320* &
                  x77 + x323*x325 - x327*x80 - x327*x82 - x35*x57 - x46*x60
        wout(3) = -P1(0)*P2(0)*w1(3)*x323 + P1(1)*P2(1)*w1(3)*x323 + P1(1)*x161&
                  *x228 - P1(1)*x279 + P1(1)*x288 + P1(1)*x294 + P1(2)*P2(2)*w1&
                  (3)*x323 - P1(2)*co(4)*x0 - P1(3)*P2(1)*w1(1)*x271 - P1(3)*P2&
                  (2)*w1(2)*x271 + P1(3)*P2(3)*w1(3)*x323 - P1(3)*P2(3)*x105*  &
                  x256 - P1(3)*P2(3)*x110*x257 + P1(3)*co(5)*x10 - P1(3)*x13 + &
                  P1(3)*x27 - P1(3)*x284 + P1(3)*x29 - P2(1)*x279 - P2(1)*x280 &
                   + P2(3)*x13 - P2(3)*x64 - co(6)*x100 - co(6)*x103 + co(6)*  &
                  x104 - co(6)*x107 - co(6)*x108 + co(6)*x109 + co(7)*x100 + co&
                  (7)*x103 - co(7)*x104 + co(7)*x107 + co(7)*x108 - co(7)*x109 &
                   + w1(3)*x283 + w2(3)*x52 + w2(3)*x53 + w2(3)*x54 - w2(3)*x68&
                   - w2(3)*x75 - x10*x315 - x100*x166 - x100*x168 - x103*x166  &
                   - x103*x168 + x104*x166 + x104*x168 - x106*x152 + x106*x167 &
                   - x106*x80 - x110*x19 - x110*x21 - x110*x23 + x110*x25 -    &
                  x112*x186 - x112*x195 - x117*x289 + x118*x226 + x118*x231 -  &
                  x121*x183 - x122*x274 - x125*x183 - x126*x174 - x126*x177 +  &
                  x134*x217 + x134*x220 - x135*x265 - x138*x172 + x139*x35 +   &
                  x140*x304 + x140*x305 - x145*x290 - x145*x291 + x147*x261 +  &
                  x147*x265 - x150*x172 - x152*x276 + x152*x324 - x152*x330 +  &
                  x154*x200 + x154*x99 + x155*x216 + x156*x243 + x156*x244 -   &
                  x156*x245 + x156*x247 + x156*x248 - x156*x249 + x158*x62 +   &
                  x163*x241 + x163*x242 - x163*x273 + x167*x276 + x167*x330 -  &
                  x171*x237 + x172*x308 + x172*x322 - x175*x240 - x175*x255 -  &
                  x18*x276 - x183*x56 - x183*x58 - x190*x238 - x190*x239 - x192&
                  *x266 - x196*x93 - x196*x98 - x197*x93 - x197*x98 + x199*x319&
                   - x200*x258 + x200*x259 + x200*x295 + x200*x302 + x208*x331 &
                   + x209*x232 + x213*x331 + x214*x232 + x219*x318 - x235*x299 &
                   + x24*x276 + x246*x45 + x250*x45 + x253*x296 + x264*x30 -   &
                  x272*x55 - x276*x80 + x281*x40 - x281*x89 - x286*x83 - x292* &
                  x83 + x295*x99 - x316*x329 + x324*x80 - x326*x49 - x329*x71  &
                   - x329*x73 - x330*x80 - x332*x80 - x332*x82 - x37*x49 + x38*&
                  x40 + x43*x62 + x43*x70 + x44*x62 + x44*x70
      case(VVV9)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(2,3)*P(-1,1)*P(-1,2)*P(
!       1,3))
!       c2*(-Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1) - Metric(2,3)*P(-1,1)*P(-1,3)*P(1
!       ,2))
!       c3*(Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + Epsilon(-1,-2,2,3)*P(-1,1
!       )*P(-2,3)*P(1,2))
        if (last) VB_last = .true.
        x0 = P2(1)**2
        x1 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x2 = P1(0)*co(1)*x1
        x3 = P2(2)**2
        x4 = P2(3)**2
        x5 = P1(3)*w2(2)
        x6 = P1(2)*w2(3) - x5
        x7 = P2(2)*w1(2)
        x8 = P2(3)*w1(3)
        x9 = P2(0)*w1(0)
        x10 = P2(1)*w1(1) + x7 + x8 - x9
        x11 = P1(1)*co(3)*x10
        x12 = P2(2)*w2(3) - P2(3)*w2(2)
        x13 = P1(2)*w2(1)
        x14 = P1(1)*w2(2) - x13
        x15 = P1(3)*co(3)*x10
        x16 = P2(1)*w2(2) - P2(2)*w2(1)
        x17 = P1(1)**2
        x18 = P2(0)*co(1)*x1
        x19 = P1(2)**2
        x20 = co(1)*x1*x19
        x21 = P1(3)**2
        x22 = P1(2)*w1(3)
        x23 = -P1(3)*w1(2) + x22
        x24 = P1(2)*w2(2)
        x25 = P1(3)*w2(3)
        x26 = -P1(0)*w2(0) + P1(1)*w2(1) + x24 + x25
        x27 = P2(1)*co(3)*x26
        x28 = P2(2)*w1(3)
        x29 = P2(3)*w1(2)
        x30 = x28 - x29
        x31 = P1(2)*w1(1)
        x32 = P1(1)*w1(2) - x31
        x33 = P2(3)*co(3)*x26
        x34 = P2(1)*w1(2)
        x35 = P2(2)*w1(1)
        x36 = x34 - x35
        x37 = P2(0)**2
        x38 = w1(0)*x26*x37
        x39 = co(2)*x0*x26
        x40 = co(2)*w1(0)*x26
        x41 = co(2)*x10*x17
        x42 = co(2)*x10*x19
        x43 = co(2)*x10*x21
        x44 = P1(1)*w2(3) - P1(3)*w2(1)
        x45 = P1(2)*co(3)*x10
        x46 = P2(1)*w2(3) - P2(3)*w2(1)
        x47 = P1(1)*w1(3)
        x48 = P1(3)*w1(1)
        x49 = x47 - x48
        x50 = P2(2)*co(3)*x26
        x51 = P2(3)*w1(1)
        x52 = P2(1)*w1(3) - x51
        x53 = P1(0)**2
        x54 = co(2)*x10*x53
        x55 = co(1)*x1*x37
        x56 = P1(1)*P2(1)
        x57 = P1(3)*P2(3)
        x58 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x59 = co(0)*x58
        x60 = P1(0)*P2(0)*w1(0)
        x61 = P1(1)*P2(1)*co(1)*x1
        x62 = P2(1)*w1(0)
        x63 = P1(1)*co(1)*x26
        x64 = co(1)*x58
        x65 = P1(1)*P2(1)*w1(0)
        x66 = P1(1)*P2(1)*w2(0)
        x67 = P1(1)*w1(1)
        x68 = P1(2)*w1(2)
        x69 = P1(3)*w1(3)
        x70 = P1(0)*w1(0)
        x71 = x67 + x68 + x69 - x70
        x72 = co(1)*x71
        x73 = co(1)*x10
        x74 = co(2)*x26
        x75 = co(2)*x10
        x76 = P1(2)*P2(2)*co(1)*x1
        x77 = P1(2)*P2(2)*w1(0)
        x78 = co(1)*x26
        x79 = P1(2)*P2(2)*w2(0)
        x80 = P1(3)*P2(3)*co(1)*x1
        x81 = P1(3)*P2(3)*w1(0)
        x82 = P1(3)*P2(3)*w2(0)
        x83 = P2(0)*co(1)*x58
        x84 = P1(0)*P2(0)*w2(0)
        x85 = P2(0)*co(2)*x26
        x86 = P1(0)*w1(1)
        x87 = P2(1)*co(0)*x26
        x88 = P2(1)*co(0)*x58
        x89 = co(0)*x26
        x90 = P1(0)*P2(2)*w1(2)
        x91 = P1(0)*w1(3)
        x92 = P2(3)*co(0)*x26
        x93 = P2(3)*co(0)*x58
        x94 = P2(0)*co(0)*x26
        x95 = P2(0)*w1(1)
        x96 = P1(0)*co(3)*x10
        x97 = co(1)*x1*x3
        x98 = co(1)*x1*x4
        x99 = P1(0)*w2(2) - P1(2)*w2(0)
        x100 = P2(0)*w2(2) - P2(2)*w2(0)
        x101 = P2(0)*co(3)*x26
        x102 = P2(1)*co(1)*x1
        x103 = P1(2)*w1(0)
        x104 = P1(0)*w1(2) - x103
        x105 = P2(0)*w1(2)
        x106 = P2(2)*w1(0)
        x107 = x105 - x106
        x108 = co(2)*w1(1)*x26
        x109 = P1(0)*w2(3) - P1(3)*w2(0)
        x110 = P2(0)*w2(3) - P2(3)*w2(0)
        x111 = -P1(3)*w1(0) + x91
        x112 = P2(3)*w1(0)
        x113 = P2(0)*w1(3) - x112
        x114 = co(1)*x0*x1
        x115 = P1(1)*co(0)*x26
        x116 = P1(1)*co(0)*x58
        x117 = P1(1)*P2(1)*w1(1)
        x118 = P1(1)*P2(1)*w2(1)
        x119 = P1(2)*P2(2)*w1(1)
        x120 = P2(2)*co(1)*x71
        x121 = P2(2)*co(1)*x10
        x122 = P2(2)*co(2)*x10
        x123 = P1(3)*co(1)*x26
        x124 = P1(3)*co(1)*x58
        x125 = P1(3)*P2(3)*w2(1)
        x126 = P1(3)*co(2)*x26
        x127 = P1(0)*P2(0)*co(1)*x1
        x128 = P1(0)*co(1)*x26
        x129 = P1(0)*co(1)*x58
        x130 = P1(0)*P2(0)*w2(1)
        x131 = P1(0)*co(2)*x26
        x132 = P1(2)*co(0)*x26
        x133 = P2(2)*co(0)*x26
        x134 = 2*co(0)*x26
        x135 = P2(2)*co(1)*x1
        x136 = co(2)*w1(2)*x26
        x137 = P1(0)*w2(1) - P1(1)*w2(0)
        x138 = P2(0)*w2(1) - P2(1)*w2(0)
        x139 = -P1(1)*w1(0) + x86
        x140 = -x62 + x95
        x141 = P1(1)*P2(1)*w1(2)
        x142 = P1(1)*P2(1)*w2(2)
        x143 = P1(2)*P2(2)*w1(2)
        x144 = P2(3)*co(1)*x71
        x145 = P2(3)*co(1)*x10
        x146 = P2(3)*co(2)*x10
        x147 = P1(0)*P2(0)*w2(2)
        x148 = P1(3)*co(0)*x26
        x149 = P2(3)*co(1)*x1
        x150 = co(2)*w1(3)*x26
        x151 = P1(1)*P2(1)*w1(3)
        x152 = P1(1)*P2(1)*w2(3)
        x153 = P1(2)*P2(2)*w1(3)
        x154 = P1(2)*P2(2)*w2(3)
        x155 = P1(3)*P2(0)*w1(0)
        x156 = P1(3)*P2(3)*w1(3)
        x157 = P1(0)*P2(0)*w2(3)
        wout(0) = 2*P1(0)*w1(0)*x94 - 2*P1(0)*x55 + P1(2)*P2(2)*x2 + P2(0)*x20 &
                   + P2(0)*x61 + P2(0)*x76 + P2(0)*x80 + co(0)*x38 - co(2)*x38 &
                   + w1(0)*x39 + w2(0)*x41 + w2(0)*x42 + w2(0)*x43 - w2(0)*x54 &
                   + x0*x2 + x11*x12 + x11*x6 + x14*x15 + x15*x16 + x17*x18 +  &
                  x18*x21 - 2*x18*x53 + x2*x3 + x2*x4 + x2*x56 + x2*x57 + x23* &
                  x27 + x27*x30 + x3*x40 + x32*x33 + x33*x36 + x4*x40 - x44*x45&
                   - x45*x46 - x49*x50 - x50*x52 + x59*x60 - x59*x90 - x60*x78 &
                   + x62*x63 + x64*x65 + x64*x77 + x64*x81 + x65*x74 + x66*x72 &
                   + x66*x73 + x66*x75 - x67*x94 - x68*x94 - x69*x94 - x7*x94  &
                   - x70*x83 - x70*x85 + x72*x79 + x72*x82 - x72*x84 + x73*x79 &
                   + x73*x82 - x73*x84 + x74*x77 + x74*x81 + x75*x79 + x75*x82 &
                   - x75*x84 + x77*x78 + x78*x81 - x8*x94 - x86*x87 - x86*x88  &
                   - x87*x95 - x89*x90 - x91*x92 - x91*x93
        wout(1) = 2*P1(1)*x114 - P1(1)*x127 - P1(1)*x55 + P1(1)*x76 + P1(1)*x80&
                   + P1(1)*x97 + P1(1)*x98 - P2(1)*x127 + P2(1)*x20 + P2(1)*x76&
                   - w1(1)*x0*x89 + w1(1)*x39 + w2(1)*x41 + w2(1)*x42 + w2(1)* &
                  x43 - w2(1)*x54 + x100*x15 + x101*x23 + x101*x30 + 2*x102*x17&
                   + x102*x21 - x102*x53 + x102*x57 + x104*x33 + x107*x33 +    &
                  x108*x3 - x108*x37 + x108*x4 - x109*x45 - x110*x45 - x111*x50&
                   - x113*x50 - x115*x7 + x115*x9 - x116*x7 + x116*x9 - x117*  &
                  x134 + x117*x64 + x117*x74 + x117*x78 + x118*x72 + x118*x73  &
                   + x118*x75 + x119*x64 + x119*x74 + x119*x78 + x12*x96 + x120&
                  *x13 + x121*x13 + x122*x13 + x123*x51 + x124*x51 + x125*x72  &
                   + x125*x73 + x125*x75 + x126*x51 - x128*x95 - x129*x95 -    &
                  x130*x72 - x130*x73 - x130*x75 - x131*x95 - x132*x34 - x133* &
                  x34 + x15*x99 - x47*x92 - x47*x93 + x6*x96 + x62*x94 - x67*  &
                  x88 - x69*x87 + x70*x87 - x8*x87
        wout(2) = P1(2)*P2(0)*w1(0)*x59 + P1(2)*x114 - P1(2)*x127 - P1(2)*x55  &
                   + P1(2)*x61 + P1(2)*x80 + 2*P1(2)*x97 + P1(2)*x98 - P2(2)*  &
                  x127 + 2*P2(2)*x20 - w1(2)*x3*x89 + w1(2)*x39 + w2(2)*x41 +  &
                  w2(2)*x42 + w2(2)*x43 - w2(2)*x54 - x101*x49 - x101*x52 +    &
                  x103*x94 - x105*x128 - x105*x129 - x105*x131 + x106*x94 +    &
                  x109*x11 + x11*x110 + x111*x27 + x113*x27 + x120*x24 + x121* &
                  x24 + x122*x24 + x123*x29 + x124*x29 + x126*x29 - x133*x67 + &
                  x133*x70 - x134*x143 + x135*x17 + x135*x21 - x135*x53 + x135*&
                  x56 + x135*x57 + x136*x3 - x136*x37 + x136*x4 - x137*x15 -   &
                  x138*x15 - x139*x33 - x140*x33 + x141*x64 + x141*x74 + x142* &
                  x72 + x142*x73 + x142*x75 - x143*x59 + x143*x64 + x143*x74 + &
                  x143*x78 + x144*x5 + x145*x5 + x146*x5 - x147*x72 - x147*x73 &
                   - x147*x75 - x148*x28 - x22*x92 - x22*x93 - x28*x92 - x31*  &
                  x87 - x31*x88 + x34*x63 - x35*x87 - x44*x96 - x46*x96
        wout(3) = -P1(0)*P2(0)*w1(3)*x78 - P1(3)*P2(2)*w1(2)*x59 - 2*P1(3)*w1(3&
                  )*x92 + P1(3)*x114 - P1(3)*x127 - P1(3)*x55 + P1(3)*x61 + P1(&
                  3)*x76 + P1(3)*x97 + 2*P1(3)*x98 - P2(3)*x127 + P2(3)*x20 +  &
                  P2(3)*x61 + P2(3)*x76 + w1(3)*x39 - w1(3)*x4*x89 + w2(3)*x41 &
                   + w2(3)*x42 + w2(3)*x43 - w2(3)*x54 - x100*x11 + x101*x32 + &
                  x101*x36 - x104*x27 - x107*x27 - x11*x99 + x112*x94 - x132*  &
                  x29 - x133*x29 + x137*x45 + x138*x45 + x139*x50 + x14*x96 +  &
                  x140*x50 + x144*x25 + x145*x25 + x146*x25 - x148*x7 + x149*  &
                  x17 + 2*x149*x21 - x149*x53 + x150*x3 - x150*x37 + x150*x4 + &
                  x151*x64 + x151*x74 + x151*x78 + x152*x72 + x152*x73 + x152* &
                  x75 + x153*x64 + x153*x74 + x153*x78 + x154*x72 + x154*x73 + &
                  x154*x75 + x155*x59 + x155*x89 + x156*x64 + x156*x74 + x156* &
                  x78 - x157*x72 - x157*x73 - x157*x75 + x16*x96 - x48*x87 -   &
                  x48*x88 - x51*x87 - x67*x92 - x69*x93 + x70*x92 - x83*x91 -  &
                  x85*x91
      case(VVV10)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1) - Metric(2,3)*P(-1,1)*P(-1,3)*P(1
!       ,2))
!       c2*(-Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + Epsilon(-1
!       ,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + Epsilon(-1,-2,1,2)*P(-1,
!       2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) + Epsilon(-
!       1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3) + Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2
!       ,3) - Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + Epsilon(-1,-2,2,3)*P(-1,1
!       )*P(-2,3)*P(1,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(0)**2
        x5 = co(3)*x4
        x6 = P1(1)**2
        x7 = co(3)*x6
        x8 = P1(2)**2
        x9 = co(3)*x8
        x10 = P1(3)**2
        x11 = co(3)*x10
        x12 = P1(0)*P2(0)
        x13 = co(3)*x3
        x14 = P1(0)*x2
        x15 = w1(0)*w2(1) - w1(1)*w2(0)
        x16 = P1(3)*x15
        x17 = w1(0)*w2(3) - w1(3)*w2(0)
        x18 = P1(1)*x17
        x19 = x14 + x16 - x18
        x20 = P1(0)*P2(2)*co(3)
        x21 = P2(0)*x2 - P2(1)*x17 + P2(3)*x15
        x22 = co(3)*x21
        x23 = P1(0)*w1(0)
        x24 = P1(2)*w2(3)
        x25 = P1(3)*w2(2)
        x26 = x24 - x25
        x27 = P1(1)*w2(2)
        x28 = P1(2)*w2(1)
        x29 = x27 - x28
        x30 = P1(1)*w2(3)
        x31 = P1(3)*w2(1)
        x32 = x30 - x31
        x33 = co(2)*(P2(1)*x26 - P2(2)*x32 + P2(3)*x29)
        x34 = P2(2)*w2(3) - P2(3)*w2(2)
        x35 = P2(1)*w2(2) - P2(2)*w2(1)
        x36 = P2(1)*w2(3)
        x37 = P2(3)*w2(1)
        x38 = x36 - x37
        x39 = co(2)*(P2(1)*x34 - P2(2)*x38 + P2(3)*x35)
        x40 = P1(0)*x0
        x41 = w1(0)*w2(2) - w1(2)*w2(0)
        x42 = P1(3)*x41
        x43 = P1(2)*x17
        x44 = x40 + x42 - x43
        x45 = co(3)*x44
        x46 = P1(1)*P2(0)
        x47 = P2(0)*x0 - P2(2)*x17 + P2(3)*x41
        x48 = co(3)*x47
        x49 = P1(1)*w2(0)
        x50 = P1(2)*w1(3)
        x51 = P1(3)*w1(2)
        x52 = x50 - x51
        x53 = P2(0)*x52
        x54 = P1(0)*w1(2)
        x55 = P1(2)*w1(0)
        x56 = x54 - x55
        x57 = P2(3)*x56
        x58 = P1(0)*w1(3)
        x59 = P1(3)*w1(0)
        x60 = x58 - x59
        x61 = P2(2)*x60
        x62 = co(2)*(x53 + x57 - x61)
        x63 = P2(2)*w1(3)
        x64 = P2(3)*w1(2)
        x65 = x63 - x64
        x66 = P2(0)*x65
        x67 = P2(2)*w1(0)
        x68 = P2(0)*w1(2) - x67
        x69 = P2(3)*x68
        x70 = P2(3)*w1(0)
        x71 = P2(0)*w1(3) - x70
        x72 = P2(2)*x71
        x73 = co(2)*(x66 + x69 - x72)
        x74 = P1(1)*x34
        x75 = P1(1)*w1(1)
        x76 = P1(2)*w1(2)
        x77 = P1(3)*w1(3)
        x78 = -x23 + x75 + x76 + x77
        x79 = P2(2)*w1(2)
        x80 = P2(3)*w1(3)
        x81 = -P2(0)*w1(0) + P2(1)*w1(1) + x79 + x80
        x82 = P1(1)*x0
        x83 = P2(1)**2
        x84 = P2(2)**2
        x85 = P2(3)**2
        x86 = P2(0)**2
        x87 = co(3)*(x83 + x84 + x85 - x86)
        x88 = P1(1)*P2(1)
        x89 = P1(2)*P2(2)
        x90 = P1(3)*P2(3)
        x91 = co(3)*(-x12 + x88 + x89 + x90)
        x92 = P1(1)*co(4)*x81
        x93 = P1(0)*w2(1)
        x94 = -x49 + x93
        x95 = P1(0)*w2(3)
        x96 = P1(3)*w2(0)
        x97 = x95 - x96
        x98 = co(2)*(P2(0)*x32 - P2(1)*x97 + P2(3)*x94)
        x99 = P2(0)*w2(1) - P2(1)*w2(0)
        x100 = P2(3)*w2(0)
        x101 = P2(0)*w2(3) - x100
        x102 = co(2)*(P2(0)*x38 - P2(1)*x101 + P2(3)*x99)
        x103 = P2(3)*w1(1)
        x104 = P2(1)*w1(3) - x103
        x105 = P1(1)*w2(1)
        x106 = P1(2)*w2(2)
        x107 = P1(3)*w2(3)
        x108 = P1(0)*w2(0)
        x109 = x105 + x106 + x107 - x108
        x110 = P1(2)*co(3)*x109
        x111 = P2(1)*w2(1)
        x112 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x111
        x113 = P1(2)*co(3)*x112
        x114 = P1(3)*P2(0)
        x115 = P1(0)*x1
        x116 = P1(2)*x15
        x117 = P1(1)*x41
        x118 = x115 + x116 - x117
        x119 = co(3)*x118
        x120 = P2(0)*x1 - P2(1)*x41 + P2(2)*x15
        x121 = co(3)*x120
        x122 = P1(1)*w1(2)
        x123 = P1(2)*w1(1)
        x124 = x122 - x123
        x125 = P2(0)*x124
        x126 = P1(0)*w1(1)
        x127 = P1(1)*w1(0)
        x128 = x126 - x127
        x129 = P2(2)*x128
        x130 = P2(1)*x56
        x131 = co(2)*(x125 + x129 - x130)
        x132 = P2(1)*w1(2)
        x133 = P2(2)*w1(1)
        x134 = x132 - x133
        x135 = P2(0)*x134
        x136 = P2(0)*w1(1)
        x137 = P2(1)*w1(0)
        x138 = x136 - x137
        x139 = P2(2)*x138
        x140 = P2(1)*x68
        x141 = co(2)*(x135 + x139 - x140)
        x142 = P1(3)*co(3)*x78
        x143 = P1(3)*co(3)*x81
        x144 = P1(3)*x1
        x145 = P1(3)*co(4)*x81
        x146 = P2(1)*x52
        x147 = co(4)*x109
        x148 = P2(1)*x65
        x149 = P2(3)*x124
        x150 = P2(3)*x134
        x151 = w1(0)*x109*x86
        x152 = co(1)*w1(0)*x109
        x153 = co(1)*x85
        x154 = co(1)*x6*x81
        x155 = co(1)*x8*x81
        x156 = co(1)*x10*x81
        x157 = P1(0)*P2(1)*co(3)
        x158 = P2(1)*co(3)*x47
        x159 = P1(0)*P2(3)*co(3)
        x160 = P1(1)*w1(3)
        x161 = P1(3)*w1(1)
        x162 = x160 - x161
        x163 = P2(2)*x162
        x164 = co(2)*(x146 + x149 - x163)
        x165 = P2(2)*x104
        x166 = co(2)*(x148 + x150 - x165)
        x167 = P1(0)*w2(2)
        x168 = P1(2)*w2(0)
        x169 = x167 - x168
        x170 = co(2)*(P2(0)*x26 - P2(2)*x97 + P2(3)*x169)
        x171 = P2(0)*w2(2) - P2(2)*w2(0)
        x172 = co(2)*(P2(0)*x34 - P2(2)*x101 + P2(3)*x171)
        x173 = co(3)*x109
        x174 = P1(1)*x65
        x175 = co(3)*x112
        x176 = P1(2)*co(3)*x19
        x177 = P1(2)*co(3)*x21
        x178 = P2(0)*x162
        x179 = P2(3)*x128
        x180 = P2(1)*x60
        x181 = co(2)*(x178 + x179 - x180)
        x182 = P2(0)*x104
        x183 = P2(3)*x138
        x184 = P2(1)*x71
        x185 = co(2)*(x182 + x183 - x184)
        x186 = P1(2)*co(3)*x78
        x187 = P1(2)*co(3)*x81
        x188 = P1(2)*x2
        x189 = P1(2)*co(4)*x81
        x190 = co(2)*(P2(0)*x29 - P2(1)*x169 + P2(2)*x94)
        x191 = co(2)*(P2(0)*x35 - P2(1)*x171 + P2(2)*x99)
        x192 = P1(3)*x134
        x193 = co(1)*x4*x81
        x194 = co(0)*x112
        x195 = co(1)*x81
        x196 = P1(2)*P2(2)*co(1)*x81
        x197 = P1(3)*co(1)*x81
        x198 = P1(0)*P2(0)*co(1)*x81
        x199 = P2(1)*co(0)*x109
        x200 = P2(1)*co(0)*x112
        x201 = co(0)*x109
        x202 = P1(0)*P2(2)*w1(2)
        x203 = P2(3)*co(0)*x109
        x204 = P2(3)*co(0)*x112
        x205 = P2(0)*co(0)*x109
        x206 = 2*co(0)
        x207 = P1(0)*co(3)*x78
        x208 = P1(0)*co(3)*x81
        x209 = P1(0)*co(4)*x81
        x210 = x144 - x188 + x82
        x211 = co(3)*x210
        x212 = P1(1)*P2(2)
        x213 = co(3)*x19
        x214 = P1(3)*P2(1)
        x215 = w1(1)*x109*x83
        x216 = co(1)*w1(1)*x109
        x217 = w1(1)*x109
        x218 = P1(0)*co(3)*x109
        x219 = P1(0)*co(3)*x112
        x220 = P1(1)*P2(3)
        x221 = P1(2)*P2(1)
        x222 = P1(3)*x68
        x223 = co(1)*x86
        x224 = P1(1)*P2(0)*w1(0)
        x225 = P1(1)*co(1)*x81
        x226 = P2(2)*co(0)*x109
        x227 = P1(2)*co(0)*x109
        x228 = P1(1)*co(3)*x78
        x229 = P1(1)*co(3)*x81
        x230 = P1(2)*P2(0)
        x231 = P1(3)*P2(2)
        x232 = P1(3)*x138
        x233 = co(1)*w1(2)*x109
        x234 = w1(2)*x109*x84
        x235 = w1(2)*x109
        x236 = co(1)*w2(2)*x81
        x237 = P1(1)*x71
        x238 = P1(2)*P2(3)
        x239 = co(1)*x109
        x240 = P2(0)*co(0)*x112
        x241 = P2(0)*co(1)*x81
        x242 = P1(3)*co(0)*x109
        x243 = P1(0)*co(3)*x35
        x244 = P1(1)*x68
        x245 = co(1)*w1(3)*x109
        x246 = w1(3)*x109
        x247 = co(1)*w2(3)*x81
        wout(0) = P1(0)*P2(0)*w1(0)*x109*x206 + P1(0)*P2(0)*w1(0)*x194 + P1(0)*&
                  P2(2)*x22 - P1(0)*x158 + P1(1)*P2(1)*w2(0)*x195 - P2(0)*x176 &
                   - P2(0)*x177 + co(0)*x151 - co(1)*x151 + co(3)*x74*x78 + co(&
                  3)*x74*x81 + w1(0)*x109*x153 + w2(0)*x154 + w2(0)*x155 + w2(0&
                  )*x156 - w2(0)*x193 + w2(0)*x196 - w2(0)*x198 + x100*x197 +  &
                  x102*x55 + x104*x110 + x104*x113 - x108*x164 - x108*x166 -   &
                  x11*x3 + x114*x119 + x114*x121 - x118*x159 + x12*x13 - x12*  &
                  x152 - x120*x159 - x126*x199 - x126*x200 - x127*x170 - x127* &
                  x172 - x13*x88 - x13*x89 - x13*x90 + x131*x96 - x136*x199 +  &
                  x141*x96 + x142*x35 + x143*x35 + x144*x87 + x144*x91 + x145* &
                  x29 + x145*x35 + x146*x147 + x147*x148 + x147*x149 + x147*   &
                  x150 - x147*x163 - x147*x165 + x152*x83 + x152*x84 + x152*x88&
                   + x152*x89 + x152*x90 - x157*x44 - x168*x181 - x168*x185 -  &
                  x173*x174 - x173*x192 - x174*x175 - x175*x192 - x186*x38 -   &
                  x187*x38 - x188*x87 - x188*x91 - x189*x32 - x189*x38 + x19*  &
                  x20 - x190*x59 - x191*x59 - x194*x202 - x201*x202 - x203*x58 &
                   - x204*x58 - x205*x75 - x205*x76 - x205*x77 - x205*x79 -    &
                  x205*x80 + x23*x33 + x23*x39 + x26*x92 + x3*x5 - x3*x7 - x3* &
                  x9 + x34*x92 + x45*x46 + x46*x48 + x49*x62 + x49*x73 + x55*  &
                  x98 + x82*x87 + x82*x91
        wout(1) = -P1(1)*P2(1)*w1(1)*x109*x206 - P1(1)*P2(1)*w1(1)*x194 - P1(1 &
                  )*P2(2)*w1(2)*x194 - P2(1)*x177 - co(0)*x215 + co(1)*x215 +  &
                  w2(1)*x154 + w2(1)*x155 + w2(1)*x156 - w2(1)*x193 + w2(1)*   &
                  x196 - w2(1)*x198 - x101*x186 - x101*x187 - x101*x189 + x102*&
                  x123 + x105*x62 + x105*x73 - x11*x47 + x110*x71 + x111*x225  &
                   + x113*x71 + x119*x214 - x119*x220 - x12*x216 + x12*x48 +   &
                  x121*x214 - x121*x220 - x122*x226 + x123*x98 + x126*x33 +    &
                  x126*x39 + x13*x46 + x131*x31 - x132*x226 - x132*x227 + x137*&
                  x205 + x141*x31 + x142*x171 + x143*x171 + x145*x169 + x145*  &
                  x171 + x147*x53 + x147*x57 - x147*x61 + x147*x66 + x147*x69  &
                   - x147*x72 + x153*x217 - x157*x210 - x157*x3 - x160*x203 -  &
                  x160*x204 - x161*x190 - x161*x191 - x164*x93 - x166*x93 -    &
                  x170*x75 - x172*x75 - x173*x222 - x175*x222 - x181*x28 - x185&
                  *x28 - x189*x97 + x194*x224 + x197*x37 + x199*x23 - x199*x77 &
                   - x199*x80 + x201*x224 + x207*x34 + x208*x34 + x209*x26 +   &
                  x209*x34 + x211*x46 + x212*x213 + x212*x22 - x213*x221 + x216&
                  *x84 + x216*x88 + x216*x89 + x216*x90 - x217*x223 - x218*x65 &
                   - x219*x65 + x40*x87 + x40*x91 + x42*x87 + x42*x91 - x43*x87&
                   - x43*x91 + x47*x5 - x47*x7 - x47*x9 - x48*x88 - x48*x89 -  &
                  x48*x90
        wout(2) = P1(1)*P2(1)*w1(2)*x239 - P1(2)*P2(2)*w1(2)*x109*x206 - P1(2)*&
                  P2(2)*w1(2)*x194 - P1(2)*x158 + P1(3)*P2(3)*w1(2)*x239 + P1(3&
                  )*P2(3)*w2(2)*x195 - co(0)*x234 + co(1)*x234 + w2(2)*x155 +  &
                  x10*x236 + x101*x228 + x101*x229 + x101*x92 + x102*x76 + x104&
                  *x218 + x104*x219 - x106*x181 - x106*x185 + x11*x21 + x119*  &
                  x231 - x119*x238 - x12*x22 - x12*x233 + x121*x231 - x121*x238&
                   - x122*x170 - x122*x172 - x123*x199 - x123*x200 + x13*x230  &
                   + x131*x25 - x133*x199 - x14*x87 - x14*x91 + x141*x25 - x142&
                  *x99 - x143*x99 - x145*x94 - x145*x99 - x147*x178 - x147*x179&
                   + x147*x180 - x147*x182 - x147*x183 + x147*x184 + x153*x235 &
                   - x16*x87 - x16*x91 - x164*x167 - x166*x167 - x167*x241 +   &
                  x173*x232 - x173*x237 + x175*x232 - x175*x237 + x18*x87 + x18&
                  *x91 - x190*x51 - x191*x51 - x20*x210 - x20*x3 - x203*x50 -  &
                  x203*x63 - x204*x50 + x205*x55 + x205*x67 - x207*x38 - x208* &
                  x38 - x209*x32 - x209*x38 - x21*x5 + x21*x7 + x21*x9 + x211* &
                  x230 + x212*x45 + x212*x48 + x22*x88 + x22*x89 + x22*x90 -   &
                  x221*x45 - x223*x235 + x226*x23 - x226*x75 + x233*x83 + x233*&
                  x89 - x236*x4 + x236*x6 + x236*x88 + x236*x89 + x240*x55 -   &
                  x242*x63 + x27*x62 + x27*x73 + x33*x54 + x39*x54 + x76*x98 + &
                  x92*x97
        wout(3) = -P1(0)*P2(0)*w1(3)*x239 - P1(1)*P2(3)*w1(1)*x201 + P1(2)*P2(2&
                  )*w1(3)*x239 - P1(3)*P2(2)*w1(2)*x194 + P1(3)*P2(3)*w1(3)*   &
                  x239 - 2*P1(3)*w1(3)*x203 - P1(3)*x158 - P2(3)*x176 - P2(3)* &
                  x177 - co(0)*x246*x85 + w2(3)*x155 + x10*x247 + x102*x50 -   &
                  x103*x199 + x107*x131 + x107*x141 - x11*x120 - x110*x138 -   &
                  x113*x138 + x114*x13 + x114*x211 + x115*x87 + x115*x91 + x116&
                  *x87 + x116*x91 - x117*x87 - x117*x91 + x12*x121 + x120*x5 - &
                  x120*x7 - x120*x9 - x121*x88 - x121*x89 - x121*x90 + x125*   &
                  x147 + x129*x147 - x130*x147 - x134*x218 - x134*x219 + x135* &
                  x147 + x139*x147 - x140*x147 + x153*x246 - x159*x210 - x159* &
                  x3 - x160*x170 - x160*x172 - x161*x199 - x161*x200 - x164*x95&
                   - x166*x95 - x169*x92 - x171*x228 - x171*x229 - x171*x92 +  &
                  x173*x244 + x175*x244 - x181*x24 - x185*x24 + x186*x99 + x187&
                  *x99 + x189*x94 + x189*x99 - x190*x77 - x191*x77 + x203*x23  &
                   - x204*x77 + x205*x59 + x205*x70 + x209*x29 + x209*x35 +    &
                  x213*x231 - x214*x45 + x22*x231 + x220*x45 + x220*x48 + x225*&
                  x36 - x226*x64 - x227*x64 + x240*x59 - x241*x95 - x242*x79 + &
                  x243*x78 + x243*x81 + x245*x83 + x245*x84 - x245*x86 + x245* &
                  x88 - x247*x4 + x247*x6 + x247*x89 + x247*x90 + x30*x62 + x30&
                  *x73 + x33*x58 + x39*x58 + x50*x98
      case(VVV11)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1
!       ,3))
!       c2*(-Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + Epsilon(-1
!       ,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - Epsilon(-1,-2,1,3)*P(-1,
!       1)*P(-2,2)*P(2,3) - Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - Epsilon(-
!       1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) - Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2
!       ,3) + Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3))
!       c4*(-Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,2,3)*P(-1,
!       1)*P(-2,2)*P(1,3))
        if (last) VB_last = .true.
        x0 = P1(0)*P2(1)
        x1 = w1(2)*w2(3) - w1(3)*w2(2)
        x2 = P1(0)*x1
        x3 = w1(0)*w2(2) - w1(2)*w2(0)
        x4 = P1(3)*x3
        x5 = w1(0)*w2(3) - w1(3)*w2(0)
        x6 = P1(2)*x5
        x7 = x2 + x4 - x6
        x8 = co(4)*x7
        x9 = P2(0)*x1 - P2(2)*x5 + P2(3)*x3
        x10 = co(4)*x9
        x11 = P1(0)*P2(3)
        x12 = w1(1)*w2(2) - w1(2)*w2(1)
        x13 = P1(0)*x12
        x14 = w1(0)*w2(1) - w1(1)*w2(0)
        x15 = P1(2)*x14
        x16 = P1(1)*x3
        x17 = x13 + x15 - x16
        x18 = co(4)*x17
        x19 = P2(0)*x12 - P2(1)*x3 + P2(2)*x14
        x20 = co(4)*x19
        x21 = P2(1)**2
        x22 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x23 = P1(0)*co(1)*x22
        x24 = P2(2)**2
        x25 = P2(3)**2
        x26 = P1(1)*P2(0)
        x27 = co(3)*x7
        x28 = co(3)*x9
        x29 = P1(1)*P2(1)
        x30 = P1(1)*x1
        x31 = P1(3)*x12
        x32 = w1(1)*w2(3) - w1(3)*w2(1)
        x33 = P1(2)*x32
        x34 = x30 + x31 - x33
        x35 = co(3)*x34
        x36 = P2(1)*x1 - P2(2)*x32 + P2(3)*x12
        x37 = co(3)*x36
        x38 = P1(1)*w2(0)
        x39 = P1(2)*w1(3) - P1(3)*w1(2)
        x40 = P2(0)*x39
        x41 = P1(2)*w1(0)
        x42 = P1(0)*w1(2) - x41
        x43 = P2(3)*x42
        x44 = P1(0)*w1(3)
        x45 = -P1(3)*w1(0) + x44
        x46 = P2(2)*x45
        x47 = co(2)*(x40 + x43 - x46)
        x48 = P2(2)*w1(3)
        x49 = P2(3)*w1(2)
        x50 = x48 - x49
        x51 = P2(0)*x50
        x52 = P2(2)*w1(0)
        x53 = P2(0)*w1(2) - x52
        x54 = P2(3)*x53
        x55 = P2(3)*w1(0)
        x56 = P2(0)*w1(3) - x55
        x57 = P2(2)*x56
        x58 = co(2)*(x51 + x54 - x57)
        x59 = P1(2)*P2(2)
        x60 = P1(1)*P2(3)
        x61 = P1(3)*P2(1)
        x62 = x60 - x61
        x63 = P1(2)*co(2)*x22
        x64 = P1(1)*w2(3)
        x65 = -P1(3)*w2(1) + x64
        x66 = P2(2)*w1(2)
        x67 = P2(3)*w1(3)
        x68 = -P2(0)*w1(0) + P2(1)*w1(1) + x66 + x67
        x69 = P1(2)*co(3)*x68
        x70 = P2(3)*w1(1)
        x71 = P2(1)*w1(3) - x70
        x72 = P1(1)*w2(1)
        x73 = P1(2)*w2(2)
        x74 = P1(3)*w2(3)
        x75 = P1(0)*w2(0)
        x76 = x72 + x73 + x74 - x75
        x77 = P1(2)*co(3)*x76
        x78 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x79 = P1(2)*co(3)*x78
        x80 = P2(1)*w2(3) - P2(3)*w2(1)
        x81 = P2(0)**2
        x82 = co(3)*(x21 + x24 + x25 - x81)
        x83 = P1(3)*P2(3)
        x84 = P1(0)*P2(0)
        x85 = co(3)*(x29 + x59 + x83 - x84)
        x86 = P1(2)*x80
        x87 = P1(1)*w1(1)
        x88 = P1(3)*w1(3)
        x89 = P1(0)*w1(0)
        x90 = P1(2)*w1(2) + x87 + x88 - x89
        x91 = co(4)*x68
        x92 = P1(3)*P2(0)
        x93 = co(3)*x17
        x94 = co(3)*x19
        x95 = P1(1)*w1(2)
        x96 = P1(2)*w1(1)
        x97 = x95 - x96
        x98 = P2(0)*x97
        x99 = P1(0)*w1(1) - P1(1)*w1(0)
        x100 = P2(2)*x99
        x101 = P2(1)*x42
        x102 = x100 - x101 + x98
        x103 = P1(3)*co(2)*w2(0)
        x104 = P2(1)*w1(2)
        x105 = P2(2)*w1(1)
        x106 = x104 - x105
        x107 = P2(0)*x106
        x108 = P2(0)*w1(1)
        x109 = P2(1)*w1(0)
        x110 = x108 - x109
        x111 = P2(2)*x110
        x112 = P2(1)*x53
        x113 = x107 + x111 - x112
        x114 = P1(3)*w1(1)
        x115 = P1(1)*w1(3) - x114
        x116 = P2(2)*x115
        x117 = co(3)*x76
        x118 = P2(2)*x71
        x119 = co(0)*w1(0)*x76
        x120 = P1(0)*P2(0)*co(4)
        x121 = P1(0)*P2(2)
        x122 = P1(0)*x32
        x123 = P1(3)*x14
        x124 = P1(1)*x5
        x125 = x122 + x123 - x124
        x126 = co(4)*x125
        x127 = P2(0)*x32 - P2(1)*x5 + P2(3)*x14
        x128 = co(4)*x127
        x129 = P2(1)*x39
        x130 = P2(3)*x97
        x131 = co(2)*(-x116 + x129 + x130)
        x132 = P2(1)*x50
        x133 = P2(3)*x106
        x134 = co(2)*(-x118 + x132 + x133)
        x135 = P1(2)*P2(3)
        x136 = P1(3)*P2(2)
        x137 = x135 - x136
        x138 = P1(1)*co(2)*x22
        x139 = P1(2)*w2(3)
        x140 = P1(3)*w2(2)
        x141 = x139 - x140
        x142 = P1(1)*co(3)*x68
        x143 = P1(1)*co(3)*x76
        x144 = P1(1)*co(3)*x78
        x145 = P2(2)*w2(3) - P2(3)*w2(2)
        x146 = P1(1)*co(4)*x90
        x147 = P1(1)*co(4)*x68
        x148 = P1(2)*P2(0)
        x149 = co(3)*x125
        x150 = co(3)*x127
        x151 = P1(2)*w2(0)
        x152 = P2(0)*x115
        x153 = P2(3)*x99
        x154 = P2(1)*x45
        x155 = co(2)*(x152 + x153 - x154)
        x156 = P2(0)*x71
        x157 = P2(3)*x110
        x158 = P2(1)*x56
        x159 = co(2)*(x156 + x157 - x158)
        x160 = P1(1)*P2(2)
        x161 = P1(2)*P2(1)
        x162 = x160 - x161
        x163 = P1(3)*co(2)*x22
        x164 = P1(1)*w2(2)
        x165 = P1(2)*w2(1)
        x166 = x164 - x165
        x167 = P1(3)*co(3)*x68
        x168 = P1(3)*x106
        x169 = co(3)*x78
        x170 = P2(1)*w2(2) - P2(2)*w2(1)
        x171 = co(4)*x170*x90
        x172 = P1(3)*co(4)*x68
        x173 = co(1)*x22
        x174 = P1(0)*P2(0)*co(3)
        x175 = 2*P1(0)*P2(0)
        x176 = co(0)*w1(0)*x78
        x177 = P1(1)*P2(1)*co(1)*w2(0)
        x178 = P1(2)*P2(2)*co(1)*x90
        x179 = P1(2)*P2(2)*co(1)*x68
        x180 = P1(3)*w2(0)
        x181 = P2(3)*co(1)*x90
        x182 = P2(3)*co(1)*x68
        x183 = P1(0)*P2(0)*co(1)*x90
        x184 = P1(0)*P2(0)*co(1)*x68
        x185 = co(0)*w1(1)*x76
        x186 = co(0)*x78
        x187 = P2(2)*co(0)*w1(2)*x76
        x188 = P2(2)*co(0)*w1(2)*x78
        x189 = P2(3)*co(0)*x76
        x190 = P2(3)*co(0)*x78
        x191 = P2(0)*co(0)*x76
        x192 = co(0)*w1(2)*x76
        x193 = P2(1)*co(0)*x76
        x194 = co(1)*x21*x22
        x195 = co(1)*x22*x24
        x196 = co(1)*x22*x25
        x197 = x11 - x92
        x198 = P1(0)*w2(3)
        x199 = -x180 + x198
        x200 = P2(0)*w2(3) - P2(3)*w2(0)
        x201 = P1(2)*co(4)*x90
        x202 = co(4)*x200*x68
        x203 = P1(3)*co(2)*w2(1)
        x204 = P1(0)*w2(1)
        x205 = P1(0)*co(2)*x22
        x206 = P1(0)*co(3)*x68
        x207 = P1(0)*co(3)*x76
        x208 = P1(0)*co(3)*x78
        x209 = P1(0)*co(4)*x90
        x210 = P1(0)*co(4)*x68
        x211 = P1(1)*P2(0)*co(4)
        x212 = co(1)*x22*x81
        x213 = x121 - x148
        x214 = P1(0)*w2(2)
        x215 = -x151 + x214
        x216 = P1(3)*x53
        x217 = P2(0)*w2(2) - P2(2)*w2(0)
        x218 = P1(3)*co(4)*x90
        x219 = 2*P1(1)*P2(1)
        x220 = P1(3)*co(1)*x22
        x221 = co(1)*x90
        x222 = P1(1)*P2(1)*w2(1)
        x223 = co(1)*x68
        x224 = P1(3)*P2(3)*w2(1)
        x225 = P1(0)*P2(0)*co(1)*x22
        x226 = P2(1)*co(0)*x78
        x227 = P2(2)*co(0)*x76
        x228 = co(0)*w1(3)*x76
        x229 = P1(2)*co(0)*x76
        x230 = P1(3)*co(2)*w2(2)
        x231 = x0 - x26
        x232 = x204 - x38
        x233 = P1(3)*x110
        x234 = P2(0)*w2(1) - P2(1)*w2(0)
        x235 = P1(2)*P2(0)*co(4)
        x236 = 2*P1(2)*P2(2)
        x237 = P1(1)*P2(1)*w2(2)
        x238 = P2(0)*co(1)*x90
        x239 = P2(0)*co(1)*x68
        x240 = P1(2)*P2(3)*w1(3)
        x241 = P1(1)*x53
        x242 = P1(3)*co(2)*w2(3)
        x243 = P1(3)*P2(0)*co(4)
        x244 = 2*P1(3)*P2(3)
        x245 = P1(1)*P2(1)*w2(3)
        wout(0) = -P1(0)**2*P2(0)*x173 - P1(0)*P2(1)*w1(1)*x186 - P1(0)*x187 - &
                  P1(0)*x188 - P1(3)*x171 + co(4)*x86*x90 + w2(0)*x178 + w2(0)*&
                  x179 - w2(0)*x183 - w2(0)*x184 + x0*x10 - x0*x185 + x0*x8 +  &
                  x102*x103 + x103*x113 - x108*x193 + x11*x18 + x11*x20 + x116*&
                  x117 + x117*x118 - x117*x129 - x117*x130 - x117*x132 - x117* &
                  x133 - x117*x168 + x119*x175 + x119*x81 - x120*x34 - x120*x36&
                   - x121*x126 - x121*x128 - x131*x75 - x134*x75 - x137*x138 - &
                  x141*x142 - x142*x145 - x143*x50 - x144*x50 - x145*x146 -    &
                  x145*x147 - x148*x149 - x148*x150 - x148*x192 - x151*x155 -  &
                  x151*x159 - x162*x163 - x166*x167 - x167*x170 - x168*x169 -  &
                  x170*x172 - x174*(2*P1(1)*x1 - 2*P1(2)*x32 + 2*P1(3)*x12) -  &
                  x175*x37 + x176*x84 + x177*x68 + x177*x90 + x180*x181 + x180*&
                  x182 - x189*x44 - x190*x44 - x191*x66 - x191*x67 - x191*x87  &
                   - x191*x88 + x21*x23 + x23*x24 + x23*x25 + x23*x29 + x23*x59&
                   - x23*x81 + x23*x83 + x26*x27 + x26*x28 + x29*x35 + x29*x37 &
                   - x30*x82 - x30*x85 - x31*x82 - x31*x85 + x33*x82 + x33*x85 &
                   + x35*x59 + x35*x83 + x37*x59 + x37*x83 + x38*x47 + x38*x58 &
                   + x62*x63 + x65*x69 + x69*x80 + x71*x77 + x71*x79 + x86*x91 &
                   + x92*x93 + x92*x94
        wout(1) = P1(1)**2*P2(1)*x173 + P1(1)*P1(2)*P2(2)*x173 - P1(1)*P2(2)*w1&
                  (2)*x186 - P1(1)*P2(3)*w1(3)*x186 - 2*P1(1)*w1(1)*x193 + P1(1&
                  )*x194 + P1(1)*x195 + P1(1)*x196 - P1(1)*x212 - P1(1)*x225 + &
                  P1(2)*x202 + w2(1)*x178 + w2(1)*x179 - w2(1)*x183 - w2(1)*   &
                  x184 - x0*x35 - x0*x37 + x10*x29 + x102*x203 - x104*x227 -   &
                  x104*x229 + x109*x191 + x113*x203 - x117*x216 - x117*x40 -   &
                  x117*x43 + x117*x46 - x117*x51 - x117*x54 + x117*x57 + x119* &
                  x26 - x126*x160 - x128*x160 - x131*x204 - x134*x204 - x137*  &
                  x205 - x141*x206 - x145*x206 - x145*x209 - x145*x210 - x149* &
                  x161 - x150*x161 - x155*x165 - x159*x165 - x163*x213 - x167* &
                  x215 - x167*x217 - x169*x216 - x172*x217 - x174*x7 + x176*x26&
                   + x18*x60 - x185*x21 - x193*x67 - x193*x88 + x193*x89 + x197&
                  *x63 + x199*x69 - x2*x82 - x2*x85 + x20*x60 + x200*x201 +    &
                  x200*x69 - x207*x50 - x208*x50 - x211*x34 - x211*x36 - x217* &
                  x218 + x219*x27 + x219*x28 + x220*x60 + x221*x222 + x221*x224&
                   + x222*x223 + x223*x224 - x226*x87 - x227*x95 - x228*x60 +  &
                  x27*x59 + x27*x83 + x28*x59 + x28*x83 - x28*x84 + x29*x8 - x4&
                  *x82 - x4*x85 + x47*x72 + x56*x77 + x56*x79 + x58*x72 + x6*  &
                  x82 + x6*x85 + x61*x93 + x61*x94
        wout(2) = P1(1)*P1(2)*P2(1)*x173 - P1(1)*x202 + P1(2)**2*P2(2)*x173 +  &
                  P1(2)*P2(0)*w1(0)*x186 - P1(2)*P2(2)*w1(2)*x186 + P1(2)*x194 &
                   + P1(2)*x195 + P1(2)*x196 - P1(2)*x212 - P1(2)*x225 - co(0)*&
                  x240*x76 + w2(2)*x178 + w2(2)*x179 + x10*x161 + x102*x230 -  &
                  x105*x193 + x113*x230 + x117*x152 + x117*x153 - x117*x154 +  &
                  x117*x156 + x117*x157 - x117*x158 + x117*x233 - x121*x35 -   &
                  x121*x37 + x122*x82 + x122*x85 + x123*x82 + x123*x85 - x124* &
                  x82 - x124*x85 + x125*x174 - x126*x59 - x128*x59 - x131*x214 &
                   - x134*x214 + x135*x18 + x135*x20 + x135*x220 + x136*x93 +  &
                  x136*x94 - x138*x197 + x140*x181 + x140*x182 - x142*x199 -   &
                  x142*x200 - x143*x56 - x144*x56 - x146*x200 - x149*x236 -    &
                  x149*x29 - x149*x83 - x150*x236 - x150*x29 - x150*x83 + x150*&
                  x84 - x155*x73 - x159*x73 + x160*x27 + x160*x28 + x161*x8 +  &
                  x163*x231 + x164*x47 + x164*x58 + x167*x232 + x167*x234 +    &
                  x169*x233 + x172*x234 - x186*x240 - x189*x48 + x191*x41 +    &
                  x191*x52 - x192*x236 - x192*x24 - x193*x96 + x205*x62 + x206*&
                  x65 + x206*x80 + x207*x71 + x208*x71 + x209*x80 + x210*x80 - &
                  x214*x238 - x214*x239 + x218*x234 + x221*x237 + x223*x237 -  &
                  x226*x96 - x227*x87 - x227*x88 + x227*x89 - x235*x34 - x235* &
                  x36
        wout(3) = -P1(0)*x171 - P1(2)*x234*x91 + P1(3)**2*P2(3)*x173 - 2*P1(3)*&
                  w1(3)*x189 - P1(3)*x187 - P1(3)*x188 + P1(3)*x194 + P1(3)*   &
                  x195 + P1(3)*x196 - P1(3)*x212 + w2(3)*x178 + w2(3)*x179 +   &
                  x10*x61 - x100*x117 + x101*x117 + x102*x242 - x106*x207 -    &
                  x106*x208 - x107*x117 - x11*x35 - x11*x37 - x110*x77 - x110* &
                  x79 - x111*x117 + x112*x117 + x113*x242 - x114*x193 - x114*  &
                  x226 + x117*x241 - x117*x98 + x119*x92 - x126*x136 - x128*   &
                  x136 - x13*x82 - x13*x85 - x131*x198 - x134*x198 - x135*x149 &
                   - x135*x150 + x138*x213 - x139*x155 - x139*x159 + x142*x215 &
                   + x142*x217 + x146*x217 + x147*x217 - x15*x82 - x15*x85 +   &
                  x16*x82 + x16*x85 - x162*x205 - x166*x206 + x169*x241 - x170*&
                  x206 - x170*x210 - x174*x19 + x176*x92 + x18*x83 + x181*x74  &
                   + x182*x74 - x185*x60 + x189*x89 - x190*x88 + x191*x55 -    &
                  x193*x70 - x198*x238 - x198*x239 + x20*x83 - x201*x234 + x220&
                  *x29 + x220*x59 + x221*x245 + x223*x245 - x227*x49 - x228*x25&
                   - x229*x49 - x23*x92 - x231*x63 - x232*x69 - x234*x69 - x243&
                  *x34 - x243*x36 + x244*x93 + x244*x94 + x27*x60 + x28*x60 +  &
                  x29*x93 + x29*x94 + x47*x64 + x58*x64 + x59*x93 + x59*x94 +  &
                  x61*x8 - x84*x93
      case(VVV12)
!       c0*(P(1,2)*P(2,3)*P(3,1) - P(1,3)*P(2,1)*P(3,2))
!       c1*(Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3,
!       1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) + Metric(1,3)*P(-1,2)*P(-1,3)*P(2
!       ,1) + Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(-2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*      
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*Epsilon(-1,-2
!       ,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + 2*Epsilon(-1,-2,1,2)*P 
!       (-1,2)*P(-2,3)*P(3,1) - 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) + 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) - 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(-Metric(1,2)*P(3,1) + Metric(1,3)*P(2,1))
!       Epsilon(-1,1,2,3)*P(-1,1)*c5
        if (last) VB_last = .true.
        x0 = w1(3)*w2(3)
        x1 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + x0
        x2 = co(4)*x1
        x3 = w1(2)*w2(3)
        x4 = -w1(3)*w2(2) + x3
        x5 = P1(1)*x4
        x6 = w1(2)*w2(1)
        x7 = w1(1)*w2(2) - x6
        x8 = P1(3)*x7
        x9 = w1(1)*w2(3)
        x10 = -w1(3)*w2(1) + x9
        x11 = P1(2)*x10
        x12 = P2(1)*x4 - P2(2)*x10 + P2(3)*x7
        x13 = P1(1)**2
        x14 = 2*co(3)*x13
        x15 = P1(2)**2
        x16 = 2*co(3)*x15
        x17 = P1(3)**2
        x18 = 2*co(3)*x17
        x19 = P1(0)**2
        x20 = 2*co(3)*x19
        x21 = P1(0)*x1
        x22 = P2(1)**2
        x23 = co(1)*x22
        x24 = P2(2)**2
        x25 = co(1)*x24
        x26 = P2(3)**2
        x27 = co(1)*x26
        x28 = P1(0)*w1(0)
        x29 = co(4)*w2(0)
        x30 = P2(0)**2
        x31 = P1(1)*w2(1)
        x32 = P1(2)*w2(2)
        x33 = P1(3)*w2(3)
        x34 = P1(0)*w2(0)
        x35 = x31 + x32 + x33 - x34
        x36 = w1(0)*x30*x35
        x37 = P2(2)*w1(2)
        x38 = P2(3)*w1(3)
        x39 = -P2(0)*w1(0) + P2(1)*w1(1) + x37 + x38
        x40 = co(1)*x13*x39
        x41 = co(1)*x15*x39
        x42 = co(1)*x17*x39
        x43 = co(4)*w1(0)
        x44 = P1(2)*w1(0)
        x45 = P2(0)*co(1)*x1
        x46 = co(1)*x1*x15
        x47 = x22*x35
        x48 = co(1)*x24*x35
        x49 = co(1)*x26*x35
        x50 = co(1)*x19*x39
        x51 = 4*P1(1)*P2(1)*co(3)
        x52 = 4*co(3)*x39
        x53 = P2(2)*w2(3) - P2(3)*w2(2)
        x54 = P1(1)*x53
        x55 = P1(2)*P2(2)
        x56 = 4*co(3)*x12
        x57 = P1(3)*P2(3)
        x58 = P2(1)*w2(2) - P2(2)*w2(1)
        x59 = 4*P1(3)*co(3)*x39
        x60 = P1(0)*P2(1)
        x61 = P1(0)*x4
        x62 = w1(0)*w2(2) - w1(2)*w2(0)
        x63 = P1(3)*x62
        x64 = w1(0)*w2(3) - w1(3)*w2(0)
        x65 = P1(2)*x64
        x66 = x61 + x63 - x65
        x67 = 2*co(3)*x66
        x68 = P2(0)*x4 - P2(2)*x64 + P2(3)*x62
        x69 = 2*co(3)*x68
        x70 = P1(0)*P2(3)
        x71 = P1(0)*x7
        x72 = w1(0)*w2(1) - w1(1)*w2(0)
        x73 = P1(2)*x72
        x74 = P1(1)*x62
        x75 = x71 + x73 - x74
        x76 = 2*co(3)*x75
        x77 = P2(0)*x7 - P2(1)*x62 + P2(2)*x72
        x78 = 2*co(3)*x77
        x79 = P1(2)*w2(3)
        x80 = P1(3)*w2(2)
        x81 = x79 - x80
        x82 = P1(1)*w2(2)
        x83 = P1(2)*w2(1)
        x84 = x82 - x83
        x85 = P1(1)*w2(3)
        x86 = P1(3)*w2(1)
        x87 = x85 - x86
        x88 = 2*co(2)*(P2(1)*x81 - P2(2)*x87 + P2(3)*x84)
        x89 = P2(1)*w2(3) - P2(3)*w2(1)
        x90 = 2*co(2)*(P2(1)*x53 - P2(2)*x89 + P2(3)*x58)
        x91 = P1(2)*w1(3)
        x92 = P1(3)*w1(2)
        x93 = x91 - x92
        x94 = P2(1)*x93
        x95 = P1(1)*w1(2)
        x96 = P1(2)*w1(1)
        x97 = x95 - x96
        x98 = P2(3)*x97
        x99 = P1(1)*w1(3)
        x100 = P1(3)*w1(1)
        x101 = -x100 + x99
        x102 = P2(2)*x101
        x103 = 2*co(2)*(-x102 + x94 + x98)
        x104 = P2(2)*w1(3)
        x105 = P2(3)*w1(2)
        x106 = x104 - x105
        x107 = P2(1)*x106
        x108 = P2(1)*w1(2)
        x109 = P2(2)*w1(1)
        x110 = x108 - x109
        x111 = P2(3)*x110
        x112 = P2(3)*w1(1)
        x113 = P2(1)*w1(3) - x112
        x114 = P2(2)*x113
        x115 = 2*co(2)*(x107 + x111 - x114)
        x116 = P1(1)*P2(0)
        x117 = P1(1)*P2(1)
        x118 = -x11 + x5 + x8
        x119 = 2*co(3)*x118
        x120 = 2*P1(1)*co(3)*x39
        x121 = 2*co(3)*x35
        x122 = P1(1)*x106
        x123 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x124 = 2*co(3)*x123
        x125 = P1(1)*w1(1)
        x126 = P1(2)*w1(2)
        x127 = P1(3)*w1(3)
        x128 = x125 + x126 + x127 - x28
        x129 = 2*co(3)*x128
        x130 = 2*co(3)*(x22 + x24 + x26 - x30)
        x131 = P1(0)*P2(0)
        x132 = 2*co(3)*(x117 - x131 + x55 + x57)
        x133 = P1(0)*w2(1)
        x134 = P1(1)*w2(0)
        x135 = x133 - x134
        x136 = P1(0)*w2(3)
        x137 = P1(3)*w2(0)
        x138 = x136 - x137
        x139 = 2*co(2)*(P2(0)*x87 - P2(1)*x138 + P2(3)*x135)
        x140 = P2(0)*w2(1) - P2(1)*w2(0)
        x141 = P2(0)*w2(3) - P2(3)*w2(0)
        x142 = 2*co(2)*(P2(0)*x89 - P2(1)*x141 + P2(3)*x140)
        x143 = P1(2)*w2(0)
        x144 = P2(0)*x101
        x145 = P1(0)*w1(1)
        x146 = P1(1)*w1(0)
        x147 = x145 - x146
        x148 = P2(3)*x147
        x149 = P1(0)*w1(3)
        x150 = P1(3)*w1(0)
        x151 = x149 - x150
        x152 = P2(1)*x151
        x153 = 2*co(2)*(x144 + x148 - x152)
        x154 = P2(0)*x113
        x155 = P2(0)*w1(1)
        x156 = P2(1)*w1(0)
        x157 = x155 - x156
        x158 = P2(3)*x157
        x159 = P2(3)*w1(0)
        x160 = P2(0)*w1(3) - x159
        x161 = P2(1)*x160
        x162 = 2*co(2)*(x154 + x158 - x161)
        x163 = P1(1)*P2(3)
        x164 = P1(3)*P2(1)
        x165 = x163 - x164
        x166 = 2*P1(2)*co(2)*x1
        x167 = P1(3)*P2(0)
        x168 = 2*P1(3)*co(3)*x39
        x169 = 2*co(3)*x110*x35
        x170 = 2*P1(3)*co(3)*x123
        x171 = 2*P1(3)*co(3)*x128
        x172 = P1(0)*P2(2)
        x173 = P1(0)*x10
        x174 = P1(3)*x72
        x175 = P1(1)*x64
        x176 = x173 + x174 - x175
        x177 = 2*co(3)*x176
        x178 = P2(0)*x10 - P2(1)*x64 + P2(3)*x72
        x179 = 2*co(3)*x178
        x180 = P1(0)*w2(2)
        x181 = -x143 + x180
        x182 = 2*co(2)*(P2(0)*x81 - P2(2)*x138 + P2(3)*x181)
        x183 = P2(0)*w2(2) - P2(2)*w2(0)
        x184 = 2*co(2)*(P2(0)*x53 - P2(2)*x141 + P2(3)*x183)
        x185 = P2(0)*x93
        x186 = P1(0)*w1(2)
        x187 = x186 - x44
        x188 = P2(3)*x187
        x189 = P2(2)*x151
        x190 = 2*co(2)*(x185 + x188 - x189)
        x191 = P2(0)*x106
        x192 = P2(2)*w1(0)
        x193 = P2(0)*w1(2) - x192
        x194 = P2(3)*x193
        x195 = P2(2)*x160
        x196 = 2*co(2)*(x191 + x194 - x195)
        x197 = P1(2)*P2(3)
        x198 = P1(3)*P2(2)
        x199 = x197 - x198
        x200 = 2*P1(1)*co(2)*x1
        x201 = P1(2)*P2(0)
        x202 = 2*P1(2)*co(3)*x39
        x203 = 2*P1(2)*co(3)*x35
        x204 = 2*P1(2)*co(3)*x123
        x205 = 2*P1(2)*co(3)*x128
        x206 = 2*co(2)*(P2(0)*x84 - P2(1)*x181 + P2(2)*x135)
        x207 = 2*co(2)*(P2(0)*x58 - P2(1)*x183 + P2(2)*x140)
        x208 = P2(0)*x97
        x209 = P2(2)*x147
        x210 = P2(1)*x187
        x211 = 2*co(2)*(x208 + x209 - x210)
        x212 = P2(0)*x110
        x213 = P2(2)*x157
        x214 = P2(1)*x193
        x215 = 2*co(2)*(x212 + x213 - x214)
        x216 = P1(1)*P2(2)
        x217 = P1(2)*P2(1)
        x218 = x216 - x217
        x219 = 2*P1(3)*co(2)*x1
        x220 = 4*P1(2)*co(3)*x39
        x221 = 6*co(3)
        x222 = 8*co(3)
        x223 = P1(0)*co(1)*x1
        x224 = co(0)*w1(0)*x123
        x225 = P1(0)*P2(0)*co(1)*x128
        x226 = co(0)*x35
        x227 = co(1)*w1(0)*x123
        x228 = w1(2)*x35
        x229 = co(0)*w1(3)*x35
        x230 = P2(1)*co(0)*x35
        x231 = P2(0)*co(0)*x35
        x232 = co(0)*w1(1)*x35
        x233 = co(0)*w1(1)*x123
        x234 = P1(0)*P2(2)*w1(2)
        x235 = co(0)*x123
        x236 = P2(3)*co(0)*x35
        x237 = P2(3)*co(0)*x123
        x238 = P2(1)*co(1)*x128
        x239 = P1(2)*P2(2)*co(1)*x128
        x240 = P2(3)*co(1)*x1
        x241 = co(1)*x128
        x242 = P1(0)*co(4)*w2(0)
        x243 = P1(1)*x1
        x244 = P2(1)*co(1)*x1
        x245 = x30*x35
        x246 = co(1)*w1(1)
        x247 = co(1)*x1*x30
        x248 = P1(1)*co(4)*w2(1)
        x249 = P1(2)*co(4)*w2(2)
        x250 = P1(3)*co(4)
        x251 = 4*P1(0)*co(3)*x39
        x252 = 4*co(3)*x68
        x253 = 4*co(3)*x183*x39
        x254 = 2*P1(0)*co(3)*x39
        x255 = P1(0)*x106
        x256 = 2*P1(0)*co(3)*x128
        x257 = P1(2)*x1
        x258 = 2*co(2)*(-x167 + x70)
        x259 = 2*co(3)*x193*x35
        x260 = 2*co(3)*x12
        x261 = 2*P1(0)*co(2)*x1
        x262 = 2*co(3)*x123*x160
        x263 = x172 - x201
        x264 = 4*co(3)*x141*x39
        x265 = co(1)*x1
        x266 = P1(3)*co(1)*x1
        x267 = co(0)*w1(0)*x35
        x268 = co(1)*w1(1)*x123
        x269 = P1(2)*co(0)*x35
        x270 = P2(2)*co(0)*x35
        x271 = P1(0)*P2(0)*co(1)*x1
        x272 = P1(1)*P2(2)*w1(2)
        x273 = co(1)*x1*x22
        x274 = P2(2)*co(1)*x1
        x275 = w1(2)*x24*x35
        x276 = co(1)*w2(2)*x39
        x277 = 4*co(3)*x178
        x278 = 2*P1(1)*co(3)*x128
        x279 = -x116 + x60
        x280 = P1(0)*x113
        x281 = P1(0)*x89
        x282 = P1(3)*x157
        x283 = P2(0)*co(1)*x128
        x284 = co(1)*x123
        x285 = P1(2)*P2(2)*w1(2)
        x286 = P1(3)*co(0)*x35
        x287 = co(1)*w2(2)*x128
        x288 = P1(2)*P2(1)*w1(1)
        x289 = P1(2)*P2(3)*w1(3)
        x290 = co(1)*w1(3)
        x291 = co(1)*w2(3)*x39
        x292 = 4*co(3)*x77
        x293 = 2*P1(3)*P2(2)*co(3)
        x294 = co(1)*w2(3)*x128
        wout(0) = P1(0)*P2(0)*x118*x221 + P1(0)*P2(0)*x12*x222 + P1(0)*x2 + P1(&
                  1)*P2(0)*w1(1)*x226 + P1(2)*P2(0)*co(0)*x228 - P1(3)*P2(3)*w2&
                  (0)*x241 - P1(3)*x169 - P2(0)*x46 - co(0)*x36 - co(1)*w1(0)* &
                  x47 + co(1)*x36 - co(4)*w2(2)*x44 - co(5)*x11 + co(5)*x5 + co&
                  (5)*x8 - w1(0)*x48 - w1(0)*x49 + w2(0)*x225 - w2(0)*x239 + w2&
                  (0)*x40 + w2(0)*x41 + w2(0)*x42 - w2(0)*x50 - x102*x121 -    &
                  x103*x34 + x107*x121 + x11*x130 + x11*x132 - x110*x170 + x111&
                  *x121 + x113*x203 + x113*x204 - x114*x121 - x115*x34 - x116* &
                  x67 - x116*x69 - x117*x119 + x117*x223 + x117*x227 - x117*x45&
                   - x119*x55 - x119*x57 - x12*x14 - x12*x16 - x12*x18 + x12*  &
                  x20 - x12*x51 - x120*x81 - x121*x122 + x121*x94 + x121*x98 - &
                  x122*x124 - x129*x54 - x13*x45 - x130*x5 - x130*x8 + x131*   &
                  x224 - x131*x227 - x132*x5 - x132*x8 + x134*x190 + x134*x196 &
                   - x134*x238 + x137*x211 + x137*x215 - x139*x44 - x142*x44 - &
                  x143*x153 - x143*x162 + x146*x182 + x146*x184 - x149*x236 -  &
                  x149*x237 + x150*x206 + x150*x207 + x155*x230 - x165*x166 +  &
                  x167*x229 - x167*x240 - x167*x76 - x167*x78 - x168*x84 - x17*&
                  x45 - x171*x58 + x172*x177 + x172*x179 + x177*x201 + x179*   &
                  x201 + x199*x200 + x202*x87 + x205*x89 + x21*x23 + x21*x25 + &
                  x21*x27 + x218*x219 + x220*x89 + x223*x55 + x223*x57 - x226* &
                  x234 + x227*x55 + x227*x57 + x231*x37 + x231*x38 - x232*x60  &
                   - x233*x60 - x234*x235 + x28*x29 - x28*x88 - x28*x90 - x31* &
                  x43 - x33*x43 - x45*x55 - x52*x54 - x55*x56 - x56*x57 - x58* &
                  x59 - x60*x67 - x60*x69 - x70*x76 - x70*x78
        wout(1) = P1(1)*P1(2)*P2(2)*x265 - P1(1)*P2(1)*x221*x66 - P1(1)*P2(1)* &
                  x222*x68 - P1(1)*P2(3)*w1(3)*x235 + P1(1)*x2 - P1(1)*x247 -  &
                  P1(1)*x271 + P1(2)*x262 + P1(2)*x264 - P1(3)*P2(3)*w2(1)*x241&
                   - P1(3)*x253 - P1(3)*x259 - P2(1)*x46 + co(0)*w1(1)*x47 + co&
                  (5)*x61 + co(5)*x63 - co(5)*x65 + w1(1)*x242 - w1(1)*x248 -  &
                  w1(1)*x249 - w1(1)*x48 - w1(1)*x49 + w2(1)*x225 - w2(1)*x239 &
                   + w2(1)*x40 + w2(1)*x41 + w2(1)*x42 - w2(1)*x50 + x100*x206 &
                   + x100*x207 - x103*x133 + x108*x269 + x108*x270 - x115*x133 &
                   + x116*x119 + x116*x224 + x116*x260 + x116*x267 - x117*x233 &
                   + x117*x268 + x119*x60 + x121*x185 + x121*x188 - x121*x189  &
                   + x121*x191 + x121*x194 - x121*x195 - x121*x255 - x124*x255 &
                   + x125*x182 + x125*x184 + x127*x230 - x130*x61 - x130*x63 + &
                  x130*x65 + x131*x244 + x131*x252 - x131*x268 + x131*x67 -    &
                  x132*x61 - x132*x63 + x132*x65 + x138*x202 - x139*x96 - x14* &
                  x68 + x141*x205 - x142*x96 - x145*x88 - x145*x90 - x153*x83  &
                   - x156*x231 - x16*x68 + x160*x203 - x162*x83 - x163*x229 +  &
                  x163*x266 - x163*x76 - x163*x78 - x164*x76 - x164*x78 - x168*&
                  x181 - x17*x244 - x170*x193 - x171*x183 + x177*x216 + x177*  &
                  x217 + x179*x216 + x179*x217 - x18*x68 + x19*x244 + x190*x31 &
                   + x196*x31 + x199*x261 + x20*x68 + x211*x86 + x215*x86 +    &
                  x219*x263 - x226*x272 - x230*x28 + x230*x38 - x235*x272 -    &
                  x238*x31 + x243*x25 + x243*x27 - x244*x55 - x244*x57 + x245* &
                  x246 - x246*x47 - x250*x9 - x251*x53 - x252*x55 - x252*x57 - &
                  x254*x81 - x256*x53 - x257*x258 + x260*x60 + x268*x55 + x268*&
                  x57 - x55*x67 - x57*x67
        wout(2) = -P1(0)*P2(0)*w1(2)*x284 + P1(1)*P1(2)*P2(1)*x265 + P1(1)*P2(1&
                  )*w1(2)*x284 - P1(1)*co(4)*x6 - P1(1)*x121*x160 - P1(1)*x262 &
                   - P1(1)*x264 + P1(2)*P2(0)*w1(0)*x235 + P1(2)*P2(2)*x176*   &
                  x221 + P1(2)*P2(2)*x178*x222 + P1(2)*x2 - P1(2)*x247 - P1(2)*&
                  x271 + P1(2)*x273 + P1(3)*P2(3)*w1(2)*x284 + co(0)*x275 + co(&
                  1)*x228*x30 - co(1)*x275 - co(5)*x173 - co(5)*x174 + co(5)*  &
                  x175 + w1(2)*x242 - w1(2)*x249 + w2(2)*x41 - x103*x180 + x104&
                  *x236 + x104*x286 + x109*x230 - x115*x180 + x117*x177 - x117*&
                  x274 - x117*x287 + x119*x172 + x119*x201 - x120*x138 - x121* &
                  x144 - x121*x148 + x121*x152 - x121*x154 - x121*x158 + x121* &
                  x161 + x121*x280 + x121*x282 + x124*x280 + x124*x282 + x125* &
                  x270 - x126*x139 - x126*x142 + x129*x281 - x13*x274 + x13*   &
                  x276 + x130*x173 + x130*x174 - x130*x175 - x131*x177 + x131* &
                  x274 - x131*x277 + x132*x173 + x132*x174 - x132*x175 + x135* &
                  x168 + x14*x178 + x140*x171 + x140*x59 - x141*x278 - x153*x32&
                   + x16*x178 - x162*x32 - x165*x261 - x17*x274 + x17*x276 +   &
                  x172*x260 + x177*x57 + x178*x18 - x178*x20 + x178*x51 + x180*&
                  x283 + x182*x95 + x184*x95 - x186*x88 - x186*x90 + x19*x274  &
                   - x19*x276 + x190*x82 - x192*x231 + x196*x82 + x197*x266 -  &
                  x197*x76 - x197*x78 - x198*x76 - x198*x78 + x201*x260 + x206*&
                  x92 + x207*x92 + x211*x80 + x215*x80 - x216*x67 - x216*x69 - &
                  x217*x67 - x217*x69 - x219*x279 - x226*x288 - x226*x289 -    &
                  x228*x23 - x228*x27 + x231*x44 - x235*x285 - x235*x288 - x235&
                  *x289 + x243*x258 - x250*x3 + x254*x87 + x257*x27 - x270*x28 &
                   - x274*x57 + x277*x57 + x281*x52 + x284*x285 - x287*x55 -   &
                  x287*x57
        wout(3) = -P1(0)*P2(0)*w1(3)*x284 - P1(0)*x110*x124 - P1(0)*x169 - P1(1&
                  )*P2(1)*w2(3)*x241 + P1(1)*P2(1)*x123*x290 + P1(1)*x124*x193 &
                   + P1(1)*x253 + P1(1)*x259 + P1(2)*P2(2)*w1(3)*x284 - P1(3)* &
                  P2(1)*w1(1)*x235 - P1(3)*P2(2)*w1(2)*x235 + P1(3)*P2(3)*w1(3 &
                  )*x284 - P1(3)*P2(3)*x221*x75 - P1(3)*P2(3)*x222*x77 + P1(3)*&
                  x1*x25 + P1(3)*x2 - P1(3)*x247 + P1(3)*x273 - P2(3)*x46 + co(&
                  5)*x71 + co(5)*x73 - co(5)*x74 - w1(3)*x248 - w1(3)*x249 - w1&
                  (3)*x49 + w2(3)*x41 - x0*x250 - x100*x230 - x103*x136 + x105*&
                  x269 + x105*x270 + x112*x230 - x115*x136 + x117*x266 - x117* &
                  x292 - x117*x76 + x119*x167 + x119*x70 + x120*x181 + x121*   &
                  x208 + x121*x209 - x121*x210 + x121*x212 + x121*x213 - x121* &
                  x214 + x127*x206 + x127*x207 - x127*x237 - x13*x240 + x13*   &
                  x291 - x13*x78 - x130*x71 - x130*x73 + x130*x74 + x131*x240  &
                   + x131*x292 + x131*x76 - x132*x71 - x132*x73 + x132*x74 -   &
                  x135*x202 + x136*x283 - x139*x91 - x140*x205 - x140*x220 -   &
                  x142*x91 + x149*x29 - x149*x88 - x149*x90 - x15*x78 - x153*  &
                  x79 - x157*x203 - x157*x204 - x159*x231 - x162*x79 + x163*   &
                  x232 - x163*x244 - x163*x67 - x163*x69 - x164*x67 - x164*x69 &
                   + x166*x279 - x167*x223 + x167*x224 + x167*x260 + x167*x267 &
                   + x17*x291 - x17*x78 + x176*x293 + x177*x197 + x178*x293 +  &
                  x179*x197 + x182*x99 + x183*x278 + x184*x99 + x19*x240 - x19*&
                  x291 + x19*x78 + x190*x85 + x196*x85 - x200*x263 + x211*x33  &
                   + x215*x33 + x218*x261 + x229*x26 - x236*x28 - x24*x290*x35 &
                   - x240*x55 + x245*x290 - x251*x58 - x254*x84 - x256*x58 +   &
                  x260*x70 + x266*x55 - x286*x37 - x290*x47 - x292*x55 - x294* &
                  x55 - x294*x57 - x55*x76
      case(VVV13)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2
!       ,3))
!       c2*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - Epsilon(-1,-2,1,3)*P(-1,
!       1)*P(-2,2)*P(2,3))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(0)*w2(2) - w1(2)*w2(0)
        x2 = w1(0)*w2(3) - w1(3)*w2(0)
        x3 = P1(0)*x0 - P1(2)*x2 + P1(3)*x1
        x4 = P1(1)*P2(0)*co(2)
        x5 = P2(0)*x0 - P2(2)*x2 + P2(3)*x1
        x6 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x7 = P2(1)*w1(3)
        x8 = P2(3)*w1(1)
        x9 = x7 - x8
        x10 = P1(2)*co(2)*x9
        x11 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x12 = w1(1)*w2(2) - w1(2)*w2(1)
        x13 = w1(0)*w2(1) - w1(1)*w2(0)
        x14 = P1(3)*co(2)*(P1(0)*x12 - P1(1)*x1 + P1(2)*x13)
        x15 = P1(3)*co(2)*(P2(0)*x12 - P2(1)*x1 + P2(2)*x13)
        x16 = P1(1)**2
        x17 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x18 = co(1)*x16*x17
        x19 = P1(2)**2
        x20 = co(1)*x17*x19
        x21 = P1(3)**2
        x22 = co(1)*x17*x21
        x23 = P2(0)**2
        x24 = w1(1)*w2(3) - w1(3)*w2(1)
        x25 = P1(0)*co(2)*(P1(1)*x0 - P1(2)*x24 + P1(3)*x12)
        x26 = P1(0)*co(2)*(P2(1)*x0 - P2(2)*x24 + P2(3)*x12)
        x27 = P1(0)*co(1)*x17
        x28 = P2(2)*w1(3)
        x29 = P2(3)*w1(2)
        x30 = x28 - x29
        x31 = P1(1)*co(2)*x30
        x32 = P1(2)*co(2)*(P1(0)*x24 - P1(1)*x2 + P1(3)*x13)
        x33 = P1(2)*co(2)*(P2(0)*x24 - P2(1)*x2 + P2(3)*x13)
        x34 = P2(1)*w1(2)
        x35 = P2(2)*w1(1)
        x36 = x34 - x35
        x37 = P1(3)*co(2)*x6
        x38 = P1(3)*co(2)*x11
        x39 = P1(0)**2
        x40 = co(1)*x17*x39
        x41 = co(0)*x11
        x42 = P1(0)*P2(0)*w1(0)
        x43 = P1(1)*P2(1)*co(1)*x17
        x44 = P2(1)*w1(0)
        x45 = P1(1)*co(1)*x6
        x46 = P1(1)*co(1)*x11
        x47 = P1(2)*co(1)*x17
        x48 = P2(0)*P2(2)
        x49 = P2(2)*w1(0)
        x50 = P1(2)*co(1)*x6
        x51 = P1(2)*co(1)*x11
        x52 = P2(0)*P2(3)*co(1)*x17
        x53 = P2(3)*w1(0)
        x54 = P1(3)*co(1)*x6
        x55 = P1(3)*co(1)*x11
        x56 = P1(0)*co(1)*x11
        x57 = P2(1)*co(0)*w1(1)*x6
        x58 = P2(1)*co(0)*w1(1)*x11
        x59 = P2(2)*co(0)*w1(2)*x6
        x60 = P2(2)*co(0)*w1(2)*x11
        x61 = P2(3)*co(0)*w1(3)*x6
        x62 = P2(3)*co(0)*w1(3)*x11
        x63 = P2(0)*co(0)*w1(1)*x6
        x64 = P2(0)*w1(2)
        x65 = P1(2)*co(0)*x6
        x66 = P2(0)*co(0)*w1(3)*x6
        x67 = P2(2)*co(0)*x6
        x68 = P2(0)*co(0)*w1(0)*x6
        x69 = P1(1)*co(2)*x3
        x70 = P1(1)*co(2)*x5
        x71 = P2(1)**2
        x72 = P1(2)*co(2)
        x73 = P2(0)*w1(3)
        x74 = -x53 + x73
        x75 = x6*x74
        x76 = P1(0)*co(2)*x6
        x77 = P1(0)*co(2)*x11
        x78 = -x49 + x64
        x79 = co(0)*w1(1)*x6
        x80 = P1(0)*co(0)*x6
        x81 = P2(0)*co(0)*w1(0)*x11
        x82 = P2(1)*w1(1)
        x83 = P2(3)*co(1)*x17
        x84 = P1(3)*P2(1)
        x85 = P2(0)*co(0)*x6
        x86 = P2(0)*w1(1)
        x87 = P1(0)*co(1)*x6
        x88 = P2(1)*co(0)*w1(3)*x6
        x89 = P2(2)**2
        x90 = -x44 + x86
        x91 = P1(1)*co(2)
        x92 = P1(1)*co(2)*x11
        x93 = P2(2)*co(0)*w1(0)*x6
        x94 = P2(2)*w1(2)
        x95 = P2(2)*P2(3)*co(1)*x17
        x96 = P2(2)*co(0)*w1(1)*x6
        x97 = P2(2)*co(0)*w1(3)*x6
        x98 = P2(3)**2
        x99 = P1(2)*co(2)*x90
        x100 = P2(3)*w1(3)
        x101 = P2(3)*co(0)*w1(1)*x6
        x102 = P2(3)*co(0)*w1(2)*x6
        wout(0) = -P1(0)*x57 - P1(0)*x58 - P1(0)*x59 - P1(0)*x60 - P1(0)*x61 - &
                  P1(0)*x62 + 2*P1(0)*x68 - P1(1)*x63 + P1(3)*x52 - P1(3)*x66  &
                   - P2(0)*w1(0)*x56 + P2(0)*x14 + P2(0)*x15 + P2(0)*x18 + P2(0&
                  )*x20 + P2(0)*x22 - P2(0)*x25 - P2(0)*x26 - P2(0)*x32 - P2(0 &
                  )*x33 - P2(0)*x40 + P2(0)*x43 - P2(1)*x63 - P2(3)*x66 + co(0 &
                  )*w1(0)*x23*x6 - co(1)*x42*x6 + x10*x11 + x10*x6 - x11*x31 - &
                  x23*x27 + x3*x4 - x31*x6 - x36*x37 - x36*x38 + x4*x5 + x41*  &
                  x42 + x44*x45 + x44*x46 + x47*x48 + x49*x50 + x49*x51 + x53* &
                  x54 + x53*x55 - x64*x65 - x64*x67
        wout(1) = P1(1)*co(1)*x17*x71 - 2*P1(1)*x57 - P1(1)*x58 - P1(1)*x59 -  &
                  P1(1)*x60 - P1(1)*x61 - P1(1)*x62 + P1(1)*x68 + P1(1)*x81 -  &
                  P1(3)*x88 - P2(0)*P2(1)*x27 + P2(1)*P2(2)*x47 + P2(1)*x14 +  &
                  P2(1)*x15 + P2(1)*x18 + P2(1)*x20 + P2(1)*x22 - P2(1)*x25 -  &
                  P2(1)*x26 - P2(1)*x32 - P2(1)*x33 - P2(1)*x40 + P2(1)*x69 +  &
                  P2(1)*x70 - P2(3)*x88 + x11*x72*x74 - x30*x76 - x30*x77 - x34&
                  *x65 - x34*x67 + x35*x50 + x35*x51 - x37*x78 - x38*x78 + x44*&
                  x80 + x44*x85 + x45*x82 + x46*x82 + x54*x8 + x55*x8 - x56*x86&
                   - x71*x79 + x72*x75 + x83*x84 - x86*x87
        wout(2) = P1(0)*x93 - P1(1)*x96 - P1(2)*x57 - P1(2)*x58 - 2*P1(2)*x59  &
                   - P1(2)*x60 - P1(2)*x61 - P1(2)*x62 + P1(2)*x68 + P1(2)*x81 &
                   + P1(3)*x95 - P1(3)*x97 + P2(0)*x93 - P2(1)*x96 + P2(2)*x14 &
                   + P2(2)*x15 + P2(2)*x18 + P2(2)*x20 + P2(2)*x22 - P2(2)*x25 &
                   - P2(2)*x26 - P2(2)*x32 - P2(2)*x33 - P2(2)*x40 + P2(2)*x43 &
                   + P2(2)*x69 + P2(2)*x70 - P2(3)*x97 - co(0)*w1(2)*x6*x89 -  &
                  x27*x48 + x29*x54 + x29*x55 + x34*x45 + x34*x46 + x37*x90 +  &
                  x38*x90 + x47*x89 + x50*x94 + x51*x94 - x56*x64 - x64*x87 -  &
                  x74*x92 - x75*x91 + x76*x9 + x77*x9
        wout(3) = -P1(0)*x52 - P1(1)*x101 - P1(2)*x102 + P1(2)*x95 - P1(3)*P2(1&
                  )*w1(1)*x41 + P1(3)*co(1)*x17*x98 - P1(3)*x59 - P1(3)*x60 - 2&
                  *P1(3)*x61 - P1(3)*x62 + P1(3)*x68 + P1(3)*x81 - P2(1)*x101  &
                   - P2(2)*x102 + P2(3)*x14 + P2(3)*x15 - P2(3)*x25 - P2(3)*x26&
                   - P2(3)*x32 - P2(3)*x33 + P2(3)*x43 + P2(3)*x69 + P2(3)*x70 &
                   - co(0)*w1(3)*x6*x98 + x100*x54 + x100*x55 - x11*x99 + x16* &
                  x83 + x19*x83 + x21*x83 + x28*x50 + x28*x51 - x36*x76 - x36* &
                  x77 - x39*x83 + x45*x7 + x46*x7 + x53*x80 + x53*x85 - x56*x73&
                   + x6*x78*x91 - x6*x99 - x73*x87 + x78*x92 - x79*x84
      case(VVV14)
!       c0*(P(1,2)*P(2,3)*P(3,1) - P(1,3)*P(2,1)*P(3,2))
!       c1*(Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3,
!       1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) + Metric(1,3)*P(-1,2)*P(-1,3)*P(2
!       ,1) + Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(-2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*      
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) - 2*Epsilon(-1,-2
!       ,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + 2*Epsilon(-1,-2,1,2)*P 
!       (-1,2)*P(-2,3)*P(3,1) - 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) + 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) - 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) - 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) - 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(Metric(1,2)*P(3,2) - Metric(2,3)*P(1,2))
!       Epsilon(-1,1,2,3)*P(-1,2)*c5
        if (last) VB_last = .true.
        x0 = w1(3)*w2(2)
        x1 = w1(2)*w2(3) - x0
        x2 = P2(1)*x1
        x3 = w1(1)*w2(2)
        x4 = -w1(2)*w2(1) + x3
        x5 = P2(3)*x4
        x6 = w1(3)*w2(3)
        x7 = w1(0)*w2(0)
        x8 = w1(1)*w2(1) + w1(2)*w2(2) + x6 - x7
        x9 = co(4)*x8
        x10 = w1(1)*w2(3) - w1(3)*w2(1)
        x11 = P2(2)*x10
        x12 = -x11 + x2 + x5
        x13 = P1(1)**2
        x14 = 2*co(3)*x13
        x15 = P1(2)**2
        x16 = 2*co(3)*x15
        x17 = P1(3)**2
        x18 = 2*co(3)*x17
        x19 = P1(0)**2
        x20 = 2*co(3)*x19
        x21 = P1(0)*x8
        x22 = P2(1)**2
        x23 = co(1)*x22
        x24 = P2(2)**2
        x25 = co(1)*x24
        x26 = P2(3)**2
        x27 = co(1)*x26
        x28 = P2(1)*w2(0)
        x29 = co(4)*w1(1)
        x30 = P2(2)*co(4)*w1(2)
        x31 = P2(3)*w2(0)
        x32 = co(4)*w1(3)
        x33 = P2(0)**2
        x34 = P1(1)*w2(1)
        x35 = P1(2)*w2(2)
        x36 = P1(3)*w2(3)
        x37 = P1(0)*w2(0)
        x38 = x34 + x35 + x36 - x37
        x39 = w1(0)*x33*x38
        x40 = P2(2)*w1(2)
        x41 = P2(3)*w1(3)
        x42 = -P2(0)*w1(0) + P2(1)*w1(1) + x40 + x41
        x43 = co(1)*x13*x42
        x44 = co(1)*x15*x42
        x45 = co(1)*x17*x42
        x46 = P2(0)*co(1)*x8
        x47 = co(1)*x15*x8
        x48 = P2(0)*co(4)
        x49 = x22*x38
        x50 = co(1)*x24*x38
        x51 = co(1)*x26*x38
        x52 = co(1)*x19*x42
        x53 = 4*P1(1)*P2(1)*co(3)
        x54 = P2(2)*w2(3) - P2(3)*w2(2)
        x55 = P1(1)*x54
        x56 = P1(2)*P2(2)
        x57 = 4*co(3)*x12
        x58 = P1(3)*P2(3)
        x59 = P2(1)*w2(2) - P2(2)*w2(1)
        x60 = 4*P1(3)*co(3)*x42
        x61 = P1(0)*P2(1)
        x62 = P1(0)*x1
        x63 = w1(0)*w2(2) - w1(2)*w2(0)
        x64 = P1(3)*x63
        x65 = w1(0)*w2(3)
        x66 = -w1(3)*w2(0) + x65
        x67 = P1(2)*x66
        x68 = x62 + x64 - x67
        x69 = 2*co(3)*x68
        x70 = P2(0)*x1
        x71 = P2(3)*x63
        x72 = P2(2)*x66
        x73 = x70 + x71 - x72
        x74 = 2*co(3)*x73
        x75 = P1(0)*P2(3)
        x76 = P1(0)*x4
        x77 = w1(0)*w2(1)
        x78 = -w1(1)*w2(0) + x77
        x79 = P1(2)*x78
        x80 = P1(1)*x63
        x81 = x76 + x79 - x80
        x82 = 2*co(3)*x81
        x83 = P2(0)*x4
        x84 = P2(2)*x78
        x85 = P2(1)*x63
        x86 = x83 + x84 - x85
        x87 = 2*co(3)*x86
        x88 = P1(0)*w1(0)
        x89 = P1(2)*w2(3)
        x90 = P1(3)*w2(2)
        x91 = x89 - x90
        x92 = P1(1)*w2(2)
        x93 = P1(2)*w2(1)
        x94 = x92 - x93
        x95 = P1(1)*w2(3)
        x96 = P1(3)*w2(1)
        x97 = x95 - x96
        x98 = 2*co(2)*(P2(1)*x91 - P2(2)*x97 + P2(3)*x94)
        x99 = P2(1)*w2(3)
        x100 = P2(3)*w2(1)
        x101 = -x100 + x99
        x102 = 2*co(2)*(P2(1)*x54 - P2(2)*x101 + P2(3)*x59)
        x103 = P1(2)*w1(3)
        x104 = P1(3)*w1(2)
        x105 = x103 - x104
        x106 = P2(1)*x105
        x107 = P1(1)*w1(2)
        x108 = P1(2)*w1(1)
        x109 = x107 - x108
        x110 = P2(3)*x109
        x111 = P1(1)*w1(3)
        x112 = P1(3)*w1(1)
        x113 = x111 - x112
        x114 = P2(2)*x113
        x115 = 2*co(2)*(x106 + x110 - x114)
        x116 = P2(2)*w1(3)
        x117 = P2(3)*w1(2)
        x118 = x116 - x117
        x119 = P2(1)*x118
        x120 = P2(1)*w1(2)
        x121 = P2(2)*w1(1)
        x122 = x120 - x121
        x123 = P2(3)*x122
        x124 = P2(3)*w1(1)
        x125 = P2(1)*w1(3) - x124
        x126 = P2(2)*x125
        x127 = 2*co(2)*(x119 + x123 - x126)
        x128 = P1(1)*P2(0)
        x129 = P1(1)*P2(1)
        x130 = P1(1)*x1
        x131 = P1(3)*x4
        x132 = P1(2)*x10
        x133 = x130 + x131 - x132
        x134 = 2*co(3)*x133
        x135 = 2*P1(1)*co(3)*x42
        x136 = 2*co(3)*x38
        x137 = P1(1)*x118
        x138 = P2(1)*w2(1)
        x139 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x138
        x140 = 2*co(3)*x139
        x141 = P1(1)*w1(1)
        x142 = P1(2)*w1(2)
        x143 = P1(3)*w1(3)
        x144 = x141 + x142 + x143 - x88
        x145 = 2*co(3)*(x22 + x24 + x26 - x33)
        x146 = P1(0)*P2(0)
        x147 = 2*co(3)*(x129 - x146 + x56 + x58)
        x148 = P1(2)*w1(0)
        x149 = P1(0)*w2(1)
        x150 = P1(1)*w2(0)
        x151 = x149 - x150
        x152 = P1(0)*w2(3)
        x153 = P1(3)*w2(0)
        x154 = x152 - x153
        x155 = 2*co(2)*(P2(0)*x97 - P2(1)*x154 + P2(3)*x151)
        x156 = P2(0)*w2(1) - x28
        x157 = P2(0)*w2(3) - x31
        x158 = 2*co(2)*(P2(0)*x101 - P2(1)*x157 + P2(3)*x156)
        x159 = P1(2)*w2(0)
        x160 = P2(0)*x113
        x161 = P1(0)*w1(1)
        x162 = P1(1)*w1(0)
        x163 = x161 - x162
        x164 = P2(3)*x163
        x165 = P1(0)*w1(3)
        x166 = P1(3)*w1(0)
        x167 = x165 - x166
        x168 = P2(1)*x167
        x169 = 2*co(2)*(x160 + x164 - x168)
        x170 = P2(0)*x125
        x171 = P2(0)*w1(1)
        x172 = P2(1)*w1(0)
        x173 = x171 - x172
        x174 = P2(3)*x173
        x175 = P2(3)*w1(0)
        x176 = P2(0)*w1(3) - x175
        x177 = P2(1)*x176
        x178 = 2*co(2)*(x170 + x174 - x177)
        x179 = P1(1)*P2(3)
        x180 = P1(3)*P2(1)
        x181 = x179 - x180
        x182 = 2*P1(2)*co(2)*x8
        x183 = P1(3)*P2(0)
        x184 = 2*P1(3)*co(3)*x42
        x185 = 2*co(3)*x122*x38
        x186 = 2*P1(3)*co(3)*x139
        x187 = 2*P1(3)*co(3)*x144
        x188 = P1(0)*P2(2)
        x189 = P1(0)*x10
        x190 = P1(3)*x78
        x191 = P1(1)*x66
        x192 = x189 + x190 - x191
        x193 = 2*co(3)*x192
        x194 = P2(0)*x10
        x195 = P2(3)*x78
        x196 = P2(1)*x66
        x197 = x194 + x195 - x196
        x198 = 2*co(3)*x197
        x199 = P1(0)*w2(2)
        x200 = -x159 + x199
        x201 = 2*co(2)*(P2(0)*x91 - P2(2)*x154 + P2(3)*x200)
        x202 = P2(0)*w2(2)
        x203 = -P2(2)*w2(0) + x202
        x204 = 2*co(2)*(P2(0)*x54 - P2(2)*x157 + P2(3)*x203)
        x205 = P2(0)*x105
        x206 = P1(0)*w1(2)
        x207 = -x148 + x206
        x208 = P2(3)*x207
        x209 = P2(2)*x167
        x210 = 2*co(2)*(x205 + x208 - x209)
        x211 = P2(0)*x118
        x212 = P2(2)*w1(0)
        x213 = P2(0)*w1(2) - x212
        x214 = P2(3)*x213
        x215 = P2(2)*x176
        x216 = 2*co(2)*(x211 + x214 - x215)
        x217 = P1(2)*P2(3)
        x218 = P1(3)*P2(2)
        x219 = x217 - x218
        x220 = 2*P1(1)*co(2)*x8
        x221 = P1(2)*P2(0)
        x222 = 2*P1(2)*co(3)*x42
        x223 = 2*P1(2)*co(3)*x38
        x224 = 2*P1(2)*co(3)*x139
        x225 = 2*P1(2)*co(3)*x144
        x226 = 2*co(2)*(P2(0)*x94 - P2(1)*x200 + P2(2)*x151)
        x227 = 2*co(2)*(P2(0)*x59 - P2(1)*x203 + P2(2)*x156)
        x228 = P2(0)*x109
        x229 = P2(2)*x163
        x230 = P2(1)*x207
        x231 = 2*co(2)*(x228 + x229 - x230)
        x232 = P2(0)*x122
        x233 = P2(2)*x173
        x234 = P2(1)*x213
        x235 = 2*co(2)*(x232 + x233 - x234)
        x236 = P1(1)*P2(2)
        x237 = P1(2)*P2(1)
        x238 = x236 - x237
        x239 = 2*P1(3)*co(2)*x8
        x240 = 4*P1(2)*co(3)*x42
        x241 = 6*co(3)
        x242 = 8*co(3)
        x243 = P1(0)*co(1)*x8
        x244 = co(0)*w1(0)*x139
        x245 = P1(0)*P2(0)*co(1)*x144
        x246 = P2(0)*co(0)*x38
        x247 = co(1)*w1(0)*x139
        x248 = w1(2)*x38
        x249 = co(0)*w1(3)*x38
        x250 = P2(1)*co(0)*x38
        x251 = P1(0)*P2(1)*co(0)*w1(1)
        x252 = co(0)*x38
        x253 = P1(0)*P2(2)*w1(2)
        x254 = co(0)*x139
        x255 = P2(3)*co(0)*x38
        x256 = P2(3)*co(0)*x139
        x257 = co(1)*x144
        x258 = P1(2)*P2(2)*co(1)*x144
        x259 = P2(3)*co(1)*x8
        x260 = P1(3)*P2(3)*co(1)*x144
        x261 = P1(1)*x8
        x262 = P2(1)*co(1)*x8
        x263 = x33*x38
        x264 = co(1)*w1(1)
        x265 = co(1)*x33*x8
        x266 = 4*P1(0)*co(3)*x42
        x267 = 4*co(3)*x73
        x268 = 4*co(3)*x203*x42
        x269 = 2*P1(0)*co(3)*x42
        x270 = P1(0)*x118
        x271 = 2*P1(0)*co(3)*x144
        x272 = P1(2)*x8
        x273 = 2*co(2)*(-x183 + x75)
        x274 = 2*co(3)*x213*x38
        x275 = 2*co(3)*x12
        x276 = 2*P1(0)*co(2)*x8
        x277 = 2*co(3)*x139*x176
        x278 = x188 - x221
        x279 = 4*co(3)*x157*x42
        x280 = P1(1)*co(1)*x8
        x281 = co(0)*w1(0)*x38
        x282 = P1(2)*co(0)*x38
        x283 = co(1)*w1(1)*x139
        x284 = P2(2)*co(0)*x38
        x285 = P1(0)*P2(0)*co(1)*x8
        x286 = P2(1)*co(0)*x139
        x287 = P1(1)*co(1)*x144
        x288 = P1(1)*P2(2)*w1(2)
        x289 = co(1)*x22*x8
        x290 = P2(2)*co(1)*x8
        x291 = P2(3)*co(4)
        x292 = w1(2)*x24*x38
        x293 = co(1)*w2(2)*x42
        x294 = 4*co(3)*x197
        x295 = 2*P1(1)*co(3)*x144
        x296 = -x128 + x61
        x297 = P1(0)*x125
        x298 = P1(3)*x173
        x299 = P2(0)*co(1)*x144
        x300 = co(1)*x139
        x301 = P1(3)*co(1)*x8
        x302 = P1(2)*P2(2)*w1(2)
        x303 = P1(3)*co(0)*x38
        x304 = co(1)*w2(2)*x144
        x305 = co(1)*w1(3)
        x306 = co(1)*w2(3)*x42
        x307 = 4*co(3)*x86
        x308 = 2*P1(3)*P2(2)*co(3)
        x309 = co(1)*w2(3)*x144
        wout(0) = P1(0)*P2(0)*x12*x242 + P1(0)*P2(0)*x133*x241 - P1(1)*P2(1)*w2&
                  (0)*x257 + P1(2)*P2(0)*co(0)*x248 - P1(3)*x185 - P2(0)*x47 - &
                  P2(0)*x9 - co(0)*x39 - co(1)*w1(0)*x49 + co(1)*x39 - 2*co(3)*&
                  x144*x55 - 4*co(3)*x42*x55 - co(5)*x11 + co(5)*x2 + co(5)*x5 &
                   - w1(0)*x50 - w1(0)*x51 + w2(0)*x245 - w2(0)*x258 - w2(0)*  &
                  x260 + w2(0)*x30 + w2(0)*x43 + w2(0)*x44 + w2(0)*x45 - w2(0)*&
                  x52 + x101*x225 + x101*x240 - x102*x88 + x106*x136 + x110*   &
                  x136 - x114*x136 - x115*x37 + x119*x136 - x12*x14 - x12*x16  &
                   - x12*x18 + x12*x20 - x12*x53 - x122*x186 + x123*x136 + x125&
                  *x223 + x125*x224 - x126*x136 - x127*x37 - x128*x69 - x128*  &
                  x74 - x129*x134 + x129*x243 + x129*x247 - x129*x46 - x13*x46 &
                   - x130*x145 - x130*x147 - x131*x145 - x131*x147 + x132*x145 &
                   + x132*x147 - x134*x56 - x134*x58 - x135*x91 - x136*x137 -  &
                  x137*x140 - x139*x251 + x141*x246 + x146*x244 - x146*x247 -  &
                  x148*x155 - x148*x158 + x150*x210 + x150*x216 + x153*x231 +  &
                  x153*x235 - x159*x169 - x159*x178 + x162*x201 + x162*x204 -  &
                  x165*x255 - x165*x256 + x166*x226 + x166*x227 - x17*x46 +    &
                  x171*x250 - x181*x182 + x183*x249 - x183*x259 - x183*x82 -   &
                  x183*x87 - x184*x94 - x187*x59 + x188*x193 + x188*x198 + x193&
                  *x221 + x198*x221 + x21*x23 + x21*x25 + x21*x27 + x219*x220  &
                   + x222*x97 + x238*x239 + x243*x56 + x243*x58 + x246*x40 +   &
                  x246*x41 + x247*x56 + x247*x58 - x251*x38 - x252*x253 - x253*&
                  x254 + x28*x29 + x31*x32 - x46*x56 - x48*x7 - x56*x57 - x57* &
                  x58 - x59*x60 - x61*x69 - x61*x74 - x75*x82 - x75*x87 - x88* &
                  x98
        wout(1) = P1(1)*P2(1)*co(1)*w1(1)*x139 - P1(1)*P2(1)*x241*x68 - P1(1)* &
                  P2(1)*x242*x73 - P1(1)*x265 - P1(1)*x285 + P1(2)*x277 + P1(2 &
                  )*x279 - P1(3)*P2(3)*w2(1)*x257 - P1(3)*x268 - P1(3)*x274 -  &
                  P2(1)*x47 - P2(1)*x9 + co(0)*w1(1)*x49 + co(5)*x70 + co(5)*  &
                  x71 - co(5)*x72 - w1(1)*x50 - w1(1)*x51 + w2(1)*x245 - w2(1)*&
                  x258 + w2(1)*x30 + w2(1)*x43 + w2(1)*x44 + w2(1)*x45 - w2(1)*&
                  x52 + x100*x32 - x102*x161 - x108*x155 - x108*x158 - x111*   &
                  x255 - x111*x256 + x112*x226 + x112*x227 - x115*x149 + x120* &
                  x282 + x120*x284 - x127*x149 + x128*x134 + x128*x244 + x128* &
                  x275 + x128*x281 + x134*x61 + x136*x205 + x136*x208 - x136*  &
                  x209 + x136*x211 + x136*x214 - x136*x215 - x136*x270 - x138* &
                  x287 + x138*x29 - x14*x73 - x140*x270 + x141*x201 + x141*x204&
                   - x141*x286 + x143*x250 - x145*x62 - x145*x64 + x145*x67 +  &
                  x146*x262 + x146*x267 - x146*x283 + x146*x69 - x147*x62 -    &
                  x147*x64 + x147*x67 + x154*x222 + x157*x225 - x16*x73 - x161*&
                  x98 - x169*x93 - x17*x262 - x172*x246 + x176*x223 - x178*x93 &
                   - x179*x82 - x179*x87 - x18*x73 - x180*x82 - x180*x87 - x184&
                  *x200 - x186*x213 - x187*x203 + x19*x262 + x193*x236 + x193* &
                  x237 + x198*x236 + x198*x237 + x20*x73 + x210*x34 + x216*x34 &
                   + x219*x276 + x231*x96 + x235*x96 + x239*x278 + x25*x261 +  &
                  x250*x41 - x250*x88 - x252*x288 - x254*x288 + x261*x27 - x262&
                  *x56 - x262*x58 + x263*x264 - x264*x49 - x266*x54 - x267*x56 &
                   - x267*x58 - x269*x91 - x271*x54 - x272*x273 + x275*x61 +   &
                  x280*x56 + x280*x58 + x283*x56 + x283*x58 - x48*x77 - x56*x69&
                   - x58*x69
        wout(2) = -P1(0)*P2(0)*w1(2)*x300 + P1(1)*P1(2)*P2(1)*co(1)*x8 + P1(1)*&
                  P2(1)*w1(2)*x300 - P1(1)*x136*x176 - P1(1)*x277 - P1(1)*x279 &
                   + P1(2)*P2(0)*w1(0)*x254 + P1(2)*P2(2)*x192*x241 + P1(2)*P2(&
                  2)*x197*x242 - P1(2)*x265 - P1(2)*x285 + P1(2)*x289 + P1(3)* &
                  P2(3)*w1(2)*x300 + P2(1)*co(4)*x3 - P2(2)*x9 + co(0)*x292 +  &
                  co(1)*x248*x33 - co(1)*x292 - co(4)*w1(0)*x202 - co(5)*x194  &
                   - co(5)*x195 + co(5)*x196 - w2(2)*x260 + w2(2)*x30 + w2(2)* &
                  x44 + x0*x291 + x101*x266 + x101*x271 - x102*x206 - x103*x255&
                   - x103*x256 + x104*x226 + x104*x227 + x107*x201 + x107*x204 &
                   - x108*x250 - x108*x286 - x115*x199 + x116*x255 + x116*x303 &
                   + x121*x250 - x127*x199 + x129*x193 - x129*x290 - x129*x304 &
                   - x13*x290 + x13*x293 + x134*x188 + x134*x221 - x135*x154 - &
                  x136*x160 - x136*x164 + x136*x168 - x136*x170 - x136*x174 +  &
                  x136*x177 + x136*x297 + x136*x298 + x14*x197 + x140*x297 +   &
                  x140*x298 + x141*x284 - x142*x155 - x142*x158 + x145*x189 +  &
                  x145*x190 - x145*x191 - x146*x193 + x146*x290 - x146*x294 +  &
                  x147*x189 + x147*x190 - x147*x191 + x148*x246 + x151*x184 +  &
                  x156*x187 + x156*x60 - x157*x295 + x16*x197 - x169*x35 - x17*&
                  x290 + x17*x293 - x178*x35 + x18*x197 - x181*x276 + x188*x275&
                   + x19*x290 - x19*x293 + x193*x58 - x197*x20 + x197*x53 +    &
                  x199*x299 - x206*x98 + x210*x92 - x212*x246 + x216*x92 + x217&
                  *x301 - x217*x82 - x217*x87 - x218*x82 - x218*x87 + x221*x275&
                   - x23*x248 + x231*x90 + x235*x90 - x236*x69 - x236*x74 -    &
                  x237*x69 - x237*x74 - x239*x296 - x248*x27 - x254*x302 + x261&
                  *x273 + x269*x97 + x27*x272 - x284*x88 - x290*x58 + x294*x58 &
                   + x300*x302 - x304*x56
        wout(3) = -P1(0)*P2(0)*w1(3)*x300 - P1(0)*x122*x140 - P1(0)*x185 + P1(1&
                  )*P2(1)*x139*x305 + P1(1)*x140*x213 + P1(1)*x268 + P1(1)*x274&
                   + P1(2)*P2(2)*w1(3)*x300 - P1(3)*P2(2)*w1(2)*x254 + P1(3)*P2&
                  (3)*w1(3)*x300 - P1(3)*P2(3)*x241*x81 - P1(3)*P2(3)*x242*x86 &
                   + P1(3)*x25*x8 - P1(3)*x265 + P1(3)*x289 - P2(3)*x47 - P2(3 &
                  )*x9 + co(5)*x83 + co(5)*x84 - co(5)*x85 - w1(3)*x51 + w2(3)*&
                  x30 + w2(3)*x44 - x102*x165 - x103*x155 - x103*x158 + x111*  &
                  x201 + x111*x204 - x112*x250 - x112*x286 - x115*x152 + x117* &
                  x282 + x117*x284 + x124*x250 - x127*x152 - x129*x259 + x129* &
                  x301 - x129*x307 - x129*x82 - x13*x259 + x13*x306 + x134*x183&
                   + x134*x75 + x135*x200 + x136*x228 + x136*x229 - x136*x230  &
                   + x136*x232 + x136*x233 - x136*x234 - x14*x86 + x141*x255 + &
                  x143*x226 + x143*x227 - x143*x256 - x145*x76 - x145*x79 +    &
                  x145*x80 + x146*x259 + x146*x307 + x146*x82 - x147*x76 - x147&
                  *x79 + x147*x80 - x151*x222 + x152*x299 - x156*x225 - x156*  &
                  x240 - x16*x86 - x165*x98 - x169*x89 + x17*x306 - x173*x223  &
                   - x173*x224 - x175*x246 - x178*x89 - x179*x69 - x179*x74 -  &
                  x18*x86 - x180*x69 - x180*x74 + x182*x296 - x183*x243 + x183*&
                  x244 + x183*x275 + x183*x281 + x19*x259 - x19*x306 + x192*   &
                  x308 + x193*x217 + x197*x308 + x198*x217 + x20*x86 + x203*   &
                  x295 + x210*x95 + x216*x95 - x220*x278 + x231*x36 + x235*x36 &
                   + x238*x276 - x24*x305*x38 + x249*x26 - x255*x88 - x259*x56 &
                   + x263*x305 - x266*x59 - x269*x94 - x271*x59 + x275*x75 -   &
                  x287*x99 + x29*x99 + x291*x6 + x301*x56 - x303*x40 - x305*x49&
                   - x307*x56 - x309*x56 - x309*x58 - x48*x65 - x56*x82
      case(VVV15)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1
!       ,3))
!       c2*(Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1) + Epsilon(-1,-2,2,3)*P(-1,1
!       )*P(-2,2)*P(1,3))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(0)*co(2)*(P1(1)*x0 - P1(2)*x2 + P1(3)*x1)
        x4 = P2(0)*co(2)*(P2(1)*x0 - P2(2)*x2 + P2(3)*x1)
        x5 = w1(0)*w2(1) - w1(1)*w2(0)
        x6 = w1(0)*w2(3) - w1(3)*w2(0)
        x7 = P2(2)*co(2)*(P1(0)*x2 - P1(1)*x6 + P1(3)*x5)
        x8 = P2(0)*x2 - P2(1)*x6 + P2(3)*x5
        x9 = P2(2)*co(2)*x8
        x10 = P2(1)**2
        x11 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x12 = co(1)*x10*x11
        x13 = P2(2)**2
        x14 = P1(0)*co(1)*x11
        x15 = P2(3)**2
        x16 = P2(2)*w2(3)
        x17 = P2(3)*w2(2)
        x18 = x16 - x17
        x19 = P1(1)*w1(1)
        x20 = P1(2)*w1(2)
        x21 = P1(3)*w1(3)
        x22 = P1(0)*w1(0)
        x23 = x19 + x20 + x21 - x22
        x24 = P1(1)*co(2)*x23
        x25 = P2(1)*w1(1)
        x26 = P2(2)*w1(2)
        x27 = P2(3)*w1(3)
        x28 = P2(0)*w1(0)
        x29 = x25 + x26 + x27 - x28
        x30 = P1(1)*co(2)*x29
        x31 = P2(1)*w2(2)
        x32 = P2(2)*w2(1)
        x33 = x31 - x32
        x34 = co(2)*x23*x33
        x35 = P1(3)*co(2)*x29
        x36 = P2(0)**2
        x37 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x38 = co(0)*x37
        x39 = w1(0)*w2(2) - w1(2)*w2(0)
        x40 = P1(0)*x0 - P1(2)*x6 + P1(3)*x39
        x41 = P1(0)*P2(1)*co(2)
        x42 = P2(0)*x0 - P2(2)*x6 + P2(3)*x39
        x43 = P1(0)*x1 - P1(1)*x39 + P1(2)*x5
        x44 = P1(0)*P2(3)*co(2)
        x45 = P2(0)*x1 - P2(1)*x39 + P2(2)*x5
        x46 = P2(1)*w2(3)
        x47 = P2(3)*w2(1)
        x48 = x46 - x47
        x49 = co(2)*x23*x48
        x50 = co(2)*x29*x48
        x51 = co(1)*x11
        x52 = P1(1)*P2(1)*co(1)*x11
        x53 = P1(0)*P1(2)*co(1)*x11
        x54 = P1(3)*P2(3)
        x55 = P2(3)*w2(3)
        x56 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + x55
        x57 = co(0)*x56
        x58 = P2(1)*w2(0)
        x59 = P1(1)*co(1)*x23
        x60 = P1(1)*co(1)*x29
        x61 = P2(2)*w2(0)
        x62 = P1(2)*co(1)*x23
        x63 = P1(2)*co(1)*x29
        x64 = P2(3)*w2(0)
        x65 = P1(3)*co(1)*x23
        x66 = P1(3)*co(1)*x29
        x67 = co(1)*x23
        x68 = P1(0)*P2(0)*w2(0)
        x69 = co(1)*x29
        x70 = P2(1)*co(0)*w1(1)*x37
        x71 = P1(0)*P2(2)*w1(2)
        x72 = P2(3)*co(0)*w1(3)*x37
        x73 = P2(3)*co(0)*w1(3)*x56
        x74 = P2(0)*co(0)*x37
        x75 = co(2)*x23
        x76 = P1(0)*x18
        x77 = co(2)*x29
        x78 = P1(1)*co(1)*x11
        x79 = P2(0)*w2(2)
        x80 = -x61 + x79
        x81 = P1(3)*co(2)*x23
        x82 = P2(1)*co(2)*x40
        x83 = P2(1)*co(2)*x42
        x84 = P2(3)*co(2)*x43
        x85 = P2(3)*co(2)*x45
        x86 = P2(0)*w2(3)
        x87 = -x64 + x86
        x88 = co(2)*x23*x87
        x89 = P1(2)*co(2)*x29
        x90 = P2(1)*co(0)*x37
        x91 = P1(1)*P2(0)*w1(0)
        x92 = P1(1)*P2(1)*w2(1)
        x93 = P2(0)*co(0)*w1(0)*x37
        x94 = P2(0)*w2(1)
        x95 = P1(0)*co(1)*x23
        x96 = P1(0)*co(1)*x29
        x97 = P1(1)*P2(1)*w1(1)
        x98 = P1(1)*co(0)*x37
        x99 = 2*co(0)*x37
        x100 = P1(2)*co(1)*x11
        x101 = -x58 + x94
        x102 = P2(2)*co(0)*x37
        x103 = P1(2)*co(0)*x56
        x104 = P1(2)*P2(2)*w2(2)
        x105 = P1(3)*co(1)*x11
        x106 = P1(3)*P2(3)*co(2)
        x107 = P2(3)*co(0)*x37
        x108 = P1(3)*co(0)*x56
        x109 = P1(3)*co(0)*x37
        wout(0) = -P1(0)**2*P2(0)*x51 + P1(0)*P2(0)*w1(0)*x57 - P1(0)*P2(1)*w1(&
                  1)*x57 + 2*P1(0)*w1(0)*x74 + P1(0)*x12 + P1(0)*x3 + P1(0)*x4 &
                   + P1(0)*x52 + P1(0)*x7 - P1(0)*x70 - P1(0)*x72 - P1(0)*x73  &
                   + P1(0)*x9 - P1(2)*x49 - P1(2)*x50 + P1(3)*x34 + P2(2)*x53  &
                   + w1(0)*x36*x38 + x13*x14 + x14*x15 - x14*x36 + x14*x54 +   &
                  x18*x24 + x18*x30 - x19*x74 - x20*x74 - x21*x74 - x25*x74 -  &
                  x26*x74 - x27*x74 + x33*x35 - x38*x71 - x40*x41 - x41*x42 -  &
                  x43*x44 - x44*x45 - x57*x71 + x58*x59 + x58*x60 + x61*x62 +  &
                  x61*x63 + x64*x65 + x64*x66 - x67*x68 - x68*x69
        wout(1) = -P1(0)*P2(0)*x78 + P1(1)**2*P2(1)*x51 - P1(1)*P2(2)*w1(2)*x57&
                   + P1(1)*x12 + P1(1)*x3 + P1(1)*x4 + P1(1)*x7 - P1(1)*x73 -  &
                  P1(1)*x82 - P1(1)*x83 - P1(1)*x84 - P1(1)*x85 + P1(1)*x9 + P1&
                  (2)*P2(2)*x78 - P1(2)*x88 + P2(1)*x93 - w1(1)*x10*x38 + x13* &
                  x78 + x15*x78 - x20*x90 - x21*x90 + x22*x90 - x26*x90 - x26* &
                  x98 - x27*x90 - x27*x98 + x32*x62 + x32*x63 + x35*x80 - x36* &
                  x78 + x38*x91 + x47*x65 + x47*x66 + x54*x78 + x57*x91 - x57* &
                  x97 + x67*x92 + x69*x92 + x75*x76 + x76*x77 + x80*x81 - x87* &
                  x89 - x94*x95 - x94*x96 - x97*x99
        wout(2) = -P1(0)*x49 - P1(0)*x50 + P1(1)*x88 + P1(2)**2*P2(2)*x51 - P1(&
                  2)*P2(2)*w1(2)*x99 + P1(2)*x12 + P1(2)*x3 + P1(2)*x4 + P1(2)*&
                  x52 + P1(2)*x7 - P1(2)*x70 - P1(2)*x72 - P1(2)*x73 - P1(2)*  &
                  x82 - P1(2)*x83 - P1(2)*x84 - P1(2)*x85 + P1(2)*x9 + P1(2)*  &
                  x93 - P2(0)*x53 - w1(2)*x13*x38 + x100*x13 + x100*x15 - x100*&
                  x36 + x100*x54 - x101*x35 - x101*x81 - x102*x19 - x102*x21 + &
                  x102*x22 - x102*x25 - x102*x27 + x102*x28 - x103*x25 - x103* &
                  x26 + x103*x28 + x104*x67 + x104*x69 + x17*x65 + x17*x66 +   &
                  x30*x87 + x31*x59 + x31*x60 - x79*x95 - x79*x96
        wout(3) = P1(0)*x33*x77 + P1(0)*x34 + P1(2)*x101*x75 + P1(3)**2*P2(3)* &
                  x51 - P1(3)*P2(0)*x14 + P1(3)*P2(2)*co(2)*x8 + P1(3)*P2(2)*  &
                  x100 + P1(3)*x12 + P1(3)*x3 + P1(3)*x4 + P1(3)*x52 + P1(3)*x7&
                   - P1(3)*x73 - P1(3)*x82 - P1(3)*x83 + P1(3)*x93 - 2*P2(3)*w1&
                  (3)*x109 - w1(3)*x15*x38 + x101*x89 + x105*x13 + x105*x15 -  &
                  x105*x36 - x106*x43 - x106*x45 - x107*x19 - x107*x20 + x107* &
                  x22 - x107*x25 - x107*x26 + x107*x28 - x108*x25 - x108*x26 + &
                  x108*x28 - x109*x25 - x109*x26 + x16*x62 + x16*x63 - x24*x80 &
                   - x30*x80 + x46*x59 + x46*x60 + x55*x65 + x55*x66 - x86*x95 &
                   - x86*x96
      case(VVV16)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3,
!       1) + Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(2
!       ,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) - Epsilon(-1 
!       ,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,1,3)*P(-1,2
!       )*P(-2,3)*P(2,1) + Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3) - Epsilon(-1
!       ,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) + Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,
!       3) - Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(0)**2
        x5 = co(3)*x4
        x6 = P1(1)**2
        x7 = co(3)*x6
        x8 = P1(2)**2
        x9 = co(3)*x8
        x10 = P1(3)**2
        x11 = co(3)*x10
        x12 = co(3)*x3
        x13 = P1(0)*P2(2)
        x14 = w1(0)*w2(1) - w1(1)*w2(0)
        x15 = w1(0)*w2(3) - w1(3)*w2(0)
        x16 = P1(0)*x2 - P1(1)*x15 + P1(3)*x14
        x17 = co(3)*x16
        x18 = P2(0)*x2 - P2(1)*x15 + P2(3)*x14
        x19 = co(3)*x18
        x20 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x21 = P1(0)*x20
        x22 = P2(1)**2
        x23 = co(1)*x22
        x24 = P2(2)**2
        x25 = co(1)*x24
        x26 = P2(3)**2
        x27 = co(1)*x26
        x28 = P1(0)*w1(0)
        x29 = P1(3)*w2(2)
        x30 = P1(2)*w2(3) - x29
        x31 = P1(1)*w2(2)
        x32 = P1(2)*w2(1)
        x33 = x31 - x32
        x34 = P1(1)*w2(3) - P1(3)*w2(1)
        x35 = co(2)*(P2(1)*x30 - P2(2)*x34 + P2(3)*x33)
        x36 = P2(2)*w2(3) - P2(3)*w2(2)
        x37 = P2(1)*w2(2) - P2(2)*w2(1)
        x38 = P2(1)*w2(3)
        x39 = P2(3)*w2(1)
        x40 = x38 - x39
        x41 = co(2)*(P2(1)*x36 - P2(2)*x40 + P2(3)*x37)
        x42 = P1(1)*x0 - P1(2)*x2 + P1(3)*x1
        x43 = P1(1)*P2(1)*co(3)
        x44 = P1(2)*P2(3)
        x45 = P1(3)*P2(2)
        x46 = x44 - x45
        x47 = P1(1)*co(2)*x20
        x48 = P1(1)*w1(1)
        x49 = P1(2)*w1(2)
        x50 = P1(3)*w1(3)
        x51 = -x28 + x48 + x49 + x50
        x52 = P1(1)*co(3)*x51
        x53 = P1(2)*P2(2)
        x54 = co(3)*x42
        x55 = P1(2)*w1(0)
        x56 = P1(1)*w2(0)
        x57 = P1(0)*w2(1) - x56
        x58 = P1(0)*w2(3)
        x59 = -P1(3)*w2(0) + x58
        x60 = co(2)*(P2(0)*x34 - P2(1)*x59 + P2(3)*x57)
        x61 = P2(0)*w2(1) - P2(1)*w2(0)
        x62 = P2(3)*w2(0)
        x63 = P2(0)*w2(3) - x62
        x64 = co(2)*(P2(0)*x40 - P2(1)*x63 + P2(3)*x61)
        x65 = P2(2)*w1(2)
        x66 = P2(3)*w1(3)
        x67 = -P2(0)*w1(0) + P2(1)*w1(1) + x65 + x66
        x68 = P1(2)*co(3)*x67
        x69 = P1(3)*P2(3)*co(3)
        x70 = P1(1)*P2(2)
        x71 = P1(2)*P2(1)
        x72 = x70 - x71
        x73 = P1(3)*co(2)*x20
        x74 = P1(3)*co(3)*x51
        x75 = P1(1)*w1(3)
        x76 = P1(3)*w1(1)
        x77 = x75 - x76
        x78 = P1(2)*w2(2)
        x79 = P1(3)*w2(3)
        x80 = P1(0)*w2(0)
        x81 = P1(1)*w2(1) + x78 + x79 - x80
        x82 = P2(2)*co(3)*x81
        x83 = P2(3)*w1(1)
        x84 = P2(1)*w1(3) - x83
        x85 = P2(0)**2
        x86 = w1(0)*x81*x85
        x87 = w1(0)*x81
        x88 = co(1)*w2(0)*x67
        x89 = co(1)*x67*x8
        x90 = w1(0)*w2(2) - w1(2)*w2(0)
        x91 = P1(0)*x0 - P1(2)*x15 + P1(3)*x90
        x92 = P1(0)*P2(1)*co(3)
        x93 = P2(0)*x0 - P2(2)*x15 + P2(3)*x90
        x94 = P1(0)*x1 - P1(1)*x90 + P1(2)*x14
        x95 = P1(0)*P2(3)*co(3)
        x96 = P2(0)*x1 - P2(1)*x90 + P2(2)*x14
        x97 = P1(1)*w1(0)
        x98 = P1(0)*w2(2)
        x99 = P1(2)*w2(0)
        x100 = x98 - x99
        x101 = co(2)*(P2(0)*x30 - P2(2)*x59 + P2(3)*x100)
        x102 = P2(0)*w2(2) - P2(2)*w2(0)
        x103 = co(2)*(P2(0)*x36 - P2(2)*x63 + P2(3)*x102)
        x104 = P1(1)*co(3)*x67
        x105 = P1(1)*P2(3)
        x106 = P1(3)*P2(1)
        x107 = x105 - x106
        x108 = P1(2)*co(2)*x20
        x109 = P1(2)*co(3)*x51
        x110 = P1(3)*w1(0)
        x111 = co(2)*(P2(0)*x33 - P2(1)*x100 + P2(2)*x57)
        x112 = co(2)*(P2(0)*x37 - P2(1)*x102 + P2(2)*x61)
        x113 = P1(3)*co(3)*x67
        x114 = P2(0)*co(1)*x20
        x115 = co(1)*x20*x8
        x116 = P1(2)*w1(3)
        x117 = P1(3)*w1(2)
        x118 = x116 - x117
        x119 = P2(1)*co(3)*x81
        x120 = P2(2)*w1(3)
        x121 = P2(3)*w1(2)
        x122 = x120 - x121
        x123 = P1(1)*w1(2)
        x124 = P1(2)*w1(1)
        x125 = x123 - x124
        x126 = P2(3)*co(3)*x81
        x127 = P2(1)*w1(2)
        x128 = P2(2)*w1(1)
        x129 = x127 - x128
        x130 = P1(0)*P2(1)
        x131 = P1(1)*co(1)*x20
        x132 = P1(2)*co(1)*x20
        x133 = P1(0)*P2(3)
        x134 = P1(3)*co(1)*x20
        x135 = P2(1)*w2(1)
        x136 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x135
        x137 = P2(0)*co(0)*x136
        x138 = P2(0)*co(1)*x136
        x139 = P2(1)*co(1)*x51
        x140 = P2(2)*co(1)*x51
        x141 = P1(3)*co(1)*x51
        x142 = P2(0)*co(1)*x51
        x143 = co(0)*w1(1)*x81
        x144 = co(0)*x136
        x145 = co(0)*x81
        x146 = P2(2)*co(0)*w1(2)*x136
        x147 = P1(0)*w1(3)
        x148 = P2(3)*co(0)*x81
        x149 = P2(3)*co(0)*x136
        x150 = P1(1)*P2(0)
        x151 = P2(1)*co(1)*x20
        x152 = P2(0)*co(0)*x81
        x153 = P2(1)*w1(0)
        x154 = P1(1)*co(1)*x136
        x155 = P1(2)*P2(0)
        x156 = P2(2)*co(1)*x20
        x157 = w1(2)*x81
        x158 = P2(2)*co(1)*x136
        x159 = P1(3)*P2(0)
        x160 = P2(3)*co(1)*x20
        x161 = co(0)*w1(3)*x81
        x162 = P2(3)*co(1)*x136
        x163 = P2(0)*w1(1)
        x164 = P2(1)*co(0)*x81
        x165 = 2*P2(0)*co(1)*x67
        x166 = 2*P2(1)*co(1)*x67
        x167 = 2*P2(2)*co(1)*x67
        x168 = 2*P1(3)*co(1)*x67
        x169 = P1(0)*w1(1)
        x170 = P1(0)*co(2)*x20
        x171 = P1(0)*co(3)*x51
        x172 = co(1)*x20*x24
        x173 = co(1)*x20*x26
        x174 = co(3)*x91
        x175 = x13 - x155
        x176 = -x110 + x147
        x177 = P2(3)*w1(0)
        x178 = P2(0)*w1(3) - x177
        x179 = w1(1)*x81
        x180 = co(1)*w2(1)*x67
        x181 = P1(0)*P2(0)*co(3)
        x182 = P1(0)*co(3)*x67
        x183 = co(3)*x94
        x184 = co(3)*x96
        x185 = co(1)*x20*x85
        x186 = x133 - x159
        x187 = x51*x63
        x188 = P2(0)*co(3)*x81
        x189 = P1(0)*w1(2)
        x190 = x189 - x55
        x191 = P2(0)*w1(2)
        x192 = P2(2)*w1(0)
        x193 = x191 - x192
        x194 = co(1)*x81*x85
        x195 = P1(0)*co(1)*x136
        x196 = co(0)*w1(0)*x81
        x197 = co(0)*w1(0)*x136
        x198 = P1(1)*co(1)*x51
        x199 = P1(0)*co(1)*x20
        x200 = co(1)*x51
        x201 = P1(0)*P2(0)*w2(1)
        x202 = P2(1)*co(0)*x136
        x203 = P2(1)*co(1)*x136
        x204 = P1(1)*P2(2)*w1(2)
        x205 = P1(2)*co(0)*x81
        x206 = P1(3)*co(1)*x136
        x207 = P2(2)*co(0)*x81
        x208 = 2*co(1)*x67
        x209 = 2*P1(1)*co(1)*x67
        x210 = co(1)*x20*x22
        x211 = x169 - x97
        x212 = -x153 + x163
        x213 = w1(2)*x24*x81
        x214 = co(1)*w2(2)*x67
        x215 = co(3)*x93
        x216 = x130 - x150
        x217 = P2(3)*co(1)*x51
        x218 = P1(2)*co(1)*x136
        x219 = P1(3)*co(0)*x81
        x220 = 2*P2(3)*co(1)*x67
        x221 = co(1)*w1(3)*x81
        x222 = co(1)*w2(3)*x67
        x223 = P1(2)*P2(2)*w2(3)
        wout(0) = P1(0)*P2(0)*x12 - P1(0)*P2(1)*w1(1)*x144 - P1(0)*P2(2)*w1(2)*&
                  x145 + 2*P1(0)*w1(0)*x152 - P1(0)*x146 - P1(2)*P2(0)*co(0)*  &
                  x157 - P2(0)*x115 + co(0)*x86 - co(1)*x86 + w2(0)*x89 - x10* &
                  x114 + x10*x88 - x101*x97 - x103*x97 - x104*x30 - x107*x108  &
                   - x109*x40 - x11*x3 - x110*x111 - x110*x112 - x110*x162 -   &
                  x113*x33 - x114*x6 - x118*x119 - x119*x122 - x125*x126 - x126&
                  *x129 + x13*x132 + x13*x17 + x13*x19 + x130*x131 - x130*x143 &
                   + x133*x134 + x137*x28 + x138*x28 + x139*x56 + x140*x99 +   &
                  x141*x62 - x142*x80 - x147*x148 - x147*x149 - x150*x151 -    &
                  x152*x48 - x152*x65 - x152*x66 - x153*x154 - x155*x156 - x158&
                  *x55 - x159*x160 - x159*x161 - x163*x164 - x165*x80 + x166*  &
                  x56 + x167*x99 + x168*x62 + x21*x23 + x21*x25 + x21*x27 + x23&
                  *x87 + x25*x87 + x27*x87 + x28*x35 + x28*x41 + x3*x5 - x3*x7 &
                   - x3*x9 + x34*x68 + x36*x52 + x37*x74 - x4*x88 + x42*x43 +  &
                  x42*x69 + x46*x47 + x53*x54 + x55*x60 + x55*x64 + x6*x88 +   &
                  x72*x73 + x77*x82 + x82*x84 - x91*x92 - x92*x93 - x94*x95 -  &
                  x95*x96
        wout(1) = -2*P1(1)*w1(1)*x164 + P1(1)*x172 + P1(1)*x173 - P1(1)*x185 - &
                  P1(2)*co(3)*x187 - P2(1)*x115 - w1(1)*x194 + w2(1)*x89 - x10*&
                  x151 + x10*x180 - x100*x113 - x101*x48 + x102*x74 - x103*x48 &
                   + x105*x134 - x105*x183 - x105*x184 - x106*x160 - x108*x186 &
                   - x11*x93 - x111*x76 - x112*x76 + x114*x130 - x118*x188 +   &
                  x12*x150 - x122*x188 - x124*x158 + x124*x60 + x124*x64 - x126&
                  *x190 - x126*x193 - x127*x205 - x127*x207 + x132*x70 + x135* &
                  x198 + x135*x209 + x140*x32 + x141*x39 - x143*x22 - x144*x204&
                   - x145*x204 - x148*x75 - x149*x75 + x150*x196 + x150*x197 - &
                  x150*x199 + x150*x54 + x151*x4 + x152*x153 - x156*x71 + x163*&
                  x195 + x164*x28 - x164*x50 - x164*x66 + x167*x32 + x168*x39  &
                   + x169*x35 + x169*x41 + x17*x70 + x170*x46 + x171*x36 + x174&
                  *x53 + x175*x73 + x176*x82 + x178*x82 + x179*x23 + x179*x25  &
                   + x179*x27 - x180*x4 + x180*x6 - x181*x91 - x182*x30 + x19* &
                  x70 - x200*x201 - x201*x208 - x202*x48 - x203*x48 - x206*x83 &
                   - x43*x93 + x5*x93 + x59*x68 + x69*x91 - x7*x93 - x9*x93
        wout(2) = P1(1)*co(3)*x187 - P1(2)*P2(3)*w1(3)*x144 - P1(2)*x146 + P1(2&
                  )*x173 - P1(2)*x185 + P1(2)*x210 - 2*P2(2)*w1(2)*x205 - co(0 &
                  )*x213 - co(1)*x157*x85 + co(1)*x213 + w2(2)*x89 - x10*x156  &
                   + x10*x214 - x101*x123 - x103*x123 - x104*x59 - x107*x170 + &
                  x11*x18 - x111*x117 - x112*x117 + x113*x57 + x114*x13 - x119*&
                  x176 - x119*x178 + x12*x155 - x120*x148 - x120*x219 - x121*  &
                  x206 - x124*x164 - x124*x202 + x126*x211 + x126*x212 - x127* &
                  x154 - x128*x164 + x131*x71 + x134*x44 + x137*x55 + x139*x31 &
                   + x140*x78 - x142*x98 - x151*x70 + x152*x192 + x152*x55 -   &
                  x155*x199 + x155*x54 + x156*x4 - x156*x6 + x157*x23 + x157*  &
                  x27 + x16*x181 - x16*x43 - x16*x69 - x160*x45 - x161*x44 -   &
                  x165*x98 + x166*x31 + x167*x78 - x171*x40 - x174*x71 - x18*x5&
                   + x18*x7 + x18*x9 + x182*x34 - x183*x44 - x184*x44 + x186*  &
                  x47 + x188*x77 + x188*x84 + x189*x35 + x189*x41 + x19*x53 +  &
                  x191*x195 + x207*x28 - x207*x48 - x214*x4 + x214*x6 - x215*  &
                  x71 - x216*x73 + x217*x29 - x218*x65 + x220*x29 + x49*x60 +  &
                  x49*x64 - x61*x74
        wout(3) = -2*P1(3)*w1(3)*x148 - P1(3)*x146 + P1(3)*x172 - P1(3)*x185 + &
                  P1(3)*x210 - P2(3)*x115 - w1(3)*x194 + w1(3)*x27*x81 + w2(3)*&
                  x89 + x10*x222 + x100*x104 - x101*x75 - x102*x52 - x103*x75  &
                   - x105*x151 + x106*x131 - x106*x174 - x106*x215 + x108*x216 &
                   + x109*x61 - x11*x96 - x111*x50 - x112*x50 + x114*x133 +    &
                  x116*x60 + x116*x64 + x119*x190 + x119*x193 + x12*x159 - x120&
                  *x218 - x121*x205 - x121*x207 - x125*x188 - x129*x188 + x132*&
                  x45 + x138*x147 - x142*x58 + x147*x35 + x147*x41 + x148*x28  &
                   - x148*x48 - x149*x50 + x152*x177 - x156*x44 + x159*x196 +  &
                  x159*x197 - x159*x199 + x159*x54 + x160*x4 - x160*x6 - x161* &
                  x26 - x162*x50 - x164*x76 - x164*x83 - x165*x58 + x17*x45 +  &
                  x170*x72 + x171*x37 - x175*x47 - x181*x94 - x182*x33 + x183* &
                  x53 + x19*x45 + x198*x38 + x200*x223 - x202*x76 - x203*x75 + &
                  x208*x223 + x209*x38 - x211*x82 - x212*x82 + x217*x79 - x219*&
                  x65 + x22*x221 + x220*x79 + x221*x24 - x222*x4 + x222*x6 +   &
                  x43*x94 + x5*x96 - x57*x68 - x69*x96 - x7*x96 - x9*x96
      case(VVV17)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) + Metric(1,3)*P(-1,2)*P(-1,3)*P(
!       2,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) + Metric(2,3)*P(-1,1)*P(-1,3)*P
!       (1,2))
!       c2*(-Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + Epsilon(-1
!       ,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + Epsilon(-1,-2,1,2)*P(-1,
!       2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) + Epsilon(-
!       1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3) - Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2
!       ,3) + Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(1)**2
        x5 = co(3)*x4
        x6 = P1(2)**2
        x7 = co(3)*x6
        x8 = P1(3)**2
        x9 = co(3)*x8
        x10 = P1(0)**2
        x11 = co(3)*x10
        x12 = P1(0)*x2
        x13 = w1(0)*w2(1) - w1(1)*w2(0)
        x14 = P1(3)*x13
        x15 = w1(0)*w2(3) - w1(3)*w2(0)
        x16 = P1(1)*x15
        x17 = x12 + x14 - x16
        x18 = P1(0)*P2(2)*co(3)
        x19 = P2(0)*x2 - P2(1)*x15 + P2(3)*x13
        x20 = P2(1)**2
        x21 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x22 = co(1)*x20*x21
        x23 = P2(2)**2
        x24 = co(1)*x21*x23
        x25 = P2(3)**2
        x26 = co(1)*x21*x25
        x27 = P1(0)*w1(0)
        x28 = P1(2)*w2(3)
        x29 = P1(3)*w2(2)
        x30 = x28 - x29
        x31 = P1(1)*w2(2)
        x32 = P1(2)*w2(1)
        x33 = x31 - x32
        x34 = P1(1)*w2(3)
        x35 = P1(3)*w2(1)
        x36 = x34 - x35
        x37 = co(2)*(P2(1)*x30 - P2(2)*x36 + P2(3)*x33)
        x38 = P2(2)*w2(3) - P2(3)*w2(2)
        x39 = P2(1)*w2(2) - P2(2)*w2(1)
        x40 = P2(1)*w2(3)
        x41 = P2(3)*w2(1)
        x42 = x40 - x41
        x43 = co(2)*(P2(1)*x38 - P2(2)*x42 + P2(3)*x39)
        x44 = P1(0)*x0
        x45 = w1(0)*w2(2) - w1(2)*w2(0)
        x46 = P1(3)*x45
        x47 = P1(2)*x15
        x48 = x44 + x46 - x47
        x49 = P1(1)*P2(0)*co(3)
        x50 = P2(0)*x0 - P2(2)*x15 + P2(3)*x45
        x51 = co(3)*x50
        x52 = P1(1)*P2(0)
        x53 = P1(1)*P2(1)
        x54 = co(3)*x3
        x55 = P1(1)*w2(0)
        x56 = P1(2)*w1(3)
        x57 = P1(3)*w1(2)
        x58 = x56 - x57
        x59 = P1(0)*w1(2)
        x60 = P1(2)*w1(0)
        x61 = x59 - x60
        x62 = P1(0)*w1(3)
        x63 = P1(3)*w1(0)
        x64 = x62 - x63
        x65 = P2(0)*x58 - P2(2)*x64 + P2(3)*x61
        x66 = co(2)*x65
        x67 = P2(2)*w1(3)
        x68 = P2(3)*w1(2)
        x69 = x67 - x68
        x70 = P2(2)*w1(0)
        x71 = P2(0)*w1(2) - x70
        x72 = P2(3)*w1(0)
        x73 = P2(0)*w1(3) - x72
        x74 = P2(0)*x69 - P2(2)*x73 + P2(3)*x71
        x75 = co(2)*x74
        x76 = P1(1)*w1(1)
        x77 = P1(2)*w1(2)
        x78 = P1(3)*w1(3)
        x79 = -x27 + x76 + x77 + x78
        x80 = P1(1)*co(3)*x38
        x81 = P2(2)*w1(2)
        x82 = P2(3)*w1(3)
        x83 = P2(0)*w1(0)
        x84 = P2(1)*w1(1) + x81 + x82 - x83
        x85 = P1(2)*P2(2)
        x86 = P1(0)*w2(1)
        x87 = -x55 + x86
        x88 = P1(0)*w2(3)
        x89 = P1(3)*w2(0)
        x90 = x88 - x89
        x91 = co(2)*(P2(0)*x36 - P2(1)*x90 + P2(3)*x87)
        x92 = P2(0)*w2(1) - P2(1)*w2(0)
        x93 = P2(3)*w2(0)
        x94 = P2(0)*w2(3) - x93
        x95 = co(2)*(P2(0)*x42 - P2(1)*x94 + P2(3)*x92)
        x96 = P2(3)*w1(1)
        x97 = P2(1)*w1(3) - x96
        x98 = P1(2)*w2(2)
        x99 = P1(3)*w2(3)
        x100 = P1(0)*w2(0)
        x101 = P1(1)*w2(1) - x100 + x98 + x99
        x102 = P1(2)*co(3)*x101
        x103 = P2(1)*w2(1)
        x104 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x103
        x105 = P1(2)*co(3)*x104
        x106 = P1(2)*x2
        x107 = P2(0)**2
        x108 = co(3)*(-x107 + x20 + x23 + x25)
        x109 = P1(3)*P2(3)
        x110 = P1(0)*P2(0)
        x111 = co(3)*(x109 - x110 + x53 + x85)
        x112 = P1(3)*P2(0)
        x113 = P1(0)*x1
        x114 = P1(2)*x13
        x115 = P1(1)*x45
        x116 = x113 + x114 - x115
        x117 = co(3)*x116
        x118 = P2(0)*x1 - P2(1)*x45 + P2(2)*x13
        x119 = co(3)*x118
        x120 = P1(1)*w1(2)
        x121 = P1(2)*w1(1)
        x122 = x120 - x121
        x123 = P1(0)*w1(1)
        x124 = P1(1)*w1(0)
        x125 = x123 - x124
        x126 = co(2)*(P2(0)*x122 - P2(1)*x61 + P2(2)*x125)
        x127 = P2(1)*w1(2)
        x128 = P2(2)*w1(1)
        x129 = x127 - x128
        x130 = P2(0)*w1(1)
        x131 = P2(1)*w1(0)
        x132 = x130 - x131
        x133 = co(2)*(P2(0)*x129 - P2(1)*x71 + P2(2)*x132)
        x134 = P1(3)*co(3)*x79
        x135 = P1(3)*co(3)*x84
        x136 = P2(0)*co(1)*x21
        x137 = co(1)*x21*x6
        x138 = w1(0)*x101*x107
        x139 = co(1)*x10*x84
        x140 = P2(1)*x48
        x141 = P2(1)*co(3)*x50
        x142 = P1(0)*P2(3)*co(3)
        x143 = P1(1)*w1(3)
        x144 = P1(3)*w1(1)
        x145 = x143 - x144
        x146 = co(2)*(P2(1)*x58 - P2(2)*x145 + P2(3)*x122)
        x147 = co(2)*(P2(1)*x69 - P2(2)*x97 + P2(3)*x129)
        x148 = P1(0)*w2(2)
        x149 = P1(2)*w2(0)
        x150 = x148 - x149
        x151 = co(2)*(P2(0)*x30 - P2(2)*x90 + P2(3)*x150)
        x152 = P2(0)*w2(2) - P2(2)*w2(0)
        x153 = co(2)*(P2(0)*x38 - P2(2)*x94 + P2(3)*x152)
        x154 = P1(1)*co(3)*x101
        x155 = P1(1)*co(3)*x104
        x156 = P1(1)*x0
        x157 = P1(2)*co(3)*x17
        x158 = P1(2)*co(3)*x19
        x159 = co(2)*(P2(0)*x145 - P2(1)*x64 + P2(3)*x125)
        x160 = co(2)*(P2(0)*x97 - P2(1)*x73 + P2(3)*x132)
        x161 = P1(2)*co(3)*x79
        x162 = P1(2)*co(3)*x84
        x163 = co(2)*(P2(0)*x33 - P2(1)*x150 + P2(2)*x87)
        x164 = co(2)*(P2(0)*x39 - P2(1)*x152 + P2(2)*x92)
        x165 = P1(3)*co(3)*x129
        x166 = P1(3)*x1
        x167 = w1(0)*x101
        x168 = co(1)*x20
        x169 = co(1)*x23
        x170 = co(1)*x25
        x171 = co(1)*x4*x84
        x172 = co(1)*x6*x84
        x173 = co(1)*x8*x84
        x174 = co(1)*x107*x21
        x175 = P1(1)*P2(1)*co(1)*x21
        x176 = P1(2)*P2(2)*co(1)*x21
        x177 = P1(3)*P2(3)*co(1)*x21
        x178 = co(0)*x104
        x179 = co(1)*w1(0)*x104
        x180 = co(1)*x79
        x181 = P1(2)*P2(2)*co(1)*x79
        x182 = P1(3)*co(1)*x79
        x183 = P1(0)*P2(0)*co(1)*x79
        x184 = P2(1)*co(0)*x101
        x185 = P2(1)*co(0)*x104
        x186 = P1(0)*P2(2)*w1(2)
        x187 = P2(3)*co(0)*x101
        x188 = P2(3)*co(0)*x104
        x189 = P1(1)*co(0)*x101
        x190 = P2(0)*co(0)*x101
        x191 = 2*co(0)
        x192 = P1(0)*co(3)*x79
        x193 = P1(0)*co(3)*x84
        x194 = -x106 + x156 + x166
        x195 = P1(1)*P2(2)*co(3)
        x196 = P1(1)*P2(2)
        x197 = co(3)*x19
        x198 = P1(1)*co(2)*w2(1)
        x199 = P1(3)*co(3)*x116
        x200 = P1(3)*co(3)*x118
        x201 = P2(1)*co(1)*x21
        x202 = w1(1)*x101
        x203 = co(1)*x107
        x204 = P1(0)*P2(1)*co(3)
        x205 = P1(0)*co(3)*x101
        x206 = P1(0)*co(3)*x104
        x207 = P1(1)*P2(3)
        x208 = P1(2)*co(3)
        x209 = x79*x94
        x210 = P1(3)*co(3)*x71
        x211 = co(0)*w1(1)*x101
        x212 = P1(1)*co(0)*x104
        x213 = co(1)*w1(1)*x104
        x214 = P1(1)*co(1)*x79
        x215 = P1(0)*P2(0)*co(1)*x21
        x216 = P1(2)*co(0)*x101
        x217 = P2(2)*co(0)*x101
        x218 = P1(1)*co(3)
        x219 = P1(2)*P2(0)*co(3)
        x220 = P1(3)*co(3)*x132
        x221 = P2(2)*co(1)*x21
        x222 = w1(2)*x101
        x223 = co(1)*w2(2)*x84
        x224 = P1(2)*P2(3)*co(3)
        x225 = w1(2)*x101*x23
        x226 = P1(2)*co(1)*x21
        x227 = co(1)*x104
        x228 = co(1)*w2(2)*x79
        x229 = P2(0)*co(0)*x104
        x230 = P1(2)*P2(2)*w1(2)
        x231 = P2(0)*co(1)*x79
        x232 = P1(3)*co(0)*x101
        x233 = P1(0)*co(3)*x39
        x234 = P1(1)*co(3)*x71
        x235 = P1(3)*P2(2)*co(3)
        x236 = P2(3)*co(1)*x21
        x237 = co(1)*w1(3)*x101
        x238 = co(1)*w2(3)*x84
        x239 = P1(1)*co(3)*x152
        x240 = w1(3)*x101
        x241 = co(1)*w2(3)*x79
        wout(0) = P1(0)*P2(0)*w1(0)*x101*x191 + P1(0)*P2(0)*w1(0)*x178 - P1(0)*&
                  co(3)*x140 - P1(0)*x141 - 2*P1(0)*x174 + P1(0)*x175 + P1(0)* &
                  x176 + P1(0)*x177 + P1(0)*x22 + P1(0)*x24 + P1(0)*x26 + P1(1 &
                  )*P2(1)*w2(0)*x180 + P2(0)*x137 - P2(0)*x157 - P2(0)*x158 -  &
                  co(0)*x101*x186 + co(0)*x138 + co(1)*x138 + w2(0)*x139 - w2(0&
                  )*x171 - w2(0)*x172 - w2(0)*x173 + w2(0)*x181 - w2(0)*x183 - &
                  2*x10*x136 - x100*x146 - x100*x147 - x101*x165 + x102*x97 -  &
                  x104*x165 + x105*x97 + x106*x108 + x106*x111 - x108*x156 -   &
                  x108*x166 + x109*x136 + x109*x179 + x109*x54 - x11*x3 - x110*&
                  x179 - x110*x54 - x111*x156 - x111*x166 + x112*x117 + x112*  &
                  x119 - x116*x142 - x118*x142 - x123*x184 - x123*x185 - x124* &
                  x151 - x124*x153 + x126*x89 - x130*x184 - x130*x189 + x133*  &
                  x89 + x134*x39 + x135*x39 + x136*x4 + x136*x53 + x136*x8 +   &
                  x136*x85 - x149*x159 - x149*x160 - x154*x69 - x155*x69 - x161&
                  *x42 - x162*x42 - x163*x63 - x164*x63 - x167*x168 - x167*x169&
                   - x167*x170 + x17*x18 - x178*x186 + x179*x53 + x179*x85 +   &
                  x18*x19 + x182*x93 - x187*x62 - x188*x62 - x190*x77 - x190*  &
                  x78 - x190*x81 - x190*x82 + x27*x37 + x27*x43 + x3*x5 + x3*x7&
                   + x3*x9 + x48*x49 + x51*x52 + x53*x54 + x54*x85 + x55*x66 + &
                  x55*x75 + x60*x91 + x60*x95 + x79*x80 + x80*x84
        wout(1) = -P1(1)*P2(1)*w1(1)*x178 - 2*P1(1)*P2(1)*x211 - P1(1)*x174 +  &
                  P1(1)*x176 + P1(1)*x177 - P1(1)*x215 + 2*P1(1)*x22 + P1(1)*  &
                  x24 + P1(1)*x26 + P2(1)*x137 - P2(1)*x157 - P2(1)*x158 + P2(1&
                  )*x199 + P2(1)*x200 + w2(1)*x139 - w2(1)*x171 - w2(1)*x172 - &
                  w2(1)*x173 + w2(1)*x181 - w2(1)*x183 - x10*x201 - x101*x210  &
                   + x102*x73 + x103*x214 - x104*x210 + x105*x73 - x108*x44 -  &
                  x108*x46 + x108*x47 + x109*x201 + x109*x213 + x109*x51 - x11*&
                  x50 - x110*x201 - x110*x213 - x110*x51 - x111*x44 - x111*x46 &
                   + x111*x47 - x117*x207 - x119*x207 + x121*x91 + x121*x95 +  &
                  x123*x37 + x123*x43 + x126*x35 - x127*x216 - x127*x217 + x131&
                  *x190 + x133*x35 + x134*x152 + x135*x152 - x143*x187 - x143* &
                  x188 - x144*x163 - x144*x164 - x146*x86 - x147*x86 - x151*x76&
                   - x153*x76 - x159*x32 - x160*x32 - x162*x94 - x168*x202 -   &
                  x169*x202 + x17*x195 - x170*x202 + x182*x41 + x184*x27 - x184&
                  *x78 - x184*x82 - x189*x81 + x189*x83 + x192*x38 + x193*x38  &
                   - x194*x204 + x194*x49 + x196*x197 + x198*x65 + x198*x74 -  &
                  x20*x211 + 2*x201*x4 + x201*x8 + x201*x85 + x202*x203 - x204*&
                  x3 - x205*x69 - x206*x69 - x208*x209 - x212*x81 + x212*x83 + &
                  x213*x53 + x213*x85 + x5*x50 + x50*x7 + x50*x9 + x51*x53 +   &
                  x51*x85 + x52*x54
        wout(2) = -P1(0)*P2(0)*w1(2)*x227 + P1(1)*P2(1)*w1(2)*x227 - P1(2)*P2(2&
                  )*w1(2)*x101*x191 - P1(2)*x174 - P1(2)*x215 + P1(2)*x22 + 2* &
                  P1(2)*x24 + P1(2)*x26 + P1(3)*P2(3)*w1(2)*x227 + P1(3)*P2(3)*&
                  w2(2)*x180 - P2(1)*x208*x50 + 2*P2(2)*x137 + P2(2)*x199 + P2(&
                  2)*x200 - co(0)*x225 - co(1)*x225 - w2(2)*x172 - x10*x221 +  &
                  x10*x223 + x101*x220 + x104*x220 + x108*x12 + x108*x14 - x108&
                  *x16 - x109*x197 + x109*x221 + x109*x226 + x11*x19 + x110*   &
                  x197 - x110*x221 + x111*x12 + x111*x14 - x111*x16 - x116*x224&
                   - x118*x224 - x120*x151 - x120*x153 - x121*x184 - x121*x185 &
                   + x126*x29 - x128*x184 + x133*x29 - x134*x92 - x135*x92 -   &
                  x140*x208 - x146*x148 - x147*x148 - x148*x231 - x154*x73 -   &
                  x155*x73 - x159*x98 - x160*x98 - x163*x57 - x164*x57 - x168* &
                  x222 - x170*x222 - x178*x230 - x18*x194 - x18*x3 - x187*x56  &
                   - x187*x67 - x188*x56 - x19*x5 - x19*x7 - x19*x9 + x190*x60 &
                   + x190*x70 - x192*x42 - x193*x42 + x194*x219 + x195*x48 +   &
                  x196*x51 - x197*x53 - x197*x85 + x203*x222 + x205*x97 + x206*&
                  x97 + x209*x218 + x217*x27 - x217*x76 + x218*x84*x94 + x219* &
                  x3 + x221*x4 + x221*x53 + x221*x8 - x223*x4 - x223*x8 + x226*&
                  x53 + x227*x230 + x228*x53 + x228*x85 + x229*x60 - x232*x67  &
                   + x31*x66 + x31*x75 + x37*x59 + x43*x59 + x77*x91 + x77*x95
        wout(3) = -P1(0)*P2(0)*w1(3)*x227 + P1(1)*P2(1)*w1(3)*x227 + P1(2)*P2(2&
                  )*w1(3)*x227 - P1(3)*P2(2)*w1(2)*x178 + P1(3)*P2(3)*w1(3)*   &
                  x227 - P1(3)*co(3)*x140 - 2*P1(3)*w1(3)*x187 - P1(3)*x141 -  &
                  P1(3)*x174 + P1(3)*x175 + P1(3)*x176 - P1(3)*x215 + P1(3)*x22&
                   + P1(3)*x24 + 2*P1(3)*x26 + P2(3)*x137 - P2(3)*x157 - P2(3)*&
                  x158 + P2(3)*x218*x48 - co(0)*x240*x25 + co(3)*x112*x194 - w2&
                  (3)*x172 - x10*x236 + x10*x238 + x101*x234 - x102*x132 + x104&
                  *x234 - x105*x132 + x107*x237 - x108*x113 - x108*x114 + x108*&
                  x115 + x109*x119 + x109*x241 - x11*x118 - x110*x119 - x110*  &
                  x236 - x111*x113 - x111*x114 + x111*x115 + x112*x54 + x118*x5&
                   + x118*x7 + x118*x9 + x119*x53 + x119*x85 + x126*x99 - x129*&
                  x205 - x129*x206 + x133*x99 - x142*x194 - x142*x3 - x143*x151&
                   - x143*x153 - x144*x184 - x144*x185 - x146*x88 - x147*x88 - &
                  x159*x28 - x160*x28 + x161*x92 + x162*x92 - x163*x78 - x164* &
                  x78 + x17*x235 - x170*x240 - x184*x96 + x187*x27 - x188*x78  &
                   - x189*x96 + x19*x235 + x190*x63 + x190*x72 - x20*x237 +    &
                  x207*x51 + x214*x40 - x216*x68 - x217*x68 + x229*x63 - x23*  &
                  x237 - x231*x88 - x232*x81 + x233*x79 + x233*x84 + x236*x4 + &
                  x236*x53 + 2*x236*x8 + x236*x85 - x238*x4 - x238*x8 - x239*  &
                  x79 - x239*x84 + x241*x85 + x34*x66 + x34*x75 + x37*x62 + x43&
                  *x62 + x56*x91 + x56*x95
      case(VVV18)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2)/3 - Metric(1,2)*P(-1,2)*P(-1,3)*P
!       (3,1)/3 - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3)/3 - Metric(1,3)*P(-1,2)*P(-1
!       ,3)*P(2,1)/3 - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3)/3 - Metric(2,3)*P(-1,1 
!       )*P(-1,3)*P(1,2)/3)
!       c2*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + Epsilon(-1,-2,1,2)*P(-1,
!       2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) - Epsilon(-
!       1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1
!       ,3) - Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2))
        if (last) VB_last = .true.
        x0 = w1(1)*w2(3) - w1(3)*w2(1)
        x1 = w1(0)*w2(1) - w1(1)*w2(0)
        x2 = w1(0)*w2(3) - w1(3)*w2(0)
        x3 = P1(0)*x0 - P1(1)*x2 + P1(3)*x1
        x4 = P1(0)*P2(2)*co(2)
        x5 = P1(0)*co(2)
        x6 = P2(0)*x0 - P2(1)*x2 + P2(3)*x1
        x7 = P2(2)*x6
        x8 = w1(2)*w2(3) - w1(3)*w2(2)
        x9 = w1(0)*w2(2) - w1(2)*w2(0)
        x10 = P1(0)*x8 - P1(2)*x2 + P1(3)*x9
        x11 = P1(1)*P2(0)*co(2)
        x12 = P2(0)*x8 - P2(2)*x2 + P2(3)*x9
        x13 = P2(2)*w2(3) - P2(3)*w2(2)
        x14 = P1(1)*w1(1)
        x15 = P1(2)*w1(2)
        x16 = P1(3)*w1(3)
        x17 = P1(0)*w1(0)
        x18 = x14 + x15 + x16 - x17
        x19 = P1(1)*co(2)*x18
        x20 = P2(2)*w1(2)
        x21 = P2(3)*w1(3)
        x22 = -P2(0)*w1(0) + P2(1)*w1(1) + x20 + x21
        x23 = x22*(P1(1)*w2(3) - P1(3)*w2(1))
        x24 = P1(2)*co(2)
        x25 = P1(2)*w2(2)
        x26 = P1(0)*w2(0)
        x27 = P1(1)*w2(1) + P1(3)*w2(3) + x25 - x26
        x28 = P2(3)*w1(1)
        x29 = P2(1)*w1(3) - x28
        x30 = P1(2)*co(2)*x29
        x31 = P2(1)*w2(1)
        x32 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x31
        x33 = w1(1)*w2(2) - w1(2)*w2(1)
        x34 = P1(0)*x33 - P1(1)*x9 + P1(2)*x1
        x35 = P1(3)*P2(0)*co(2)
        x36 = P2(0)*x33 - P2(1)*x9 + P2(2)*x1
        x37 = P2(1)*w2(2)
        x38 = -P2(2)*w2(1) + x37
        x39 = P1(3)*co(2)*x18
        x40 = P1(1)*w1(3)
        x41 = P1(3)*w1(1)
        x42 = co(2)*x27*(x40 - x41)
        x43 = P2(2)*co(2)*x27
        x44 = co(0)*x27
        x45 = P2(0)**2
        x46 = w1(0)*x45
        x47 = P1(0)*P2(1)*co(2)
        x48 = P1(0)*P2(3)*co(2)
        x49 = P1(2)*w2(3) - P1(3)*w2(2)
        x50 = P1(1)*co(2)
        x51 = P2(2)*w1(3)
        x52 = P2(3)*w1(2)
        x53 = x51 - x52
        x54 = x27*x53
        x55 = x32*x53
        x56 = P1(2)*P2(0)*co(2)
        x57 = P2(1)*w2(3)
        x58 = P2(3)*w2(1)
        x59 = x18*(x57 - x58)
        x60 = P1(2)*w2(1)
        x61 = P1(1)*w2(2) - x60
        x62 = P1(3)*co(2)
        x63 = P2(1)*w1(2)
        x64 = P2(2)*w1(1)
        x65 = x63 - x64
        x66 = x27*x65
        x67 = x32*x65
        x68 = P1(2)*w1(3)
        x69 = -P1(3)*w1(2) + x68
        x70 = P2(1)*co(2)*x27
        x71 = P1(2)*w1(1)
        x72 = P1(1)*w1(2) - x71
        x73 = P2(3)*co(2)*x27
        x74 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x75 = 2*co(1)*x74/3
        x76 = P1(0)**2
        x77 = co(1)*x27/3
        x78 = co(1)*x22*x76/3
        x79 = P2(1)**2
        x80 = P1(0)*co(1)*x74/3
        x81 = P2(2)**2
        x82 = P2(3)**2
        x83 = P1(1)**2
        x84 = P2(0)*co(1)*x74/3
        x85 = P1(2)**2
        x86 = P1(3)**2
        x87 = co(1)*w1(0)*x27/3
        x88 = co(1)*x27*x82/3
        x89 = co(1)*x22*x83/3
        x90 = co(1)*x22*x85/3
        x91 = co(1)*x22*x86/3
        x92 = P2(0)*co(0)*x32
        x93 = P1(0)*w1(1)
        x94 = P2(1)*co(0)*x27
        x95 = P2(1)*co(0)*x32
        x96 = P2(2)*co(0)*w1(2)*x27
        x97 = P2(2)*co(0)*w1(2)*x32
        x98 = P1(0)*w1(3)
        x99 = P2(3)*co(0)*x27
        x100 = P2(3)*co(0)*x32
        x101 = P2(0)*co(0)*x27
        x102 = P2(0)*w1(1)
        x103 = 2*P2(0)*co(1)*x27/3
        x104 = -2*P2(0)*w1(0)/3 + 2*P2(1)*w1(1)/3 + 2*P2(2)*w1(2)/3 + 2*P2(3)* &
        w1(3)/3
        x105 = P2(0)*co(1)*x104
        x106 = -P2(0)*w2(0)/3 + P2(1)*w2(1)/3 + P2(2)*w2(2)/3 + P2(3)*w2(3)/3
        x107 = P2(0)*co(1)*x106
        x108 = P2(0)*co(1)*x18/3
        x109 = P1(1)*P2(1)
        x110 = P1(2)*P2(2)
        x111 = P1(0)*P1(3)*co(1)*x74/3
        x112 = P1(1)*P2(1)*co(1)*w1(0)
        x113 = co(1)*x18/3
        x114 = P1(1)*P2(1)*w2(0)
        x115 = P1(2)*w1(0)
        x116 = P2(2)*co(1)*x106
        x117 = P1(2)*P2(2)*w2(0)
        x118 = P1(3)*P2(3)
        x119 = co(1)*x106
        x120 = P1(3)*P2(3)*w1(0)
        x121 = P2(3)*w2(0)
        x122 = P1(3)*co(1)*x18/3
        x123 = -2*P1(0)*w2(0)/3 + 2*P1(1)*w2(1)/3 + 2*P1(2)*w2(2)/3 + 2*P1(3)* &
        w2(3)/3
        x124 = co(1)*x104
        x125 = 2*P2(2)*co(1)*x27/3
        x126 = 2*co(1)*x27/3
        x127 = P1(3)*co(1)*x104
        x128 = P1(0)*co(2)*x18
        x129 = P1(1)*x8 - P1(2)*x0 + P1(3)*x33
        x130 = P2(1)*x8 - P2(2)*x0 + P2(3)*x33
        x131 = P1(1)*P2(2)*co(2)
        x132 = P1(0)*w2(3)
        x133 = x22*(-P1(3)*w2(0) + x132)
        x134 = P2(3)*w1(0)
        x135 = P2(0)*w1(3) - x134
        x136 = x135*x27
        x137 = P1(2)*co(2)*x32
        x138 = P1(3)*P2(1)*co(2)
        x139 = P2(0)*w2(2) - P2(2)*w2(0)
        x140 = P1(3)*w1(0)
        x141 = -x140 + x98
        x142 = P1(0)*co(2)*x22
        x143 = P1(1)*P2(3)*co(2)
        x144 = P1(2)*P2(1)*co(2)
        x145 = P2(0)*w2(3) - x121
        x146 = P1(2)*co(2)*x18
        x147 = P1(0)*w2(2)
        x148 = x22*(-P1(2)*w2(0) + x147)
        x149 = P2(0)*w1(2)
        x150 = P2(2)*w1(0)
        x151 = x149 - x150
        x152 = x151*x27
        x153 = P1(3)*co(2)*x32
        x154 = P2(0)*co(2)*x27
        x155 = P1(0)*w1(2) - x115
        x156 = P2(3)*co(2)
        x157 = w1(1)*x79
        x158 = P1(1)*co(1)*x74/3
        x159 = P2(1)*co(1)*x74/3
        x160 = co(1)*w1(1)*x27/3
        x161 = P1(1)*P2(0)*w1(0)
        x162 = P2(1)*w1(0)
        x163 = P1(2)*co(0)*x27
        x164 = P2(2)*co(0)*x27
        x165 = 2*P1(0)*co(1)*x27/3
        x166 = P1(0)*P2(0)*w2(1)
        x167 = P1(0)*P2(0)*co(1)*x74/3
        x168 = P1(0)*co(1)*x106
        x169 = P1(2)*P2(2)*co(1)*x74/3
        x170 = P2(1)*co(1)*x106
        x171 = P1(1)*co(1)*x18/3
        x172 = P2(2)*co(1)*x18/3
        x173 = P1(3)*P2(3)*w1(1)
        x174 = 2*P2(1)*co(1)*x27/3
        x175 = P1(1)*co(1)*x104
        x176 = P2(2)*co(1)*x104
        x177 = P1(0)*co(2)*x29
        x178 = P1(3)*P2(2)*co(2)
        x179 = x22*(P1(0)*w2(1) - P1(1)*w2(0))
        x180 = x102 - x162
        x181 = x180*x27
        x182 = -P1(1)*w1(0) + x93
        x183 = P1(1)*co(2)*x32
        x184 = P1(2)*P2(3)*co(2)
        x185 = P2(0)*w2(1) - P2(1)*w2(0)
        x186 = w1(2)*x81
        x187 = P1(2)*co(1)*x74/3
        x188 = P2(2)*co(1)*x74/3
        x189 = co(1)*w1(2)*x27/3
        x190 = P1(1)*P2(1)*co(1)*x74/3
        x191 = P1(1)*P2(1)*co(1)*w1(2)
        x192 = P1(3)*co(1)*x74/3
        x193 = P1(2)*P2(2)*w1(2)
        x194 = P1(3)*P2(3)*w1(2)
        x195 = P1(3)*P2(3)*w2(2)
        x196 = w1(3)*x82
        x197 = P2(3)*co(1)*x74/3
        x198 = co(1)*w1(3)*x27/3
        x199 = co(1)*w2(3)*x22/3
        x200 = P1(2)*P2(2)*w1(3)
        x201 = P1(2)*P2(2)*w2(3)
        x202 = P1(3)*P2(3)*w1(3)
        x203 = P1(3)*P2(3)*w2(3)
        wout(0) = 2*P1(0)*w1(0)*x101 - P1(0)*x45*x75 - P1(0)*x96 - P1(0)*x97 - &
                  P2(0)*x75*x76 + P2(2)*x42 + P2(3)*x111 + w1(0)*x88 - w2(0)*  &
                  x78 + w2(0)*x89 + w2(0)*x90 + w2(0)*x91 + x10*x11 - x10*x47  &
                   - x100*x98 - x101*x14 - x101*x15 - x101*x16 - x101*x20 -    &
                  x101*x21 - x102*x94 - x103*x17 - x105*x26 + x106*x112 - x107*&
                  x17 - x108*x26 + x109*x80 + x109*x84 + x11*x12 + x110*x80 +  &
                  x110*x84 + x112*x123 + x113*x114 + x113*x117 + x114*x124 +   &
                  x115*x116 + x115*x125 + x117*x124 + x118*x84 + x119*x120 -   &
                  x12*x47 + x120*x126 + x121*x122 + x121*x127 + x13*x19 + x17* &
                  x92 - x22*x49*x50 - x22*x61*x62 + x23*x24 - x24*x59 + x27*x30&
                   + x29*x43 + x3*x4 - x3*x56 + x30*x32 + x34*x35 - x34*x48 +  &
                  x35*x36 - x36*x48 + x38*x39 + x44*x46 - x46*x77 + x5*x7 - x50&
                  *x54 - x50*x55 - x53*x70 - x56*x6 - x62*x66 - x62*x67 - x65* &
                  x73 - x69*x70 - x72*x73 + x79*x80 + x79*x87 + x80*x81 + x80* &
                  x82 + x81*x87 + x83*x84 + x84*x85 + x84*x86 - x93*x94 - x93* &
                  x95 - x98*x99
        wout(1) = -2*P1(1)*w1(1)*x94 - P1(1)*x167 + P1(1)*x169 + P1(1)*x75*x79 &
                   - P1(1)*x96 - P1(1)*x97 - P2(1)*x167 + P2(1)*x169 + P2(1)*  &
                  x75*x83 + co(0)*x161*x32 + w1(1)*x88 - w2(1)*x78 + w2(1)*x89 &
                   + w2(1)*x90 + w2(1)*x91 - x100*x40 + x101*x162 - x102*x165  &
                   - x102*x168 + x11*x129 + x11*x130 - x113*x166 + x116*x71 +  &
                  x118*x158 + x118*x159 + x119*x173 + x122*x58 - x124*x166 +   &
                  x125*x71 + x126*x173 + x127*x58 + x128*x13 - x129*x47 - x130*&
                  x47 + x131*x3 + x133*x24 + x135*x137 + x135*x43 + x136*x24 + &
                  x138*x34 + x138*x36 + x139*x39 + x14*x170 + x14*x174 - x14*  &
                  x95 + x141*x43 - x142*x49 - x143*x34 - x143*x36 - x144*x3 -  &
                  x144*x6 - x145*x146 - x148*x62 - x151*x153 - x152*x156 - x152&
                  *x62 - x154*x53 - x154*x69 - x155*x73 - x157*x44 + x157*x77  &
                   - x158*x45 + x158*x81 + x158*x82 - x159*x76 + x159*x85 +    &
                  x159*x86 - x16*x94 - x160*x45 + x160*x81 + x161*x44 - x163*  &
                  x63 - x164*x63 + x17*x94 + x171*x31 + x172*x60 + x175*x31 +  &
                  x176*x60 - x21*x94 - x40*x99 - x5*x54 - x5*x55 + x50*x7
        wout(2) = P1(2)*P2(3)*x192 - P1(2)*x167 + P1(2)*x190 + P1(2)*x75*x81 - &
                  P1(2)*x97 - P1(3)*P2(2)*w1(3)*x44 + P2(0)*x42 - 2*P2(2)*w1(2 &
                  )*x163 - P2(2)*x167 + P2(2)*x75*x85 + w1(2)*x88 - w2(2)*x78  &
                   + w2(2)*x89 + w2(2)*x90 + w2(2)*x91 + x10*x131 - x10*x144 - &
                  x100*x68 + x101*x115 + x101*x150 - x105*x147 + x106*x191 -   &
                  x108*x147 + x109*x188 + x113*x195 + x115*x92 + x118*x188 +   &
                  x119*x193 + x119*x194 + x12*x131 - x12*x144 + x123*x191 +    &
                  x124*x195 + x126*x193 + x126*x194 - x129*x4 + x129*x56 - x130&
                  *x4 + x130*x56 - x133*x50 - x135*x183 - x135*x70 - x136*x50  &
                   - x14*x164 - x141*x70 + x145*x19 - x149*x165 - x149*x168 +  &
                  x153*x180 + x154*x29 + x156*x181 + x164*x17 + x171*x37 + x172&
                  *x25 + x175*x37 + x176*x25 + x177*x27 + x177*x32 + x178*x34  &
                   + x178*x36 + x179*x62 + x181*x62 + x182*x73 - x184*x34 -    &
                  x184*x36 - x185*x39 - x186*x44 + x186*x77 - x187*x45 + x187* &
                  x79 + x187*x82 - x188*x76 + x188*x83 + x188*x86 - x189*x45 + &
                  x189*x79 + x23*x5 - x5*x59 - x51*x99 - x64*x94 - x68*x99 -   &
                  x71*x94 - x71*x95
        wout(3) = -2*P1(3)*w1(3)*x99 + P1(3)*x169 + P1(3)*x190 + P1(3)*x75*x82 &
                   - P1(3)*x96 - P1(3)*x97 - P2(0)*x111 + P2(1)*co(2)*x152 - P2&
                  (2)*co(2)*x181 - P2(3)*x167 + P2(3)*x169 + P2(3)*x190 + P2(3 &
                  )*x75*x86 - x10*x138 + x10*x143 - x100*x16 + x101*x134 + x101&
                  *x140 - x103*x98 - x105*x132 - x107*x98 - x108*x132 + x113*  &
                  x201 + x113*x203 + x119*x200 + x119*x202 - x12*x138 + x12*   &
                  x143 + x124*x201 + x124*x203 + x126*x200 + x126*x202 + x128* &
                  x38 + x129*x35 - x129*x48 + x130*x35 - x130*x48 - x137*x180  &
                   - x139*x19 - x14*x99 + x140*x92 - x142*x61 + x146*x185 +    &
                  x148*x50 + x151*x183 + x152*x50 - x154*x65 - x154*x72 + x155*&
                  x70 - x163*x52 - x164*x52 + x17*x99 + x170*x40 + x171*x57 +  &
                  x174*x40 + x175*x57 + x178*x3 - x179*x24 - x181*x24 - x182*  &
                  x43 - x184*x3 - x184*x6 - x192*x45 + x192*x79 + x192*x81 -   &
                  x196*x44 + x196*x77 - x197*x76 + x197*x83 + x197*x85 - x198* &
                  x45 + x198*x79 + x198*x81 - x199*x76 + x199*x83 + x199*x85 + &
                  x199*x86 - x28*x94 - x41*x94 - x41*x95 - x5*x66 - x5*x67 +   &
                  x62*x7
      case(VVV19)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2
!       ,3))
!       c2*(Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) - Epsilon(-1 
!       ,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + Epsilon(-1,-2,1,3)*P(-1,1
!       )*P(-2,2)*P(2,3))
!       c4*(Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,1,3)*P(-1,2
!       )*P(-2,3)*P(2,1) + Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3) - Epsilon(-1
!       ,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) - Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,
!       3) + Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(1)**2
        x5 = co(4)*x4
        x6 = P1(2)**2
        x7 = co(4)*x6
        x8 = P1(3)**2
        x9 = co(4)*x8
        x10 = P1(0)**2
        x11 = co(4)*x10
        x12 = P1(1)*x0 - P1(2)*x2 + P1(3)*x1
        x13 = P1(0)*P2(0)*co(3)
        x14 = P1(0)*P2(0)
        x15 = co(4)*x3
        x16 = P1(0)*P2(2)
        x17 = w1(0)*w2(1) - w1(1)*w2(0)
        x18 = w1(0)*w2(3) - w1(3)*w2(0)
        x19 = P1(0)*x2 - P1(1)*x18 + P1(3)*x17
        x20 = co(4)*x19
        x21 = P2(0)*x2 - P2(1)*x18 + P2(3)*x17
        x22 = co(4)*x21
        x23 = P1(0)*w1(0)
        x24 = P1(2)*w2(3) - P1(3)*w2(2)
        x25 = P1(1)*w2(2) - P1(2)*w2(1)
        x26 = P1(1)*w2(3) - P1(3)*w2(1)
        x27 = co(2)*(P2(1)*x24 - P2(2)*x26 + P2(3)*x25)
        x28 = P2(2)*w2(3) - P2(3)*w2(2)
        x29 = P2(1)*w2(2) - P2(2)*w2(1)
        x30 = P2(1)*w2(3) - P2(3)*w2(1)
        x31 = co(2)*(P2(1)*x28 - P2(2)*x30 + P2(3)*x29)
        x32 = P1(2)*P2(3)
        x33 = P1(3)*P2(2)
        x34 = x32 - x33
        x35 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x36 = P1(1)*co(2)*x35
        x37 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x38 = co(3)*x37
        x39 = P2(2)*w1(3)
        x40 = P2(3)*w1(2)
        x41 = x39 - x40
        x42 = P1(1)*x41
        x43 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x44 = co(3)*x43
        x45 = P1(1)*w1(1)
        x46 = P1(2)*w1(2)
        x47 = P1(3)*w1(3)
        x48 = -x23 + x45 + x46 + x47
        x49 = P1(1)*co(4)*x48
        x50 = P1(2)*P2(0)
        x51 = co(3)*x19
        x52 = co(3)*x21
        x53 = P1(2)*w1(0)
        x54 = P1(0)*w2(1) - P1(1)*w2(0)
        x55 = P1(0)*w2(3) - P1(3)*w2(0)
        x56 = co(2)*(P2(0)*x26 - P2(1)*x55 + P2(3)*x54)
        x57 = P2(0)*w2(1) - P2(1)*w2(0)
        x58 = P2(0)*w2(3) - P2(3)*w2(0)
        x59 = co(2)*(P2(0)*x30 - P2(1)*x58 + P2(3)*x57)
        x60 = P2(2)*w1(2)
        x61 = P2(3)*w1(3)
        x62 = -P2(0)*w1(0) + P2(1)*w1(1) + x60 + x61
        x63 = P1(2)*co(4)*x62
        x64 = P1(1)*P2(2)
        x65 = P1(2)*P2(1)
        x66 = x64 - x65
        x67 = P1(3)*co(2)*x35
        x68 = P2(1)*w1(2)
        x69 = P2(2)*w1(1)
        x70 = x68 - x69
        x71 = P1(3)*co(3)*x37
        x72 = P1(3)*co(3)*x43
        x73 = co(4)*x29*x48
        x74 = P2(0)*co(1)*x35
        x75 = co(1)*x35*x6
        x76 = P1(1)*w1(3)
        x77 = P1(3)*w1(1)
        x78 = x76 - x77
        x79 = P2(2)*co(4)*x37
        x80 = P2(3)*w1(1)
        x81 = P2(1)*w1(3) - x80
        x82 = P2(0)**2
        x83 = co(0)*w1(0)*x37
        x84 = P1(0)*P2(1)
        x85 = w1(0)*w2(2) - w1(2)*w2(0)
        x86 = P1(0)*x0 - P1(2)*x18 + P1(3)*x85
        x87 = co(4)*x86
        x88 = P2(0)*x0 - P2(2)*x18 + P2(3)*x85
        x89 = co(4)*x88
        x90 = P1(0)*P2(3)
        x91 = P1(0)*x1 - P1(1)*x85 + P1(2)*x17
        x92 = co(4)*x91
        x93 = P2(0)*x1 - P2(1)*x85 + P2(2)*x17
        x94 = co(4)*x93
        x95 = co(1)*x35
        x96 = P1(1)*P2(0)
        x97 = co(3)*x86
        x98 = co(3)*x88
        x99 = P1(1)*P2(1)
        x100 = co(4)*x12
        x101 = P1(1)*w1(0)
        x102 = P1(0)*w2(2) - P1(2)*w2(0)
        x103 = co(2)*(P2(0)*x24 - P2(2)*x55 + P2(3)*x102)
        x104 = P2(0)*w2(2) - P2(2)*w2(0)
        x105 = co(2)*(P2(0)*x28 - P2(2)*x58 + P2(3)*x104)
        x106 = P1(1)*co(4)*x62
        x107 = P1(2)*P2(2)
        x108 = P1(1)*P2(3)
        x109 = P1(3)*P2(1)
        x110 = x108 - x109
        x111 = P1(2)*co(2)*x35
        x112 = P1(2)*co(3)*x37
        x113 = P1(2)*co(3)*x43
        x114 = P1(2)*co(4)*x48
        x115 = P1(3)*P2(0)*co(3)
        x116 = P1(3)*P2(3)
        x117 = P1(3)*w1(0)
        x118 = co(2)*(P2(0)*x25 - P2(1)*x102 + P2(2)*x54)
        x119 = co(2)*(P2(0)*x29 - P2(1)*x104 + P2(2)*x57)
        x120 = P1(3)*co(4)*x62
        x121 = P1(2)*w1(3)
        x122 = P1(3)*w1(2)
        x123 = x121 - x122
        x124 = P2(1)*co(4)*x37
        x125 = P1(1)*w1(2)
        x126 = P1(2)*w1(1)
        x127 = x125 - x126
        x128 = P2(3)*co(4)*x37
        x129 = co(0)*x43
        x130 = P1(0)*P2(0)*w1(0)
        x131 = P2(1)*co(1)*x35
        x132 = P2(1)*w1(0)
        x133 = P1(1)*co(1)*x37
        x134 = P1(1)*co(1)*x43
        x135 = P2(2)*co(1)*x35
        x136 = co(1)*x37
        x137 = P1(2)*P2(2)*w1(0)
        x138 = co(1)*x43
        x139 = P1(3)*P2(0)
        x140 = P2(3)*co(1)*x35
        x141 = P1(3)*P2(3)*w1(0)
        x142 = P2(0)*co(1)*x43
        x143 = co(0)*w1(1)*x37
        x144 = co(0)*x37
        x145 = P2(2)*co(0)*w1(2)*x43
        x146 = P1(0)*w1(3)
        x147 = P2(3)*co(0)*x37
        x148 = P2(3)*co(0)*x43
        x149 = P2(0)*co(0)*x37
        x150 = co(0)*w1(3)*x37
        x151 = P2(0)*w1(1)
        x152 = P2(1)*co(0)*x37
        x153 = co(3)*x12
        x154 = co(3)*x3
        x155 = P1(0)*w1(1)
        x156 = P1(0)*co(2)*x35
        x157 = P1(0)*co(3)*x37
        x158 = P1(0)*co(3)*x43
        x159 = P1(0)*co(4)*x48
        x160 = P2(1)**2
        x161 = x16 - x50
        x162 = P2(2)*w1(0)
        x163 = P2(0)*w1(2) - x162
        x164 = P1(3)*co(4)*x48
        x165 = -x117 + x146
        x166 = P2(3)*w1(0)
        x167 = P2(0)*w1(3) - x166
        x168 = P1(0)*co(4)*x62
        x169 = -x139 + x90
        x170 = co(3)*x91
        x171 = co(3)*x93
        x172 = P2(0)*co(4)*x37
        x173 = P1(0)*w1(2)
        x174 = x173 - x53
        x175 = co(0)*w1(0)*x43
        x176 = P1(1)*P2(1)*w1(1)
        x177 = P1(2)*P2(2)*w1(1)
        x178 = P1(3)*P2(3)*w1(1)
        x179 = P1(0)*P2(0)*w1(1)
        x180 = P2(1)*co(0)*x43
        x181 = P2(2)*co(0)*x37
        x182 = P1(2)*co(0)*x37
        x183 = P1(1)*x167
        x184 = P1(2)*P2(0)*co(4)
        x185 = P2(2)**2
        x186 = -x101 + x155
        x187 = -x132 + x151
        x188 = x84 - x96
        x189 = co(3)*x187*x43
        x190 = P1(2)*co(1)*x37
        x191 = P1(2)*co(1)*x43
        x192 = P1(3)*P2(3)*w1(2)
        x193 = P2(0)*co(1)*x37
        x194 = P1(3)*co(0)*x37
        x195 = P2(3)**2
        x196 = P1(1)*x163
        x197 = P1(1)*P2(1)*w1(3)
        x198 = P1(3)*P2(3)*w1(3)
        wout(0) = 2*P1(0)*P2(0)*x100 - P1(0)*P2(1)*w1(1)*x129 - P1(0)*P2(2)*w1(&
                  2)*x144 + 2*P1(0)*w1(0)*x149 - P1(0)*x145 - P1(0)*x82*x95 +  &
                  P1(3)*x73 + P2(0)*x75 - x10*x74 - x100*x107 - x100*x116 -    &
                  x100*x99 - x101*x103 - x101*x105 - x106*x24 - x11*x3 - x110* &
                  x111 - x112*x81 - x113*x81 - x114*x30 - x115*x91 - x115*x93  &
                   - x117*x118 - x117*x119 + x12*x13 - x120*x25 - x123*x124 -  &
                  x124*x41 - x127*x128 - x128*x70 + x129*x130 + x13*x3 - x130* &
                  x136 + x131*x96 + x132*x133 + x132*x134 + x135*x50 + x136*   &
                  x137 + x136*x141 + x137*x138 + x138*x141 + x139*x140 - x139* &
                  x150 + x14*x15 - x142*x23 - x143*x84 - x146*x147 - x146*x148 &
                   - x149*x45 - x149*x46 - x149*x60 - x149*x61 - x151*x152 +   &
                  x16*x20 + x16*x22 + x23*x27 + x23*x31 + x26*x63 + x28*x49 +  &
                  x3*x5 + x3*x7 + x3*x9 + x34*x36 + x38*x42 + x4*x74 + x42*x44 &
                   + x50*x51 + x50*x52 + x53*x56 + x53*x59 + x66*x67 + x70*x71 &
                   + x70*x72 + x74*x8 + x78*x79 + x79*x81 + x82*x83 - x84*x87  &
                   - x84*x89 - x90*x92 - x90*x94 - x96*x97 - x96*x98
        wout(1) = -2*P1(1)*P2(1)*x87 - P1(1)*P2(2)*w1(2)*x129 + P1(1)*x160*x95 &
                   + P2(1)*x75 - 2*co(0)*x176*x37 - x10*x131 + x100*x96 - x102*&
                  x120 - x103*x45 + x104*x164 - x105*x45 - x107*x87 - x108*x92 &
                   - x108*x94 + x109*x140 - x109*x170 - x109*x171 - x11*x88 -  &
                  x111*x169 - x112*x167 - x113*x167 - x114*x58 - x116*x87 -    &
                  x118*x77 - x119*x77 - x123*x172 - x125*x181 + x126*x56 + x126&
                  *x59 - x128*x163 - x128*x174 + x131*x4 + x131*x8 + x132*x149 &
                   + x135*x65 + x136*x176 + x136*x177 + x136*x178 - x136*x179  &
                   + x138*x176 + x138*x177 + x138*x178 - x138*x179 + x14*x87 - &
                  x143*x160 - x147*x76 - x148*x76 + x15*x96 + x152*x23 - x152* &
                  x47 - x152*x61 + x153*x84 + x154*x84 + x155*x27 + x155*x31 + &
                  x156*x34 + x157*x41 + x158*x41 + x159*x28 + x161*x67 + x163* &
                  x71 + x163*x72 + x165*x79 + x167*x79 - x168*x24 - x172*x41 + &
                  x175*x96 - x180*x45 - x181*x68 - x182*x68 + x20*x64 + x22*x64&
                   + x5*x88 + x51*x65 + x52*x65 + x55*x63 + x7*x88 - x74*x84 + &
                  x83*x96 + x88*x9 - x89*x99 - x97*x99 - x98*x99
        wout(2) = P1(2)*P2(0)*w1(0)*x129 - P1(2)*P2(3)*w1(3)*x129 - P1(2)*x145 &
                   + P1(2)*x185*x95 - P1(3)*x189 - 2*P2(2)*w1(2)*x182 + P2(2)* &
                  x75 + 2*co(4)*x107*x19 - w1(2)*x144*x185 - x10*x135 - x103*  &
                  x125 - x105*x125 - x106*x55 + x107*x22 + x107*x51 + x107*x52 &
                   + x11*x21 - x110*x156 + x116*x20 - x118*x122 - x119*x122 +  &
                  x12*x184 + x120*x54 - x124*x165 - x124*x167 - x126*x152 -    &
                  x126*x180 + x128*x186 + x128*x187 + x131*x64 + x133*x68 +    &
                  x134*x68 + x135*x4 + x135*x8 + x136*x192 + x138*x192 - x14*  &
                  x20 + x140*x33 - x142*x173 - x147*x39 + x149*x162 + x149*x53 &
                   - x150*x32 - x152*x69 + x153*x16 + x154*x16 - x157*x81 -    &
                  x158*x81 - x159*x30 - x16*x74 - x164*x57 + x168*x26 + x169*  &
                  x36 - x170*x33 - x171*x33 + x172*x78 + x172*x81 - x173*x193  &
                   + x173*x27 + x173*x31 + x181*x23 - x181*x45 + x183*x38 +    &
                  x183*x44 + x184*x3 - x187*x71 - x188*x67 + x190*x60 + x191*  &
                  x60 - x194*x39 + x20*x99 - x21*x5 - x21*x7 - x21*x9 - x32*x92&
                   - x32*x94 + x46*x56 + x46*x59 + x49*x58 - x64*x97 - x64*x98 &
                   - x65*x87 - x65*x89
        wout(3) = P1(0)*x73 + P1(2)*x189 - 2*P1(3)*w1(3)*x147 - P1(3)*x145 + P1&
                  (3)*x195*x95 + P2(3)*x75 - 2*co(4)*x116*x91 - x10*x140 + x100&
                  *x139 + x102*x106 - x103*x76 - x104*x49 - x105*x76 - x107*x92&
                   + x108*x131 - x108*x97 - x108*x98 - x109*x87 - x109*x89 -   &
                  x11*x93 + x111*x188 + x112*x187 + x114*x57 - x116*x170 - x116&
                  *x171 - x116*x94 - x118*x47 - x119*x47 + x121*x56 + x121*x59 &
                   + x124*x163 + x124*x174 - x127*x172 - x129*x198 + x135*x32  &
                   + x136*x197 + x136*x198 + x138*x197 + x138*x198 + x139*x15  &
                   + x139*x175 + x139*x83 + x14*x92 + x140*x4 + x140*x8 - x142*&
                  x146 - x146*x193 + x146*x27 + x146*x31 + x147*x23 - x147*x45 &
                   + x149*x166 - x150*x195 - x152*x77 - x152*x80 + x153*x90 +  &
                  x154*x90 + x156*x66 + x157*x70 + x158*x70 - x161*x36 - x168* &
                  x25 - x172*x70 - x180*x77 - x181*x40 - x182*x40 - x186*x79 - &
                  x187*x79 + x190*x39 + x191*x39 - x194*x60 - x196*x38 - x196* &
                  x44 + x20*x33 + x22*x33 + x32*x51 + x32*x52 + x5*x93 - x54*  &
                  x63 + x7*x93 - x74*x90 + x9*x93 - x92*x99
      end select 
    end subroutine treeVVV
end module tcVVV
